#line 1 "numpy/core/src/multiarray/einsum_sumprod.c.src"

/*
 *****************************************************************************
 **       This file was autogenerated from a template  DO NOT EDIT!!!!      **
 **       Changes should be made to the original source (.src) file         **
 *****************************************************************************
 */

#line 1
/*
 * This file provides optimized sum of product implementations used internally
 * by einsum.
 *
 * Copyright (c) 2011 by Mark Wiebe (mwwiebe@gmail.com)
 * The University of British Columbia
 *
 * See LICENSE.txt for the license.
 */

#define NPY_NO_DEPRECATED_API NPY_API_VERSION
#define _MULTIARRAYMODULE

#include <numpy/npy_common.h>
#include <numpy/ndarraytypes.h>  /* for NPY_NTYPES */
#include <numpy/halffloat.h>

#include "einsum_sumprod.h"
#include "einsum_debug.h"


#ifdef NPY_HAVE_SSE_INTRINSICS
#define EINSUM_USE_SSE1 1
#else
#define EINSUM_USE_SSE1 0
#endif

#ifdef NPY_HAVE_SSE2_INTRINSICS
#define EINSUM_USE_SSE2 1
#else
#define EINSUM_USE_SSE2 0
#endif

#if EINSUM_USE_SSE1
#include <xmmintrin.h>
#endif

#if EINSUM_USE_SSE2
#include <emmintrin.h>
#endif

#define EINSUM_IS_SSE_ALIGNED(x) ((((npy_intp)x)&0xf) == 0)

/**********************************************/

#line 80

#line 85
static void
byte_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_byte *)data_out = ((*(npy_byte *)data0) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_byte *)data_out = ((*(npy_byte *)data0) *
                                         (*(npy_byte *)data1) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_byte *)data_out = ((*(npy_byte *)data0) *
                                         (*(npy_byte *)data1) *
                                         (*(npy_byte *)data2) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        *(npy_byte *)dataptr[nop] = (temp +
                                           (*(npy_byte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_byte *)data_out)[0] = ((npy_byte *)data0)[0] +
                                         ((npy_byte *)data_out)[0];
        ((npy_byte *)data_out)[1] = ((npy_byte *)data0)[1] +
                                         ((npy_byte *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_byte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_byte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
byte_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data_out = (npy_byte *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_byte *)data_out + 2*6)[0] =
                                    ((npy_byte *)data0 + 2*6)[0] +
                                    ((npy_byte *)data_out + 2*6)[0];
            ((npy_byte *)data_out + 2*6)[1] =
                                    ((npy_byte *)data0 + 2*6)[1] +
                                    ((npy_byte *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_byte *)data_out + 2*5)[0] =
                                    ((npy_byte *)data0 + 2*5)[0] +
                                    ((npy_byte *)data_out + 2*5)[0];
            ((npy_byte *)data_out + 2*5)[1] =
                                    ((npy_byte *)data0 + 2*5)[1] +
                                    ((npy_byte *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_byte *)data_out + 2*4)[0] =
                                    ((npy_byte *)data0 + 2*4)[0] +
                                    ((npy_byte *)data_out + 2*4)[0];
            ((npy_byte *)data_out + 2*4)[1] =
                                    ((npy_byte *)data0 + 2*4)[1] +
                                    ((npy_byte *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_byte *)data_out + 2*3)[0] =
                                    ((npy_byte *)data0 + 2*3)[0] +
                                    ((npy_byte *)data_out + 2*3)[0];
            ((npy_byte *)data_out + 2*3)[1] =
                                    ((npy_byte *)data0 + 2*3)[1] +
                                    ((npy_byte *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_byte *)data_out + 2*2)[0] =
                                    ((npy_byte *)data0 + 2*2)[0] +
                                    ((npy_byte *)data_out + 2*2)[0];
            ((npy_byte *)data_out + 2*2)[1] =
                                    ((npy_byte *)data0 + 2*2)[1] +
                                    ((npy_byte *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_byte *)data_out + 2*1)[0] =
                                    ((npy_byte *)data0 + 2*1)[0] +
                                    ((npy_byte *)data_out + 2*1)[0];
            ((npy_byte *)data_out + 2*1)[1] =
                                    ((npy_byte *)data0 + 2*1)[1] +
                                    ((npy_byte *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_byte *)data_out + 2*0)[0] =
                                    ((npy_byte *)data0 + 2*0)[0] +
                                    ((npy_byte *)data_out + 2*0)[0];
            ((npy_byte *)data_out + 2*0)[1] =
                                    ((npy_byte *)data0 + 2*0)[1] +
                                    ((npy_byte *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_byte *)data_out + 2*0)[0] =
                                ((npy_byte *)data0 + 2*0)[0] +
                                ((npy_byte *)data_out + 2*0)[0];
        ((npy_byte *)data_out + 2*0)[1] =
                                ((npy_byte *)data0 + 2*0)[1] +
                                ((npy_byte *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_byte *)data_out + 2*1)[0] =
                                ((npy_byte *)data0 + 2*1)[0] +
                                ((npy_byte *)data_out + 2*1)[0];
        ((npy_byte *)data_out + 2*1)[1] =
                                ((npy_byte *)data0 + 2*1)[1] +
                                ((npy_byte *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_byte *)data_out + 2*2)[0] =
                                ((npy_byte *)data0 + 2*2)[0] +
                                ((npy_byte *)data_out + 2*2)[0];
        ((npy_byte *)data_out + 2*2)[1] =
                                ((npy_byte *)data0 + 2*2)[1] +
                                ((npy_byte *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_byte *)data_out + 2*3)[0] =
                                ((npy_byte *)data0 + 2*3)[0] +
                                ((npy_byte *)data_out + 2*3)[0];
        ((npy_byte *)data_out + 2*3)[1] =
                                ((npy_byte *)data0 + 2*3)[1] +
                                ((npy_byte *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_byte *)data_out + 2*4)[0] =
                                ((npy_byte *)data0 + 2*4)[0] +
                                ((npy_byte *)data_out + 2*4)[0];
        ((npy_byte *)data_out + 2*4)[1] =
                                ((npy_byte *)data0 + 2*4)[1] +
                                ((npy_byte *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_byte *)data_out + 2*5)[0] =
                                ((npy_byte *)data0 + 2*5)[0] +
                                ((npy_byte *)data_out + 2*5)[0];
        ((npy_byte *)data_out + 2*5)[1] =
                                ((npy_byte *)data0 + 2*5)[1] +
                                ((npy_byte *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_byte *)data_out + 2*6)[0] =
                                ((npy_byte *)data0 + 2*6)[0] +
                                ((npy_byte *)data_out + 2*6)[0];
        ((npy_byte *)data_out + 2*6)[1] =
                                ((npy_byte *)data0 + 2*6)[1] +
                                ((npy_byte *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_byte *)data_out + 2*7)[0] =
                                ((npy_byte *)data0 + 2*7)[0] +
                                ((npy_byte *)data_out + 2*7)[0];
        ((npy_byte *)data_out + 2*7)[1] =
                                ((npy_byte *)data0 + 2*7)[1] +
                                ((npy_byte *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
byte_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
byte_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte value0 = (*(npy_byte *)dataptr[0]);
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
byte_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte value1 = (*(npy_byte *)dataptr[1]);
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte value0 = (*(npy_byte *)dataptr[0]);
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte value1 = (*(npy_byte *)dataptr[1]);
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
byte_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data2 = (npy_byte *)dataptr[2];
    npy_byte *data_out = (npy_byte *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
byte_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        *(npy_byte *)dataptr[nop] = (temp +
                                           (*(npy_byte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_byte);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_byte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_byte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_byte);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
byte_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_byte accum_re = 0, accum_im = 0;
    npy_byte *data0 = (npy_byte *)dataptr[0];
#else
    npy_byte accum = 0;
    npy_byte *data0 = (npy_byte *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_byte *)dataptr[1])[0] += accum_re;
            ((npy_byte *)dataptr[1])[1] += accum_im;
#else
            *((npy_byte *)dataptr[1]) = (accum +
                                    (*((npy_byte *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
byte_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_byte accum_re = 0, accum_im = 0;
#else
    npy_byte accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_byte *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_byte *)data0) *
                 (*(npy_byte *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_byte *)data0) *
                 (*(npy_byte *)data1) *
                 (*(npy_byte *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_byte *)data0)[0];
        accum_im += ((npy_byte *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_byte *)dataptr[1])[0] += accum_re;
    ((npy_byte *)dataptr[1])[1] += accum_im;
#  else
    ((npy_byte *)dataptr[nop])[0] += accum_re;
    ((npy_byte *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_byte *)dataptr[1]) = (accum +
                                    (*((npy_byte *)dataptr[1])));
#  else
    *((npy_byte *)dataptr[nop]) = (accum +
                                    (*((npy_byte *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
byte_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_byte *)data_out = ((*(npy_byte *)data0) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_byte *)data_out = ((*(npy_byte *)data0) *
                                         (*(npy_byte *)data1) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_byte *)data_out = ((*(npy_byte *)data0) *
                                         (*(npy_byte *)data1) *
                                         (*(npy_byte *)data2) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        *(npy_byte *)dataptr[nop] = (temp +
                                           (*(npy_byte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_byte *)data_out)[0] = ((npy_byte *)data0)[0] +
                                         ((npy_byte *)data_out)[0];
        ((npy_byte *)data_out)[1] = ((npy_byte *)data0)[1] +
                                         ((npy_byte *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_byte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_byte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
byte_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data_out = (npy_byte *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_byte *)data_out + 2*6)[0] =
                                    ((npy_byte *)data0 + 2*6)[0] +
                                    ((npy_byte *)data_out + 2*6)[0];
            ((npy_byte *)data_out + 2*6)[1] =
                                    ((npy_byte *)data0 + 2*6)[1] +
                                    ((npy_byte *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_byte *)data_out + 2*5)[0] =
                                    ((npy_byte *)data0 + 2*5)[0] +
                                    ((npy_byte *)data_out + 2*5)[0];
            ((npy_byte *)data_out + 2*5)[1] =
                                    ((npy_byte *)data0 + 2*5)[1] +
                                    ((npy_byte *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_byte *)data_out + 2*4)[0] =
                                    ((npy_byte *)data0 + 2*4)[0] +
                                    ((npy_byte *)data_out + 2*4)[0];
            ((npy_byte *)data_out + 2*4)[1] =
                                    ((npy_byte *)data0 + 2*4)[1] +
                                    ((npy_byte *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_byte *)data_out + 2*3)[0] =
                                    ((npy_byte *)data0 + 2*3)[0] +
                                    ((npy_byte *)data_out + 2*3)[0];
            ((npy_byte *)data_out + 2*3)[1] =
                                    ((npy_byte *)data0 + 2*3)[1] +
                                    ((npy_byte *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_byte *)data_out + 2*2)[0] =
                                    ((npy_byte *)data0 + 2*2)[0] +
                                    ((npy_byte *)data_out + 2*2)[0];
            ((npy_byte *)data_out + 2*2)[1] =
                                    ((npy_byte *)data0 + 2*2)[1] +
                                    ((npy_byte *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_byte *)data_out + 2*1)[0] =
                                    ((npy_byte *)data0 + 2*1)[0] +
                                    ((npy_byte *)data_out + 2*1)[0];
            ((npy_byte *)data_out + 2*1)[1] =
                                    ((npy_byte *)data0 + 2*1)[1] +
                                    ((npy_byte *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_byte *)data_out + 2*0)[0] =
                                    ((npy_byte *)data0 + 2*0)[0] +
                                    ((npy_byte *)data_out + 2*0)[0];
            ((npy_byte *)data_out + 2*0)[1] =
                                    ((npy_byte *)data0 + 2*0)[1] +
                                    ((npy_byte *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_byte *)data_out + 2*0)[0] =
                                ((npy_byte *)data0 + 2*0)[0] +
                                ((npy_byte *)data_out + 2*0)[0];
        ((npy_byte *)data_out + 2*0)[1] =
                                ((npy_byte *)data0 + 2*0)[1] +
                                ((npy_byte *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_byte *)data_out + 2*1)[0] =
                                ((npy_byte *)data0 + 2*1)[0] +
                                ((npy_byte *)data_out + 2*1)[0];
        ((npy_byte *)data_out + 2*1)[1] =
                                ((npy_byte *)data0 + 2*1)[1] +
                                ((npy_byte *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_byte *)data_out + 2*2)[0] =
                                ((npy_byte *)data0 + 2*2)[0] +
                                ((npy_byte *)data_out + 2*2)[0];
        ((npy_byte *)data_out + 2*2)[1] =
                                ((npy_byte *)data0 + 2*2)[1] +
                                ((npy_byte *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_byte *)data_out + 2*3)[0] =
                                ((npy_byte *)data0 + 2*3)[0] +
                                ((npy_byte *)data_out + 2*3)[0];
        ((npy_byte *)data_out + 2*3)[1] =
                                ((npy_byte *)data0 + 2*3)[1] +
                                ((npy_byte *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_byte *)data_out + 2*4)[0] =
                                ((npy_byte *)data0 + 2*4)[0] +
                                ((npy_byte *)data_out + 2*4)[0];
        ((npy_byte *)data_out + 2*4)[1] =
                                ((npy_byte *)data0 + 2*4)[1] +
                                ((npy_byte *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_byte *)data_out + 2*5)[0] =
                                ((npy_byte *)data0 + 2*5)[0] +
                                ((npy_byte *)data_out + 2*5)[0];
        ((npy_byte *)data_out + 2*5)[1] =
                                ((npy_byte *)data0 + 2*5)[1] +
                                ((npy_byte *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_byte *)data_out + 2*6)[0] =
                                ((npy_byte *)data0 + 2*6)[0] +
                                ((npy_byte *)data_out + 2*6)[0];
        ((npy_byte *)data_out + 2*6)[1] =
                                ((npy_byte *)data0 + 2*6)[1] +
                                ((npy_byte *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_byte *)data_out + 2*7)[0] =
                                ((npy_byte *)data0 + 2*7)[0] +
                                ((npy_byte *)data_out + 2*7)[0];
        ((npy_byte *)data_out + 2*7)[1] =
                                ((npy_byte *)data0 + 2*7)[1] +
                                ((npy_byte *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
byte_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
byte_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte value0 = (*(npy_byte *)dataptr[0]);
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
byte_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte value1 = (*(npy_byte *)dataptr[1]);
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte value0 = (*(npy_byte *)dataptr[0]);
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte value1 = (*(npy_byte *)dataptr[1]);
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
byte_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data2 = (npy_byte *)dataptr[2];
    npy_byte *data_out = (npy_byte *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
byte_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        *(npy_byte *)dataptr[nop] = (temp +
                                           (*(npy_byte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_byte);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_byte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_byte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_byte);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
byte_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_byte accum_re = 0, accum_im = 0;
    npy_byte *data0 = (npy_byte *)dataptr[0];
#else
    npy_byte accum = 0;
    npy_byte *data0 = (npy_byte *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_byte *)dataptr[1])[0] += accum_re;
            ((npy_byte *)dataptr[1])[1] += accum_im;
#else
            *((npy_byte *)dataptr[1]) = (accum +
                                    (*((npy_byte *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
byte_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_byte accum_re = 0, accum_im = 0;
#else
    npy_byte accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_byte *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_byte *)data0) *
                 (*(npy_byte *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_byte *)data0) *
                 (*(npy_byte *)data1) *
                 (*(npy_byte *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_byte *)data0)[0];
        accum_im += ((npy_byte *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_byte *)dataptr[2])[0] += accum_re;
    ((npy_byte *)dataptr[2])[1] += accum_im;
#  else
    ((npy_byte *)dataptr[nop])[0] += accum_re;
    ((npy_byte *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_byte *)dataptr[2]) = (accum +
                                    (*((npy_byte *)dataptr[2])));
#  else
    *((npy_byte *)dataptr[nop]) = (accum +
                                    (*((npy_byte *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
byte_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_byte *)data_out = ((*(npy_byte *)data0) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_byte *)data_out = ((*(npy_byte *)data0) *
                                         (*(npy_byte *)data1) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_byte *)data_out = ((*(npy_byte *)data0) *
                                         (*(npy_byte *)data1) *
                                         (*(npy_byte *)data2) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        *(npy_byte *)dataptr[nop] = (temp +
                                           (*(npy_byte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_byte *)data_out)[0] = ((npy_byte *)data0)[0] +
                                         ((npy_byte *)data_out)[0];
        ((npy_byte *)data_out)[1] = ((npy_byte *)data0)[1] +
                                         ((npy_byte *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_byte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_byte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
byte_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data_out = (npy_byte *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_byte *)data_out + 2*6)[0] =
                                    ((npy_byte *)data0 + 2*6)[0] +
                                    ((npy_byte *)data_out + 2*6)[0];
            ((npy_byte *)data_out + 2*6)[1] =
                                    ((npy_byte *)data0 + 2*6)[1] +
                                    ((npy_byte *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_byte *)data_out + 2*5)[0] =
                                    ((npy_byte *)data0 + 2*5)[0] +
                                    ((npy_byte *)data_out + 2*5)[0];
            ((npy_byte *)data_out + 2*5)[1] =
                                    ((npy_byte *)data0 + 2*5)[1] +
                                    ((npy_byte *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_byte *)data_out + 2*4)[0] =
                                    ((npy_byte *)data0 + 2*4)[0] +
                                    ((npy_byte *)data_out + 2*4)[0];
            ((npy_byte *)data_out + 2*4)[1] =
                                    ((npy_byte *)data0 + 2*4)[1] +
                                    ((npy_byte *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_byte *)data_out + 2*3)[0] =
                                    ((npy_byte *)data0 + 2*3)[0] +
                                    ((npy_byte *)data_out + 2*3)[0];
            ((npy_byte *)data_out + 2*3)[1] =
                                    ((npy_byte *)data0 + 2*3)[1] +
                                    ((npy_byte *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_byte *)data_out + 2*2)[0] =
                                    ((npy_byte *)data0 + 2*2)[0] +
                                    ((npy_byte *)data_out + 2*2)[0];
            ((npy_byte *)data_out + 2*2)[1] =
                                    ((npy_byte *)data0 + 2*2)[1] +
                                    ((npy_byte *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_byte *)data_out + 2*1)[0] =
                                    ((npy_byte *)data0 + 2*1)[0] +
                                    ((npy_byte *)data_out + 2*1)[0];
            ((npy_byte *)data_out + 2*1)[1] =
                                    ((npy_byte *)data0 + 2*1)[1] +
                                    ((npy_byte *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_byte *)data_out + 2*0)[0] =
                                    ((npy_byte *)data0 + 2*0)[0] +
                                    ((npy_byte *)data_out + 2*0)[0];
            ((npy_byte *)data_out + 2*0)[1] =
                                    ((npy_byte *)data0 + 2*0)[1] +
                                    ((npy_byte *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_byte *)data_out + 2*0)[0] =
                                ((npy_byte *)data0 + 2*0)[0] +
                                ((npy_byte *)data_out + 2*0)[0];
        ((npy_byte *)data_out + 2*0)[1] =
                                ((npy_byte *)data0 + 2*0)[1] +
                                ((npy_byte *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_byte *)data_out + 2*1)[0] =
                                ((npy_byte *)data0 + 2*1)[0] +
                                ((npy_byte *)data_out + 2*1)[0];
        ((npy_byte *)data_out + 2*1)[1] =
                                ((npy_byte *)data0 + 2*1)[1] +
                                ((npy_byte *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_byte *)data_out + 2*2)[0] =
                                ((npy_byte *)data0 + 2*2)[0] +
                                ((npy_byte *)data_out + 2*2)[0];
        ((npy_byte *)data_out + 2*2)[1] =
                                ((npy_byte *)data0 + 2*2)[1] +
                                ((npy_byte *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_byte *)data_out + 2*3)[0] =
                                ((npy_byte *)data0 + 2*3)[0] +
                                ((npy_byte *)data_out + 2*3)[0];
        ((npy_byte *)data_out + 2*3)[1] =
                                ((npy_byte *)data0 + 2*3)[1] +
                                ((npy_byte *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_byte *)data_out + 2*4)[0] =
                                ((npy_byte *)data0 + 2*4)[0] +
                                ((npy_byte *)data_out + 2*4)[0];
        ((npy_byte *)data_out + 2*4)[1] =
                                ((npy_byte *)data0 + 2*4)[1] +
                                ((npy_byte *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_byte *)data_out + 2*5)[0] =
                                ((npy_byte *)data0 + 2*5)[0] +
                                ((npy_byte *)data_out + 2*5)[0];
        ((npy_byte *)data_out + 2*5)[1] =
                                ((npy_byte *)data0 + 2*5)[1] +
                                ((npy_byte *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_byte *)data_out + 2*6)[0] =
                                ((npy_byte *)data0 + 2*6)[0] +
                                ((npy_byte *)data_out + 2*6)[0];
        ((npy_byte *)data_out + 2*6)[1] =
                                ((npy_byte *)data0 + 2*6)[1] +
                                ((npy_byte *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_byte *)data_out + 2*7)[0] =
                                ((npy_byte *)data0 + 2*7)[0] +
                                ((npy_byte *)data_out + 2*7)[0];
        ((npy_byte *)data_out + 2*7)[1] =
                                ((npy_byte *)data0 + 2*7)[1] +
                                ((npy_byte *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
byte_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
byte_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte value0 = (*(npy_byte *)dataptr[0]);
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
byte_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte value1 = (*(npy_byte *)dataptr[1]);
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte value0 = (*(npy_byte *)dataptr[0]);
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte value1 = (*(npy_byte *)dataptr[1]);
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
byte_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data2 = (npy_byte *)dataptr[2];
    npy_byte *data_out = (npy_byte *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
byte_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        *(npy_byte *)dataptr[nop] = (temp +
                                           (*(npy_byte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_byte);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_byte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_byte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_byte);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
byte_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_byte accum_re = 0, accum_im = 0;
    npy_byte *data0 = (npy_byte *)dataptr[0];
#else
    npy_byte accum = 0;
    npy_byte *data0 = (npy_byte *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_byte *)dataptr[1])[0] += accum_re;
            ((npy_byte *)dataptr[1])[1] += accum_im;
#else
            *((npy_byte *)dataptr[1]) = (accum +
                                    (*((npy_byte *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
byte_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_byte accum_re = 0, accum_im = 0;
#else
    npy_byte accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_byte *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_byte *)data0) *
                 (*(npy_byte *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_byte *)data0) *
                 (*(npy_byte *)data1) *
                 (*(npy_byte *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_byte *)data0)[0];
        accum_im += ((npy_byte *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_byte *)dataptr[3])[0] += accum_re;
    ((npy_byte *)dataptr[3])[1] += accum_im;
#  else
    ((npy_byte *)dataptr[nop])[0] += accum_re;
    ((npy_byte *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_byte *)dataptr[3]) = (accum +
                                    (*((npy_byte *)dataptr[3])));
#  else
    *((npy_byte *)dataptr[nop]) = (accum +
                                    (*((npy_byte *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
byte_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_byte *)data_out = ((*(npy_byte *)data0) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_byte *)data_out = ((*(npy_byte *)data0) *
                                         (*(npy_byte *)data1) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_byte *)data_out = ((*(npy_byte *)data0) *
                                         (*(npy_byte *)data1) *
                                         (*(npy_byte *)data2) +
                                         (*(npy_byte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        *(npy_byte *)dataptr[nop] = (temp +
                                           (*(npy_byte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_byte *)data_out)[0] = ((npy_byte *)data0)[0] +
                                         ((npy_byte *)data_out)[0];
        ((npy_byte *)data_out)[1] = ((npy_byte *)data0)[1] +
                                         ((npy_byte *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_byte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_byte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
byte_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data_out = (npy_byte *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_byte *)data_out + 2*6)[0] =
                                    ((npy_byte *)data0 + 2*6)[0] +
                                    ((npy_byte *)data_out + 2*6)[0];
            ((npy_byte *)data_out + 2*6)[1] =
                                    ((npy_byte *)data0 + 2*6)[1] +
                                    ((npy_byte *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_byte *)data_out + 2*5)[0] =
                                    ((npy_byte *)data0 + 2*5)[0] +
                                    ((npy_byte *)data_out + 2*5)[0];
            ((npy_byte *)data_out + 2*5)[1] =
                                    ((npy_byte *)data0 + 2*5)[1] +
                                    ((npy_byte *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_byte *)data_out + 2*4)[0] =
                                    ((npy_byte *)data0 + 2*4)[0] +
                                    ((npy_byte *)data_out + 2*4)[0];
            ((npy_byte *)data_out + 2*4)[1] =
                                    ((npy_byte *)data0 + 2*4)[1] +
                                    ((npy_byte *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_byte *)data_out + 2*3)[0] =
                                    ((npy_byte *)data0 + 2*3)[0] +
                                    ((npy_byte *)data_out + 2*3)[0];
            ((npy_byte *)data_out + 2*3)[1] =
                                    ((npy_byte *)data0 + 2*3)[1] +
                                    ((npy_byte *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_byte *)data_out + 2*2)[0] =
                                    ((npy_byte *)data0 + 2*2)[0] +
                                    ((npy_byte *)data_out + 2*2)[0];
            ((npy_byte *)data_out + 2*2)[1] =
                                    ((npy_byte *)data0 + 2*2)[1] +
                                    ((npy_byte *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_byte *)data_out + 2*1)[0] =
                                    ((npy_byte *)data0 + 2*1)[0] +
                                    ((npy_byte *)data_out + 2*1)[0];
            ((npy_byte *)data_out + 2*1)[1] =
                                    ((npy_byte *)data0 + 2*1)[1] +
                                    ((npy_byte *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_byte *)data_out + 2*0)[0] =
                                    ((npy_byte *)data0 + 2*0)[0] +
                                    ((npy_byte *)data_out + 2*0)[0];
            ((npy_byte *)data_out + 2*0)[1] =
                                    ((npy_byte *)data0 + 2*0)[1] +
                                    ((npy_byte *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_byte *)data_out + 2*0)[0] =
                                ((npy_byte *)data0 + 2*0)[0] +
                                ((npy_byte *)data_out + 2*0)[0];
        ((npy_byte *)data_out + 2*0)[1] =
                                ((npy_byte *)data0 + 2*0)[1] +
                                ((npy_byte *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_byte *)data_out + 2*1)[0] =
                                ((npy_byte *)data0 + 2*1)[0] +
                                ((npy_byte *)data_out + 2*1)[0];
        ((npy_byte *)data_out + 2*1)[1] =
                                ((npy_byte *)data0 + 2*1)[1] +
                                ((npy_byte *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_byte *)data_out + 2*2)[0] =
                                ((npy_byte *)data0 + 2*2)[0] +
                                ((npy_byte *)data_out + 2*2)[0];
        ((npy_byte *)data_out + 2*2)[1] =
                                ((npy_byte *)data0 + 2*2)[1] +
                                ((npy_byte *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_byte *)data_out + 2*3)[0] =
                                ((npy_byte *)data0 + 2*3)[0] +
                                ((npy_byte *)data_out + 2*3)[0];
        ((npy_byte *)data_out + 2*3)[1] =
                                ((npy_byte *)data0 + 2*3)[1] +
                                ((npy_byte *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_byte *)data_out + 2*4)[0] =
                                ((npy_byte *)data0 + 2*4)[0] +
                                ((npy_byte *)data_out + 2*4)[0];
        ((npy_byte *)data_out + 2*4)[1] =
                                ((npy_byte *)data0 + 2*4)[1] +
                                ((npy_byte *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_byte *)data_out + 2*5)[0] =
                                ((npy_byte *)data0 + 2*5)[0] +
                                ((npy_byte *)data_out + 2*5)[0];
        ((npy_byte *)data_out + 2*5)[1] =
                                ((npy_byte *)data0 + 2*5)[1] +
                                ((npy_byte *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_byte *)data_out + 2*6)[0] =
                                ((npy_byte *)data0 + 2*6)[0] +
                                ((npy_byte *)data_out + 2*6)[0];
        ((npy_byte *)data_out + 2*6)[1] =
                                ((npy_byte *)data0 + 2*6)[1] +
                                ((npy_byte *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_byte *)data_out + 2*7)[0] =
                                ((npy_byte *)data0 + 2*7)[0] +
                                ((npy_byte *)data_out + 2*7)[0];
        ((npy_byte *)data_out + 2*7)[1] =
                                ((npy_byte *)data0 + 2*7)[1] +
                                ((npy_byte *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
byte_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
byte_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte value0 = (*(npy_byte *)dataptr[0]);
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
byte_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte value1 = (*(npy_byte *)dataptr[1]);
    npy_byte *data_out = (npy_byte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte value0 = (*(npy_byte *)dataptr[0]);
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
byte_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte value1 = (*(npy_byte *)dataptr[1]);
    npy_byte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_byte *)dataptr[2] = ((*(npy_byte *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
byte_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_byte *data0 = (npy_byte *)dataptr[0];
    npy_byte *data1 = (npy_byte *)dataptr[1];
    npy_byte *data2 = (npy_byte *)dataptr[2];
    npy_byte *data_out = (npy_byte *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
byte_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        *(npy_byte *)dataptr[nop] = (temp +
                                           (*(npy_byte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_byte);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_byte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_byte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_byte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_byte);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
byte_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_byte accum_re = 0, accum_im = 0;
    npy_byte *data0 = (npy_byte *)dataptr[0];
#else
    npy_byte accum = 0;
    npy_byte *data0 = (npy_byte *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_byte *)dataptr[1])[0] += accum_re;
            ((npy_byte *)dataptr[1])[1] += accum_im;
#else
            *((npy_byte *)dataptr[1]) = (accum +
                                    (*((npy_byte *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
byte_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_byte accum_re = 0, accum_im = 0;
#else
    npy_byte accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("byte_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_byte *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_byte *)data0) *
                 (*(npy_byte *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_byte *)data0) *
                 (*(npy_byte *)data1) *
                 (*(npy_byte *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_byte temp = (*(npy_byte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_byte *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_byte *)data0)[0];
        accum_im += ((npy_byte *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_byte re, im, tmp;
        int i;
        re = ((npy_byte *)dataptr[0])[0];
        im = ((npy_byte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_byte *)dataptr[i])[0] -
                  im * ((npy_byte *)dataptr[i])[1];
            im = re * ((npy_byte *)dataptr[i])[1] +
                 im * ((npy_byte *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_byte *)dataptr[1000])[0] += accum_re;
    ((npy_byte *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_byte *)dataptr[nop])[0] += accum_re;
    ((npy_byte *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_byte *)dataptr[1000]) = (accum +
                                    (*((npy_byte *)dataptr[1000])));
#  else
    *((npy_byte *)dataptr[nop]) = (accum +
                                    (*((npy_byte *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
short_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_short *)data_out = ((*(npy_short *)data0) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_short *)data_out = ((*(npy_short *)data0) *
                                         (*(npy_short *)data1) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_short *)data_out = ((*(npy_short *)data0) *
                                         (*(npy_short *)data1) *
                                         (*(npy_short *)data2) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        *(npy_short *)dataptr[nop] = (temp +
                                           (*(npy_short *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_short *)data_out)[0] = ((npy_short *)data0)[0] +
                                         ((npy_short *)data_out)[0];
        ((npy_short *)data_out)[1] = ((npy_short *)data0)[1] +
                                         ((npy_short *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_short *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[0];
        ((npy_short *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
short_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data_out = (npy_short *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_short *)data_out + 2*6)[0] =
                                    ((npy_short *)data0 + 2*6)[0] +
                                    ((npy_short *)data_out + 2*6)[0];
            ((npy_short *)data_out + 2*6)[1] =
                                    ((npy_short *)data0 + 2*6)[1] +
                                    ((npy_short *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_short *)data_out + 2*5)[0] =
                                    ((npy_short *)data0 + 2*5)[0] +
                                    ((npy_short *)data_out + 2*5)[0];
            ((npy_short *)data_out + 2*5)[1] =
                                    ((npy_short *)data0 + 2*5)[1] +
                                    ((npy_short *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_short *)data_out + 2*4)[0] =
                                    ((npy_short *)data0 + 2*4)[0] +
                                    ((npy_short *)data_out + 2*4)[0];
            ((npy_short *)data_out + 2*4)[1] =
                                    ((npy_short *)data0 + 2*4)[1] +
                                    ((npy_short *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_short *)data_out + 2*3)[0] =
                                    ((npy_short *)data0 + 2*3)[0] +
                                    ((npy_short *)data_out + 2*3)[0];
            ((npy_short *)data_out + 2*3)[1] =
                                    ((npy_short *)data0 + 2*3)[1] +
                                    ((npy_short *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_short *)data_out + 2*2)[0] =
                                    ((npy_short *)data0 + 2*2)[0] +
                                    ((npy_short *)data_out + 2*2)[0];
            ((npy_short *)data_out + 2*2)[1] =
                                    ((npy_short *)data0 + 2*2)[1] +
                                    ((npy_short *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_short *)data_out + 2*1)[0] =
                                    ((npy_short *)data0 + 2*1)[0] +
                                    ((npy_short *)data_out + 2*1)[0];
            ((npy_short *)data_out + 2*1)[1] =
                                    ((npy_short *)data0 + 2*1)[1] +
                                    ((npy_short *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_short *)data_out + 2*0)[0] =
                                    ((npy_short *)data0 + 2*0)[0] +
                                    ((npy_short *)data_out + 2*0)[0];
            ((npy_short *)data_out + 2*0)[1] =
                                    ((npy_short *)data0 + 2*0)[1] +
                                    ((npy_short *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_short *)data_out + 2*0)[0] =
                                ((npy_short *)data0 + 2*0)[0] +
                                ((npy_short *)data_out + 2*0)[0];
        ((npy_short *)data_out + 2*0)[1] =
                                ((npy_short *)data0 + 2*0)[1] +
                                ((npy_short *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_short *)data_out + 2*1)[0] =
                                ((npy_short *)data0 + 2*1)[0] +
                                ((npy_short *)data_out + 2*1)[0];
        ((npy_short *)data_out + 2*1)[1] =
                                ((npy_short *)data0 + 2*1)[1] +
                                ((npy_short *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_short *)data_out + 2*2)[0] =
                                ((npy_short *)data0 + 2*2)[0] +
                                ((npy_short *)data_out + 2*2)[0];
        ((npy_short *)data_out + 2*2)[1] =
                                ((npy_short *)data0 + 2*2)[1] +
                                ((npy_short *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_short *)data_out + 2*3)[0] =
                                ((npy_short *)data0 + 2*3)[0] +
                                ((npy_short *)data_out + 2*3)[0];
        ((npy_short *)data_out + 2*3)[1] =
                                ((npy_short *)data0 + 2*3)[1] +
                                ((npy_short *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_short *)data_out + 2*4)[0] =
                                ((npy_short *)data0 + 2*4)[0] +
                                ((npy_short *)data_out + 2*4)[0];
        ((npy_short *)data_out + 2*4)[1] =
                                ((npy_short *)data0 + 2*4)[1] +
                                ((npy_short *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_short *)data_out + 2*5)[0] =
                                ((npy_short *)data0 + 2*5)[0] +
                                ((npy_short *)data_out + 2*5)[0];
        ((npy_short *)data_out + 2*5)[1] =
                                ((npy_short *)data0 + 2*5)[1] +
                                ((npy_short *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_short *)data_out + 2*6)[0] =
                                ((npy_short *)data0 + 2*6)[0] +
                                ((npy_short *)data_out + 2*6)[0];
        ((npy_short *)data_out + 2*6)[1] =
                                ((npy_short *)data0 + 2*6)[1] +
                                ((npy_short *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_short *)data_out + 2*7)[0] =
                                ((npy_short *)data0 + 2*7)[0] +
                                ((npy_short *)data_out + 2*7)[0];
        ((npy_short *)data_out + 2*7)[1] =
                                ((npy_short *)data0 + 2*7)[1] +
                                ((npy_short *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
short_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
short_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short value0 = (*(npy_short *)dataptr[0]);
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
short_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short value1 = (*(npy_short *)dataptr[1]);
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short value0 = (*(npy_short *)dataptr[0]);
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short value1 = (*(npy_short *)dataptr[1]);
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
short_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data2 = (npy_short *)dataptr[2];
    npy_short *data_out = (npy_short *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
short_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        *(npy_short *)dataptr[nop] = (temp +
                                           (*(npy_short *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_short);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_short *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[0];
        ((npy_short *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_short);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
short_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_short accum_re = 0, accum_im = 0;
    npy_short *data0 = (npy_short *)dataptr[0];
#else
    npy_short accum = 0;
    npy_short *data0 = (npy_short *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_short *)dataptr[1])[0] += accum_re;
            ((npy_short *)dataptr[1])[1] += accum_im;
#else
            *((npy_short *)dataptr[1]) = (accum +
                                    (*((npy_short *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
short_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_short accum_re = 0, accum_im = 0;
#else
    npy_short accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_short *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_short *)data0) *
                 (*(npy_short *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_short *)data0) *
                 (*(npy_short *)data1) *
                 (*(npy_short *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_short *)data0)[0];
        accum_im += ((npy_short *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_short *)dataptr[1])[0] += accum_re;
    ((npy_short *)dataptr[1])[1] += accum_im;
#  else
    ((npy_short *)dataptr[nop])[0] += accum_re;
    ((npy_short *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_short *)dataptr[1]) = (accum +
                                    (*((npy_short *)dataptr[1])));
#  else
    *((npy_short *)dataptr[nop]) = (accum +
                                    (*((npy_short *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
short_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_short *)data_out = ((*(npy_short *)data0) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_short *)data_out = ((*(npy_short *)data0) *
                                         (*(npy_short *)data1) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_short *)data_out = ((*(npy_short *)data0) *
                                         (*(npy_short *)data1) *
                                         (*(npy_short *)data2) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        *(npy_short *)dataptr[nop] = (temp +
                                           (*(npy_short *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_short *)data_out)[0] = ((npy_short *)data0)[0] +
                                         ((npy_short *)data_out)[0];
        ((npy_short *)data_out)[1] = ((npy_short *)data0)[1] +
                                         ((npy_short *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_short *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[0];
        ((npy_short *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
short_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data_out = (npy_short *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_short *)data_out + 2*6)[0] =
                                    ((npy_short *)data0 + 2*6)[0] +
                                    ((npy_short *)data_out + 2*6)[0];
            ((npy_short *)data_out + 2*6)[1] =
                                    ((npy_short *)data0 + 2*6)[1] +
                                    ((npy_short *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_short *)data_out + 2*5)[0] =
                                    ((npy_short *)data0 + 2*5)[0] +
                                    ((npy_short *)data_out + 2*5)[0];
            ((npy_short *)data_out + 2*5)[1] =
                                    ((npy_short *)data0 + 2*5)[1] +
                                    ((npy_short *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_short *)data_out + 2*4)[0] =
                                    ((npy_short *)data0 + 2*4)[0] +
                                    ((npy_short *)data_out + 2*4)[0];
            ((npy_short *)data_out + 2*4)[1] =
                                    ((npy_short *)data0 + 2*4)[1] +
                                    ((npy_short *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_short *)data_out + 2*3)[0] =
                                    ((npy_short *)data0 + 2*3)[0] +
                                    ((npy_short *)data_out + 2*3)[0];
            ((npy_short *)data_out + 2*3)[1] =
                                    ((npy_short *)data0 + 2*3)[1] +
                                    ((npy_short *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_short *)data_out + 2*2)[0] =
                                    ((npy_short *)data0 + 2*2)[0] +
                                    ((npy_short *)data_out + 2*2)[0];
            ((npy_short *)data_out + 2*2)[1] =
                                    ((npy_short *)data0 + 2*2)[1] +
                                    ((npy_short *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_short *)data_out + 2*1)[0] =
                                    ((npy_short *)data0 + 2*1)[0] +
                                    ((npy_short *)data_out + 2*1)[0];
            ((npy_short *)data_out + 2*1)[1] =
                                    ((npy_short *)data0 + 2*1)[1] +
                                    ((npy_short *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_short *)data_out + 2*0)[0] =
                                    ((npy_short *)data0 + 2*0)[0] +
                                    ((npy_short *)data_out + 2*0)[0];
            ((npy_short *)data_out + 2*0)[1] =
                                    ((npy_short *)data0 + 2*0)[1] +
                                    ((npy_short *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_short *)data_out + 2*0)[0] =
                                ((npy_short *)data0 + 2*0)[0] +
                                ((npy_short *)data_out + 2*0)[0];
        ((npy_short *)data_out + 2*0)[1] =
                                ((npy_short *)data0 + 2*0)[1] +
                                ((npy_short *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_short *)data_out + 2*1)[0] =
                                ((npy_short *)data0 + 2*1)[0] +
                                ((npy_short *)data_out + 2*1)[0];
        ((npy_short *)data_out + 2*1)[1] =
                                ((npy_short *)data0 + 2*1)[1] +
                                ((npy_short *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_short *)data_out + 2*2)[0] =
                                ((npy_short *)data0 + 2*2)[0] +
                                ((npy_short *)data_out + 2*2)[0];
        ((npy_short *)data_out + 2*2)[1] =
                                ((npy_short *)data0 + 2*2)[1] +
                                ((npy_short *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_short *)data_out + 2*3)[0] =
                                ((npy_short *)data0 + 2*3)[0] +
                                ((npy_short *)data_out + 2*3)[0];
        ((npy_short *)data_out + 2*3)[1] =
                                ((npy_short *)data0 + 2*3)[1] +
                                ((npy_short *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_short *)data_out + 2*4)[0] =
                                ((npy_short *)data0 + 2*4)[0] +
                                ((npy_short *)data_out + 2*4)[0];
        ((npy_short *)data_out + 2*4)[1] =
                                ((npy_short *)data0 + 2*4)[1] +
                                ((npy_short *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_short *)data_out + 2*5)[0] =
                                ((npy_short *)data0 + 2*5)[0] +
                                ((npy_short *)data_out + 2*5)[0];
        ((npy_short *)data_out + 2*5)[1] =
                                ((npy_short *)data0 + 2*5)[1] +
                                ((npy_short *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_short *)data_out + 2*6)[0] =
                                ((npy_short *)data0 + 2*6)[0] +
                                ((npy_short *)data_out + 2*6)[0];
        ((npy_short *)data_out + 2*6)[1] =
                                ((npy_short *)data0 + 2*6)[1] +
                                ((npy_short *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_short *)data_out + 2*7)[0] =
                                ((npy_short *)data0 + 2*7)[0] +
                                ((npy_short *)data_out + 2*7)[0];
        ((npy_short *)data_out + 2*7)[1] =
                                ((npy_short *)data0 + 2*7)[1] +
                                ((npy_short *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
short_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
short_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short value0 = (*(npy_short *)dataptr[0]);
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
short_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short value1 = (*(npy_short *)dataptr[1]);
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short value0 = (*(npy_short *)dataptr[0]);
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short value1 = (*(npy_short *)dataptr[1]);
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
short_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data2 = (npy_short *)dataptr[2];
    npy_short *data_out = (npy_short *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
short_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        *(npy_short *)dataptr[nop] = (temp +
                                           (*(npy_short *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_short);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_short *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[0];
        ((npy_short *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_short);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
short_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_short accum_re = 0, accum_im = 0;
    npy_short *data0 = (npy_short *)dataptr[0];
#else
    npy_short accum = 0;
    npy_short *data0 = (npy_short *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_short *)dataptr[1])[0] += accum_re;
            ((npy_short *)dataptr[1])[1] += accum_im;
#else
            *((npy_short *)dataptr[1]) = (accum +
                                    (*((npy_short *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
short_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_short accum_re = 0, accum_im = 0;
#else
    npy_short accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_short *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_short *)data0) *
                 (*(npy_short *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_short *)data0) *
                 (*(npy_short *)data1) *
                 (*(npy_short *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_short *)data0)[0];
        accum_im += ((npy_short *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_short *)dataptr[2])[0] += accum_re;
    ((npy_short *)dataptr[2])[1] += accum_im;
#  else
    ((npy_short *)dataptr[nop])[0] += accum_re;
    ((npy_short *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_short *)dataptr[2]) = (accum +
                                    (*((npy_short *)dataptr[2])));
#  else
    *((npy_short *)dataptr[nop]) = (accum +
                                    (*((npy_short *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
short_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_short *)data_out = ((*(npy_short *)data0) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_short *)data_out = ((*(npy_short *)data0) *
                                         (*(npy_short *)data1) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_short *)data_out = ((*(npy_short *)data0) *
                                         (*(npy_short *)data1) *
                                         (*(npy_short *)data2) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        *(npy_short *)dataptr[nop] = (temp +
                                           (*(npy_short *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_short *)data_out)[0] = ((npy_short *)data0)[0] +
                                         ((npy_short *)data_out)[0];
        ((npy_short *)data_out)[1] = ((npy_short *)data0)[1] +
                                         ((npy_short *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_short *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[0];
        ((npy_short *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
short_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data_out = (npy_short *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_short *)data_out + 2*6)[0] =
                                    ((npy_short *)data0 + 2*6)[0] +
                                    ((npy_short *)data_out + 2*6)[0];
            ((npy_short *)data_out + 2*6)[1] =
                                    ((npy_short *)data0 + 2*6)[1] +
                                    ((npy_short *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_short *)data_out + 2*5)[0] =
                                    ((npy_short *)data0 + 2*5)[0] +
                                    ((npy_short *)data_out + 2*5)[0];
            ((npy_short *)data_out + 2*5)[1] =
                                    ((npy_short *)data0 + 2*5)[1] +
                                    ((npy_short *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_short *)data_out + 2*4)[0] =
                                    ((npy_short *)data0 + 2*4)[0] +
                                    ((npy_short *)data_out + 2*4)[0];
            ((npy_short *)data_out + 2*4)[1] =
                                    ((npy_short *)data0 + 2*4)[1] +
                                    ((npy_short *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_short *)data_out + 2*3)[0] =
                                    ((npy_short *)data0 + 2*3)[0] +
                                    ((npy_short *)data_out + 2*3)[0];
            ((npy_short *)data_out + 2*3)[1] =
                                    ((npy_short *)data0 + 2*3)[1] +
                                    ((npy_short *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_short *)data_out + 2*2)[0] =
                                    ((npy_short *)data0 + 2*2)[0] +
                                    ((npy_short *)data_out + 2*2)[0];
            ((npy_short *)data_out + 2*2)[1] =
                                    ((npy_short *)data0 + 2*2)[1] +
                                    ((npy_short *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_short *)data_out + 2*1)[0] =
                                    ((npy_short *)data0 + 2*1)[0] +
                                    ((npy_short *)data_out + 2*1)[0];
            ((npy_short *)data_out + 2*1)[1] =
                                    ((npy_short *)data0 + 2*1)[1] +
                                    ((npy_short *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_short *)data_out + 2*0)[0] =
                                    ((npy_short *)data0 + 2*0)[0] +
                                    ((npy_short *)data_out + 2*0)[0];
            ((npy_short *)data_out + 2*0)[1] =
                                    ((npy_short *)data0 + 2*0)[1] +
                                    ((npy_short *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_short *)data_out + 2*0)[0] =
                                ((npy_short *)data0 + 2*0)[0] +
                                ((npy_short *)data_out + 2*0)[0];
        ((npy_short *)data_out + 2*0)[1] =
                                ((npy_short *)data0 + 2*0)[1] +
                                ((npy_short *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_short *)data_out + 2*1)[0] =
                                ((npy_short *)data0 + 2*1)[0] +
                                ((npy_short *)data_out + 2*1)[0];
        ((npy_short *)data_out + 2*1)[1] =
                                ((npy_short *)data0 + 2*1)[1] +
                                ((npy_short *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_short *)data_out + 2*2)[0] =
                                ((npy_short *)data0 + 2*2)[0] +
                                ((npy_short *)data_out + 2*2)[0];
        ((npy_short *)data_out + 2*2)[1] =
                                ((npy_short *)data0 + 2*2)[1] +
                                ((npy_short *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_short *)data_out + 2*3)[0] =
                                ((npy_short *)data0 + 2*3)[0] +
                                ((npy_short *)data_out + 2*3)[0];
        ((npy_short *)data_out + 2*3)[1] =
                                ((npy_short *)data0 + 2*3)[1] +
                                ((npy_short *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_short *)data_out + 2*4)[0] =
                                ((npy_short *)data0 + 2*4)[0] +
                                ((npy_short *)data_out + 2*4)[0];
        ((npy_short *)data_out + 2*4)[1] =
                                ((npy_short *)data0 + 2*4)[1] +
                                ((npy_short *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_short *)data_out + 2*5)[0] =
                                ((npy_short *)data0 + 2*5)[0] +
                                ((npy_short *)data_out + 2*5)[0];
        ((npy_short *)data_out + 2*5)[1] =
                                ((npy_short *)data0 + 2*5)[1] +
                                ((npy_short *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_short *)data_out + 2*6)[0] =
                                ((npy_short *)data0 + 2*6)[0] +
                                ((npy_short *)data_out + 2*6)[0];
        ((npy_short *)data_out + 2*6)[1] =
                                ((npy_short *)data0 + 2*6)[1] +
                                ((npy_short *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_short *)data_out + 2*7)[0] =
                                ((npy_short *)data0 + 2*7)[0] +
                                ((npy_short *)data_out + 2*7)[0];
        ((npy_short *)data_out + 2*7)[1] =
                                ((npy_short *)data0 + 2*7)[1] +
                                ((npy_short *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
short_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
short_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short value0 = (*(npy_short *)dataptr[0]);
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
short_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short value1 = (*(npy_short *)dataptr[1]);
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short value0 = (*(npy_short *)dataptr[0]);
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short value1 = (*(npy_short *)dataptr[1]);
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
short_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data2 = (npy_short *)dataptr[2];
    npy_short *data_out = (npy_short *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
short_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        *(npy_short *)dataptr[nop] = (temp +
                                           (*(npy_short *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_short);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_short *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[0];
        ((npy_short *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_short);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
short_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_short accum_re = 0, accum_im = 0;
    npy_short *data0 = (npy_short *)dataptr[0];
#else
    npy_short accum = 0;
    npy_short *data0 = (npy_short *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_short *)dataptr[1])[0] += accum_re;
            ((npy_short *)dataptr[1])[1] += accum_im;
#else
            *((npy_short *)dataptr[1]) = (accum +
                                    (*((npy_short *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
short_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_short accum_re = 0, accum_im = 0;
#else
    npy_short accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_short *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_short *)data0) *
                 (*(npy_short *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_short *)data0) *
                 (*(npy_short *)data1) *
                 (*(npy_short *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_short *)data0)[0];
        accum_im += ((npy_short *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_short *)dataptr[3])[0] += accum_re;
    ((npy_short *)dataptr[3])[1] += accum_im;
#  else
    ((npy_short *)dataptr[nop])[0] += accum_re;
    ((npy_short *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_short *)dataptr[3]) = (accum +
                                    (*((npy_short *)dataptr[3])));
#  else
    *((npy_short *)dataptr[nop]) = (accum +
                                    (*((npy_short *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
short_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_short *)data_out = ((*(npy_short *)data0) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_short *)data_out = ((*(npy_short *)data0) *
                                         (*(npy_short *)data1) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_short *)data_out = ((*(npy_short *)data0) *
                                         (*(npy_short *)data1) *
                                         (*(npy_short *)data2) +
                                         (*(npy_short *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        *(npy_short *)dataptr[nop] = (temp +
                                           (*(npy_short *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_short *)data_out)[0] = ((npy_short *)data0)[0] +
                                         ((npy_short *)data_out)[0];
        ((npy_short *)data_out)[1] = ((npy_short *)data0)[1] +
                                         ((npy_short *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_short *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[0];
        ((npy_short *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
short_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data_out = (npy_short *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_short *)data_out + 2*6)[0] =
                                    ((npy_short *)data0 + 2*6)[0] +
                                    ((npy_short *)data_out + 2*6)[0];
            ((npy_short *)data_out + 2*6)[1] =
                                    ((npy_short *)data0 + 2*6)[1] +
                                    ((npy_short *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_short *)data_out + 2*5)[0] =
                                    ((npy_short *)data0 + 2*5)[0] +
                                    ((npy_short *)data_out + 2*5)[0];
            ((npy_short *)data_out + 2*5)[1] =
                                    ((npy_short *)data0 + 2*5)[1] +
                                    ((npy_short *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_short *)data_out + 2*4)[0] =
                                    ((npy_short *)data0 + 2*4)[0] +
                                    ((npy_short *)data_out + 2*4)[0];
            ((npy_short *)data_out + 2*4)[1] =
                                    ((npy_short *)data0 + 2*4)[1] +
                                    ((npy_short *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_short *)data_out + 2*3)[0] =
                                    ((npy_short *)data0 + 2*3)[0] +
                                    ((npy_short *)data_out + 2*3)[0];
            ((npy_short *)data_out + 2*3)[1] =
                                    ((npy_short *)data0 + 2*3)[1] +
                                    ((npy_short *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_short *)data_out + 2*2)[0] =
                                    ((npy_short *)data0 + 2*2)[0] +
                                    ((npy_short *)data_out + 2*2)[0];
            ((npy_short *)data_out + 2*2)[1] =
                                    ((npy_short *)data0 + 2*2)[1] +
                                    ((npy_short *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_short *)data_out + 2*1)[0] =
                                    ((npy_short *)data0 + 2*1)[0] +
                                    ((npy_short *)data_out + 2*1)[0];
            ((npy_short *)data_out + 2*1)[1] =
                                    ((npy_short *)data0 + 2*1)[1] +
                                    ((npy_short *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_short *)data_out + 2*0)[0] =
                                    ((npy_short *)data0 + 2*0)[0] +
                                    ((npy_short *)data_out + 2*0)[0];
            ((npy_short *)data_out + 2*0)[1] =
                                    ((npy_short *)data0 + 2*0)[1] +
                                    ((npy_short *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_short *)data_out + 2*0)[0] =
                                ((npy_short *)data0 + 2*0)[0] +
                                ((npy_short *)data_out + 2*0)[0];
        ((npy_short *)data_out + 2*0)[1] =
                                ((npy_short *)data0 + 2*0)[1] +
                                ((npy_short *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_short *)data_out + 2*1)[0] =
                                ((npy_short *)data0 + 2*1)[0] +
                                ((npy_short *)data_out + 2*1)[0];
        ((npy_short *)data_out + 2*1)[1] =
                                ((npy_short *)data0 + 2*1)[1] +
                                ((npy_short *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_short *)data_out + 2*2)[0] =
                                ((npy_short *)data0 + 2*2)[0] +
                                ((npy_short *)data_out + 2*2)[0];
        ((npy_short *)data_out + 2*2)[1] =
                                ((npy_short *)data0 + 2*2)[1] +
                                ((npy_short *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_short *)data_out + 2*3)[0] =
                                ((npy_short *)data0 + 2*3)[0] +
                                ((npy_short *)data_out + 2*3)[0];
        ((npy_short *)data_out + 2*3)[1] =
                                ((npy_short *)data0 + 2*3)[1] +
                                ((npy_short *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_short *)data_out + 2*4)[0] =
                                ((npy_short *)data0 + 2*4)[0] +
                                ((npy_short *)data_out + 2*4)[0];
        ((npy_short *)data_out + 2*4)[1] =
                                ((npy_short *)data0 + 2*4)[1] +
                                ((npy_short *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_short *)data_out + 2*5)[0] =
                                ((npy_short *)data0 + 2*5)[0] +
                                ((npy_short *)data_out + 2*5)[0];
        ((npy_short *)data_out + 2*5)[1] =
                                ((npy_short *)data0 + 2*5)[1] +
                                ((npy_short *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_short *)data_out + 2*6)[0] =
                                ((npy_short *)data0 + 2*6)[0] +
                                ((npy_short *)data_out + 2*6)[0];
        ((npy_short *)data_out + 2*6)[1] =
                                ((npy_short *)data0 + 2*6)[1] +
                                ((npy_short *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_short *)data_out + 2*7)[0] =
                                ((npy_short *)data0 + 2*7)[0] +
                                ((npy_short *)data_out + 2*7)[0];
        ((npy_short *)data_out + 2*7)[1] =
                                ((npy_short *)data0 + 2*7)[1] +
                                ((npy_short *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
short_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
short_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short value0 = (*(npy_short *)dataptr[0]);
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
short_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short value1 = (*(npy_short *)dataptr[1]);
    npy_short *data_out = (npy_short *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short value0 = (*(npy_short *)dataptr[0]);
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
short_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short value1 = (*(npy_short *)dataptr[1]);
    npy_short accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_short *)dataptr[2] = ((*(npy_short *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
short_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_short *data0 = (npy_short *)dataptr[0];
    npy_short *data1 = (npy_short *)dataptr[1];
    npy_short *data2 = (npy_short *)dataptr[2];
    npy_short *data_out = (npy_short *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
short_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        *(npy_short *)dataptr[nop] = (temp +
                                           (*(npy_short *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_short);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_short *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[0];
        ((npy_short *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_short *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_short);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
short_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_short accum_re = 0, accum_im = 0;
    npy_short *data0 = (npy_short *)dataptr[0];
#else
    npy_short accum = 0;
    npy_short *data0 = (npy_short *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_short *)dataptr[1])[0] += accum_re;
            ((npy_short *)dataptr[1])[1] += accum_im;
#else
            *((npy_short *)dataptr[1]) = (accum +
                                    (*((npy_short *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
short_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_short accum_re = 0, accum_im = 0;
#else
    npy_short accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("short_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_short *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_short *)data0) *
                 (*(npy_short *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_short *)data0) *
                 (*(npy_short *)data1) *
                 (*(npy_short *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_short temp = (*(npy_short *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_short *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_short *)data0)[0];
        accum_im += ((npy_short *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_short re, im, tmp;
        int i;
        re = ((npy_short *)dataptr[0])[0];
        im = ((npy_short *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_short *)dataptr[i])[0] -
                  im * ((npy_short *)dataptr[i])[1];
            im = re * ((npy_short *)dataptr[i])[1] +
                 im * ((npy_short *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_short *)dataptr[1000])[0] += accum_re;
    ((npy_short *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_short *)dataptr[nop])[0] += accum_re;
    ((npy_short *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_short *)dataptr[1000]) = (accum +
                                    (*((npy_short *)dataptr[1000])));
#  else
    *((npy_short *)dataptr[nop]) = (accum +
                                    (*((npy_short *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
int_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_int *)data_out = ((*(npy_int *)data0) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_int *)data_out = ((*(npy_int *)data0) *
                                         (*(npy_int *)data1) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_int *)data_out = ((*(npy_int *)data0) *
                                         (*(npy_int *)data1) *
                                         (*(npy_int *)data2) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        *(npy_int *)dataptr[nop] = (temp +
                                           (*(npy_int *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_int *)data_out)[0] = ((npy_int *)data0)[0] +
                                         ((npy_int *)data_out)[0];
        ((npy_int *)data_out)[1] = ((npy_int *)data0)[1] +
                                         ((npy_int *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_int *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[0];
        ((npy_int *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
int_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data_out = (npy_int *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_int *)data_out + 2*6)[0] =
                                    ((npy_int *)data0 + 2*6)[0] +
                                    ((npy_int *)data_out + 2*6)[0];
            ((npy_int *)data_out + 2*6)[1] =
                                    ((npy_int *)data0 + 2*6)[1] +
                                    ((npy_int *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_int *)data_out + 2*5)[0] =
                                    ((npy_int *)data0 + 2*5)[0] +
                                    ((npy_int *)data_out + 2*5)[0];
            ((npy_int *)data_out + 2*5)[1] =
                                    ((npy_int *)data0 + 2*5)[1] +
                                    ((npy_int *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_int *)data_out + 2*4)[0] =
                                    ((npy_int *)data0 + 2*4)[0] +
                                    ((npy_int *)data_out + 2*4)[0];
            ((npy_int *)data_out + 2*4)[1] =
                                    ((npy_int *)data0 + 2*4)[1] +
                                    ((npy_int *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_int *)data_out + 2*3)[0] =
                                    ((npy_int *)data0 + 2*3)[0] +
                                    ((npy_int *)data_out + 2*3)[0];
            ((npy_int *)data_out + 2*3)[1] =
                                    ((npy_int *)data0 + 2*3)[1] +
                                    ((npy_int *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_int *)data_out + 2*2)[0] =
                                    ((npy_int *)data0 + 2*2)[0] +
                                    ((npy_int *)data_out + 2*2)[0];
            ((npy_int *)data_out + 2*2)[1] =
                                    ((npy_int *)data0 + 2*2)[1] +
                                    ((npy_int *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_int *)data_out + 2*1)[0] =
                                    ((npy_int *)data0 + 2*1)[0] +
                                    ((npy_int *)data_out + 2*1)[0];
            ((npy_int *)data_out + 2*1)[1] =
                                    ((npy_int *)data0 + 2*1)[1] +
                                    ((npy_int *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_int *)data_out + 2*0)[0] =
                                    ((npy_int *)data0 + 2*0)[0] +
                                    ((npy_int *)data_out + 2*0)[0];
            ((npy_int *)data_out + 2*0)[1] =
                                    ((npy_int *)data0 + 2*0)[1] +
                                    ((npy_int *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_int *)data_out + 2*0)[0] =
                                ((npy_int *)data0 + 2*0)[0] +
                                ((npy_int *)data_out + 2*0)[0];
        ((npy_int *)data_out + 2*0)[1] =
                                ((npy_int *)data0 + 2*0)[1] +
                                ((npy_int *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_int *)data_out + 2*1)[0] =
                                ((npy_int *)data0 + 2*1)[0] +
                                ((npy_int *)data_out + 2*1)[0];
        ((npy_int *)data_out + 2*1)[1] =
                                ((npy_int *)data0 + 2*1)[1] +
                                ((npy_int *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_int *)data_out + 2*2)[0] =
                                ((npy_int *)data0 + 2*2)[0] +
                                ((npy_int *)data_out + 2*2)[0];
        ((npy_int *)data_out + 2*2)[1] =
                                ((npy_int *)data0 + 2*2)[1] +
                                ((npy_int *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_int *)data_out + 2*3)[0] =
                                ((npy_int *)data0 + 2*3)[0] +
                                ((npy_int *)data_out + 2*3)[0];
        ((npy_int *)data_out + 2*3)[1] =
                                ((npy_int *)data0 + 2*3)[1] +
                                ((npy_int *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_int *)data_out + 2*4)[0] =
                                ((npy_int *)data0 + 2*4)[0] +
                                ((npy_int *)data_out + 2*4)[0];
        ((npy_int *)data_out + 2*4)[1] =
                                ((npy_int *)data0 + 2*4)[1] +
                                ((npy_int *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_int *)data_out + 2*5)[0] =
                                ((npy_int *)data0 + 2*5)[0] +
                                ((npy_int *)data_out + 2*5)[0];
        ((npy_int *)data_out + 2*5)[1] =
                                ((npy_int *)data0 + 2*5)[1] +
                                ((npy_int *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_int *)data_out + 2*6)[0] =
                                ((npy_int *)data0 + 2*6)[0] +
                                ((npy_int *)data_out + 2*6)[0];
        ((npy_int *)data_out + 2*6)[1] =
                                ((npy_int *)data0 + 2*6)[1] +
                                ((npy_int *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_int *)data_out + 2*7)[0] =
                                ((npy_int *)data0 + 2*7)[0] +
                                ((npy_int *)data_out + 2*7)[0];
        ((npy_int *)data_out + 2*7)[1] =
                                ((npy_int *)data0 + 2*7)[1] +
                                ((npy_int *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
int_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
int_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int value0 = (*(npy_int *)dataptr[0]);
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
int_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int value1 = (*(npy_int *)dataptr[1]);
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int value0 = (*(npy_int *)dataptr[0]);
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int value1 = (*(npy_int *)dataptr[1]);
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
int_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data2 = (npy_int *)dataptr[2];
    npy_int *data_out = (npy_int *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
int_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        *(npy_int *)dataptr[nop] = (temp +
                                           (*(npy_int *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_int);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_int *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[0];
        ((npy_int *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_int);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
int_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_int accum_re = 0, accum_im = 0;
    npy_int *data0 = (npy_int *)dataptr[0];
#else
    npy_int accum = 0;
    npy_int *data0 = (npy_int *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_int *)dataptr[1])[0] += accum_re;
            ((npy_int *)dataptr[1])[1] += accum_im;
#else
            *((npy_int *)dataptr[1]) = (accum +
                                    (*((npy_int *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
int_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_int accum_re = 0, accum_im = 0;
#else
    npy_int accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_int *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_int *)data0) *
                 (*(npy_int *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_int *)data0) *
                 (*(npy_int *)data1) *
                 (*(npy_int *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_int *)data0)[0];
        accum_im += ((npy_int *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_int *)dataptr[1])[0] += accum_re;
    ((npy_int *)dataptr[1])[1] += accum_im;
#  else
    ((npy_int *)dataptr[nop])[0] += accum_re;
    ((npy_int *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_int *)dataptr[1]) = (accum +
                                    (*((npy_int *)dataptr[1])));
#  else
    *((npy_int *)dataptr[nop]) = (accum +
                                    (*((npy_int *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
int_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_int *)data_out = ((*(npy_int *)data0) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_int *)data_out = ((*(npy_int *)data0) *
                                         (*(npy_int *)data1) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_int *)data_out = ((*(npy_int *)data0) *
                                         (*(npy_int *)data1) *
                                         (*(npy_int *)data2) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        *(npy_int *)dataptr[nop] = (temp +
                                           (*(npy_int *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_int *)data_out)[0] = ((npy_int *)data0)[0] +
                                         ((npy_int *)data_out)[0];
        ((npy_int *)data_out)[1] = ((npy_int *)data0)[1] +
                                         ((npy_int *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_int *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[0];
        ((npy_int *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
int_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data_out = (npy_int *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_int *)data_out + 2*6)[0] =
                                    ((npy_int *)data0 + 2*6)[0] +
                                    ((npy_int *)data_out + 2*6)[0];
            ((npy_int *)data_out + 2*6)[1] =
                                    ((npy_int *)data0 + 2*6)[1] +
                                    ((npy_int *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_int *)data_out + 2*5)[0] =
                                    ((npy_int *)data0 + 2*5)[0] +
                                    ((npy_int *)data_out + 2*5)[0];
            ((npy_int *)data_out + 2*5)[1] =
                                    ((npy_int *)data0 + 2*5)[1] +
                                    ((npy_int *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_int *)data_out + 2*4)[0] =
                                    ((npy_int *)data0 + 2*4)[0] +
                                    ((npy_int *)data_out + 2*4)[0];
            ((npy_int *)data_out + 2*4)[1] =
                                    ((npy_int *)data0 + 2*4)[1] +
                                    ((npy_int *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_int *)data_out + 2*3)[0] =
                                    ((npy_int *)data0 + 2*3)[0] +
                                    ((npy_int *)data_out + 2*3)[0];
            ((npy_int *)data_out + 2*3)[1] =
                                    ((npy_int *)data0 + 2*3)[1] +
                                    ((npy_int *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_int *)data_out + 2*2)[0] =
                                    ((npy_int *)data0 + 2*2)[0] +
                                    ((npy_int *)data_out + 2*2)[0];
            ((npy_int *)data_out + 2*2)[1] =
                                    ((npy_int *)data0 + 2*2)[1] +
                                    ((npy_int *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_int *)data_out + 2*1)[0] =
                                    ((npy_int *)data0 + 2*1)[0] +
                                    ((npy_int *)data_out + 2*1)[0];
            ((npy_int *)data_out + 2*1)[1] =
                                    ((npy_int *)data0 + 2*1)[1] +
                                    ((npy_int *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_int *)data_out + 2*0)[0] =
                                    ((npy_int *)data0 + 2*0)[0] +
                                    ((npy_int *)data_out + 2*0)[0];
            ((npy_int *)data_out + 2*0)[1] =
                                    ((npy_int *)data0 + 2*0)[1] +
                                    ((npy_int *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_int *)data_out + 2*0)[0] =
                                ((npy_int *)data0 + 2*0)[0] +
                                ((npy_int *)data_out + 2*0)[0];
        ((npy_int *)data_out + 2*0)[1] =
                                ((npy_int *)data0 + 2*0)[1] +
                                ((npy_int *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_int *)data_out + 2*1)[0] =
                                ((npy_int *)data0 + 2*1)[0] +
                                ((npy_int *)data_out + 2*1)[0];
        ((npy_int *)data_out + 2*1)[1] =
                                ((npy_int *)data0 + 2*1)[1] +
                                ((npy_int *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_int *)data_out + 2*2)[0] =
                                ((npy_int *)data0 + 2*2)[0] +
                                ((npy_int *)data_out + 2*2)[0];
        ((npy_int *)data_out + 2*2)[1] =
                                ((npy_int *)data0 + 2*2)[1] +
                                ((npy_int *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_int *)data_out + 2*3)[0] =
                                ((npy_int *)data0 + 2*3)[0] +
                                ((npy_int *)data_out + 2*3)[0];
        ((npy_int *)data_out + 2*3)[1] =
                                ((npy_int *)data0 + 2*3)[1] +
                                ((npy_int *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_int *)data_out + 2*4)[0] =
                                ((npy_int *)data0 + 2*4)[0] +
                                ((npy_int *)data_out + 2*4)[0];
        ((npy_int *)data_out + 2*4)[1] =
                                ((npy_int *)data0 + 2*4)[1] +
                                ((npy_int *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_int *)data_out + 2*5)[0] =
                                ((npy_int *)data0 + 2*5)[0] +
                                ((npy_int *)data_out + 2*5)[0];
        ((npy_int *)data_out + 2*5)[1] =
                                ((npy_int *)data0 + 2*5)[1] +
                                ((npy_int *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_int *)data_out + 2*6)[0] =
                                ((npy_int *)data0 + 2*6)[0] +
                                ((npy_int *)data_out + 2*6)[0];
        ((npy_int *)data_out + 2*6)[1] =
                                ((npy_int *)data0 + 2*6)[1] +
                                ((npy_int *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_int *)data_out + 2*7)[0] =
                                ((npy_int *)data0 + 2*7)[0] +
                                ((npy_int *)data_out + 2*7)[0];
        ((npy_int *)data_out + 2*7)[1] =
                                ((npy_int *)data0 + 2*7)[1] +
                                ((npy_int *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
int_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
int_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int value0 = (*(npy_int *)dataptr[0]);
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
int_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int value1 = (*(npy_int *)dataptr[1]);
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int value0 = (*(npy_int *)dataptr[0]);
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int value1 = (*(npy_int *)dataptr[1]);
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
int_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data2 = (npy_int *)dataptr[2];
    npy_int *data_out = (npy_int *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
int_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        *(npy_int *)dataptr[nop] = (temp +
                                           (*(npy_int *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_int);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_int *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[0];
        ((npy_int *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_int);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
int_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_int accum_re = 0, accum_im = 0;
    npy_int *data0 = (npy_int *)dataptr[0];
#else
    npy_int accum = 0;
    npy_int *data0 = (npy_int *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_int *)dataptr[1])[0] += accum_re;
            ((npy_int *)dataptr[1])[1] += accum_im;
#else
            *((npy_int *)dataptr[1]) = (accum +
                                    (*((npy_int *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
int_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_int accum_re = 0, accum_im = 0;
#else
    npy_int accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_int *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_int *)data0) *
                 (*(npy_int *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_int *)data0) *
                 (*(npy_int *)data1) *
                 (*(npy_int *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_int *)data0)[0];
        accum_im += ((npy_int *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_int *)dataptr[2])[0] += accum_re;
    ((npy_int *)dataptr[2])[1] += accum_im;
#  else
    ((npy_int *)dataptr[nop])[0] += accum_re;
    ((npy_int *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_int *)dataptr[2]) = (accum +
                                    (*((npy_int *)dataptr[2])));
#  else
    *((npy_int *)dataptr[nop]) = (accum +
                                    (*((npy_int *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
int_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_int *)data_out = ((*(npy_int *)data0) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_int *)data_out = ((*(npy_int *)data0) *
                                         (*(npy_int *)data1) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_int *)data_out = ((*(npy_int *)data0) *
                                         (*(npy_int *)data1) *
                                         (*(npy_int *)data2) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        *(npy_int *)dataptr[nop] = (temp +
                                           (*(npy_int *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_int *)data_out)[0] = ((npy_int *)data0)[0] +
                                         ((npy_int *)data_out)[0];
        ((npy_int *)data_out)[1] = ((npy_int *)data0)[1] +
                                         ((npy_int *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_int *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[0];
        ((npy_int *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
int_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data_out = (npy_int *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_int *)data_out + 2*6)[0] =
                                    ((npy_int *)data0 + 2*6)[0] +
                                    ((npy_int *)data_out + 2*6)[0];
            ((npy_int *)data_out + 2*6)[1] =
                                    ((npy_int *)data0 + 2*6)[1] +
                                    ((npy_int *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_int *)data_out + 2*5)[0] =
                                    ((npy_int *)data0 + 2*5)[0] +
                                    ((npy_int *)data_out + 2*5)[0];
            ((npy_int *)data_out + 2*5)[1] =
                                    ((npy_int *)data0 + 2*5)[1] +
                                    ((npy_int *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_int *)data_out + 2*4)[0] =
                                    ((npy_int *)data0 + 2*4)[0] +
                                    ((npy_int *)data_out + 2*4)[0];
            ((npy_int *)data_out + 2*4)[1] =
                                    ((npy_int *)data0 + 2*4)[1] +
                                    ((npy_int *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_int *)data_out + 2*3)[0] =
                                    ((npy_int *)data0 + 2*3)[0] +
                                    ((npy_int *)data_out + 2*3)[0];
            ((npy_int *)data_out + 2*3)[1] =
                                    ((npy_int *)data0 + 2*3)[1] +
                                    ((npy_int *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_int *)data_out + 2*2)[0] =
                                    ((npy_int *)data0 + 2*2)[0] +
                                    ((npy_int *)data_out + 2*2)[0];
            ((npy_int *)data_out + 2*2)[1] =
                                    ((npy_int *)data0 + 2*2)[1] +
                                    ((npy_int *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_int *)data_out + 2*1)[0] =
                                    ((npy_int *)data0 + 2*1)[0] +
                                    ((npy_int *)data_out + 2*1)[0];
            ((npy_int *)data_out + 2*1)[1] =
                                    ((npy_int *)data0 + 2*1)[1] +
                                    ((npy_int *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_int *)data_out + 2*0)[0] =
                                    ((npy_int *)data0 + 2*0)[0] +
                                    ((npy_int *)data_out + 2*0)[0];
            ((npy_int *)data_out + 2*0)[1] =
                                    ((npy_int *)data0 + 2*0)[1] +
                                    ((npy_int *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_int *)data_out + 2*0)[0] =
                                ((npy_int *)data0 + 2*0)[0] +
                                ((npy_int *)data_out + 2*0)[0];
        ((npy_int *)data_out + 2*0)[1] =
                                ((npy_int *)data0 + 2*0)[1] +
                                ((npy_int *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_int *)data_out + 2*1)[0] =
                                ((npy_int *)data0 + 2*1)[0] +
                                ((npy_int *)data_out + 2*1)[0];
        ((npy_int *)data_out + 2*1)[1] =
                                ((npy_int *)data0 + 2*1)[1] +
                                ((npy_int *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_int *)data_out + 2*2)[0] =
                                ((npy_int *)data0 + 2*2)[0] +
                                ((npy_int *)data_out + 2*2)[0];
        ((npy_int *)data_out + 2*2)[1] =
                                ((npy_int *)data0 + 2*2)[1] +
                                ((npy_int *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_int *)data_out + 2*3)[0] =
                                ((npy_int *)data0 + 2*3)[0] +
                                ((npy_int *)data_out + 2*3)[0];
        ((npy_int *)data_out + 2*3)[1] =
                                ((npy_int *)data0 + 2*3)[1] +
                                ((npy_int *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_int *)data_out + 2*4)[0] =
                                ((npy_int *)data0 + 2*4)[0] +
                                ((npy_int *)data_out + 2*4)[0];
        ((npy_int *)data_out + 2*4)[1] =
                                ((npy_int *)data0 + 2*4)[1] +
                                ((npy_int *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_int *)data_out + 2*5)[0] =
                                ((npy_int *)data0 + 2*5)[0] +
                                ((npy_int *)data_out + 2*5)[0];
        ((npy_int *)data_out + 2*5)[1] =
                                ((npy_int *)data0 + 2*5)[1] +
                                ((npy_int *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_int *)data_out + 2*6)[0] =
                                ((npy_int *)data0 + 2*6)[0] +
                                ((npy_int *)data_out + 2*6)[0];
        ((npy_int *)data_out + 2*6)[1] =
                                ((npy_int *)data0 + 2*6)[1] +
                                ((npy_int *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_int *)data_out + 2*7)[0] =
                                ((npy_int *)data0 + 2*7)[0] +
                                ((npy_int *)data_out + 2*7)[0];
        ((npy_int *)data_out + 2*7)[1] =
                                ((npy_int *)data0 + 2*7)[1] +
                                ((npy_int *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
int_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
int_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int value0 = (*(npy_int *)dataptr[0]);
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
int_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int value1 = (*(npy_int *)dataptr[1]);
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int value0 = (*(npy_int *)dataptr[0]);
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int value1 = (*(npy_int *)dataptr[1]);
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
int_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data2 = (npy_int *)dataptr[2];
    npy_int *data_out = (npy_int *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
int_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        *(npy_int *)dataptr[nop] = (temp +
                                           (*(npy_int *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_int);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_int *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[0];
        ((npy_int *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_int);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
int_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_int accum_re = 0, accum_im = 0;
    npy_int *data0 = (npy_int *)dataptr[0];
#else
    npy_int accum = 0;
    npy_int *data0 = (npy_int *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_int *)dataptr[1])[0] += accum_re;
            ((npy_int *)dataptr[1])[1] += accum_im;
#else
            *((npy_int *)dataptr[1]) = (accum +
                                    (*((npy_int *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
int_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_int accum_re = 0, accum_im = 0;
#else
    npy_int accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_int *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_int *)data0) *
                 (*(npy_int *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_int *)data0) *
                 (*(npy_int *)data1) *
                 (*(npy_int *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_int *)data0)[0];
        accum_im += ((npy_int *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_int *)dataptr[3])[0] += accum_re;
    ((npy_int *)dataptr[3])[1] += accum_im;
#  else
    ((npy_int *)dataptr[nop])[0] += accum_re;
    ((npy_int *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_int *)dataptr[3]) = (accum +
                                    (*((npy_int *)dataptr[3])));
#  else
    *((npy_int *)dataptr[nop]) = (accum +
                                    (*((npy_int *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
int_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_int *)data_out = ((*(npy_int *)data0) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_int *)data_out = ((*(npy_int *)data0) *
                                         (*(npy_int *)data1) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_int *)data_out = ((*(npy_int *)data0) *
                                         (*(npy_int *)data1) *
                                         (*(npy_int *)data2) +
                                         (*(npy_int *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        *(npy_int *)dataptr[nop] = (temp +
                                           (*(npy_int *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_int *)data_out)[0] = ((npy_int *)data0)[0] +
                                         ((npy_int *)data_out)[0];
        ((npy_int *)data_out)[1] = ((npy_int *)data0)[1] +
                                         ((npy_int *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_int *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[0];
        ((npy_int *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
int_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data_out = (npy_int *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_int *)data_out + 2*6)[0] =
                                    ((npy_int *)data0 + 2*6)[0] +
                                    ((npy_int *)data_out + 2*6)[0];
            ((npy_int *)data_out + 2*6)[1] =
                                    ((npy_int *)data0 + 2*6)[1] +
                                    ((npy_int *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_int *)data_out + 2*5)[0] =
                                    ((npy_int *)data0 + 2*5)[0] +
                                    ((npy_int *)data_out + 2*5)[0];
            ((npy_int *)data_out + 2*5)[1] =
                                    ((npy_int *)data0 + 2*5)[1] +
                                    ((npy_int *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_int *)data_out + 2*4)[0] =
                                    ((npy_int *)data0 + 2*4)[0] +
                                    ((npy_int *)data_out + 2*4)[0];
            ((npy_int *)data_out + 2*4)[1] =
                                    ((npy_int *)data0 + 2*4)[1] +
                                    ((npy_int *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_int *)data_out + 2*3)[0] =
                                    ((npy_int *)data0 + 2*3)[0] +
                                    ((npy_int *)data_out + 2*3)[0];
            ((npy_int *)data_out + 2*3)[1] =
                                    ((npy_int *)data0 + 2*3)[1] +
                                    ((npy_int *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_int *)data_out + 2*2)[0] =
                                    ((npy_int *)data0 + 2*2)[0] +
                                    ((npy_int *)data_out + 2*2)[0];
            ((npy_int *)data_out + 2*2)[1] =
                                    ((npy_int *)data0 + 2*2)[1] +
                                    ((npy_int *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_int *)data_out + 2*1)[0] =
                                    ((npy_int *)data0 + 2*1)[0] +
                                    ((npy_int *)data_out + 2*1)[0];
            ((npy_int *)data_out + 2*1)[1] =
                                    ((npy_int *)data0 + 2*1)[1] +
                                    ((npy_int *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_int *)data_out + 2*0)[0] =
                                    ((npy_int *)data0 + 2*0)[0] +
                                    ((npy_int *)data_out + 2*0)[0];
            ((npy_int *)data_out + 2*0)[1] =
                                    ((npy_int *)data0 + 2*0)[1] +
                                    ((npy_int *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_int *)data_out + 2*0)[0] =
                                ((npy_int *)data0 + 2*0)[0] +
                                ((npy_int *)data_out + 2*0)[0];
        ((npy_int *)data_out + 2*0)[1] =
                                ((npy_int *)data0 + 2*0)[1] +
                                ((npy_int *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_int *)data_out + 2*1)[0] =
                                ((npy_int *)data0 + 2*1)[0] +
                                ((npy_int *)data_out + 2*1)[0];
        ((npy_int *)data_out + 2*1)[1] =
                                ((npy_int *)data0 + 2*1)[1] +
                                ((npy_int *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_int *)data_out + 2*2)[0] =
                                ((npy_int *)data0 + 2*2)[0] +
                                ((npy_int *)data_out + 2*2)[0];
        ((npy_int *)data_out + 2*2)[1] =
                                ((npy_int *)data0 + 2*2)[1] +
                                ((npy_int *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_int *)data_out + 2*3)[0] =
                                ((npy_int *)data0 + 2*3)[0] +
                                ((npy_int *)data_out + 2*3)[0];
        ((npy_int *)data_out + 2*3)[1] =
                                ((npy_int *)data0 + 2*3)[1] +
                                ((npy_int *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_int *)data_out + 2*4)[0] =
                                ((npy_int *)data0 + 2*4)[0] +
                                ((npy_int *)data_out + 2*4)[0];
        ((npy_int *)data_out + 2*4)[1] =
                                ((npy_int *)data0 + 2*4)[1] +
                                ((npy_int *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_int *)data_out + 2*5)[0] =
                                ((npy_int *)data0 + 2*5)[0] +
                                ((npy_int *)data_out + 2*5)[0];
        ((npy_int *)data_out + 2*5)[1] =
                                ((npy_int *)data0 + 2*5)[1] +
                                ((npy_int *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_int *)data_out + 2*6)[0] =
                                ((npy_int *)data0 + 2*6)[0] +
                                ((npy_int *)data_out + 2*6)[0];
        ((npy_int *)data_out + 2*6)[1] =
                                ((npy_int *)data0 + 2*6)[1] +
                                ((npy_int *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_int *)data_out + 2*7)[0] =
                                ((npy_int *)data0 + 2*7)[0] +
                                ((npy_int *)data_out + 2*7)[0];
        ((npy_int *)data_out + 2*7)[1] =
                                ((npy_int *)data0 + 2*7)[1] +
                                ((npy_int *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
int_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
int_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int value0 = (*(npy_int *)dataptr[0]);
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
int_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int value1 = (*(npy_int *)dataptr[1]);
    npy_int *data_out = (npy_int *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int value0 = (*(npy_int *)dataptr[0]);
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
int_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int value1 = (*(npy_int *)dataptr[1]);
    npy_int accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_int *)dataptr[2] = ((*(npy_int *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
int_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_int *data0 = (npy_int *)dataptr[0];
    npy_int *data1 = (npy_int *)dataptr[1];
    npy_int *data2 = (npy_int *)dataptr[2];
    npy_int *data_out = (npy_int *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
int_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        *(npy_int *)dataptr[nop] = (temp +
                                           (*(npy_int *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_int);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_int *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[0];
        ((npy_int *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_int *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_int);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
int_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_int accum_re = 0, accum_im = 0;
    npy_int *data0 = (npy_int *)dataptr[0];
#else
    npy_int accum = 0;
    npy_int *data0 = (npy_int *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_int *)dataptr[1])[0] += accum_re;
            ((npy_int *)dataptr[1])[1] += accum_im;
#else
            *((npy_int *)dataptr[1]) = (accum +
                                    (*((npy_int *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
int_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_int accum_re = 0, accum_im = 0;
#else
    npy_int accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("int_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_int *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_int *)data0) *
                 (*(npy_int *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_int *)data0) *
                 (*(npy_int *)data1) *
                 (*(npy_int *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_int temp = (*(npy_int *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_int *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_int *)data0)[0];
        accum_im += ((npy_int *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_int re, im, tmp;
        int i;
        re = ((npy_int *)dataptr[0])[0];
        im = ((npy_int *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_int *)dataptr[i])[0] -
                  im * ((npy_int *)dataptr[i])[1];
            im = re * ((npy_int *)dataptr[i])[1] +
                 im * ((npy_int *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_int *)dataptr[1000])[0] += accum_re;
    ((npy_int *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_int *)dataptr[nop])[0] += accum_re;
    ((npy_int *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_int *)dataptr[1000]) = (accum +
                                    (*((npy_int *)dataptr[1000])));
#  else
    *((npy_int *)dataptr[nop]) = (accum +
                                    (*((npy_int *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
long_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_long *)data_out = ((*(npy_long *)data0) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_long *)data_out = ((*(npy_long *)data0) *
                                         (*(npy_long *)data1) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_long *)data_out = ((*(npy_long *)data0) *
                                         (*(npy_long *)data1) *
                                         (*(npy_long *)data2) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        *(npy_long *)dataptr[nop] = (temp +
                                           (*(npy_long *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_long *)data_out)[0] = ((npy_long *)data0)[0] +
                                         ((npy_long *)data_out)[0];
        ((npy_long *)data_out)[1] = ((npy_long *)data0)[1] +
                                         ((npy_long *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_long *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[0];
        ((npy_long *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
long_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data_out = (npy_long *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_long *)data_out + 2*6)[0] =
                                    ((npy_long *)data0 + 2*6)[0] +
                                    ((npy_long *)data_out + 2*6)[0];
            ((npy_long *)data_out + 2*6)[1] =
                                    ((npy_long *)data0 + 2*6)[1] +
                                    ((npy_long *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_long *)data_out + 2*5)[0] =
                                    ((npy_long *)data0 + 2*5)[0] +
                                    ((npy_long *)data_out + 2*5)[0];
            ((npy_long *)data_out + 2*5)[1] =
                                    ((npy_long *)data0 + 2*5)[1] +
                                    ((npy_long *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_long *)data_out + 2*4)[0] =
                                    ((npy_long *)data0 + 2*4)[0] +
                                    ((npy_long *)data_out + 2*4)[0];
            ((npy_long *)data_out + 2*4)[1] =
                                    ((npy_long *)data0 + 2*4)[1] +
                                    ((npy_long *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_long *)data_out + 2*3)[0] =
                                    ((npy_long *)data0 + 2*3)[0] +
                                    ((npy_long *)data_out + 2*3)[0];
            ((npy_long *)data_out + 2*3)[1] =
                                    ((npy_long *)data0 + 2*3)[1] +
                                    ((npy_long *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_long *)data_out + 2*2)[0] =
                                    ((npy_long *)data0 + 2*2)[0] +
                                    ((npy_long *)data_out + 2*2)[0];
            ((npy_long *)data_out + 2*2)[1] =
                                    ((npy_long *)data0 + 2*2)[1] +
                                    ((npy_long *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_long *)data_out + 2*1)[0] =
                                    ((npy_long *)data0 + 2*1)[0] +
                                    ((npy_long *)data_out + 2*1)[0];
            ((npy_long *)data_out + 2*1)[1] =
                                    ((npy_long *)data0 + 2*1)[1] +
                                    ((npy_long *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_long *)data_out + 2*0)[0] =
                                    ((npy_long *)data0 + 2*0)[0] +
                                    ((npy_long *)data_out + 2*0)[0];
            ((npy_long *)data_out + 2*0)[1] =
                                    ((npy_long *)data0 + 2*0)[1] +
                                    ((npy_long *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_long *)data_out + 2*0)[0] =
                                ((npy_long *)data0 + 2*0)[0] +
                                ((npy_long *)data_out + 2*0)[0];
        ((npy_long *)data_out + 2*0)[1] =
                                ((npy_long *)data0 + 2*0)[1] +
                                ((npy_long *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_long *)data_out + 2*1)[0] =
                                ((npy_long *)data0 + 2*1)[0] +
                                ((npy_long *)data_out + 2*1)[0];
        ((npy_long *)data_out + 2*1)[1] =
                                ((npy_long *)data0 + 2*1)[1] +
                                ((npy_long *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_long *)data_out + 2*2)[0] =
                                ((npy_long *)data0 + 2*2)[0] +
                                ((npy_long *)data_out + 2*2)[0];
        ((npy_long *)data_out + 2*2)[1] =
                                ((npy_long *)data0 + 2*2)[1] +
                                ((npy_long *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_long *)data_out + 2*3)[0] =
                                ((npy_long *)data0 + 2*3)[0] +
                                ((npy_long *)data_out + 2*3)[0];
        ((npy_long *)data_out + 2*3)[1] =
                                ((npy_long *)data0 + 2*3)[1] +
                                ((npy_long *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_long *)data_out + 2*4)[0] =
                                ((npy_long *)data0 + 2*4)[0] +
                                ((npy_long *)data_out + 2*4)[0];
        ((npy_long *)data_out + 2*4)[1] =
                                ((npy_long *)data0 + 2*4)[1] +
                                ((npy_long *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_long *)data_out + 2*5)[0] =
                                ((npy_long *)data0 + 2*5)[0] +
                                ((npy_long *)data_out + 2*5)[0];
        ((npy_long *)data_out + 2*5)[1] =
                                ((npy_long *)data0 + 2*5)[1] +
                                ((npy_long *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_long *)data_out + 2*6)[0] =
                                ((npy_long *)data0 + 2*6)[0] +
                                ((npy_long *)data_out + 2*6)[0];
        ((npy_long *)data_out + 2*6)[1] =
                                ((npy_long *)data0 + 2*6)[1] +
                                ((npy_long *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_long *)data_out + 2*7)[0] =
                                ((npy_long *)data0 + 2*7)[0] +
                                ((npy_long *)data_out + 2*7)[0];
        ((npy_long *)data_out + 2*7)[1] =
                                ((npy_long *)data0 + 2*7)[1] +
                                ((npy_long *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
long_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
long_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long value0 = (*(npy_long *)dataptr[0]);
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
long_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long value1 = (*(npy_long *)dataptr[1]);
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long value0 = (*(npy_long *)dataptr[0]);
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long value1 = (*(npy_long *)dataptr[1]);
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
long_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data2 = (npy_long *)dataptr[2];
    npy_long *data_out = (npy_long *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
long_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        *(npy_long *)dataptr[nop] = (temp +
                                           (*(npy_long *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_long);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_long *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[0];
        ((npy_long *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_long);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
long_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_long accum_re = 0, accum_im = 0;
    npy_long *data0 = (npy_long *)dataptr[0];
#else
    npy_long accum = 0;
    npy_long *data0 = (npy_long *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_long *)dataptr[1])[0] += accum_re;
            ((npy_long *)dataptr[1])[1] += accum_im;
#else
            *((npy_long *)dataptr[1]) = (accum +
                                    (*((npy_long *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
long_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_long accum_re = 0, accum_im = 0;
#else
    npy_long accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_long *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_long *)data0) *
                 (*(npy_long *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_long *)data0) *
                 (*(npy_long *)data1) *
                 (*(npy_long *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_long *)data0)[0];
        accum_im += ((npy_long *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_long *)dataptr[1])[0] += accum_re;
    ((npy_long *)dataptr[1])[1] += accum_im;
#  else
    ((npy_long *)dataptr[nop])[0] += accum_re;
    ((npy_long *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_long *)dataptr[1]) = (accum +
                                    (*((npy_long *)dataptr[1])));
#  else
    *((npy_long *)dataptr[nop]) = (accum +
                                    (*((npy_long *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
long_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_long *)data_out = ((*(npy_long *)data0) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_long *)data_out = ((*(npy_long *)data0) *
                                         (*(npy_long *)data1) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_long *)data_out = ((*(npy_long *)data0) *
                                         (*(npy_long *)data1) *
                                         (*(npy_long *)data2) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        *(npy_long *)dataptr[nop] = (temp +
                                           (*(npy_long *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_long *)data_out)[0] = ((npy_long *)data0)[0] +
                                         ((npy_long *)data_out)[0];
        ((npy_long *)data_out)[1] = ((npy_long *)data0)[1] +
                                         ((npy_long *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_long *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[0];
        ((npy_long *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
long_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data_out = (npy_long *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_long *)data_out + 2*6)[0] =
                                    ((npy_long *)data0 + 2*6)[0] +
                                    ((npy_long *)data_out + 2*6)[0];
            ((npy_long *)data_out + 2*6)[1] =
                                    ((npy_long *)data0 + 2*6)[1] +
                                    ((npy_long *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_long *)data_out + 2*5)[0] =
                                    ((npy_long *)data0 + 2*5)[0] +
                                    ((npy_long *)data_out + 2*5)[0];
            ((npy_long *)data_out + 2*5)[1] =
                                    ((npy_long *)data0 + 2*5)[1] +
                                    ((npy_long *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_long *)data_out + 2*4)[0] =
                                    ((npy_long *)data0 + 2*4)[0] +
                                    ((npy_long *)data_out + 2*4)[0];
            ((npy_long *)data_out + 2*4)[1] =
                                    ((npy_long *)data0 + 2*4)[1] +
                                    ((npy_long *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_long *)data_out + 2*3)[0] =
                                    ((npy_long *)data0 + 2*3)[0] +
                                    ((npy_long *)data_out + 2*3)[0];
            ((npy_long *)data_out + 2*3)[1] =
                                    ((npy_long *)data0 + 2*3)[1] +
                                    ((npy_long *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_long *)data_out + 2*2)[0] =
                                    ((npy_long *)data0 + 2*2)[0] +
                                    ((npy_long *)data_out + 2*2)[0];
            ((npy_long *)data_out + 2*2)[1] =
                                    ((npy_long *)data0 + 2*2)[1] +
                                    ((npy_long *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_long *)data_out + 2*1)[0] =
                                    ((npy_long *)data0 + 2*1)[0] +
                                    ((npy_long *)data_out + 2*1)[0];
            ((npy_long *)data_out + 2*1)[1] =
                                    ((npy_long *)data0 + 2*1)[1] +
                                    ((npy_long *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_long *)data_out + 2*0)[0] =
                                    ((npy_long *)data0 + 2*0)[0] +
                                    ((npy_long *)data_out + 2*0)[0];
            ((npy_long *)data_out + 2*0)[1] =
                                    ((npy_long *)data0 + 2*0)[1] +
                                    ((npy_long *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_long *)data_out + 2*0)[0] =
                                ((npy_long *)data0 + 2*0)[0] +
                                ((npy_long *)data_out + 2*0)[0];
        ((npy_long *)data_out + 2*0)[1] =
                                ((npy_long *)data0 + 2*0)[1] +
                                ((npy_long *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_long *)data_out + 2*1)[0] =
                                ((npy_long *)data0 + 2*1)[0] +
                                ((npy_long *)data_out + 2*1)[0];
        ((npy_long *)data_out + 2*1)[1] =
                                ((npy_long *)data0 + 2*1)[1] +
                                ((npy_long *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_long *)data_out + 2*2)[0] =
                                ((npy_long *)data0 + 2*2)[0] +
                                ((npy_long *)data_out + 2*2)[0];
        ((npy_long *)data_out + 2*2)[1] =
                                ((npy_long *)data0 + 2*2)[1] +
                                ((npy_long *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_long *)data_out + 2*3)[0] =
                                ((npy_long *)data0 + 2*3)[0] +
                                ((npy_long *)data_out + 2*3)[0];
        ((npy_long *)data_out + 2*3)[1] =
                                ((npy_long *)data0 + 2*3)[1] +
                                ((npy_long *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_long *)data_out + 2*4)[0] =
                                ((npy_long *)data0 + 2*4)[0] +
                                ((npy_long *)data_out + 2*4)[0];
        ((npy_long *)data_out + 2*4)[1] =
                                ((npy_long *)data0 + 2*4)[1] +
                                ((npy_long *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_long *)data_out + 2*5)[0] =
                                ((npy_long *)data0 + 2*5)[0] +
                                ((npy_long *)data_out + 2*5)[0];
        ((npy_long *)data_out + 2*5)[1] =
                                ((npy_long *)data0 + 2*5)[1] +
                                ((npy_long *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_long *)data_out + 2*6)[0] =
                                ((npy_long *)data0 + 2*6)[0] +
                                ((npy_long *)data_out + 2*6)[0];
        ((npy_long *)data_out + 2*6)[1] =
                                ((npy_long *)data0 + 2*6)[1] +
                                ((npy_long *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_long *)data_out + 2*7)[0] =
                                ((npy_long *)data0 + 2*7)[0] +
                                ((npy_long *)data_out + 2*7)[0];
        ((npy_long *)data_out + 2*7)[1] =
                                ((npy_long *)data0 + 2*7)[1] +
                                ((npy_long *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
long_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
long_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long value0 = (*(npy_long *)dataptr[0]);
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
long_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long value1 = (*(npy_long *)dataptr[1]);
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long value0 = (*(npy_long *)dataptr[0]);
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long value1 = (*(npy_long *)dataptr[1]);
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
long_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data2 = (npy_long *)dataptr[2];
    npy_long *data_out = (npy_long *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
long_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        *(npy_long *)dataptr[nop] = (temp +
                                           (*(npy_long *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_long);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_long *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[0];
        ((npy_long *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_long);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
long_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_long accum_re = 0, accum_im = 0;
    npy_long *data0 = (npy_long *)dataptr[0];
#else
    npy_long accum = 0;
    npy_long *data0 = (npy_long *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_long *)dataptr[1])[0] += accum_re;
            ((npy_long *)dataptr[1])[1] += accum_im;
#else
            *((npy_long *)dataptr[1]) = (accum +
                                    (*((npy_long *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
long_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_long accum_re = 0, accum_im = 0;
#else
    npy_long accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_long *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_long *)data0) *
                 (*(npy_long *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_long *)data0) *
                 (*(npy_long *)data1) *
                 (*(npy_long *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_long *)data0)[0];
        accum_im += ((npy_long *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_long *)dataptr[2])[0] += accum_re;
    ((npy_long *)dataptr[2])[1] += accum_im;
#  else
    ((npy_long *)dataptr[nop])[0] += accum_re;
    ((npy_long *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_long *)dataptr[2]) = (accum +
                                    (*((npy_long *)dataptr[2])));
#  else
    *((npy_long *)dataptr[nop]) = (accum +
                                    (*((npy_long *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
long_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_long *)data_out = ((*(npy_long *)data0) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_long *)data_out = ((*(npy_long *)data0) *
                                         (*(npy_long *)data1) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_long *)data_out = ((*(npy_long *)data0) *
                                         (*(npy_long *)data1) *
                                         (*(npy_long *)data2) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        *(npy_long *)dataptr[nop] = (temp +
                                           (*(npy_long *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_long *)data_out)[0] = ((npy_long *)data0)[0] +
                                         ((npy_long *)data_out)[0];
        ((npy_long *)data_out)[1] = ((npy_long *)data0)[1] +
                                         ((npy_long *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_long *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[0];
        ((npy_long *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
long_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data_out = (npy_long *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_long *)data_out + 2*6)[0] =
                                    ((npy_long *)data0 + 2*6)[0] +
                                    ((npy_long *)data_out + 2*6)[0];
            ((npy_long *)data_out + 2*6)[1] =
                                    ((npy_long *)data0 + 2*6)[1] +
                                    ((npy_long *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_long *)data_out + 2*5)[0] =
                                    ((npy_long *)data0 + 2*5)[0] +
                                    ((npy_long *)data_out + 2*5)[0];
            ((npy_long *)data_out + 2*5)[1] =
                                    ((npy_long *)data0 + 2*5)[1] +
                                    ((npy_long *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_long *)data_out + 2*4)[0] =
                                    ((npy_long *)data0 + 2*4)[0] +
                                    ((npy_long *)data_out + 2*4)[0];
            ((npy_long *)data_out + 2*4)[1] =
                                    ((npy_long *)data0 + 2*4)[1] +
                                    ((npy_long *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_long *)data_out + 2*3)[0] =
                                    ((npy_long *)data0 + 2*3)[0] +
                                    ((npy_long *)data_out + 2*3)[0];
            ((npy_long *)data_out + 2*3)[1] =
                                    ((npy_long *)data0 + 2*3)[1] +
                                    ((npy_long *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_long *)data_out + 2*2)[0] =
                                    ((npy_long *)data0 + 2*2)[0] +
                                    ((npy_long *)data_out + 2*2)[0];
            ((npy_long *)data_out + 2*2)[1] =
                                    ((npy_long *)data0 + 2*2)[1] +
                                    ((npy_long *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_long *)data_out + 2*1)[0] =
                                    ((npy_long *)data0 + 2*1)[0] +
                                    ((npy_long *)data_out + 2*1)[0];
            ((npy_long *)data_out + 2*1)[1] =
                                    ((npy_long *)data0 + 2*1)[1] +
                                    ((npy_long *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_long *)data_out + 2*0)[0] =
                                    ((npy_long *)data0 + 2*0)[0] +
                                    ((npy_long *)data_out + 2*0)[0];
            ((npy_long *)data_out + 2*0)[1] =
                                    ((npy_long *)data0 + 2*0)[1] +
                                    ((npy_long *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_long *)data_out + 2*0)[0] =
                                ((npy_long *)data0 + 2*0)[0] +
                                ((npy_long *)data_out + 2*0)[0];
        ((npy_long *)data_out + 2*0)[1] =
                                ((npy_long *)data0 + 2*0)[1] +
                                ((npy_long *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_long *)data_out + 2*1)[0] =
                                ((npy_long *)data0 + 2*1)[0] +
                                ((npy_long *)data_out + 2*1)[0];
        ((npy_long *)data_out + 2*1)[1] =
                                ((npy_long *)data0 + 2*1)[1] +
                                ((npy_long *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_long *)data_out + 2*2)[0] =
                                ((npy_long *)data0 + 2*2)[0] +
                                ((npy_long *)data_out + 2*2)[0];
        ((npy_long *)data_out + 2*2)[1] =
                                ((npy_long *)data0 + 2*2)[1] +
                                ((npy_long *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_long *)data_out + 2*3)[0] =
                                ((npy_long *)data0 + 2*3)[0] +
                                ((npy_long *)data_out + 2*3)[0];
        ((npy_long *)data_out + 2*3)[1] =
                                ((npy_long *)data0 + 2*3)[1] +
                                ((npy_long *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_long *)data_out + 2*4)[0] =
                                ((npy_long *)data0 + 2*4)[0] +
                                ((npy_long *)data_out + 2*4)[0];
        ((npy_long *)data_out + 2*4)[1] =
                                ((npy_long *)data0 + 2*4)[1] +
                                ((npy_long *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_long *)data_out + 2*5)[0] =
                                ((npy_long *)data0 + 2*5)[0] +
                                ((npy_long *)data_out + 2*5)[0];
        ((npy_long *)data_out + 2*5)[1] =
                                ((npy_long *)data0 + 2*5)[1] +
                                ((npy_long *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_long *)data_out + 2*6)[0] =
                                ((npy_long *)data0 + 2*6)[0] +
                                ((npy_long *)data_out + 2*6)[0];
        ((npy_long *)data_out + 2*6)[1] =
                                ((npy_long *)data0 + 2*6)[1] +
                                ((npy_long *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_long *)data_out + 2*7)[0] =
                                ((npy_long *)data0 + 2*7)[0] +
                                ((npy_long *)data_out + 2*7)[0];
        ((npy_long *)data_out + 2*7)[1] =
                                ((npy_long *)data0 + 2*7)[1] +
                                ((npy_long *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
long_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
long_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long value0 = (*(npy_long *)dataptr[0]);
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
long_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long value1 = (*(npy_long *)dataptr[1]);
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long value0 = (*(npy_long *)dataptr[0]);
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long value1 = (*(npy_long *)dataptr[1]);
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
long_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data2 = (npy_long *)dataptr[2];
    npy_long *data_out = (npy_long *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
long_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        *(npy_long *)dataptr[nop] = (temp +
                                           (*(npy_long *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_long);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_long *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[0];
        ((npy_long *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_long);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
long_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_long accum_re = 0, accum_im = 0;
    npy_long *data0 = (npy_long *)dataptr[0];
#else
    npy_long accum = 0;
    npy_long *data0 = (npy_long *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_long *)dataptr[1])[0] += accum_re;
            ((npy_long *)dataptr[1])[1] += accum_im;
#else
            *((npy_long *)dataptr[1]) = (accum +
                                    (*((npy_long *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
long_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_long accum_re = 0, accum_im = 0;
#else
    npy_long accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_long *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_long *)data0) *
                 (*(npy_long *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_long *)data0) *
                 (*(npy_long *)data1) *
                 (*(npy_long *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_long *)data0)[0];
        accum_im += ((npy_long *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_long *)dataptr[3])[0] += accum_re;
    ((npy_long *)dataptr[3])[1] += accum_im;
#  else
    ((npy_long *)dataptr[nop])[0] += accum_re;
    ((npy_long *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_long *)dataptr[3]) = (accum +
                                    (*((npy_long *)dataptr[3])));
#  else
    *((npy_long *)dataptr[nop]) = (accum +
                                    (*((npy_long *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
long_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_long *)data_out = ((*(npy_long *)data0) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_long *)data_out = ((*(npy_long *)data0) *
                                         (*(npy_long *)data1) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_long *)data_out = ((*(npy_long *)data0) *
                                         (*(npy_long *)data1) *
                                         (*(npy_long *)data2) +
                                         (*(npy_long *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        *(npy_long *)dataptr[nop] = (temp +
                                           (*(npy_long *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_long *)data_out)[0] = ((npy_long *)data0)[0] +
                                         ((npy_long *)data_out)[0];
        ((npy_long *)data_out)[1] = ((npy_long *)data0)[1] +
                                         ((npy_long *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_long *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[0];
        ((npy_long *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
long_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data_out = (npy_long *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_long *)data_out + 2*6)[0] =
                                    ((npy_long *)data0 + 2*6)[0] +
                                    ((npy_long *)data_out + 2*6)[0];
            ((npy_long *)data_out + 2*6)[1] =
                                    ((npy_long *)data0 + 2*6)[1] +
                                    ((npy_long *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_long *)data_out + 2*5)[0] =
                                    ((npy_long *)data0 + 2*5)[0] +
                                    ((npy_long *)data_out + 2*5)[0];
            ((npy_long *)data_out + 2*5)[1] =
                                    ((npy_long *)data0 + 2*5)[1] +
                                    ((npy_long *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_long *)data_out + 2*4)[0] =
                                    ((npy_long *)data0 + 2*4)[0] +
                                    ((npy_long *)data_out + 2*4)[0];
            ((npy_long *)data_out + 2*4)[1] =
                                    ((npy_long *)data0 + 2*4)[1] +
                                    ((npy_long *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_long *)data_out + 2*3)[0] =
                                    ((npy_long *)data0 + 2*3)[0] +
                                    ((npy_long *)data_out + 2*3)[0];
            ((npy_long *)data_out + 2*3)[1] =
                                    ((npy_long *)data0 + 2*3)[1] +
                                    ((npy_long *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_long *)data_out + 2*2)[0] =
                                    ((npy_long *)data0 + 2*2)[0] +
                                    ((npy_long *)data_out + 2*2)[0];
            ((npy_long *)data_out + 2*2)[1] =
                                    ((npy_long *)data0 + 2*2)[1] +
                                    ((npy_long *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_long *)data_out + 2*1)[0] =
                                    ((npy_long *)data0 + 2*1)[0] +
                                    ((npy_long *)data_out + 2*1)[0];
            ((npy_long *)data_out + 2*1)[1] =
                                    ((npy_long *)data0 + 2*1)[1] +
                                    ((npy_long *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_long *)data_out + 2*0)[0] =
                                    ((npy_long *)data0 + 2*0)[0] +
                                    ((npy_long *)data_out + 2*0)[0];
            ((npy_long *)data_out + 2*0)[1] =
                                    ((npy_long *)data0 + 2*0)[1] +
                                    ((npy_long *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_long *)data_out + 2*0)[0] =
                                ((npy_long *)data0 + 2*0)[0] +
                                ((npy_long *)data_out + 2*0)[0];
        ((npy_long *)data_out + 2*0)[1] =
                                ((npy_long *)data0 + 2*0)[1] +
                                ((npy_long *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_long *)data_out + 2*1)[0] =
                                ((npy_long *)data0 + 2*1)[0] +
                                ((npy_long *)data_out + 2*1)[0];
        ((npy_long *)data_out + 2*1)[1] =
                                ((npy_long *)data0 + 2*1)[1] +
                                ((npy_long *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_long *)data_out + 2*2)[0] =
                                ((npy_long *)data0 + 2*2)[0] +
                                ((npy_long *)data_out + 2*2)[0];
        ((npy_long *)data_out + 2*2)[1] =
                                ((npy_long *)data0 + 2*2)[1] +
                                ((npy_long *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_long *)data_out + 2*3)[0] =
                                ((npy_long *)data0 + 2*3)[0] +
                                ((npy_long *)data_out + 2*3)[0];
        ((npy_long *)data_out + 2*3)[1] =
                                ((npy_long *)data0 + 2*3)[1] +
                                ((npy_long *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_long *)data_out + 2*4)[0] =
                                ((npy_long *)data0 + 2*4)[0] +
                                ((npy_long *)data_out + 2*4)[0];
        ((npy_long *)data_out + 2*4)[1] =
                                ((npy_long *)data0 + 2*4)[1] +
                                ((npy_long *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_long *)data_out + 2*5)[0] =
                                ((npy_long *)data0 + 2*5)[0] +
                                ((npy_long *)data_out + 2*5)[0];
        ((npy_long *)data_out + 2*5)[1] =
                                ((npy_long *)data0 + 2*5)[1] +
                                ((npy_long *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_long *)data_out + 2*6)[0] =
                                ((npy_long *)data0 + 2*6)[0] +
                                ((npy_long *)data_out + 2*6)[0];
        ((npy_long *)data_out + 2*6)[1] =
                                ((npy_long *)data0 + 2*6)[1] +
                                ((npy_long *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_long *)data_out + 2*7)[0] =
                                ((npy_long *)data0 + 2*7)[0] +
                                ((npy_long *)data_out + 2*7)[0];
        ((npy_long *)data_out + 2*7)[1] =
                                ((npy_long *)data0 + 2*7)[1] +
                                ((npy_long *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
long_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
long_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long value0 = (*(npy_long *)dataptr[0]);
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
long_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long value1 = (*(npy_long *)dataptr[1]);
    npy_long *data_out = (npy_long *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long value0 = (*(npy_long *)dataptr[0]);
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
long_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long value1 = (*(npy_long *)dataptr[1]);
    npy_long accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_long *)dataptr[2] = ((*(npy_long *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
long_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_long *data0 = (npy_long *)dataptr[0];
    npy_long *data1 = (npy_long *)dataptr[1];
    npy_long *data2 = (npy_long *)dataptr[2];
    npy_long *data_out = (npy_long *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
long_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        *(npy_long *)dataptr[nop] = (temp +
                                           (*(npy_long *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_long);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_long *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[0];
        ((npy_long *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_long *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_long);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
long_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_long accum_re = 0, accum_im = 0;
    npy_long *data0 = (npy_long *)dataptr[0];
#else
    npy_long accum = 0;
    npy_long *data0 = (npy_long *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_long *)dataptr[1])[0] += accum_re;
            ((npy_long *)dataptr[1])[1] += accum_im;
#else
            *((npy_long *)dataptr[1]) = (accum +
                                    (*((npy_long *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
long_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_long accum_re = 0, accum_im = 0;
#else
    npy_long accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("long_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_long *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_long *)data0) *
                 (*(npy_long *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_long *)data0) *
                 (*(npy_long *)data1) *
                 (*(npy_long *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_long temp = (*(npy_long *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_long *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_long *)data0)[0];
        accum_im += ((npy_long *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_long re, im, tmp;
        int i;
        re = ((npy_long *)dataptr[0])[0];
        im = ((npy_long *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_long *)dataptr[i])[0] -
                  im * ((npy_long *)dataptr[i])[1];
            im = re * ((npy_long *)dataptr[i])[1] +
                 im * ((npy_long *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_long *)dataptr[1000])[0] += accum_re;
    ((npy_long *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_long *)dataptr[nop])[0] += accum_re;
    ((npy_long *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_long *)dataptr[1000]) = (accum +
                                    (*((npy_long *)dataptr[1000])));
#  else
    *((npy_long *)dataptr[nop]) = (accum +
                                    (*((npy_long *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
longlong_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) *
                                         (*(npy_longlong *)data1) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) *
                                         (*(npy_longlong *)data1) *
                                         (*(npy_longlong *)data2) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        *(npy_longlong *)dataptr[nop] = (temp +
                                           (*(npy_longlong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_longlong *)data_out)[0] = ((npy_longlong *)data0)[0] +
                                         ((npy_longlong *)data_out)[0];
        ((npy_longlong *)data_out)[1] = ((npy_longlong *)data0)[1] +
                                         ((npy_longlong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
longlong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data_out = (npy_longlong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longlong *)data_out + 2*6)[0] =
                                    ((npy_longlong *)data0 + 2*6)[0] +
                                    ((npy_longlong *)data_out + 2*6)[0];
            ((npy_longlong *)data_out + 2*6)[1] =
                                    ((npy_longlong *)data0 + 2*6)[1] +
                                    ((npy_longlong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longlong *)data_out + 2*5)[0] =
                                    ((npy_longlong *)data0 + 2*5)[0] +
                                    ((npy_longlong *)data_out + 2*5)[0];
            ((npy_longlong *)data_out + 2*5)[1] =
                                    ((npy_longlong *)data0 + 2*5)[1] +
                                    ((npy_longlong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longlong *)data_out + 2*4)[0] =
                                    ((npy_longlong *)data0 + 2*4)[0] +
                                    ((npy_longlong *)data_out + 2*4)[0];
            ((npy_longlong *)data_out + 2*4)[1] =
                                    ((npy_longlong *)data0 + 2*4)[1] +
                                    ((npy_longlong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longlong *)data_out + 2*3)[0] =
                                    ((npy_longlong *)data0 + 2*3)[0] +
                                    ((npy_longlong *)data_out + 2*3)[0];
            ((npy_longlong *)data_out + 2*3)[1] =
                                    ((npy_longlong *)data0 + 2*3)[1] +
                                    ((npy_longlong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longlong *)data_out + 2*2)[0] =
                                    ((npy_longlong *)data0 + 2*2)[0] +
                                    ((npy_longlong *)data_out + 2*2)[0];
            ((npy_longlong *)data_out + 2*2)[1] =
                                    ((npy_longlong *)data0 + 2*2)[1] +
                                    ((npy_longlong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longlong *)data_out + 2*1)[0] =
                                    ((npy_longlong *)data0 + 2*1)[0] +
                                    ((npy_longlong *)data_out + 2*1)[0];
            ((npy_longlong *)data_out + 2*1)[1] =
                                    ((npy_longlong *)data0 + 2*1)[1] +
                                    ((npy_longlong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longlong *)data_out + 2*0)[0] =
                                    ((npy_longlong *)data0 + 2*0)[0] +
                                    ((npy_longlong *)data_out + 2*0)[0];
            ((npy_longlong *)data_out + 2*0)[1] =
                                    ((npy_longlong *)data0 + 2*0)[1] +
                                    ((npy_longlong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longlong *)data_out + 2*0)[0] =
                                ((npy_longlong *)data0 + 2*0)[0] +
                                ((npy_longlong *)data_out + 2*0)[0];
        ((npy_longlong *)data_out + 2*0)[1] =
                                ((npy_longlong *)data0 + 2*0)[1] +
                                ((npy_longlong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longlong *)data_out + 2*1)[0] =
                                ((npy_longlong *)data0 + 2*1)[0] +
                                ((npy_longlong *)data_out + 2*1)[0];
        ((npy_longlong *)data_out + 2*1)[1] =
                                ((npy_longlong *)data0 + 2*1)[1] +
                                ((npy_longlong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longlong *)data_out + 2*2)[0] =
                                ((npy_longlong *)data0 + 2*2)[0] +
                                ((npy_longlong *)data_out + 2*2)[0];
        ((npy_longlong *)data_out + 2*2)[1] =
                                ((npy_longlong *)data0 + 2*2)[1] +
                                ((npy_longlong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longlong *)data_out + 2*3)[0] =
                                ((npy_longlong *)data0 + 2*3)[0] +
                                ((npy_longlong *)data_out + 2*3)[0];
        ((npy_longlong *)data_out + 2*3)[1] =
                                ((npy_longlong *)data0 + 2*3)[1] +
                                ((npy_longlong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longlong *)data_out + 2*4)[0] =
                                ((npy_longlong *)data0 + 2*4)[0] +
                                ((npy_longlong *)data_out + 2*4)[0];
        ((npy_longlong *)data_out + 2*4)[1] =
                                ((npy_longlong *)data0 + 2*4)[1] +
                                ((npy_longlong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longlong *)data_out + 2*5)[0] =
                                ((npy_longlong *)data0 + 2*5)[0] +
                                ((npy_longlong *)data_out + 2*5)[0];
        ((npy_longlong *)data_out + 2*5)[1] =
                                ((npy_longlong *)data0 + 2*5)[1] +
                                ((npy_longlong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longlong *)data_out + 2*6)[0] =
                                ((npy_longlong *)data0 + 2*6)[0] +
                                ((npy_longlong *)data_out + 2*6)[0];
        ((npy_longlong *)data_out + 2*6)[1] =
                                ((npy_longlong *)data0 + 2*6)[1] +
                                ((npy_longlong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longlong *)data_out + 2*7)[0] =
                                ((npy_longlong *)data0 + 2*7)[0] +
                                ((npy_longlong *)data_out + 2*7)[0];
        ((npy_longlong *)data_out + 2*7)[1] =
                                ((npy_longlong *)data0 + 2*7)[1] +
                                ((npy_longlong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
longlong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
longlong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong value0 = (*(npy_longlong *)dataptr[0]);
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
longlong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong value1 = (*(npy_longlong *)dataptr[1]);
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong value0 = (*(npy_longlong *)dataptr[0]);
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong value1 = (*(npy_longlong *)dataptr[1]);
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
longlong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data2 = (npy_longlong *)dataptr[2];
    npy_longlong *data_out = (npy_longlong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
longlong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        *(npy_longlong *)dataptr[nop] = (temp +
                                           (*(npy_longlong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_longlong);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_longlong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
longlong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longlong accum_re = 0, accum_im = 0;
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
#else
    npy_longlong accum = 0;
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_longlong *)dataptr[1])[0] += accum_re;
            ((npy_longlong *)dataptr[1])[1] += accum_im;
#else
            *((npy_longlong *)dataptr[1]) = (accum +
                                    (*((npy_longlong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
longlong_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longlong accum_re = 0, accum_im = 0;
#else
    npy_longlong accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_longlong *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_longlong *)data0) *
                 (*(npy_longlong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_longlong *)data0) *
                 (*(npy_longlong *)data1) *
                 (*(npy_longlong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_longlong *)data0)[0];
        accum_im += ((npy_longlong *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_longlong *)dataptr[1])[0] += accum_re;
    ((npy_longlong *)dataptr[1])[1] += accum_im;
#  else
    ((npy_longlong *)dataptr[nop])[0] += accum_re;
    ((npy_longlong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_longlong *)dataptr[1]) = (accum +
                                    (*((npy_longlong *)dataptr[1])));
#  else
    *((npy_longlong *)dataptr[nop]) = (accum +
                                    (*((npy_longlong *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
longlong_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) *
                                         (*(npy_longlong *)data1) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) *
                                         (*(npy_longlong *)data1) *
                                         (*(npy_longlong *)data2) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        *(npy_longlong *)dataptr[nop] = (temp +
                                           (*(npy_longlong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_longlong *)data_out)[0] = ((npy_longlong *)data0)[0] +
                                         ((npy_longlong *)data_out)[0];
        ((npy_longlong *)data_out)[1] = ((npy_longlong *)data0)[1] +
                                         ((npy_longlong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
longlong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data_out = (npy_longlong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longlong *)data_out + 2*6)[0] =
                                    ((npy_longlong *)data0 + 2*6)[0] +
                                    ((npy_longlong *)data_out + 2*6)[0];
            ((npy_longlong *)data_out + 2*6)[1] =
                                    ((npy_longlong *)data0 + 2*6)[1] +
                                    ((npy_longlong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longlong *)data_out + 2*5)[0] =
                                    ((npy_longlong *)data0 + 2*5)[0] +
                                    ((npy_longlong *)data_out + 2*5)[0];
            ((npy_longlong *)data_out + 2*5)[1] =
                                    ((npy_longlong *)data0 + 2*5)[1] +
                                    ((npy_longlong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longlong *)data_out + 2*4)[0] =
                                    ((npy_longlong *)data0 + 2*4)[0] +
                                    ((npy_longlong *)data_out + 2*4)[0];
            ((npy_longlong *)data_out + 2*4)[1] =
                                    ((npy_longlong *)data0 + 2*4)[1] +
                                    ((npy_longlong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longlong *)data_out + 2*3)[0] =
                                    ((npy_longlong *)data0 + 2*3)[0] +
                                    ((npy_longlong *)data_out + 2*3)[0];
            ((npy_longlong *)data_out + 2*3)[1] =
                                    ((npy_longlong *)data0 + 2*3)[1] +
                                    ((npy_longlong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longlong *)data_out + 2*2)[0] =
                                    ((npy_longlong *)data0 + 2*2)[0] +
                                    ((npy_longlong *)data_out + 2*2)[0];
            ((npy_longlong *)data_out + 2*2)[1] =
                                    ((npy_longlong *)data0 + 2*2)[1] +
                                    ((npy_longlong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longlong *)data_out + 2*1)[0] =
                                    ((npy_longlong *)data0 + 2*1)[0] +
                                    ((npy_longlong *)data_out + 2*1)[0];
            ((npy_longlong *)data_out + 2*1)[1] =
                                    ((npy_longlong *)data0 + 2*1)[1] +
                                    ((npy_longlong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longlong *)data_out + 2*0)[0] =
                                    ((npy_longlong *)data0 + 2*0)[0] +
                                    ((npy_longlong *)data_out + 2*0)[0];
            ((npy_longlong *)data_out + 2*0)[1] =
                                    ((npy_longlong *)data0 + 2*0)[1] +
                                    ((npy_longlong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longlong *)data_out + 2*0)[0] =
                                ((npy_longlong *)data0 + 2*0)[0] +
                                ((npy_longlong *)data_out + 2*0)[0];
        ((npy_longlong *)data_out + 2*0)[1] =
                                ((npy_longlong *)data0 + 2*0)[1] +
                                ((npy_longlong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longlong *)data_out + 2*1)[0] =
                                ((npy_longlong *)data0 + 2*1)[0] +
                                ((npy_longlong *)data_out + 2*1)[0];
        ((npy_longlong *)data_out + 2*1)[1] =
                                ((npy_longlong *)data0 + 2*1)[1] +
                                ((npy_longlong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longlong *)data_out + 2*2)[0] =
                                ((npy_longlong *)data0 + 2*2)[0] +
                                ((npy_longlong *)data_out + 2*2)[0];
        ((npy_longlong *)data_out + 2*2)[1] =
                                ((npy_longlong *)data0 + 2*2)[1] +
                                ((npy_longlong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longlong *)data_out + 2*3)[0] =
                                ((npy_longlong *)data0 + 2*3)[0] +
                                ((npy_longlong *)data_out + 2*3)[0];
        ((npy_longlong *)data_out + 2*3)[1] =
                                ((npy_longlong *)data0 + 2*3)[1] +
                                ((npy_longlong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longlong *)data_out + 2*4)[0] =
                                ((npy_longlong *)data0 + 2*4)[0] +
                                ((npy_longlong *)data_out + 2*4)[0];
        ((npy_longlong *)data_out + 2*4)[1] =
                                ((npy_longlong *)data0 + 2*4)[1] +
                                ((npy_longlong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longlong *)data_out + 2*5)[0] =
                                ((npy_longlong *)data0 + 2*5)[0] +
                                ((npy_longlong *)data_out + 2*5)[0];
        ((npy_longlong *)data_out + 2*5)[1] =
                                ((npy_longlong *)data0 + 2*5)[1] +
                                ((npy_longlong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longlong *)data_out + 2*6)[0] =
                                ((npy_longlong *)data0 + 2*6)[0] +
                                ((npy_longlong *)data_out + 2*6)[0];
        ((npy_longlong *)data_out + 2*6)[1] =
                                ((npy_longlong *)data0 + 2*6)[1] +
                                ((npy_longlong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longlong *)data_out + 2*7)[0] =
                                ((npy_longlong *)data0 + 2*7)[0] +
                                ((npy_longlong *)data_out + 2*7)[0];
        ((npy_longlong *)data_out + 2*7)[1] =
                                ((npy_longlong *)data0 + 2*7)[1] +
                                ((npy_longlong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
longlong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
longlong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong value0 = (*(npy_longlong *)dataptr[0]);
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
longlong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong value1 = (*(npy_longlong *)dataptr[1]);
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong value0 = (*(npy_longlong *)dataptr[0]);
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong value1 = (*(npy_longlong *)dataptr[1]);
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
longlong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data2 = (npy_longlong *)dataptr[2];
    npy_longlong *data_out = (npy_longlong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
longlong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        *(npy_longlong *)dataptr[nop] = (temp +
                                           (*(npy_longlong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_longlong);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_longlong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
longlong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longlong accum_re = 0, accum_im = 0;
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
#else
    npy_longlong accum = 0;
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_longlong *)dataptr[1])[0] += accum_re;
            ((npy_longlong *)dataptr[1])[1] += accum_im;
#else
            *((npy_longlong *)dataptr[1]) = (accum +
                                    (*((npy_longlong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
longlong_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longlong accum_re = 0, accum_im = 0;
#else
    npy_longlong accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_longlong *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_longlong *)data0) *
                 (*(npy_longlong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_longlong *)data0) *
                 (*(npy_longlong *)data1) *
                 (*(npy_longlong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_longlong *)data0)[0];
        accum_im += ((npy_longlong *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_longlong *)dataptr[2])[0] += accum_re;
    ((npy_longlong *)dataptr[2])[1] += accum_im;
#  else
    ((npy_longlong *)dataptr[nop])[0] += accum_re;
    ((npy_longlong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_longlong *)dataptr[2]) = (accum +
                                    (*((npy_longlong *)dataptr[2])));
#  else
    *((npy_longlong *)dataptr[nop]) = (accum +
                                    (*((npy_longlong *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
longlong_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) *
                                         (*(npy_longlong *)data1) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) *
                                         (*(npy_longlong *)data1) *
                                         (*(npy_longlong *)data2) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        *(npy_longlong *)dataptr[nop] = (temp +
                                           (*(npy_longlong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_longlong *)data_out)[0] = ((npy_longlong *)data0)[0] +
                                         ((npy_longlong *)data_out)[0];
        ((npy_longlong *)data_out)[1] = ((npy_longlong *)data0)[1] +
                                         ((npy_longlong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
longlong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data_out = (npy_longlong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longlong *)data_out + 2*6)[0] =
                                    ((npy_longlong *)data0 + 2*6)[0] +
                                    ((npy_longlong *)data_out + 2*6)[0];
            ((npy_longlong *)data_out + 2*6)[1] =
                                    ((npy_longlong *)data0 + 2*6)[1] +
                                    ((npy_longlong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longlong *)data_out + 2*5)[0] =
                                    ((npy_longlong *)data0 + 2*5)[0] +
                                    ((npy_longlong *)data_out + 2*5)[0];
            ((npy_longlong *)data_out + 2*5)[1] =
                                    ((npy_longlong *)data0 + 2*5)[1] +
                                    ((npy_longlong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longlong *)data_out + 2*4)[0] =
                                    ((npy_longlong *)data0 + 2*4)[0] +
                                    ((npy_longlong *)data_out + 2*4)[0];
            ((npy_longlong *)data_out + 2*4)[1] =
                                    ((npy_longlong *)data0 + 2*4)[1] +
                                    ((npy_longlong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longlong *)data_out + 2*3)[0] =
                                    ((npy_longlong *)data0 + 2*3)[0] +
                                    ((npy_longlong *)data_out + 2*3)[0];
            ((npy_longlong *)data_out + 2*3)[1] =
                                    ((npy_longlong *)data0 + 2*3)[1] +
                                    ((npy_longlong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longlong *)data_out + 2*2)[0] =
                                    ((npy_longlong *)data0 + 2*2)[0] +
                                    ((npy_longlong *)data_out + 2*2)[0];
            ((npy_longlong *)data_out + 2*2)[1] =
                                    ((npy_longlong *)data0 + 2*2)[1] +
                                    ((npy_longlong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longlong *)data_out + 2*1)[0] =
                                    ((npy_longlong *)data0 + 2*1)[0] +
                                    ((npy_longlong *)data_out + 2*1)[0];
            ((npy_longlong *)data_out + 2*1)[1] =
                                    ((npy_longlong *)data0 + 2*1)[1] +
                                    ((npy_longlong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longlong *)data_out + 2*0)[0] =
                                    ((npy_longlong *)data0 + 2*0)[0] +
                                    ((npy_longlong *)data_out + 2*0)[0];
            ((npy_longlong *)data_out + 2*0)[1] =
                                    ((npy_longlong *)data0 + 2*0)[1] +
                                    ((npy_longlong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longlong *)data_out + 2*0)[0] =
                                ((npy_longlong *)data0 + 2*0)[0] +
                                ((npy_longlong *)data_out + 2*0)[0];
        ((npy_longlong *)data_out + 2*0)[1] =
                                ((npy_longlong *)data0 + 2*0)[1] +
                                ((npy_longlong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longlong *)data_out + 2*1)[0] =
                                ((npy_longlong *)data0 + 2*1)[0] +
                                ((npy_longlong *)data_out + 2*1)[0];
        ((npy_longlong *)data_out + 2*1)[1] =
                                ((npy_longlong *)data0 + 2*1)[1] +
                                ((npy_longlong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longlong *)data_out + 2*2)[0] =
                                ((npy_longlong *)data0 + 2*2)[0] +
                                ((npy_longlong *)data_out + 2*2)[0];
        ((npy_longlong *)data_out + 2*2)[1] =
                                ((npy_longlong *)data0 + 2*2)[1] +
                                ((npy_longlong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longlong *)data_out + 2*3)[0] =
                                ((npy_longlong *)data0 + 2*3)[0] +
                                ((npy_longlong *)data_out + 2*3)[0];
        ((npy_longlong *)data_out + 2*3)[1] =
                                ((npy_longlong *)data0 + 2*3)[1] +
                                ((npy_longlong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longlong *)data_out + 2*4)[0] =
                                ((npy_longlong *)data0 + 2*4)[0] +
                                ((npy_longlong *)data_out + 2*4)[0];
        ((npy_longlong *)data_out + 2*4)[1] =
                                ((npy_longlong *)data0 + 2*4)[1] +
                                ((npy_longlong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longlong *)data_out + 2*5)[0] =
                                ((npy_longlong *)data0 + 2*5)[0] +
                                ((npy_longlong *)data_out + 2*5)[0];
        ((npy_longlong *)data_out + 2*5)[1] =
                                ((npy_longlong *)data0 + 2*5)[1] +
                                ((npy_longlong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longlong *)data_out + 2*6)[0] =
                                ((npy_longlong *)data0 + 2*6)[0] +
                                ((npy_longlong *)data_out + 2*6)[0];
        ((npy_longlong *)data_out + 2*6)[1] =
                                ((npy_longlong *)data0 + 2*6)[1] +
                                ((npy_longlong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longlong *)data_out + 2*7)[0] =
                                ((npy_longlong *)data0 + 2*7)[0] +
                                ((npy_longlong *)data_out + 2*7)[0];
        ((npy_longlong *)data_out + 2*7)[1] =
                                ((npy_longlong *)data0 + 2*7)[1] +
                                ((npy_longlong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
longlong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
longlong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong value0 = (*(npy_longlong *)dataptr[0]);
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
longlong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong value1 = (*(npy_longlong *)dataptr[1]);
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong value0 = (*(npy_longlong *)dataptr[0]);
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong value1 = (*(npy_longlong *)dataptr[1]);
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
longlong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data2 = (npy_longlong *)dataptr[2];
    npy_longlong *data_out = (npy_longlong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
longlong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        *(npy_longlong *)dataptr[nop] = (temp +
                                           (*(npy_longlong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_longlong);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_longlong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
longlong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longlong accum_re = 0, accum_im = 0;
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
#else
    npy_longlong accum = 0;
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_longlong *)dataptr[1])[0] += accum_re;
            ((npy_longlong *)dataptr[1])[1] += accum_im;
#else
            *((npy_longlong *)dataptr[1]) = (accum +
                                    (*((npy_longlong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
longlong_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longlong accum_re = 0, accum_im = 0;
#else
    npy_longlong accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_longlong *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_longlong *)data0) *
                 (*(npy_longlong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_longlong *)data0) *
                 (*(npy_longlong *)data1) *
                 (*(npy_longlong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_longlong *)data0)[0];
        accum_im += ((npy_longlong *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_longlong *)dataptr[3])[0] += accum_re;
    ((npy_longlong *)dataptr[3])[1] += accum_im;
#  else
    ((npy_longlong *)dataptr[nop])[0] += accum_re;
    ((npy_longlong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_longlong *)dataptr[3]) = (accum +
                                    (*((npy_longlong *)dataptr[3])));
#  else
    *((npy_longlong *)dataptr[nop]) = (accum +
                                    (*((npy_longlong *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
longlong_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) *
                                         (*(npy_longlong *)data1) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_longlong *)data_out = ((*(npy_longlong *)data0) *
                                         (*(npy_longlong *)data1) *
                                         (*(npy_longlong *)data2) +
                                         (*(npy_longlong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        *(npy_longlong *)dataptr[nop] = (temp +
                                           (*(npy_longlong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_longlong *)data_out)[0] = ((npy_longlong *)data0)[0] +
                                         ((npy_longlong *)data_out)[0];
        ((npy_longlong *)data_out)[1] = ((npy_longlong *)data0)[1] +
                                         ((npy_longlong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
longlong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data_out = (npy_longlong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longlong *)data_out + 2*6)[0] =
                                    ((npy_longlong *)data0 + 2*6)[0] +
                                    ((npy_longlong *)data_out + 2*6)[0];
            ((npy_longlong *)data_out + 2*6)[1] =
                                    ((npy_longlong *)data0 + 2*6)[1] +
                                    ((npy_longlong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longlong *)data_out + 2*5)[0] =
                                    ((npy_longlong *)data0 + 2*5)[0] +
                                    ((npy_longlong *)data_out + 2*5)[0];
            ((npy_longlong *)data_out + 2*5)[1] =
                                    ((npy_longlong *)data0 + 2*5)[1] +
                                    ((npy_longlong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longlong *)data_out + 2*4)[0] =
                                    ((npy_longlong *)data0 + 2*4)[0] +
                                    ((npy_longlong *)data_out + 2*4)[0];
            ((npy_longlong *)data_out + 2*4)[1] =
                                    ((npy_longlong *)data0 + 2*4)[1] +
                                    ((npy_longlong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longlong *)data_out + 2*3)[0] =
                                    ((npy_longlong *)data0 + 2*3)[0] +
                                    ((npy_longlong *)data_out + 2*3)[0];
            ((npy_longlong *)data_out + 2*3)[1] =
                                    ((npy_longlong *)data0 + 2*3)[1] +
                                    ((npy_longlong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longlong *)data_out + 2*2)[0] =
                                    ((npy_longlong *)data0 + 2*2)[0] +
                                    ((npy_longlong *)data_out + 2*2)[0];
            ((npy_longlong *)data_out + 2*2)[1] =
                                    ((npy_longlong *)data0 + 2*2)[1] +
                                    ((npy_longlong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longlong *)data_out + 2*1)[0] =
                                    ((npy_longlong *)data0 + 2*1)[0] +
                                    ((npy_longlong *)data_out + 2*1)[0];
            ((npy_longlong *)data_out + 2*1)[1] =
                                    ((npy_longlong *)data0 + 2*1)[1] +
                                    ((npy_longlong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longlong *)data_out + 2*0)[0] =
                                    ((npy_longlong *)data0 + 2*0)[0] +
                                    ((npy_longlong *)data_out + 2*0)[0];
            ((npy_longlong *)data_out + 2*0)[1] =
                                    ((npy_longlong *)data0 + 2*0)[1] +
                                    ((npy_longlong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longlong *)data_out + 2*0)[0] =
                                ((npy_longlong *)data0 + 2*0)[0] +
                                ((npy_longlong *)data_out + 2*0)[0];
        ((npy_longlong *)data_out + 2*0)[1] =
                                ((npy_longlong *)data0 + 2*0)[1] +
                                ((npy_longlong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longlong *)data_out + 2*1)[0] =
                                ((npy_longlong *)data0 + 2*1)[0] +
                                ((npy_longlong *)data_out + 2*1)[0];
        ((npy_longlong *)data_out + 2*1)[1] =
                                ((npy_longlong *)data0 + 2*1)[1] +
                                ((npy_longlong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longlong *)data_out + 2*2)[0] =
                                ((npy_longlong *)data0 + 2*2)[0] +
                                ((npy_longlong *)data_out + 2*2)[0];
        ((npy_longlong *)data_out + 2*2)[1] =
                                ((npy_longlong *)data0 + 2*2)[1] +
                                ((npy_longlong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longlong *)data_out + 2*3)[0] =
                                ((npy_longlong *)data0 + 2*3)[0] +
                                ((npy_longlong *)data_out + 2*3)[0];
        ((npy_longlong *)data_out + 2*3)[1] =
                                ((npy_longlong *)data0 + 2*3)[1] +
                                ((npy_longlong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longlong *)data_out + 2*4)[0] =
                                ((npy_longlong *)data0 + 2*4)[0] +
                                ((npy_longlong *)data_out + 2*4)[0];
        ((npy_longlong *)data_out + 2*4)[1] =
                                ((npy_longlong *)data0 + 2*4)[1] +
                                ((npy_longlong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longlong *)data_out + 2*5)[0] =
                                ((npy_longlong *)data0 + 2*5)[0] +
                                ((npy_longlong *)data_out + 2*5)[0];
        ((npy_longlong *)data_out + 2*5)[1] =
                                ((npy_longlong *)data0 + 2*5)[1] +
                                ((npy_longlong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longlong *)data_out + 2*6)[0] =
                                ((npy_longlong *)data0 + 2*6)[0] +
                                ((npy_longlong *)data_out + 2*6)[0];
        ((npy_longlong *)data_out + 2*6)[1] =
                                ((npy_longlong *)data0 + 2*6)[1] +
                                ((npy_longlong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longlong *)data_out + 2*7)[0] =
                                ((npy_longlong *)data0 + 2*7)[0] +
                                ((npy_longlong *)data_out + 2*7)[0];
        ((npy_longlong *)data_out + 2*7)[1] =
                                ((npy_longlong *)data0 + 2*7)[1] +
                                ((npy_longlong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
longlong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
longlong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong value0 = (*(npy_longlong *)dataptr[0]);
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
longlong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong value1 = (*(npy_longlong *)dataptr[1]);
    npy_longlong *data_out = (npy_longlong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong value0 = (*(npy_longlong *)dataptr[0]);
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longlong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong value1 = (*(npy_longlong *)dataptr[1]);
    npy_longlong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_longlong *)dataptr[2] = ((*(npy_longlong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
longlong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
    npy_longlong *data1 = (npy_longlong *)dataptr[1];
    npy_longlong *data2 = (npy_longlong *)dataptr[2];
    npy_longlong *data_out = (npy_longlong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
longlong_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        *(npy_longlong *)dataptr[nop] = (temp +
                                           (*(npy_longlong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_longlong);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longlong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longlong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_longlong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
longlong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longlong accum_re = 0, accum_im = 0;
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
#else
    npy_longlong accum = 0;
    npy_longlong *data0 = (npy_longlong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_longlong *)dataptr[1])[0] += accum_re;
            ((npy_longlong *)dataptr[1])[1] += accum_im;
#else
            *((npy_longlong *)dataptr[1]) = (accum +
                                    (*((npy_longlong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
longlong_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longlong accum_re = 0, accum_im = 0;
#else
    npy_longlong accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("longlong_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_longlong *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_longlong *)data0) *
                 (*(npy_longlong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_longlong *)data0) *
                 (*(npy_longlong *)data1) *
                 (*(npy_longlong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longlong temp = (*(npy_longlong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longlong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_longlong *)data0)[0];
        accum_im += ((npy_longlong *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longlong re, im, tmp;
        int i;
        re = ((npy_longlong *)dataptr[0])[0];
        im = ((npy_longlong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longlong *)dataptr[i])[0] -
                  im * ((npy_longlong *)dataptr[i])[1];
            im = re * ((npy_longlong *)dataptr[i])[1] +
                 im * ((npy_longlong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_longlong *)dataptr[1000])[0] += accum_re;
    ((npy_longlong *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_longlong *)dataptr[nop])[0] += accum_re;
    ((npy_longlong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_longlong *)dataptr[1000]) = (accum +
                                    (*((npy_longlong *)dataptr[1000])));
#  else
    *((npy_longlong *)dataptr[nop]) = (accum +
                                    (*((npy_longlong *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
ubyte_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) *
                                         (*(npy_ubyte *)data1) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) *
                                         (*(npy_ubyte *)data1) *
                                         (*(npy_ubyte *)data2) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        *(npy_ubyte *)dataptr[nop] = (temp +
                                           (*(npy_ubyte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_ubyte *)data_out)[0] = ((npy_ubyte *)data0)[0] +
                                         ((npy_ubyte *)data_out)[0];
        ((npy_ubyte *)data_out)[1] = ((npy_ubyte *)data0)[1] +
                                         ((npy_ubyte *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
ubyte_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ubyte *)data_out + 2*6)[0] =
                                    ((npy_ubyte *)data0 + 2*6)[0] +
                                    ((npy_ubyte *)data_out + 2*6)[0];
            ((npy_ubyte *)data_out + 2*6)[1] =
                                    ((npy_ubyte *)data0 + 2*6)[1] +
                                    ((npy_ubyte *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ubyte *)data_out + 2*5)[0] =
                                    ((npy_ubyte *)data0 + 2*5)[0] +
                                    ((npy_ubyte *)data_out + 2*5)[0];
            ((npy_ubyte *)data_out + 2*5)[1] =
                                    ((npy_ubyte *)data0 + 2*5)[1] +
                                    ((npy_ubyte *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ubyte *)data_out + 2*4)[0] =
                                    ((npy_ubyte *)data0 + 2*4)[0] +
                                    ((npy_ubyte *)data_out + 2*4)[0];
            ((npy_ubyte *)data_out + 2*4)[1] =
                                    ((npy_ubyte *)data0 + 2*4)[1] +
                                    ((npy_ubyte *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ubyte *)data_out + 2*3)[0] =
                                    ((npy_ubyte *)data0 + 2*3)[0] +
                                    ((npy_ubyte *)data_out + 2*3)[0];
            ((npy_ubyte *)data_out + 2*3)[1] =
                                    ((npy_ubyte *)data0 + 2*3)[1] +
                                    ((npy_ubyte *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ubyte *)data_out + 2*2)[0] =
                                    ((npy_ubyte *)data0 + 2*2)[0] +
                                    ((npy_ubyte *)data_out + 2*2)[0];
            ((npy_ubyte *)data_out + 2*2)[1] =
                                    ((npy_ubyte *)data0 + 2*2)[1] +
                                    ((npy_ubyte *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ubyte *)data_out + 2*1)[0] =
                                    ((npy_ubyte *)data0 + 2*1)[0] +
                                    ((npy_ubyte *)data_out + 2*1)[0];
            ((npy_ubyte *)data_out + 2*1)[1] =
                                    ((npy_ubyte *)data0 + 2*1)[1] +
                                    ((npy_ubyte *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ubyte *)data_out + 2*0)[0] =
                                    ((npy_ubyte *)data0 + 2*0)[0] +
                                    ((npy_ubyte *)data_out + 2*0)[0];
            ((npy_ubyte *)data_out + 2*0)[1] =
                                    ((npy_ubyte *)data0 + 2*0)[1] +
                                    ((npy_ubyte *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*0)[0] =
                                ((npy_ubyte *)data0 + 2*0)[0] +
                                ((npy_ubyte *)data_out + 2*0)[0];
        ((npy_ubyte *)data_out + 2*0)[1] =
                                ((npy_ubyte *)data0 + 2*0)[1] +
                                ((npy_ubyte *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*1)[0] =
                                ((npy_ubyte *)data0 + 2*1)[0] +
                                ((npy_ubyte *)data_out + 2*1)[0];
        ((npy_ubyte *)data_out + 2*1)[1] =
                                ((npy_ubyte *)data0 + 2*1)[1] +
                                ((npy_ubyte *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*2)[0] =
                                ((npy_ubyte *)data0 + 2*2)[0] +
                                ((npy_ubyte *)data_out + 2*2)[0];
        ((npy_ubyte *)data_out + 2*2)[1] =
                                ((npy_ubyte *)data0 + 2*2)[1] +
                                ((npy_ubyte *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*3)[0] =
                                ((npy_ubyte *)data0 + 2*3)[0] +
                                ((npy_ubyte *)data_out + 2*3)[0];
        ((npy_ubyte *)data_out + 2*3)[1] =
                                ((npy_ubyte *)data0 + 2*3)[1] +
                                ((npy_ubyte *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*4)[0] =
                                ((npy_ubyte *)data0 + 2*4)[0] +
                                ((npy_ubyte *)data_out + 2*4)[0];
        ((npy_ubyte *)data_out + 2*4)[1] =
                                ((npy_ubyte *)data0 + 2*4)[1] +
                                ((npy_ubyte *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*5)[0] =
                                ((npy_ubyte *)data0 + 2*5)[0] +
                                ((npy_ubyte *)data_out + 2*5)[0];
        ((npy_ubyte *)data_out + 2*5)[1] =
                                ((npy_ubyte *)data0 + 2*5)[1] +
                                ((npy_ubyte *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*6)[0] =
                                ((npy_ubyte *)data0 + 2*6)[0] +
                                ((npy_ubyte *)data_out + 2*6)[0];
        ((npy_ubyte *)data_out + 2*6)[1] =
                                ((npy_ubyte *)data0 + 2*6)[1] +
                                ((npy_ubyte *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*7)[0] =
                                ((npy_ubyte *)data0 + 2*7)[0] +
                                ((npy_ubyte *)data_out + 2*7)[0];
        ((npy_ubyte *)data_out + 2*7)[1] =
                                ((npy_ubyte *)data0 + 2*7)[1] +
                                ((npy_ubyte *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
ubyte_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ubyte_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte value0 = (*(npy_ubyte *)dataptr[0]);
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ubyte_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte value1 = (*(npy_ubyte *)dataptr[1]);
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte value0 = (*(npy_ubyte *)dataptr[0]);
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte value1 = (*(npy_ubyte *)dataptr[1]);
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
ubyte_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data2 = (npy_ubyte *)dataptr[2];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
ubyte_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        *(npy_ubyte *)dataptr[nop] = (temp +
                                           (*(npy_ubyte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ubyte);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ubyte);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
ubyte_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ubyte accum_re = 0, accum_im = 0;
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
#else
    npy_ubyte accum = 0;
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ubyte *)dataptr[1])[0] += accum_re;
            ((npy_ubyte *)dataptr[1])[1] += accum_im;
#else
            *((npy_ubyte *)dataptr[1]) = (accum +
                                    (*((npy_ubyte *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
ubyte_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ubyte accum_re = 0, accum_im = 0;
#else
    npy_ubyte accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_ubyte *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_ubyte *)data0) *
                 (*(npy_ubyte *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_ubyte *)data0) *
                 (*(npy_ubyte *)data1) *
                 (*(npy_ubyte *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_ubyte *)data0)[0];
        accum_im += ((npy_ubyte *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_ubyte *)dataptr[1])[0] += accum_re;
    ((npy_ubyte *)dataptr[1])[1] += accum_im;
#  else
    ((npy_ubyte *)dataptr[nop])[0] += accum_re;
    ((npy_ubyte *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_ubyte *)dataptr[1]) = (accum +
                                    (*((npy_ubyte *)dataptr[1])));
#  else
    *((npy_ubyte *)dataptr[nop]) = (accum +
                                    (*((npy_ubyte *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ubyte_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) *
                                         (*(npy_ubyte *)data1) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) *
                                         (*(npy_ubyte *)data1) *
                                         (*(npy_ubyte *)data2) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        *(npy_ubyte *)dataptr[nop] = (temp +
                                           (*(npy_ubyte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_ubyte *)data_out)[0] = ((npy_ubyte *)data0)[0] +
                                         ((npy_ubyte *)data_out)[0];
        ((npy_ubyte *)data_out)[1] = ((npy_ubyte *)data0)[1] +
                                         ((npy_ubyte *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
ubyte_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ubyte *)data_out + 2*6)[0] =
                                    ((npy_ubyte *)data0 + 2*6)[0] +
                                    ((npy_ubyte *)data_out + 2*6)[0];
            ((npy_ubyte *)data_out + 2*6)[1] =
                                    ((npy_ubyte *)data0 + 2*6)[1] +
                                    ((npy_ubyte *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ubyte *)data_out + 2*5)[0] =
                                    ((npy_ubyte *)data0 + 2*5)[0] +
                                    ((npy_ubyte *)data_out + 2*5)[0];
            ((npy_ubyte *)data_out + 2*5)[1] =
                                    ((npy_ubyte *)data0 + 2*5)[1] +
                                    ((npy_ubyte *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ubyte *)data_out + 2*4)[0] =
                                    ((npy_ubyte *)data0 + 2*4)[0] +
                                    ((npy_ubyte *)data_out + 2*4)[0];
            ((npy_ubyte *)data_out + 2*4)[1] =
                                    ((npy_ubyte *)data0 + 2*4)[1] +
                                    ((npy_ubyte *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ubyte *)data_out + 2*3)[0] =
                                    ((npy_ubyte *)data0 + 2*3)[0] +
                                    ((npy_ubyte *)data_out + 2*3)[0];
            ((npy_ubyte *)data_out + 2*3)[1] =
                                    ((npy_ubyte *)data0 + 2*3)[1] +
                                    ((npy_ubyte *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ubyte *)data_out + 2*2)[0] =
                                    ((npy_ubyte *)data0 + 2*2)[0] +
                                    ((npy_ubyte *)data_out + 2*2)[0];
            ((npy_ubyte *)data_out + 2*2)[1] =
                                    ((npy_ubyte *)data0 + 2*2)[1] +
                                    ((npy_ubyte *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ubyte *)data_out + 2*1)[0] =
                                    ((npy_ubyte *)data0 + 2*1)[0] +
                                    ((npy_ubyte *)data_out + 2*1)[0];
            ((npy_ubyte *)data_out + 2*1)[1] =
                                    ((npy_ubyte *)data0 + 2*1)[1] +
                                    ((npy_ubyte *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ubyte *)data_out + 2*0)[0] =
                                    ((npy_ubyte *)data0 + 2*0)[0] +
                                    ((npy_ubyte *)data_out + 2*0)[0];
            ((npy_ubyte *)data_out + 2*0)[1] =
                                    ((npy_ubyte *)data0 + 2*0)[1] +
                                    ((npy_ubyte *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*0)[0] =
                                ((npy_ubyte *)data0 + 2*0)[0] +
                                ((npy_ubyte *)data_out + 2*0)[0];
        ((npy_ubyte *)data_out + 2*0)[1] =
                                ((npy_ubyte *)data0 + 2*0)[1] +
                                ((npy_ubyte *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*1)[0] =
                                ((npy_ubyte *)data0 + 2*1)[0] +
                                ((npy_ubyte *)data_out + 2*1)[0];
        ((npy_ubyte *)data_out + 2*1)[1] =
                                ((npy_ubyte *)data0 + 2*1)[1] +
                                ((npy_ubyte *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*2)[0] =
                                ((npy_ubyte *)data0 + 2*2)[0] +
                                ((npy_ubyte *)data_out + 2*2)[0];
        ((npy_ubyte *)data_out + 2*2)[1] =
                                ((npy_ubyte *)data0 + 2*2)[1] +
                                ((npy_ubyte *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*3)[0] =
                                ((npy_ubyte *)data0 + 2*3)[0] +
                                ((npy_ubyte *)data_out + 2*3)[0];
        ((npy_ubyte *)data_out + 2*3)[1] =
                                ((npy_ubyte *)data0 + 2*3)[1] +
                                ((npy_ubyte *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*4)[0] =
                                ((npy_ubyte *)data0 + 2*4)[0] +
                                ((npy_ubyte *)data_out + 2*4)[0];
        ((npy_ubyte *)data_out + 2*4)[1] =
                                ((npy_ubyte *)data0 + 2*4)[1] +
                                ((npy_ubyte *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*5)[0] =
                                ((npy_ubyte *)data0 + 2*5)[0] +
                                ((npy_ubyte *)data_out + 2*5)[0];
        ((npy_ubyte *)data_out + 2*5)[1] =
                                ((npy_ubyte *)data0 + 2*5)[1] +
                                ((npy_ubyte *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*6)[0] =
                                ((npy_ubyte *)data0 + 2*6)[0] +
                                ((npy_ubyte *)data_out + 2*6)[0];
        ((npy_ubyte *)data_out + 2*6)[1] =
                                ((npy_ubyte *)data0 + 2*6)[1] +
                                ((npy_ubyte *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*7)[0] =
                                ((npy_ubyte *)data0 + 2*7)[0] +
                                ((npy_ubyte *)data_out + 2*7)[0];
        ((npy_ubyte *)data_out + 2*7)[1] =
                                ((npy_ubyte *)data0 + 2*7)[1] +
                                ((npy_ubyte *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
ubyte_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ubyte_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte value0 = (*(npy_ubyte *)dataptr[0]);
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ubyte_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte value1 = (*(npy_ubyte *)dataptr[1]);
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte value0 = (*(npy_ubyte *)dataptr[0]);
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte value1 = (*(npy_ubyte *)dataptr[1]);
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
ubyte_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data2 = (npy_ubyte *)dataptr[2];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
ubyte_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        *(npy_ubyte *)dataptr[nop] = (temp +
                                           (*(npy_ubyte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ubyte);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ubyte);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
ubyte_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ubyte accum_re = 0, accum_im = 0;
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
#else
    npy_ubyte accum = 0;
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ubyte *)dataptr[1])[0] += accum_re;
            ((npy_ubyte *)dataptr[1])[1] += accum_im;
#else
            *((npy_ubyte *)dataptr[1]) = (accum +
                                    (*((npy_ubyte *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
ubyte_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ubyte accum_re = 0, accum_im = 0;
#else
    npy_ubyte accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_ubyte *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_ubyte *)data0) *
                 (*(npy_ubyte *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_ubyte *)data0) *
                 (*(npy_ubyte *)data1) *
                 (*(npy_ubyte *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_ubyte *)data0)[0];
        accum_im += ((npy_ubyte *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_ubyte *)dataptr[2])[0] += accum_re;
    ((npy_ubyte *)dataptr[2])[1] += accum_im;
#  else
    ((npy_ubyte *)dataptr[nop])[0] += accum_re;
    ((npy_ubyte *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_ubyte *)dataptr[2]) = (accum +
                                    (*((npy_ubyte *)dataptr[2])));
#  else
    *((npy_ubyte *)dataptr[nop]) = (accum +
                                    (*((npy_ubyte *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ubyte_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) *
                                         (*(npy_ubyte *)data1) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) *
                                         (*(npy_ubyte *)data1) *
                                         (*(npy_ubyte *)data2) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        *(npy_ubyte *)dataptr[nop] = (temp +
                                           (*(npy_ubyte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_ubyte *)data_out)[0] = ((npy_ubyte *)data0)[0] +
                                         ((npy_ubyte *)data_out)[0];
        ((npy_ubyte *)data_out)[1] = ((npy_ubyte *)data0)[1] +
                                         ((npy_ubyte *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
ubyte_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ubyte *)data_out + 2*6)[0] =
                                    ((npy_ubyte *)data0 + 2*6)[0] +
                                    ((npy_ubyte *)data_out + 2*6)[0];
            ((npy_ubyte *)data_out + 2*6)[1] =
                                    ((npy_ubyte *)data0 + 2*6)[1] +
                                    ((npy_ubyte *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ubyte *)data_out + 2*5)[0] =
                                    ((npy_ubyte *)data0 + 2*5)[0] +
                                    ((npy_ubyte *)data_out + 2*5)[0];
            ((npy_ubyte *)data_out + 2*5)[1] =
                                    ((npy_ubyte *)data0 + 2*5)[1] +
                                    ((npy_ubyte *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ubyte *)data_out + 2*4)[0] =
                                    ((npy_ubyte *)data0 + 2*4)[0] +
                                    ((npy_ubyte *)data_out + 2*4)[0];
            ((npy_ubyte *)data_out + 2*4)[1] =
                                    ((npy_ubyte *)data0 + 2*4)[1] +
                                    ((npy_ubyte *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ubyte *)data_out + 2*3)[0] =
                                    ((npy_ubyte *)data0 + 2*3)[0] +
                                    ((npy_ubyte *)data_out + 2*3)[0];
            ((npy_ubyte *)data_out + 2*3)[1] =
                                    ((npy_ubyte *)data0 + 2*3)[1] +
                                    ((npy_ubyte *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ubyte *)data_out + 2*2)[0] =
                                    ((npy_ubyte *)data0 + 2*2)[0] +
                                    ((npy_ubyte *)data_out + 2*2)[0];
            ((npy_ubyte *)data_out + 2*2)[1] =
                                    ((npy_ubyte *)data0 + 2*2)[1] +
                                    ((npy_ubyte *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ubyte *)data_out + 2*1)[0] =
                                    ((npy_ubyte *)data0 + 2*1)[0] +
                                    ((npy_ubyte *)data_out + 2*1)[0];
            ((npy_ubyte *)data_out + 2*1)[1] =
                                    ((npy_ubyte *)data0 + 2*1)[1] +
                                    ((npy_ubyte *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ubyte *)data_out + 2*0)[0] =
                                    ((npy_ubyte *)data0 + 2*0)[0] +
                                    ((npy_ubyte *)data_out + 2*0)[0];
            ((npy_ubyte *)data_out + 2*0)[1] =
                                    ((npy_ubyte *)data0 + 2*0)[1] +
                                    ((npy_ubyte *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*0)[0] =
                                ((npy_ubyte *)data0 + 2*0)[0] +
                                ((npy_ubyte *)data_out + 2*0)[0];
        ((npy_ubyte *)data_out + 2*0)[1] =
                                ((npy_ubyte *)data0 + 2*0)[1] +
                                ((npy_ubyte *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*1)[0] =
                                ((npy_ubyte *)data0 + 2*1)[0] +
                                ((npy_ubyte *)data_out + 2*1)[0];
        ((npy_ubyte *)data_out + 2*1)[1] =
                                ((npy_ubyte *)data0 + 2*1)[1] +
                                ((npy_ubyte *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*2)[0] =
                                ((npy_ubyte *)data0 + 2*2)[0] +
                                ((npy_ubyte *)data_out + 2*2)[0];
        ((npy_ubyte *)data_out + 2*2)[1] =
                                ((npy_ubyte *)data0 + 2*2)[1] +
                                ((npy_ubyte *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*3)[0] =
                                ((npy_ubyte *)data0 + 2*3)[0] +
                                ((npy_ubyte *)data_out + 2*3)[0];
        ((npy_ubyte *)data_out + 2*3)[1] =
                                ((npy_ubyte *)data0 + 2*3)[1] +
                                ((npy_ubyte *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*4)[0] =
                                ((npy_ubyte *)data0 + 2*4)[0] +
                                ((npy_ubyte *)data_out + 2*4)[0];
        ((npy_ubyte *)data_out + 2*4)[1] =
                                ((npy_ubyte *)data0 + 2*4)[1] +
                                ((npy_ubyte *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*5)[0] =
                                ((npy_ubyte *)data0 + 2*5)[0] +
                                ((npy_ubyte *)data_out + 2*5)[0];
        ((npy_ubyte *)data_out + 2*5)[1] =
                                ((npy_ubyte *)data0 + 2*5)[1] +
                                ((npy_ubyte *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*6)[0] =
                                ((npy_ubyte *)data0 + 2*6)[0] +
                                ((npy_ubyte *)data_out + 2*6)[0];
        ((npy_ubyte *)data_out + 2*6)[1] =
                                ((npy_ubyte *)data0 + 2*6)[1] +
                                ((npy_ubyte *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*7)[0] =
                                ((npy_ubyte *)data0 + 2*7)[0] +
                                ((npy_ubyte *)data_out + 2*7)[0];
        ((npy_ubyte *)data_out + 2*7)[1] =
                                ((npy_ubyte *)data0 + 2*7)[1] +
                                ((npy_ubyte *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
ubyte_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ubyte_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte value0 = (*(npy_ubyte *)dataptr[0]);
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ubyte_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte value1 = (*(npy_ubyte *)dataptr[1]);
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte value0 = (*(npy_ubyte *)dataptr[0]);
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte value1 = (*(npy_ubyte *)dataptr[1]);
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
ubyte_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data2 = (npy_ubyte *)dataptr[2];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
ubyte_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        *(npy_ubyte *)dataptr[nop] = (temp +
                                           (*(npy_ubyte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ubyte);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ubyte);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
ubyte_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ubyte accum_re = 0, accum_im = 0;
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
#else
    npy_ubyte accum = 0;
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ubyte *)dataptr[1])[0] += accum_re;
            ((npy_ubyte *)dataptr[1])[1] += accum_im;
#else
            *((npy_ubyte *)dataptr[1]) = (accum +
                                    (*((npy_ubyte *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
ubyte_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ubyte accum_re = 0, accum_im = 0;
#else
    npy_ubyte accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_ubyte *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_ubyte *)data0) *
                 (*(npy_ubyte *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_ubyte *)data0) *
                 (*(npy_ubyte *)data1) *
                 (*(npy_ubyte *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_ubyte *)data0)[0];
        accum_im += ((npy_ubyte *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_ubyte *)dataptr[3])[0] += accum_re;
    ((npy_ubyte *)dataptr[3])[1] += accum_im;
#  else
    ((npy_ubyte *)dataptr[nop])[0] += accum_re;
    ((npy_ubyte *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_ubyte *)dataptr[3]) = (accum +
                                    (*((npy_ubyte *)dataptr[3])));
#  else
    *((npy_ubyte *)dataptr[nop]) = (accum +
                                    (*((npy_ubyte *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ubyte_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) *
                                         (*(npy_ubyte *)data1) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_ubyte *)data_out = ((*(npy_ubyte *)data0) *
                                         (*(npy_ubyte *)data1) *
                                         (*(npy_ubyte *)data2) +
                                         (*(npy_ubyte *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        *(npy_ubyte *)dataptr[nop] = (temp +
                                           (*(npy_ubyte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_ubyte *)data_out)[0] = ((npy_ubyte *)data0)[0] +
                                         ((npy_ubyte *)data_out)[0];
        ((npy_ubyte *)data_out)[1] = ((npy_ubyte *)data0)[1] +
                                         ((npy_ubyte *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
ubyte_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ubyte *)data_out + 2*6)[0] =
                                    ((npy_ubyte *)data0 + 2*6)[0] +
                                    ((npy_ubyte *)data_out + 2*6)[0];
            ((npy_ubyte *)data_out + 2*6)[1] =
                                    ((npy_ubyte *)data0 + 2*6)[1] +
                                    ((npy_ubyte *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ubyte *)data_out + 2*5)[0] =
                                    ((npy_ubyte *)data0 + 2*5)[0] +
                                    ((npy_ubyte *)data_out + 2*5)[0];
            ((npy_ubyte *)data_out + 2*5)[1] =
                                    ((npy_ubyte *)data0 + 2*5)[1] +
                                    ((npy_ubyte *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ubyte *)data_out + 2*4)[0] =
                                    ((npy_ubyte *)data0 + 2*4)[0] +
                                    ((npy_ubyte *)data_out + 2*4)[0];
            ((npy_ubyte *)data_out + 2*4)[1] =
                                    ((npy_ubyte *)data0 + 2*4)[1] +
                                    ((npy_ubyte *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ubyte *)data_out + 2*3)[0] =
                                    ((npy_ubyte *)data0 + 2*3)[0] +
                                    ((npy_ubyte *)data_out + 2*3)[0];
            ((npy_ubyte *)data_out + 2*3)[1] =
                                    ((npy_ubyte *)data0 + 2*3)[1] +
                                    ((npy_ubyte *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ubyte *)data_out + 2*2)[0] =
                                    ((npy_ubyte *)data0 + 2*2)[0] +
                                    ((npy_ubyte *)data_out + 2*2)[0];
            ((npy_ubyte *)data_out + 2*2)[1] =
                                    ((npy_ubyte *)data0 + 2*2)[1] +
                                    ((npy_ubyte *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ubyte *)data_out + 2*1)[0] =
                                    ((npy_ubyte *)data0 + 2*1)[0] +
                                    ((npy_ubyte *)data_out + 2*1)[0];
            ((npy_ubyte *)data_out + 2*1)[1] =
                                    ((npy_ubyte *)data0 + 2*1)[1] +
                                    ((npy_ubyte *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ubyte *)data_out + 2*0)[0] =
                                    ((npy_ubyte *)data0 + 2*0)[0] +
                                    ((npy_ubyte *)data_out + 2*0)[0];
            ((npy_ubyte *)data_out + 2*0)[1] =
                                    ((npy_ubyte *)data0 + 2*0)[1] +
                                    ((npy_ubyte *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*0)[0] =
                                ((npy_ubyte *)data0 + 2*0)[0] +
                                ((npy_ubyte *)data_out + 2*0)[0];
        ((npy_ubyte *)data_out + 2*0)[1] =
                                ((npy_ubyte *)data0 + 2*0)[1] +
                                ((npy_ubyte *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*1)[0] =
                                ((npy_ubyte *)data0 + 2*1)[0] +
                                ((npy_ubyte *)data_out + 2*1)[0];
        ((npy_ubyte *)data_out + 2*1)[1] =
                                ((npy_ubyte *)data0 + 2*1)[1] +
                                ((npy_ubyte *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*2)[0] =
                                ((npy_ubyte *)data0 + 2*2)[0] +
                                ((npy_ubyte *)data_out + 2*2)[0];
        ((npy_ubyte *)data_out + 2*2)[1] =
                                ((npy_ubyte *)data0 + 2*2)[1] +
                                ((npy_ubyte *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*3)[0] =
                                ((npy_ubyte *)data0 + 2*3)[0] +
                                ((npy_ubyte *)data_out + 2*3)[0];
        ((npy_ubyte *)data_out + 2*3)[1] =
                                ((npy_ubyte *)data0 + 2*3)[1] +
                                ((npy_ubyte *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*4)[0] =
                                ((npy_ubyte *)data0 + 2*4)[0] +
                                ((npy_ubyte *)data_out + 2*4)[0];
        ((npy_ubyte *)data_out + 2*4)[1] =
                                ((npy_ubyte *)data0 + 2*4)[1] +
                                ((npy_ubyte *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*5)[0] =
                                ((npy_ubyte *)data0 + 2*5)[0] +
                                ((npy_ubyte *)data_out + 2*5)[0];
        ((npy_ubyte *)data_out + 2*5)[1] =
                                ((npy_ubyte *)data0 + 2*5)[1] +
                                ((npy_ubyte *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*6)[0] =
                                ((npy_ubyte *)data0 + 2*6)[0] +
                                ((npy_ubyte *)data_out + 2*6)[0];
        ((npy_ubyte *)data_out + 2*6)[1] =
                                ((npy_ubyte *)data0 + 2*6)[1] +
                                ((npy_ubyte *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ubyte *)data_out + 2*7)[0] =
                                ((npy_ubyte *)data0 + 2*7)[0] +
                                ((npy_ubyte *)data_out + 2*7)[0];
        ((npy_ubyte *)data_out + 2*7)[1] =
                                ((npy_ubyte *)data0 + 2*7)[1] +
                                ((npy_ubyte *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
ubyte_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ubyte_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte value0 = (*(npy_ubyte *)dataptr[0]);
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ubyte_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte value1 = (*(npy_ubyte *)dataptr[1]);
    npy_ubyte *data_out = (npy_ubyte *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte value0 = (*(npy_ubyte *)dataptr[0]);
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ubyte_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte value1 = (*(npy_ubyte *)dataptr[1]);
    npy_ubyte accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ubyte *)dataptr[2] = ((*(npy_ubyte *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
ubyte_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
    npy_ubyte *data1 = (npy_ubyte *)dataptr[1];
    npy_ubyte *data2 = (npy_ubyte *)dataptr[2];
    npy_ubyte *data_out = (npy_ubyte *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
ubyte_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        *(npy_ubyte *)dataptr[nop] = (temp +
                                           (*(npy_ubyte *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ubyte);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ubyte *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ubyte);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
ubyte_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ubyte accum_re = 0, accum_im = 0;
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
#else
    npy_ubyte accum = 0;
    npy_ubyte *data0 = (npy_ubyte *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ubyte *)dataptr[1])[0] += accum_re;
            ((npy_ubyte *)dataptr[1])[1] += accum_im;
#else
            *((npy_ubyte *)dataptr[1]) = (accum +
                                    (*((npy_ubyte *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
ubyte_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ubyte accum_re = 0, accum_im = 0;
#else
    npy_ubyte accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ubyte_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_ubyte *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_ubyte *)data0) *
                 (*(npy_ubyte *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_ubyte *)data0) *
                 (*(npy_ubyte *)data1) *
                 (*(npy_ubyte *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ubyte temp = (*(npy_ubyte *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ubyte *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_ubyte *)data0)[0];
        accum_im += ((npy_ubyte *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ubyte re, im, tmp;
        int i;
        re = ((npy_ubyte *)dataptr[0])[0];
        im = ((npy_ubyte *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ubyte *)dataptr[i])[0] -
                  im * ((npy_ubyte *)dataptr[i])[1];
            im = re * ((npy_ubyte *)dataptr[i])[1] +
                 im * ((npy_ubyte *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_ubyte *)dataptr[1000])[0] += accum_re;
    ((npy_ubyte *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_ubyte *)dataptr[nop])[0] += accum_re;
    ((npy_ubyte *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_ubyte *)dataptr[1000]) = (accum +
                                    (*((npy_ubyte *)dataptr[1000])));
#  else
    *((npy_ubyte *)dataptr[nop]) = (accum +
                                    (*((npy_ubyte *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
ushort_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) *
                                         (*(npy_ushort *)data1) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) *
                                         (*(npy_ushort *)data1) *
                                         (*(npy_ushort *)data2) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        *(npy_ushort *)dataptr[nop] = (temp +
                                           (*(npy_ushort *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_ushort *)data_out)[0] = ((npy_ushort *)data0)[0] +
                                         ((npy_ushort *)data_out)[0];
        ((npy_ushort *)data_out)[1] = ((npy_ushort *)data0)[1] +
                                         ((npy_ushort *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
ushort_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data_out = (npy_ushort *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ushort *)data_out + 2*6)[0] =
                                    ((npy_ushort *)data0 + 2*6)[0] +
                                    ((npy_ushort *)data_out + 2*6)[0];
            ((npy_ushort *)data_out + 2*6)[1] =
                                    ((npy_ushort *)data0 + 2*6)[1] +
                                    ((npy_ushort *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ushort *)data_out + 2*5)[0] =
                                    ((npy_ushort *)data0 + 2*5)[0] +
                                    ((npy_ushort *)data_out + 2*5)[0];
            ((npy_ushort *)data_out + 2*5)[1] =
                                    ((npy_ushort *)data0 + 2*5)[1] +
                                    ((npy_ushort *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ushort *)data_out + 2*4)[0] =
                                    ((npy_ushort *)data0 + 2*4)[0] +
                                    ((npy_ushort *)data_out + 2*4)[0];
            ((npy_ushort *)data_out + 2*4)[1] =
                                    ((npy_ushort *)data0 + 2*4)[1] +
                                    ((npy_ushort *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ushort *)data_out + 2*3)[0] =
                                    ((npy_ushort *)data0 + 2*3)[0] +
                                    ((npy_ushort *)data_out + 2*3)[0];
            ((npy_ushort *)data_out + 2*3)[1] =
                                    ((npy_ushort *)data0 + 2*3)[1] +
                                    ((npy_ushort *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ushort *)data_out + 2*2)[0] =
                                    ((npy_ushort *)data0 + 2*2)[0] +
                                    ((npy_ushort *)data_out + 2*2)[0];
            ((npy_ushort *)data_out + 2*2)[1] =
                                    ((npy_ushort *)data0 + 2*2)[1] +
                                    ((npy_ushort *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ushort *)data_out + 2*1)[0] =
                                    ((npy_ushort *)data0 + 2*1)[0] +
                                    ((npy_ushort *)data_out + 2*1)[0];
            ((npy_ushort *)data_out + 2*1)[1] =
                                    ((npy_ushort *)data0 + 2*1)[1] +
                                    ((npy_ushort *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ushort *)data_out + 2*0)[0] =
                                    ((npy_ushort *)data0 + 2*0)[0] +
                                    ((npy_ushort *)data_out + 2*0)[0];
            ((npy_ushort *)data_out + 2*0)[1] =
                                    ((npy_ushort *)data0 + 2*0)[1] +
                                    ((npy_ushort *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ushort *)data_out + 2*0)[0] =
                                ((npy_ushort *)data0 + 2*0)[0] +
                                ((npy_ushort *)data_out + 2*0)[0];
        ((npy_ushort *)data_out + 2*0)[1] =
                                ((npy_ushort *)data0 + 2*0)[1] +
                                ((npy_ushort *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ushort *)data_out + 2*1)[0] =
                                ((npy_ushort *)data0 + 2*1)[0] +
                                ((npy_ushort *)data_out + 2*1)[0];
        ((npy_ushort *)data_out + 2*1)[1] =
                                ((npy_ushort *)data0 + 2*1)[1] +
                                ((npy_ushort *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ushort *)data_out + 2*2)[0] =
                                ((npy_ushort *)data0 + 2*2)[0] +
                                ((npy_ushort *)data_out + 2*2)[0];
        ((npy_ushort *)data_out + 2*2)[1] =
                                ((npy_ushort *)data0 + 2*2)[1] +
                                ((npy_ushort *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ushort *)data_out + 2*3)[0] =
                                ((npy_ushort *)data0 + 2*3)[0] +
                                ((npy_ushort *)data_out + 2*3)[0];
        ((npy_ushort *)data_out + 2*3)[1] =
                                ((npy_ushort *)data0 + 2*3)[1] +
                                ((npy_ushort *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ushort *)data_out + 2*4)[0] =
                                ((npy_ushort *)data0 + 2*4)[0] +
                                ((npy_ushort *)data_out + 2*4)[0];
        ((npy_ushort *)data_out + 2*4)[1] =
                                ((npy_ushort *)data0 + 2*4)[1] +
                                ((npy_ushort *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ushort *)data_out + 2*5)[0] =
                                ((npy_ushort *)data0 + 2*5)[0] +
                                ((npy_ushort *)data_out + 2*5)[0];
        ((npy_ushort *)data_out + 2*5)[1] =
                                ((npy_ushort *)data0 + 2*5)[1] +
                                ((npy_ushort *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ushort *)data_out + 2*6)[0] =
                                ((npy_ushort *)data0 + 2*6)[0] +
                                ((npy_ushort *)data_out + 2*6)[0];
        ((npy_ushort *)data_out + 2*6)[1] =
                                ((npy_ushort *)data0 + 2*6)[1] +
                                ((npy_ushort *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ushort *)data_out + 2*7)[0] =
                                ((npy_ushort *)data0 + 2*7)[0] +
                                ((npy_ushort *)data_out + 2*7)[0];
        ((npy_ushort *)data_out + 2*7)[1] =
                                ((npy_ushort *)data0 + 2*7)[1] +
                                ((npy_ushort *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
ushort_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ushort_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort value0 = (*(npy_ushort *)dataptr[0]);
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ushort_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort value1 = (*(npy_ushort *)dataptr[1]);
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort value0 = (*(npy_ushort *)dataptr[0]);
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort value1 = (*(npy_ushort *)dataptr[1]);
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
ushort_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data2 = (npy_ushort *)dataptr[2];
    npy_ushort *data_out = (npy_ushort *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
ushort_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        *(npy_ushort *)dataptr[nop] = (temp +
                                           (*(npy_ushort *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ushort);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ushort);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
ushort_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ushort accum_re = 0, accum_im = 0;
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
#else
    npy_ushort accum = 0;
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ushort *)dataptr[1])[0] += accum_re;
            ((npy_ushort *)dataptr[1])[1] += accum_im;
#else
            *((npy_ushort *)dataptr[1]) = (accum +
                                    (*((npy_ushort *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
ushort_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ushort accum_re = 0, accum_im = 0;
#else
    npy_ushort accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_ushort *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_ushort *)data0) *
                 (*(npy_ushort *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_ushort *)data0) *
                 (*(npy_ushort *)data1) *
                 (*(npy_ushort *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_ushort *)data0)[0];
        accum_im += ((npy_ushort *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_ushort *)dataptr[1])[0] += accum_re;
    ((npy_ushort *)dataptr[1])[1] += accum_im;
#  else
    ((npy_ushort *)dataptr[nop])[0] += accum_re;
    ((npy_ushort *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_ushort *)dataptr[1]) = (accum +
                                    (*((npy_ushort *)dataptr[1])));
#  else
    *((npy_ushort *)dataptr[nop]) = (accum +
                                    (*((npy_ushort *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ushort_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) *
                                         (*(npy_ushort *)data1) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) *
                                         (*(npy_ushort *)data1) *
                                         (*(npy_ushort *)data2) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        *(npy_ushort *)dataptr[nop] = (temp +
                                           (*(npy_ushort *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_ushort *)data_out)[0] = ((npy_ushort *)data0)[0] +
                                         ((npy_ushort *)data_out)[0];
        ((npy_ushort *)data_out)[1] = ((npy_ushort *)data0)[1] +
                                         ((npy_ushort *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
ushort_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data_out = (npy_ushort *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ushort *)data_out + 2*6)[0] =
                                    ((npy_ushort *)data0 + 2*6)[0] +
                                    ((npy_ushort *)data_out + 2*6)[0];
            ((npy_ushort *)data_out + 2*6)[1] =
                                    ((npy_ushort *)data0 + 2*6)[1] +
                                    ((npy_ushort *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ushort *)data_out + 2*5)[0] =
                                    ((npy_ushort *)data0 + 2*5)[0] +
                                    ((npy_ushort *)data_out + 2*5)[0];
            ((npy_ushort *)data_out + 2*5)[1] =
                                    ((npy_ushort *)data0 + 2*5)[1] +
                                    ((npy_ushort *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ushort *)data_out + 2*4)[0] =
                                    ((npy_ushort *)data0 + 2*4)[0] +
                                    ((npy_ushort *)data_out + 2*4)[0];
            ((npy_ushort *)data_out + 2*4)[1] =
                                    ((npy_ushort *)data0 + 2*4)[1] +
                                    ((npy_ushort *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ushort *)data_out + 2*3)[0] =
                                    ((npy_ushort *)data0 + 2*3)[0] +
                                    ((npy_ushort *)data_out + 2*3)[0];
            ((npy_ushort *)data_out + 2*3)[1] =
                                    ((npy_ushort *)data0 + 2*3)[1] +
                                    ((npy_ushort *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ushort *)data_out + 2*2)[0] =
                                    ((npy_ushort *)data0 + 2*2)[0] +
                                    ((npy_ushort *)data_out + 2*2)[0];
            ((npy_ushort *)data_out + 2*2)[1] =
                                    ((npy_ushort *)data0 + 2*2)[1] +
                                    ((npy_ushort *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ushort *)data_out + 2*1)[0] =
                                    ((npy_ushort *)data0 + 2*1)[0] +
                                    ((npy_ushort *)data_out + 2*1)[0];
            ((npy_ushort *)data_out + 2*1)[1] =
                                    ((npy_ushort *)data0 + 2*1)[1] +
                                    ((npy_ushort *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ushort *)data_out + 2*0)[0] =
                                    ((npy_ushort *)data0 + 2*0)[0] +
                                    ((npy_ushort *)data_out + 2*0)[0];
            ((npy_ushort *)data_out + 2*0)[1] =
                                    ((npy_ushort *)data0 + 2*0)[1] +
                                    ((npy_ushort *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ushort *)data_out + 2*0)[0] =
                                ((npy_ushort *)data0 + 2*0)[0] +
                                ((npy_ushort *)data_out + 2*0)[0];
        ((npy_ushort *)data_out + 2*0)[1] =
                                ((npy_ushort *)data0 + 2*0)[1] +
                                ((npy_ushort *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ushort *)data_out + 2*1)[0] =
                                ((npy_ushort *)data0 + 2*1)[0] +
                                ((npy_ushort *)data_out + 2*1)[0];
        ((npy_ushort *)data_out + 2*1)[1] =
                                ((npy_ushort *)data0 + 2*1)[1] +
                                ((npy_ushort *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ushort *)data_out + 2*2)[0] =
                                ((npy_ushort *)data0 + 2*2)[0] +
                                ((npy_ushort *)data_out + 2*2)[0];
        ((npy_ushort *)data_out + 2*2)[1] =
                                ((npy_ushort *)data0 + 2*2)[1] +
                                ((npy_ushort *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ushort *)data_out + 2*3)[0] =
                                ((npy_ushort *)data0 + 2*3)[0] +
                                ((npy_ushort *)data_out + 2*3)[0];
        ((npy_ushort *)data_out + 2*3)[1] =
                                ((npy_ushort *)data0 + 2*3)[1] +
                                ((npy_ushort *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ushort *)data_out + 2*4)[0] =
                                ((npy_ushort *)data0 + 2*4)[0] +
                                ((npy_ushort *)data_out + 2*4)[0];
        ((npy_ushort *)data_out + 2*4)[1] =
                                ((npy_ushort *)data0 + 2*4)[1] +
                                ((npy_ushort *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ushort *)data_out + 2*5)[0] =
                                ((npy_ushort *)data0 + 2*5)[0] +
                                ((npy_ushort *)data_out + 2*5)[0];
        ((npy_ushort *)data_out + 2*5)[1] =
                                ((npy_ushort *)data0 + 2*5)[1] +
                                ((npy_ushort *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ushort *)data_out + 2*6)[0] =
                                ((npy_ushort *)data0 + 2*6)[0] +
                                ((npy_ushort *)data_out + 2*6)[0];
        ((npy_ushort *)data_out + 2*6)[1] =
                                ((npy_ushort *)data0 + 2*6)[1] +
                                ((npy_ushort *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ushort *)data_out + 2*7)[0] =
                                ((npy_ushort *)data0 + 2*7)[0] +
                                ((npy_ushort *)data_out + 2*7)[0];
        ((npy_ushort *)data_out + 2*7)[1] =
                                ((npy_ushort *)data0 + 2*7)[1] +
                                ((npy_ushort *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
ushort_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ushort_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort value0 = (*(npy_ushort *)dataptr[0]);
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ushort_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort value1 = (*(npy_ushort *)dataptr[1]);
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort value0 = (*(npy_ushort *)dataptr[0]);
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort value1 = (*(npy_ushort *)dataptr[1]);
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
ushort_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data2 = (npy_ushort *)dataptr[2];
    npy_ushort *data_out = (npy_ushort *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
ushort_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        *(npy_ushort *)dataptr[nop] = (temp +
                                           (*(npy_ushort *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ushort);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ushort);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
ushort_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ushort accum_re = 0, accum_im = 0;
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
#else
    npy_ushort accum = 0;
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ushort *)dataptr[1])[0] += accum_re;
            ((npy_ushort *)dataptr[1])[1] += accum_im;
#else
            *((npy_ushort *)dataptr[1]) = (accum +
                                    (*((npy_ushort *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
ushort_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ushort accum_re = 0, accum_im = 0;
#else
    npy_ushort accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_ushort *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_ushort *)data0) *
                 (*(npy_ushort *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_ushort *)data0) *
                 (*(npy_ushort *)data1) *
                 (*(npy_ushort *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_ushort *)data0)[0];
        accum_im += ((npy_ushort *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_ushort *)dataptr[2])[0] += accum_re;
    ((npy_ushort *)dataptr[2])[1] += accum_im;
#  else
    ((npy_ushort *)dataptr[nop])[0] += accum_re;
    ((npy_ushort *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_ushort *)dataptr[2]) = (accum +
                                    (*((npy_ushort *)dataptr[2])));
#  else
    *((npy_ushort *)dataptr[nop]) = (accum +
                                    (*((npy_ushort *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ushort_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) *
                                         (*(npy_ushort *)data1) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) *
                                         (*(npy_ushort *)data1) *
                                         (*(npy_ushort *)data2) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        *(npy_ushort *)dataptr[nop] = (temp +
                                           (*(npy_ushort *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_ushort *)data_out)[0] = ((npy_ushort *)data0)[0] +
                                         ((npy_ushort *)data_out)[0];
        ((npy_ushort *)data_out)[1] = ((npy_ushort *)data0)[1] +
                                         ((npy_ushort *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
ushort_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data_out = (npy_ushort *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ushort *)data_out + 2*6)[0] =
                                    ((npy_ushort *)data0 + 2*6)[0] +
                                    ((npy_ushort *)data_out + 2*6)[0];
            ((npy_ushort *)data_out + 2*6)[1] =
                                    ((npy_ushort *)data0 + 2*6)[1] +
                                    ((npy_ushort *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ushort *)data_out + 2*5)[0] =
                                    ((npy_ushort *)data0 + 2*5)[0] +
                                    ((npy_ushort *)data_out + 2*5)[0];
            ((npy_ushort *)data_out + 2*5)[1] =
                                    ((npy_ushort *)data0 + 2*5)[1] +
                                    ((npy_ushort *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ushort *)data_out + 2*4)[0] =
                                    ((npy_ushort *)data0 + 2*4)[0] +
                                    ((npy_ushort *)data_out + 2*4)[0];
            ((npy_ushort *)data_out + 2*4)[1] =
                                    ((npy_ushort *)data0 + 2*4)[1] +
                                    ((npy_ushort *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ushort *)data_out + 2*3)[0] =
                                    ((npy_ushort *)data0 + 2*3)[0] +
                                    ((npy_ushort *)data_out + 2*3)[0];
            ((npy_ushort *)data_out + 2*3)[1] =
                                    ((npy_ushort *)data0 + 2*3)[1] +
                                    ((npy_ushort *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ushort *)data_out + 2*2)[0] =
                                    ((npy_ushort *)data0 + 2*2)[0] +
                                    ((npy_ushort *)data_out + 2*2)[0];
            ((npy_ushort *)data_out + 2*2)[1] =
                                    ((npy_ushort *)data0 + 2*2)[1] +
                                    ((npy_ushort *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ushort *)data_out + 2*1)[0] =
                                    ((npy_ushort *)data0 + 2*1)[0] +
                                    ((npy_ushort *)data_out + 2*1)[0];
            ((npy_ushort *)data_out + 2*1)[1] =
                                    ((npy_ushort *)data0 + 2*1)[1] +
                                    ((npy_ushort *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ushort *)data_out + 2*0)[0] =
                                    ((npy_ushort *)data0 + 2*0)[0] +
                                    ((npy_ushort *)data_out + 2*0)[0];
            ((npy_ushort *)data_out + 2*0)[1] =
                                    ((npy_ushort *)data0 + 2*0)[1] +
                                    ((npy_ushort *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ushort *)data_out + 2*0)[0] =
                                ((npy_ushort *)data0 + 2*0)[0] +
                                ((npy_ushort *)data_out + 2*0)[0];
        ((npy_ushort *)data_out + 2*0)[1] =
                                ((npy_ushort *)data0 + 2*0)[1] +
                                ((npy_ushort *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ushort *)data_out + 2*1)[0] =
                                ((npy_ushort *)data0 + 2*1)[0] +
                                ((npy_ushort *)data_out + 2*1)[0];
        ((npy_ushort *)data_out + 2*1)[1] =
                                ((npy_ushort *)data0 + 2*1)[1] +
                                ((npy_ushort *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ushort *)data_out + 2*2)[0] =
                                ((npy_ushort *)data0 + 2*2)[0] +
                                ((npy_ushort *)data_out + 2*2)[0];
        ((npy_ushort *)data_out + 2*2)[1] =
                                ((npy_ushort *)data0 + 2*2)[1] +
                                ((npy_ushort *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ushort *)data_out + 2*3)[0] =
                                ((npy_ushort *)data0 + 2*3)[0] +
                                ((npy_ushort *)data_out + 2*3)[0];
        ((npy_ushort *)data_out + 2*3)[1] =
                                ((npy_ushort *)data0 + 2*3)[1] +
                                ((npy_ushort *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ushort *)data_out + 2*4)[0] =
                                ((npy_ushort *)data0 + 2*4)[0] +
                                ((npy_ushort *)data_out + 2*4)[0];
        ((npy_ushort *)data_out + 2*4)[1] =
                                ((npy_ushort *)data0 + 2*4)[1] +
                                ((npy_ushort *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ushort *)data_out + 2*5)[0] =
                                ((npy_ushort *)data0 + 2*5)[0] +
                                ((npy_ushort *)data_out + 2*5)[0];
        ((npy_ushort *)data_out + 2*5)[1] =
                                ((npy_ushort *)data0 + 2*5)[1] +
                                ((npy_ushort *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ushort *)data_out + 2*6)[0] =
                                ((npy_ushort *)data0 + 2*6)[0] +
                                ((npy_ushort *)data_out + 2*6)[0];
        ((npy_ushort *)data_out + 2*6)[1] =
                                ((npy_ushort *)data0 + 2*6)[1] +
                                ((npy_ushort *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ushort *)data_out + 2*7)[0] =
                                ((npy_ushort *)data0 + 2*7)[0] +
                                ((npy_ushort *)data_out + 2*7)[0];
        ((npy_ushort *)data_out + 2*7)[1] =
                                ((npy_ushort *)data0 + 2*7)[1] +
                                ((npy_ushort *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
ushort_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ushort_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort value0 = (*(npy_ushort *)dataptr[0]);
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ushort_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort value1 = (*(npy_ushort *)dataptr[1]);
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort value0 = (*(npy_ushort *)dataptr[0]);
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort value1 = (*(npy_ushort *)dataptr[1]);
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
ushort_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data2 = (npy_ushort *)dataptr[2];
    npy_ushort *data_out = (npy_ushort *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
ushort_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        *(npy_ushort *)dataptr[nop] = (temp +
                                           (*(npy_ushort *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ushort);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ushort);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
ushort_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ushort accum_re = 0, accum_im = 0;
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
#else
    npy_ushort accum = 0;
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ushort *)dataptr[1])[0] += accum_re;
            ((npy_ushort *)dataptr[1])[1] += accum_im;
#else
            *((npy_ushort *)dataptr[1]) = (accum +
                                    (*((npy_ushort *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
ushort_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ushort accum_re = 0, accum_im = 0;
#else
    npy_ushort accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_ushort *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_ushort *)data0) *
                 (*(npy_ushort *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_ushort *)data0) *
                 (*(npy_ushort *)data1) *
                 (*(npy_ushort *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_ushort *)data0)[0];
        accum_im += ((npy_ushort *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_ushort *)dataptr[3])[0] += accum_re;
    ((npy_ushort *)dataptr[3])[1] += accum_im;
#  else
    ((npy_ushort *)dataptr[nop])[0] += accum_re;
    ((npy_ushort *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_ushort *)dataptr[3]) = (accum +
                                    (*((npy_ushort *)dataptr[3])));
#  else
    *((npy_ushort *)dataptr[nop]) = (accum +
                                    (*((npy_ushort *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ushort_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) *
                                         (*(npy_ushort *)data1) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_ushort *)data_out = ((*(npy_ushort *)data0) *
                                         (*(npy_ushort *)data1) *
                                         (*(npy_ushort *)data2) +
                                         (*(npy_ushort *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        *(npy_ushort *)dataptr[nop] = (temp +
                                           (*(npy_ushort *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_ushort *)data_out)[0] = ((npy_ushort *)data0)[0] +
                                         ((npy_ushort *)data_out)[0];
        ((npy_ushort *)data_out)[1] = ((npy_ushort *)data0)[1] +
                                         ((npy_ushort *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
ushort_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data_out = (npy_ushort *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ushort *)data_out + 2*6)[0] =
                                    ((npy_ushort *)data0 + 2*6)[0] +
                                    ((npy_ushort *)data_out + 2*6)[0];
            ((npy_ushort *)data_out + 2*6)[1] =
                                    ((npy_ushort *)data0 + 2*6)[1] +
                                    ((npy_ushort *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ushort *)data_out + 2*5)[0] =
                                    ((npy_ushort *)data0 + 2*5)[0] +
                                    ((npy_ushort *)data_out + 2*5)[0];
            ((npy_ushort *)data_out + 2*5)[1] =
                                    ((npy_ushort *)data0 + 2*5)[1] +
                                    ((npy_ushort *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ushort *)data_out + 2*4)[0] =
                                    ((npy_ushort *)data0 + 2*4)[0] +
                                    ((npy_ushort *)data_out + 2*4)[0];
            ((npy_ushort *)data_out + 2*4)[1] =
                                    ((npy_ushort *)data0 + 2*4)[1] +
                                    ((npy_ushort *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ushort *)data_out + 2*3)[0] =
                                    ((npy_ushort *)data0 + 2*3)[0] +
                                    ((npy_ushort *)data_out + 2*3)[0];
            ((npy_ushort *)data_out + 2*3)[1] =
                                    ((npy_ushort *)data0 + 2*3)[1] +
                                    ((npy_ushort *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ushort *)data_out + 2*2)[0] =
                                    ((npy_ushort *)data0 + 2*2)[0] +
                                    ((npy_ushort *)data_out + 2*2)[0];
            ((npy_ushort *)data_out + 2*2)[1] =
                                    ((npy_ushort *)data0 + 2*2)[1] +
                                    ((npy_ushort *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ushort *)data_out + 2*1)[0] =
                                    ((npy_ushort *)data0 + 2*1)[0] +
                                    ((npy_ushort *)data_out + 2*1)[0];
            ((npy_ushort *)data_out + 2*1)[1] =
                                    ((npy_ushort *)data0 + 2*1)[1] +
                                    ((npy_ushort *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ushort *)data_out + 2*0)[0] =
                                    ((npy_ushort *)data0 + 2*0)[0] +
                                    ((npy_ushort *)data_out + 2*0)[0];
            ((npy_ushort *)data_out + 2*0)[1] =
                                    ((npy_ushort *)data0 + 2*0)[1] +
                                    ((npy_ushort *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ushort *)data_out + 2*0)[0] =
                                ((npy_ushort *)data0 + 2*0)[0] +
                                ((npy_ushort *)data_out + 2*0)[0];
        ((npy_ushort *)data_out + 2*0)[1] =
                                ((npy_ushort *)data0 + 2*0)[1] +
                                ((npy_ushort *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ushort *)data_out + 2*1)[0] =
                                ((npy_ushort *)data0 + 2*1)[0] +
                                ((npy_ushort *)data_out + 2*1)[0];
        ((npy_ushort *)data_out + 2*1)[1] =
                                ((npy_ushort *)data0 + 2*1)[1] +
                                ((npy_ushort *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ushort *)data_out + 2*2)[0] =
                                ((npy_ushort *)data0 + 2*2)[0] +
                                ((npy_ushort *)data_out + 2*2)[0];
        ((npy_ushort *)data_out + 2*2)[1] =
                                ((npy_ushort *)data0 + 2*2)[1] +
                                ((npy_ushort *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ushort *)data_out + 2*3)[0] =
                                ((npy_ushort *)data0 + 2*3)[0] +
                                ((npy_ushort *)data_out + 2*3)[0];
        ((npy_ushort *)data_out + 2*3)[1] =
                                ((npy_ushort *)data0 + 2*3)[1] +
                                ((npy_ushort *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ushort *)data_out + 2*4)[0] =
                                ((npy_ushort *)data0 + 2*4)[0] +
                                ((npy_ushort *)data_out + 2*4)[0];
        ((npy_ushort *)data_out + 2*4)[1] =
                                ((npy_ushort *)data0 + 2*4)[1] +
                                ((npy_ushort *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ushort *)data_out + 2*5)[0] =
                                ((npy_ushort *)data0 + 2*5)[0] +
                                ((npy_ushort *)data_out + 2*5)[0];
        ((npy_ushort *)data_out + 2*5)[1] =
                                ((npy_ushort *)data0 + 2*5)[1] +
                                ((npy_ushort *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ushort *)data_out + 2*6)[0] =
                                ((npy_ushort *)data0 + 2*6)[0] +
                                ((npy_ushort *)data_out + 2*6)[0];
        ((npy_ushort *)data_out + 2*6)[1] =
                                ((npy_ushort *)data0 + 2*6)[1] +
                                ((npy_ushort *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ushort *)data_out + 2*7)[0] =
                                ((npy_ushort *)data0 + 2*7)[0] +
                                ((npy_ushort *)data_out + 2*7)[0];
        ((npy_ushort *)data_out + 2*7)[1] =
                                ((npy_ushort *)data0 + 2*7)[1] +
                                ((npy_ushort *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
ushort_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ushort_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort value0 = (*(npy_ushort *)dataptr[0]);
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ushort_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort value1 = (*(npy_ushort *)dataptr[1]);
    npy_ushort *data_out = (npy_ushort *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort value0 = (*(npy_ushort *)dataptr[0]);
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ushort_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort value1 = (*(npy_ushort *)dataptr[1]);
    npy_ushort accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ushort *)dataptr[2] = ((*(npy_ushort *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
ushort_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
    npy_ushort *data1 = (npy_ushort *)dataptr[1];
    npy_ushort *data2 = (npy_ushort *)dataptr[2];
    npy_ushort *data_out = (npy_ushort *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
ushort_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        *(npy_ushort *)dataptr[nop] = (temp +
                                           (*(npy_ushort *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ushort);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ushort *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ushort *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ushort);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
ushort_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ushort accum_re = 0, accum_im = 0;
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
#else
    npy_ushort accum = 0;
    npy_ushort *data0 = (npy_ushort *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ushort *)dataptr[1])[0] += accum_re;
            ((npy_ushort *)dataptr[1])[1] += accum_im;
#else
            *((npy_ushort *)dataptr[1]) = (accum +
                                    (*((npy_ushort *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
ushort_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ushort accum_re = 0, accum_im = 0;
#else
    npy_ushort accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ushort_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_ushort *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_ushort *)data0) *
                 (*(npy_ushort *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_ushort *)data0) *
                 (*(npy_ushort *)data1) *
                 (*(npy_ushort *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ushort temp = (*(npy_ushort *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ushort *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_ushort *)data0)[0];
        accum_im += ((npy_ushort *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ushort re, im, tmp;
        int i;
        re = ((npy_ushort *)dataptr[0])[0];
        im = ((npy_ushort *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ushort *)dataptr[i])[0] -
                  im * ((npy_ushort *)dataptr[i])[1];
            im = re * ((npy_ushort *)dataptr[i])[1] +
                 im * ((npy_ushort *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_ushort *)dataptr[1000])[0] += accum_re;
    ((npy_ushort *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_ushort *)dataptr[nop])[0] += accum_re;
    ((npy_ushort *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_ushort *)dataptr[1000]) = (accum +
                                    (*((npy_ushort *)dataptr[1000])));
#  else
    *((npy_ushort *)dataptr[nop]) = (accum +
                                    (*((npy_ushort *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
uint_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_uint *)data_out = ((*(npy_uint *)data0) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_uint *)data_out = ((*(npy_uint *)data0) *
                                         (*(npy_uint *)data1) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_uint *)data_out = ((*(npy_uint *)data0) *
                                         (*(npy_uint *)data1) *
                                         (*(npy_uint *)data2) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        *(npy_uint *)dataptr[nop] = (temp +
                                           (*(npy_uint *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_uint *)data_out)[0] = ((npy_uint *)data0)[0] +
                                         ((npy_uint *)data_out)[0];
        ((npy_uint *)data_out)[1] = ((npy_uint *)data0)[1] +
                                         ((npy_uint *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_uint *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[0];
        ((npy_uint *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
uint_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data_out = (npy_uint *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_uint *)data_out + 2*6)[0] =
                                    ((npy_uint *)data0 + 2*6)[0] +
                                    ((npy_uint *)data_out + 2*6)[0];
            ((npy_uint *)data_out + 2*6)[1] =
                                    ((npy_uint *)data0 + 2*6)[1] +
                                    ((npy_uint *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_uint *)data_out + 2*5)[0] =
                                    ((npy_uint *)data0 + 2*5)[0] +
                                    ((npy_uint *)data_out + 2*5)[0];
            ((npy_uint *)data_out + 2*5)[1] =
                                    ((npy_uint *)data0 + 2*5)[1] +
                                    ((npy_uint *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_uint *)data_out + 2*4)[0] =
                                    ((npy_uint *)data0 + 2*4)[0] +
                                    ((npy_uint *)data_out + 2*4)[0];
            ((npy_uint *)data_out + 2*4)[1] =
                                    ((npy_uint *)data0 + 2*4)[1] +
                                    ((npy_uint *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_uint *)data_out + 2*3)[0] =
                                    ((npy_uint *)data0 + 2*3)[0] +
                                    ((npy_uint *)data_out + 2*3)[0];
            ((npy_uint *)data_out + 2*3)[1] =
                                    ((npy_uint *)data0 + 2*3)[1] +
                                    ((npy_uint *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_uint *)data_out + 2*2)[0] =
                                    ((npy_uint *)data0 + 2*2)[0] +
                                    ((npy_uint *)data_out + 2*2)[0];
            ((npy_uint *)data_out + 2*2)[1] =
                                    ((npy_uint *)data0 + 2*2)[1] +
                                    ((npy_uint *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_uint *)data_out + 2*1)[0] =
                                    ((npy_uint *)data0 + 2*1)[0] +
                                    ((npy_uint *)data_out + 2*1)[0];
            ((npy_uint *)data_out + 2*1)[1] =
                                    ((npy_uint *)data0 + 2*1)[1] +
                                    ((npy_uint *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_uint *)data_out + 2*0)[0] =
                                    ((npy_uint *)data0 + 2*0)[0] +
                                    ((npy_uint *)data_out + 2*0)[0];
            ((npy_uint *)data_out + 2*0)[1] =
                                    ((npy_uint *)data0 + 2*0)[1] +
                                    ((npy_uint *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_uint *)data_out + 2*0)[0] =
                                ((npy_uint *)data0 + 2*0)[0] +
                                ((npy_uint *)data_out + 2*0)[0];
        ((npy_uint *)data_out + 2*0)[1] =
                                ((npy_uint *)data0 + 2*0)[1] +
                                ((npy_uint *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_uint *)data_out + 2*1)[0] =
                                ((npy_uint *)data0 + 2*1)[0] +
                                ((npy_uint *)data_out + 2*1)[0];
        ((npy_uint *)data_out + 2*1)[1] =
                                ((npy_uint *)data0 + 2*1)[1] +
                                ((npy_uint *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_uint *)data_out + 2*2)[0] =
                                ((npy_uint *)data0 + 2*2)[0] +
                                ((npy_uint *)data_out + 2*2)[0];
        ((npy_uint *)data_out + 2*2)[1] =
                                ((npy_uint *)data0 + 2*2)[1] +
                                ((npy_uint *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_uint *)data_out + 2*3)[0] =
                                ((npy_uint *)data0 + 2*3)[0] +
                                ((npy_uint *)data_out + 2*3)[0];
        ((npy_uint *)data_out + 2*3)[1] =
                                ((npy_uint *)data0 + 2*3)[1] +
                                ((npy_uint *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_uint *)data_out + 2*4)[0] =
                                ((npy_uint *)data0 + 2*4)[0] +
                                ((npy_uint *)data_out + 2*4)[0];
        ((npy_uint *)data_out + 2*4)[1] =
                                ((npy_uint *)data0 + 2*4)[1] +
                                ((npy_uint *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_uint *)data_out + 2*5)[0] =
                                ((npy_uint *)data0 + 2*5)[0] +
                                ((npy_uint *)data_out + 2*5)[0];
        ((npy_uint *)data_out + 2*5)[1] =
                                ((npy_uint *)data0 + 2*5)[1] +
                                ((npy_uint *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_uint *)data_out + 2*6)[0] =
                                ((npy_uint *)data0 + 2*6)[0] +
                                ((npy_uint *)data_out + 2*6)[0];
        ((npy_uint *)data_out + 2*6)[1] =
                                ((npy_uint *)data0 + 2*6)[1] +
                                ((npy_uint *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_uint *)data_out + 2*7)[0] =
                                ((npy_uint *)data0 + 2*7)[0] +
                                ((npy_uint *)data_out + 2*7)[0];
        ((npy_uint *)data_out + 2*7)[1] =
                                ((npy_uint *)data0 + 2*7)[1] +
                                ((npy_uint *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
uint_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
uint_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint value0 = (*(npy_uint *)dataptr[0]);
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
uint_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint value1 = (*(npy_uint *)dataptr[1]);
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint value0 = (*(npy_uint *)dataptr[0]);
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint value1 = (*(npy_uint *)dataptr[1]);
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
uint_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data2 = (npy_uint *)dataptr[2];
    npy_uint *data_out = (npy_uint *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
uint_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        *(npy_uint *)dataptr[nop] = (temp +
                                           (*(npy_uint *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_uint);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_uint *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[0];
        ((npy_uint *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_uint);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
uint_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_uint accum_re = 0, accum_im = 0;
    npy_uint *data0 = (npy_uint *)dataptr[0];
#else
    npy_uint accum = 0;
    npy_uint *data0 = (npy_uint *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_uint *)dataptr[1])[0] += accum_re;
            ((npy_uint *)dataptr[1])[1] += accum_im;
#else
            *((npy_uint *)dataptr[1]) = (accum +
                                    (*((npy_uint *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
uint_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_uint accum_re = 0, accum_im = 0;
#else
    npy_uint accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_uint *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_uint *)data0) *
                 (*(npy_uint *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_uint *)data0) *
                 (*(npy_uint *)data1) *
                 (*(npy_uint *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_uint *)data0)[0];
        accum_im += ((npy_uint *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_uint *)dataptr[1])[0] += accum_re;
    ((npy_uint *)dataptr[1])[1] += accum_im;
#  else
    ((npy_uint *)dataptr[nop])[0] += accum_re;
    ((npy_uint *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_uint *)dataptr[1]) = (accum +
                                    (*((npy_uint *)dataptr[1])));
#  else
    *((npy_uint *)dataptr[nop]) = (accum +
                                    (*((npy_uint *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
uint_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_uint *)data_out = ((*(npy_uint *)data0) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_uint *)data_out = ((*(npy_uint *)data0) *
                                         (*(npy_uint *)data1) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_uint *)data_out = ((*(npy_uint *)data0) *
                                         (*(npy_uint *)data1) *
                                         (*(npy_uint *)data2) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        *(npy_uint *)dataptr[nop] = (temp +
                                           (*(npy_uint *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_uint *)data_out)[0] = ((npy_uint *)data0)[0] +
                                         ((npy_uint *)data_out)[0];
        ((npy_uint *)data_out)[1] = ((npy_uint *)data0)[1] +
                                         ((npy_uint *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_uint *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[0];
        ((npy_uint *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
uint_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data_out = (npy_uint *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_uint *)data_out + 2*6)[0] =
                                    ((npy_uint *)data0 + 2*6)[0] +
                                    ((npy_uint *)data_out + 2*6)[0];
            ((npy_uint *)data_out + 2*6)[1] =
                                    ((npy_uint *)data0 + 2*6)[1] +
                                    ((npy_uint *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_uint *)data_out + 2*5)[0] =
                                    ((npy_uint *)data0 + 2*5)[0] +
                                    ((npy_uint *)data_out + 2*5)[0];
            ((npy_uint *)data_out + 2*5)[1] =
                                    ((npy_uint *)data0 + 2*5)[1] +
                                    ((npy_uint *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_uint *)data_out + 2*4)[0] =
                                    ((npy_uint *)data0 + 2*4)[0] +
                                    ((npy_uint *)data_out + 2*4)[0];
            ((npy_uint *)data_out + 2*4)[1] =
                                    ((npy_uint *)data0 + 2*4)[1] +
                                    ((npy_uint *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_uint *)data_out + 2*3)[0] =
                                    ((npy_uint *)data0 + 2*3)[0] +
                                    ((npy_uint *)data_out + 2*3)[0];
            ((npy_uint *)data_out + 2*3)[1] =
                                    ((npy_uint *)data0 + 2*3)[1] +
                                    ((npy_uint *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_uint *)data_out + 2*2)[0] =
                                    ((npy_uint *)data0 + 2*2)[0] +
                                    ((npy_uint *)data_out + 2*2)[0];
            ((npy_uint *)data_out + 2*2)[1] =
                                    ((npy_uint *)data0 + 2*2)[1] +
                                    ((npy_uint *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_uint *)data_out + 2*1)[0] =
                                    ((npy_uint *)data0 + 2*1)[0] +
                                    ((npy_uint *)data_out + 2*1)[0];
            ((npy_uint *)data_out + 2*1)[1] =
                                    ((npy_uint *)data0 + 2*1)[1] +
                                    ((npy_uint *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_uint *)data_out + 2*0)[0] =
                                    ((npy_uint *)data0 + 2*0)[0] +
                                    ((npy_uint *)data_out + 2*0)[0];
            ((npy_uint *)data_out + 2*0)[1] =
                                    ((npy_uint *)data0 + 2*0)[1] +
                                    ((npy_uint *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_uint *)data_out + 2*0)[0] =
                                ((npy_uint *)data0 + 2*0)[0] +
                                ((npy_uint *)data_out + 2*0)[0];
        ((npy_uint *)data_out + 2*0)[1] =
                                ((npy_uint *)data0 + 2*0)[1] +
                                ((npy_uint *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_uint *)data_out + 2*1)[0] =
                                ((npy_uint *)data0 + 2*1)[0] +
                                ((npy_uint *)data_out + 2*1)[0];
        ((npy_uint *)data_out + 2*1)[1] =
                                ((npy_uint *)data0 + 2*1)[1] +
                                ((npy_uint *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_uint *)data_out + 2*2)[0] =
                                ((npy_uint *)data0 + 2*2)[0] +
                                ((npy_uint *)data_out + 2*2)[0];
        ((npy_uint *)data_out + 2*2)[1] =
                                ((npy_uint *)data0 + 2*2)[1] +
                                ((npy_uint *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_uint *)data_out + 2*3)[0] =
                                ((npy_uint *)data0 + 2*3)[0] +
                                ((npy_uint *)data_out + 2*3)[0];
        ((npy_uint *)data_out + 2*3)[1] =
                                ((npy_uint *)data0 + 2*3)[1] +
                                ((npy_uint *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_uint *)data_out + 2*4)[0] =
                                ((npy_uint *)data0 + 2*4)[0] +
                                ((npy_uint *)data_out + 2*4)[0];
        ((npy_uint *)data_out + 2*4)[1] =
                                ((npy_uint *)data0 + 2*4)[1] +
                                ((npy_uint *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_uint *)data_out + 2*5)[0] =
                                ((npy_uint *)data0 + 2*5)[0] +
                                ((npy_uint *)data_out + 2*5)[0];
        ((npy_uint *)data_out + 2*5)[1] =
                                ((npy_uint *)data0 + 2*5)[1] +
                                ((npy_uint *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_uint *)data_out + 2*6)[0] =
                                ((npy_uint *)data0 + 2*6)[0] +
                                ((npy_uint *)data_out + 2*6)[0];
        ((npy_uint *)data_out + 2*6)[1] =
                                ((npy_uint *)data0 + 2*6)[1] +
                                ((npy_uint *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_uint *)data_out + 2*7)[0] =
                                ((npy_uint *)data0 + 2*7)[0] +
                                ((npy_uint *)data_out + 2*7)[0];
        ((npy_uint *)data_out + 2*7)[1] =
                                ((npy_uint *)data0 + 2*7)[1] +
                                ((npy_uint *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
uint_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
uint_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint value0 = (*(npy_uint *)dataptr[0]);
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
uint_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint value1 = (*(npy_uint *)dataptr[1]);
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint value0 = (*(npy_uint *)dataptr[0]);
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint value1 = (*(npy_uint *)dataptr[1]);
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
uint_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data2 = (npy_uint *)dataptr[2];
    npy_uint *data_out = (npy_uint *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
uint_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        *(npy_uint *)dataptr[nop] = (temp +
                                           (*(npy_uint *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_uint);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_uint *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[0];
        ((npy_uint *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_uint);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
uint_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_uint accum_re = 0, accum_im = 0;
    npy_uint *data0 = (npy_uint *)dataptr[0];
#else
    npy_uint accum = 0;
    npy_uint *data0 = (npy_uint *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_uint *)dataptr[1])[0] += accum_re;
            ((npy_uint *)dataptr[1])[1] += accum_im;
#else
            *((npy_uint *)dataptr[1]) = (accum +
                                    (*((npy_uint *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
uint_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_uint accum_re = 0, accum_im = 0;
#else
    npy_uint accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_uint *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_uint *)data0) *
                 (*(npy_uint *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_uint *)data0) *
                 (*(npy_uint *)data1) *
                 (*(npy_uint *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_uint *)data0)[0];
        accum_im += ((npy_uint *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_uint *)dataptr[2])[0] += accum_re;
    ((npy_uint *)dataptr[2])[1] += accum_im;
#  else
    ((npy_uint *)dataptr[nop])[0] += accum_re;
    ((npy_uint *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_uint *)dataptr[2]) = (accum +
                                    (*((npy_uint *)dataptr[2])));
#  else
    *((npy_uint *)dataptr[nop]) = (accum +
                                    (*((npy_uint *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
uint_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_uint *)data_out = ((*(npy_uint *)data0) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_uint *)data_out = ((*(npy_uint *)data0) *
                                         (*(npy_uint *)data1) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_uint *)data_out = ((*(npy_uint *)data0) *
                                         (*(npy_uint *)data1) *
                                         (*(npy_uint *)data2) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        *(npy_uint *)dataptr[nop] = (temp +
                                           (*(npy_uint *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_uint *)data_out)[0] = ((npy_uint *)data0)[0] +
                                         ((npy_uint *)data_out)[0];
        ((npy_uint *)data_out)[1] = ((npy_uint *)data0)[1] +
                                         ((npy_uint *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_uint *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[0];
        ((npy_uint *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
uint_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data_out = (npy_uint *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_uint *)data_out + 2*6)[0] =
                                    ((npy_uint *)data0 + 2*6)[0] +
                                    ((npy_uint *)data_out + 2*6)[0];
            ((npy_uint *)data_out + 2*6)[1] =
                                    ((npy_uint *)data0 + 2*6)[1] +
                                    ((npy_uint *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_uint *)data_out + 2*5)[0] =
                                    ((npy_uint *)data0 + 2*5)[0] +
                                    ((npy_uint *)data_out + 2*5)[0];
            ((npy_uint *)data_out + 2*5)[1] =
                                    ((npy_uint *)data0 + 2*5)[1] +
                                    ((npy_uint *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_uint *)data_out + 2*4)[0] =
                                    ((npy_uint *)data0 + 2*4)[0] +
                                    ((npy_uint *)data_out + 2*4)[0];
            ((npy_uint *)data_out + 2*4)[1] =
                                    ((npy_uint *)data0 + 2*4)[1] +
                                    ((npy_uint *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_uint *)data_out + 2*3)[0] =
                                    ((npy_uint *)data0 + 2*3)[0] +
                                    ((npy_uint *)data_out + 2*3)[0];
            ((npy_uint *)data_out + 2*3)[1] =
                                    ((npy_uint *)data0 + 2*3)[1] +
                                    ((npy_uint *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_uint *)data_out + 2*2)[0] =
                                    ((npy_uint *)data0 + 2*2)[0] +
                                    ((npy_uint *)data_out + 2*2)[0];
            ((npy_uint *)data_out + 2*2)[1] =
                                    ((npy_uint *)data0 + 2*2)[1] +
                                    ((npy_uint *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_uint *)data_out + 2*1)[0] =
                                    ((npy_uint *)data0 + 2*1)[0] +
                                    ((npy_uint *)data_out + 2*1)[0];
            ((npy_uint *)data_out + 2*1)[1] =
                                    ((npy_uint *)data0 + 2*1)[1] +
                                    ((npy_uint *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_uint *)data_out + 2*0)[0] =
                                    ((npy_uint *)data0 + 2*0)[0] +
                                    ((npy_uint *)data_out + 2*0)[0];
            ((npy_uint *)data_out + 2*0)[1] =
                                    ((npy_uint *)data0 + 2*0)[1] +
                                    ((npy_uint *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_uint *)data_out + 2*0)[0] =
                                ((npy_uint *)data0 + 2*0)[0] +
                                ((npy_uint *)data_out + 2*0)[0];
        ((npy_uint *)data_out + 2*0)[1] =
                                ((npy_uint *)data0 + 2*0)[1] +
                                ((npy_uint *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_uint *)data_out + 2*1)[0] =
                                ((npy_uint *)data0 + 2*1)[0] +
                                ((npy_uint *)data_out + 2*1)[0];
        ((npy_uint *)data_out + 2*1)[1] =
                                ((npy_uint *)data0 + 2*1)[1] +
                                ((npy_uint *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_uint *)data_out + 2*2)[0] =
                                ((npy_uint *)data0 + 2*2)[0] +
                                ((npy_uint *)data_out + 2*2)[0];
        ((npy_uint *)data_out + 2*2)[1] =
                                ((npy_uint *)data0 + 2*2)[1] +
                                ((npy_uint *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_uint *)data_out + 2*3)[0] =
                                ((npy_uint *)data0 + 2*3)[0] +
                                ((npy_uint *)data_out + 2*3)[0];
        ((npy_uint *)data_out + 2*3)[1] =
                                ((npy_uint *)data0 + 2*3)[1] +
                                ((npy_uint *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_uint *)data_out + 2*4)[0] =
                                ((npy_uint *)data0 + 2*4)[0] +
                                ((npy_uint *)data_out + 2*4)[0];
        ((npy_uint *)data_out + 2*4)[1] =
                                ((npy_uint *)data0 + 2*4)[1] +
                                ((npy_uint *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_uint *)data_out + 2*5)[0] =
                                ((npy_uint *)data0 + 2*5)[0] +
                                ((npy_uint *)data_out + 2*5)[0];
        ((npy_uint *)data_out + 2*5)[1] =
                                ((npy_uint *)data0 + 2*5)[1] +
                                ((npy_uint *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_uint *)data_out + 2*6)[0] =
                                ((npy_uint *)data0 + 2*6)[0] +
                                ((npy_uint *)data_out + 2*6)[0];
        ((npy_uint *)data_out + 2*6)[1] =
                                ((npy_uint *)data0 + 2*6)[1] +
                                ((npy_uint *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_uint *)data_out + 2*7)[0] =
                                ((npy_uint *)data0 + 2*7)[0] +
                                ((npy_uint *)data_out + 2*7)[0];
        ((npy_uint *)data_out + 2*7)[1] =
                                ((npy_uint *)data0 + 2*7)[1] +
                                ((npy_uint *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
uint_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
uint_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint value0 = (*(npy_uint *)dataptr[0]);
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
uint_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint value1 = (*(npy_uint *)dataptr[1]);
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint value0 = (*(npy_uint *)dataptr[0]);
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint value1 = (*(npy_uint *)dataptr[1]);
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
uint_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data2 = (npy_uint *)dataptr[2];
    npy_uint *data_out = (npy_uint *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
uint_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        *(npy_uint *)dataptr[nop] = (temp +
                                           (*(npy_uint *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_uint);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_uint *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[0];
        ((npy_uint *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_uint);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
uint_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_uint accum_re = 0, accum_im = 0;
    npy_uint *data0 = (npy_uint *)dataptr[0];
#else
    npy_uint accum = 0;
    npy_uint *data0 = (npy_uint *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_uint *)dataptr[1])[0] += accum_re;
            ((npy_uint *)dataptr[1])[1] += accum_im;
#else
            *((npy_uint *)dataptr[1]) = (accum +
                                    (*((npy_uint *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
uint_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_uint accum_re = 0, accum_im = 0;
#else
    npy_uint accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_uint *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_uint *)data0) *
                 (*(npy_uint *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_uint *)data0) *
                 (*(npy_uint *)data1) *
                 (*(npy_uint *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_uint *)data0)[0];
        accum_im += ((npy_uint *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_uint *)dataptr[3])[0] += accum_re;
    ((npy_uint *)dataptr[3])[1] += accum_im;
#  else
    ((npy_uint *)dataptr[nop])[0] += accum_re;
    ((npy_uint *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_uint *)dataptr[3]) = (accum +
                                    (*((npy_uint *)dataptr[3])));
#  else
    *((npy_uint *)dataptr[nop]) = (accum +
                                    (*((npy_uint *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
uint_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_uint *)data_out = ((*(npy_uint *)data0) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_uint *)data_out = ((*(npy_uint *)data0) *
                                         (*(npy_uint *)data1) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_uint *)data_out = ((*(npy_uint *)data0) *
                                         (*(npy_uint *)data1) *
                                         (*(npy_uint *)data2) +
                                         (*(npy_uint *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        *(npy_uint *)dataptr[nop] = (temp +
                                           (*(npy_uint *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_uint *)data_out)[0] = ((npy_uint *)data0)[0] +
                                         ((npy_uint *)data_out)[0];
        ((npy_uint *)data_out)[1] = ((npy_uint *)data0)[1] +
                                         ((npy_uint *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_uint *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[0];
        ((npy_uint *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
uint_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data_out = (npy_uint *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_uint *)data_out + 2*6)[0] =
                                    ((npy_uint *)data0 + 2*6)[0] +
                                    ((npy_uint *)data_out + 2*6)[0];
            ((npy_uint *)data_out + 2*6)[1] =
                                    ((npy_uint *)data0 + 2*6)[1] +
                                    ((npy_uint *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_uint *)data_out + 2*5)[0] =
                                    ((npy_uint *)data0 + 2*5)[0] +
                                    ((npy_uint *)data_out + 2*5)[0];
            ((npy_uint *)data_out + 2*5)[1] =
                                    ((npy_uint *)data0 + 2*5)[1] +
                                    ((npy_uint *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_uint *)data_out + 2*4)[0] =
                                    ((npy_uint *)data0 + 2*4)[0] +
                                    ((npy_uint *)data_out + 2*4)[0];
            ((npy_uint *)data_out + 2*4)[1] =
                                    ((npy_uint *)data0 + 2*4)[1] +
                                    ((npy_uint *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_uint *)data_out + 2*3)[0] =
                                    ((npy_uint *)data0 + 2*3)[0] +
                                    ((npy_uint *)data_out + 2*3)[0];
            ((npy_uint *)data_out + 2*3)[1] =
                                    ((npy_uint *)data0 + 2*3)[1] +
                                    ((npy_uint *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_uint *)data_out + 2*2)[0] =
                                    ((npy_uint *)data0 + 2*2)[0] +
                                    ((npy_uint *)data_out + 2*2)[0];
            ((npy_uint *)data_out + 2*2)[1] =
                                    ((npy_uint *)data0 + 2*2)[1] +
                                    ((npy_uint *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_uint *)data_out + 2*1)[0] =
                                    ((npy_uint *)data0 + 2*1)[0] +
                                    ((npy_uint *)data_out + 2*1)[0];
            ((npy_uint *)data_out + 2*1)[1] =
                                    ((npy_uint *)data0 + 2*1)[1] +
                                    ((npy_uint *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_uint *)data_out + 2*0)[0] =
                                    ((npy_uint *)data0 + 2*0)[0] +
                                    ((npy_uint *)data_out + 2*0)[0];
            ((npy_uint *)data_out + 2*0)[1] =
                                    ((npy_uint *)data0 + 2*0)[1] +
                                    ((npy_uint *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_uint *)data_out + 2*0)[0] =
                                ((npy_uint *)data0 + 2*0)[0] +
                                ((npy_uint *)data_out + 2*0)[0];
        ((npy_uint *)data_out + 2*0)[1] =
                                ((npy_uint *)data0 + 2*0)[1] +
                                ((npy_uint *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_uint *)data_out + 2*1)[0] =
                                ((npy_uint *)data0 + 2*1)[0] +
                                ((npy_uint *)data_out + 2*1)[0];
        ((npy_uint *)data_out + 2*1)[1] =
                                ((npy_uint *)data0 + 2*1)[1] +
                                ((npy_uint *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_uint *)data_out + 2*2)[0] =
                                ((npy_uint *)data0 + 2*2)[0] +
                                ((npy_uint *)data_out + 2*2)[0];
        ((npy_uint *)data_out + 2*2)[1] =
                                ((npy_uint *)data0 + 2*2)[1] +
                                ((npy_uint *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_uint *)data_out + 2*3)[0] =
                                ((npy_uint *)data0 + 2*3)[0] +
                                ((npy_uint *)data_out + 2*3)[0];
        ((npy_uint *)data_out + 2*3)[1] =
                                ((npy_uint *)data0 + 2*3)[1] +
                                ((npy_uint *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_uint *)data_out + 2*4)[0] =
                                ((npy_uint *)data0 + 2*4)[0] +
                                ((npy_uint *)data_out + 2*4)[0];
        ((npy_uint *)data_out + 2*4)[1] =
                                ((npy_uint *)data0 + 2*4)[1] +
                                ((npy_uint *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_uint *)data_out + 2*5)[0] =
                                ((npy_uint *)data0 + 2*5)[0] +
                                ((npy_uint *)data_out + 2*5)[0];
        ((npy_uint *)data_out + 2*5)[1] =
                                ((npy_uint *)data0 + 2*5)[1] +
                                ((npy_uint *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_uint *)data_out + 2*6)[0] =
                                ((npy_uint *)data0 + 2*6)[0] +
                                ((npy_uint *)data_out + 2*6)[0];
        ((npy_uint *)data_out + 2*6)[1] =
                                ((npy_uint *)data0 + 2*6)[1] +
                                ((npy_uint *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_uint *)data_out + 2*7)[0] =
                                ((npy_uint *)data0 + 2*7)[0] +
                                ((npy_uint *)data_out + 2*7)[0];
        ((npy_uint *)data_out + 2*7)[1] =
                                ((npy_uint *)data0 + 2*7)[1] +
                                ((npy_uint *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
uint_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
uint_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint value0 = (*(npy_uint *)dataptr[0]);
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
uint_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint value1 = (*(npy_uint *)dataptr[1]);
    npy_uint *data_out = (npy_uint *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint value0 = (*(npy_uint *)dataptr[0]);
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
uint_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint value1 = (*(npy_uint *)dataptr[1]);
    npy_uint accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_uint *)dataptr[2] = ((*(npy_uint *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
uint_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_uint *data0 = (npy_uint *)dataptr[0];
    npy_uint *data1 = (npy_uint *)dataptr[1];
    npy_uint *data2 = (npy_uint *)dataptr[2];
    npy_uint *data_out = (npy_uint *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
uint_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        *(npy_uint *)dataptr[nop] = (temp +
                                           (*(npy_uint *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_uint);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_uint *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[0];
        ((npy_uint *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_uint *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_uint);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
uint_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_uint accum_re = 0, accum_im = 0;
    npy_uint *data0 = (npy_uint *)dataptr[0];
#else
    npy_uint accum = 0;
    npy_uint *data0 = (npy_uint *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_uint *)dataptr[1])[0] += accum_re;
            ((npy_uint *)dataptr[1])[1] += accum_im;
#else
            *((npy_uint *)dataptr[1]) = (accum +
                                    (*((npy_uint *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
uint_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_uint accum_re = 0, accum_im = 0;
#else
    npy_uint accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("uint_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_uint *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_uint *)data0) *
                 (*(npy_uint *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_uint *)data0) *
                 (*(npy_uint *)data1) *
                 (*(npy_uint *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_uint temp = (*(npy_uint *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_uint *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_uint *)data0)[0];
        accum_im += ((npy_uint *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_uint re, im, tmp;
        int i;
        re = ((npy_uint *)dataptr[0])[0];
        im = ((npy_uint *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_uint *)dataptr[i])[0] -
                  im * ((npy_uint *)dataptr[i])[1];
            im = re * ((npy_uint *)dataptr[i])[1] +
                 im * ((npy_uint *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_uint *)dataptr[1000])[0] += accum_re;
    ((npy_uint *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_uint *)dataptr[nop])[0] += accum_re;
    ((npy_uint *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_uint *)dataptr[1000]) = (accum +
                                    (*((npy_uint *)dataptr[1000])));
#  else
    *((npy_uint *)dataptr[nop]) = (accum +
                                    (*((npy_uint *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
ulong_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) *
                                         (*(npy_ulong *)data1) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) *
                                         (*(npy_ulong *)data1) *
                                         (*(npy_ulong *)data2) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        *(npy_ulong *)dataptr[nop] = (temp +
                                           (*(npy_ulong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_ulong *)data_out)[0] = ((npy_ulong *)data0)[0] +
                                         ((npy_ulong *)data_out)[0];
        ((npy_ulong *)data_out)[1] = ((npy_ulong *)data0)[1] +
                                         ((npy_ulong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
ulong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data_out = (npy_ulong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ulong *)data_out + 2*6)[0] =
                                    ((npy_ulong *)data0 + 2*6)[0] +
                                    ((npy_ulong *)data_out + 2*6)[0];
            ((npy_ulong *)data_out + 2*6)[1] =
                                    ((npy_ulong *)data0 + 2*6)[1] +
                                    ((npy_ulong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ulong *)data_out + 2*5)[0] =
                                    ((npy_ulong *)data0 + 2*5)[0] +
                                    ((npy_ulong *)data_out + 2*5)[0];
            ((npy_ulong *)data_out + 2*5)[1] =
                                    ((npy_ulong *)data0 + 2*5)[1] +
                                    ((npy_ulong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ulong *)data_out + 2*4)[0] =
                                    ((npy_ulong *)data0 + 2*4)[0] +
                                    ((npy_ulong *)data_out + 2*4)[0];
            ((npy_ulong *)data_out + 2*4)[1] =
                                    ((npy_ulong *)data0 + 2*4)[1] +
                                    ((npy_ulong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ulong *)data_out + 2*3)[0] =
                                    ((npy_ulong *)data0 + 2*3)[0] +
                                    ((npy_ulong *)data_out + 2*3)[0];
            ((npy_ulong *)data_out + 2*3)[1] =
                                    ((npy_ulong *)data0 + 2*3)[1] +
                                    ((npy_ulong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ulong *)data_out + 2*2)[0] =
                                    ((npy_ulong *)data0 + 2*2)[0] +
                                    ((npy_ulong *)data_out + 2*2)[0];
            ((npy_ulong *)data_out + 2*2)[1] =
                                    ((npy_ulong *)data0 + 2*2)[1] +
                                    ((npy_ulong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ulong *)data_out + 2*1)[0] =
                                    ((npy_ulong *)data0 + 2*1)[0] +
                                    ((npy_ulong *)data_out + 2*1)[0];
            ((npy_ulong *)data_out + 2*1)[1] =
                                    ((npy_ulong *)data0 + 2*1)[1] +
                                    ((npy_ulong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ulong *)data_out + 2*0)[0] =
                                    ((npy_ulong *)data0 + 2*0)[0] +
                                    ((npy_ulong *)data_out + 2*0)[0];
            ((npy_ulong *)data_out + 2*0)[1] =
                                    ((npy_ulong *)data0 + 2*0)[1] +
                                    ((npy_ulong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ulong *)data_out + 2*0)[0] =
                                ((npy_ulong *)data0 + 2*0)[0] +
                                ((npy_ulong *)data_out + 2*0)[0];
        ((npy_ulong *)data_out + 2*0)[1] =
                                ((npy_ulong *)data0 + 2*0)[1] +
                                ((npy_ulong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ulong *)data_out + 2*1)[0] =
                                ((npy_ulong *)data0 + 2*1)[0] +
                                ((npy_ulong *)data_out + 2*1)[0];
        ((npy_ulong *)data_out + 2*1)[1] =
                                ((npy_ulong *)data0 + 2*1)[1] +
                                ((npy_ulong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ulong *)data_out + 2*2)[0] =
                                ((npy_ulong *)data0 + 2*2)[0] +
                                ((npy_ulong *)data_out + 2*2)[0];
        ((npy_ulong *)data_out + 2*2)[1] =
                                ((npy_ulong *)data0 + 2*2)[1] +
                                ((npy_ulong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ulong *)data_out + 2*3)[0] =
                                ((npy_ulong *)data0 + 2*3)[0] +
                                ((npy_ulong *)data_out + 2*3)[0];
        ((npy_ulong *)data_out + 2*3)[1] =
                                ((npy_ulong *)data0 + 2*3)[1] +
                                ((npy_ulong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ulong *)data_out + 2*4)[0] =
                                ((npy_ulong *)data0 + 2*4)[0] +
                                ((npy_ulong *)data_out + 2*4)[0];
        ((npy_ulong *)data_out + 2*4)[1] =
                                ((npy_ulong *)data0 + 2*4)[1] +
                                ((npy_ulong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ulong *)data_out + 2*5)[0] =
                                ((npy_ulong *)data0 + 2*5)[0] +
                                ((npy_ulong *)data_out + 2*5)[0];
        ((npy_ulong *)data_out + 2*5)[1] =
                                ((npy_ulong *)data0 + 2*5)[1] +
                                ((npy_ulong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ulong *)data_out + 2*6)[0] =
                                ((npy_ulong *)data0 + 2*6)[0] +
                                ((npy_ulong *)data_out + 2*6)[0];
        ((npy_ulong *)data_out + 2*6)[1] =
                                ((npy_ulong *)data0 + 2*6)[1] +
                                ((npy_ulong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ulong *)data_out + 2*7)[0] =
                                ((npy_ulong *)data0 + 2*7)[0] +
                                ((npy_ulong *)data_out + 2*7)[0];
        ((npy_ulong *)data_out + 2*7)[1] =
                                ((npy_ulong *)data0 + 2*7)[1] +
                                ((npy_ulong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
ulong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ulong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong value0 = (*(npy_ulong *)dataptr[0]);
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ulong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong value1 = (*(npy_ulong *)dataptr[1]);
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong value0 = (*(npy_ulong *)dataptr[0]);
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong value1 = (*(npy_ulong *)dataptr[1]);
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
ulong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data2 = (npy_ulong *)dataptr[2];
    npy_ulong *data_out = (npy_ulong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
ulong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        *(npy_ulong *)dataptr[nop] = (temp +
                                           (*(npy_ulong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ulong);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ulong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
ulong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulong accum_re = 0, accum_im = 0;
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
#else
    npy_ulong accum = 0;
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ulong *)dataptr[1])[0] += accum_re;
            ((npy_ulong *)dataptr[1])[1] += accum_im;
#else
            *((npy_ulong *)dataptr[1]) = (accum +
                                    (*((npy_ulong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
ulong_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulong accum_re = 0, accum_im = 0;
#else
    npy_ulong accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_ulong *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_ulong *)data0) *
                 (*(npy_ulong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_ulong *)data0) *
                 (*(npy_ulong *)data1) *
                 (*(npy_ulong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_ulong *)data0)[0];
        accum_im += ((npy_ulong *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_ulong *)dataptr[1])[0] += accum_re;
    ((npy_ulong *)dataptr[1])[1] += accum_im;
#  else
    ((npy_ulong *)dataptr[nop])[0] += accum_re;
    ((npy_ulong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_ulong *)dataptr[1]) = (accum +
                                    (*((npy_ulong *)dataptr[1])));
#  else
    *((npy_ulong *)dataptr[nop]) = (accum +
                                    (*((npy_ulong *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ulong_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) *
                                         (*(npy_ulong *)data1) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) *
                                         (*(npy_ulong *)data1) *
                                         (*(npy_ulong *)data2) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        *(npy_ulong *)dataptr[nop] = (temp +
                                           (*(npy_ulong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_ulong *)data_out)[0] = ((npy_ulong *)data0)[0] +
                                         ((npy_ulong *)data_out)[0];
        ((npy_ulong *)data_out)[1] = ((npy_ulong *)data0)[1] +
                                         ((npy_ulong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
ulong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data_out = (npy_ulong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ulong *)data_out + 2*6)[0] =
                                    ((npy_ulong *)data0 + 2*6)[0] +
                                    ((npy_ulong *)data_out + 2*6)[0];
            ((npy_ulong *)data_out + 2*6)[1] =
                                    ((npy_ulong *)data0 + 2*6)[1] +
                                    ((npy_ulong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ulong *)data_out + 2*5)[0] =
                                    ((npy_ulong *)data0 + 2*5)[0] +
                                    ((npy_ulong *)data_out + 2*5)[0];
            ((npy_ulong *)data_out + 2*5)[1] =
                                    ((npy_ulong *)data0 + 2*5)[1] +
                                    ((npy_ulong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ulong *)data_out + 2*4)[0] =
                                    ((npy_ulong *)data0 + 2*4)[0] +
                                    ((npy_ulong *)data_out + 2*4)[0];
            ((npy_ulong *)data_out + 2*4)[1] =
                                    ((npy_ulong *)data0 + 2*4)[1] +
                                    ((npy_ulong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ulong *)data_out + 2*3)[0] =
                                    ((npy_ulong *)data0 + 2*3)[0] +
                                    ((npy_ulong *)data_out + 2*3)[0];
            ((npy_ulong *)data_out + 2*3)[1] =
                                    ((npy_ulong *)data0 + 2*3)[1] +
                                    ((npy_ulong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ulong *)data_out + 2*2)[0] =
                                    ((npy_ulong *)data0 + 2*2)[0] +
                                    ((npy_ulong *)data_out + 2*2)[0];
            ((npy_ulong *)data_out + 2*2)[1] =
                                    ((npy_ulong *)data0 + 2*2)[1] +
                                    ((npy_ulong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ulong *)data_out + 2*1)[0] =
                                    ((npy_ulong *)data0 + 2*1)[0] +
                                    ((npy_ulong *)data_out + 2*1)[0];
            ((npy_ulong *)data_out + 2*1)[1] =
                                    ((npy_ulong *)data0 + 2*1)[1] +
                                    ((npy_ulong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ulong *)data_out + 2*0)[0] =
                                    ((npy_ulong *)data0 + 2*0)[0] +
                                    ((npy_ulong *)data_out + 2*0)[0];
            ((npy_ulong *)data_out + 2*0)[1] =
                                    ((npy_ulong *)data0 + 2*0)[1] +
                                    ((npy_ulong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ulong *)data_out + 2*0)[0] =
                                ((npy_ulong *)data0 + 2*0)[0] +
                                ((npy_ulong *)data_out + 2*0)[0];
        ((npy_ulong *)data_out + 2*0)[1] =
                                ((npy_ulong *)data0 + 2*0)[1] +
                                ((npy_ulong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ulong *)data_out + 2*1)[0] =
                                ((npy_ulong *)data0 + 2*1)[0] +
                                ((npy_ulong *)data_out + 2*1)[0];
        ((npy_ulong *)data_out + 2*1)[1] =
                                ((npy_ulong *)data0 + 2*1)[1] +
                                ((npy_ulong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ulong *)data_out + 2*2)[0] =
                                ((npy_ulong *)data0 + 2*2)[0] +
                                ((npy_ulong *)data_out + 2*2)[0];
        ((npy_ulong *)data_out + 2*2)[1] =
                                ((npy_ulong *)data0 + 2*2)[1] +
                                ((npy_ulong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ulong *)data_out + 2*3)[0] =
                                ((npy_ulong *)data0 + 2*3)[0] +
                                ((npy_ulong *)data_out + 2*3)[0];
        ((npy_ulong *)data_out + 2*3)[1] =
                                ((npy_ulong *)data0 + 2*3)[1] +
                                ((npy_ulong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ulong *)data_out + 2*4)[0] =
                                ((npy_ulong *)data0 + 2*4)[0] +
                                ((npy_ulong *)data_out + 2*4)[0];
        ((npy_ulong *)data_out + 2*4)[1] =
                                ((npy_ulong *)data0 + 2*4)[1] +
                                ((npy_ulong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ulong *)data_out + 2*5)[0] =
                                ((npy_ulong *)data0 + 2*5)[0] +
                                ((npy_ulong *)data_out + 2*5)[0];
        ((npy_ulong *)data_out + 2*5)[1] =
                                ((npy_ulong *)data0 + 2*5)[1] +
                                ((npy_ulong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ulong *)data_out + 2*6)[0] =
                                ((npy_ulong *)data0 + 2*6)[0] +
                                ((npy_ulong *)data_out + 2*6)[0];
        ((npy_ulong *)data_out + 2*6)[1] =
                                ((npy_ulong *)data0 + 2*6)[1] +
                                ((npy_ulong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ulong *)data_out + 2*7)[0] =
                                ((npy_ulong *)data0 + 2*7)[0] +
                                ((npy_ulong *)data_out + 2*7)[0];
        ((npy_ulong *)data_out + 2*7)[1] =
                                ((npy_ulong *)data0 + 2*7)[1] +
                                ((npy_ulong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
ulong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ulong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong value0 = (*(npy_ulong *)dataptr[0]);
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ulong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong value1 = (*(npy_ulong *)dataptr[1]);
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong value0 = (*(npy_ulong *)dataptr[0]);
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong value1 = (*(npy_ulong *)dataptr[1]);
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
ulong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data2 = (npy_ulong *)dataptr[2];
    npy_ulong *data_out = (npy_ulong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
ulong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        *(npy_ulong *)dataptr[nop] = (temp +
                                           (*(npy_ulong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ulong);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ulong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
ulong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulong accum_re = 0, accum_im = 0;
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
#else
    npy_ulong accum = 0;
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ulong *)dataptr[1])[0] += accum_re;
            ((npy_ulong *)dataptr[1])[1] += accum_im;
#else
            *((npy_ulong *)dataptr[1]) = (accum +
                                    (*((npy_ulong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
ulong_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulong accum_re = 0, accum_im = 0;
#else
    npy_ulong accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_ulong *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_ulong *)data0) *
                 (*(npy_ulong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_ulong *)data0) *
                 (*(npy_ulong *)data1) *
                 (*(npy_ulong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_ulong *)data0)[0];
        accum_im += ((npy_ulong *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_ulong *)dataptr[2])[0] += accum_re;
    ((npy_ulong *)dataptr[2])[1] += accum_im;
#  else
    ((npy_ulong *)dataptr[nop])[0] += accum_re;
    ((npy_ulong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_ulong *)dataptr[2]) = (accum +
                                    (*((npy_ulong *)dataptr[2])));
#  else
    *((npy_ulong *)dataptr[nop]) = (accum +
                                    (*((npy_ulong *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ulong_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) *
                                         (*(npy_ulong *)data1) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) *
                                         (*(npy_ulong *)data1) *
                                         (*(npy_ulong *)data2) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        *(npy_ulong *)dataptr[nop] = (temp +
                                           (*(npy_ulong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_ulong *)data_out)[0] = ((npy_ulong *)data0)[0] +
                                         ((npy_ulong *)data_out)[0];
        ((npy_ulong *)data_out)[1] = ((npy_ulong *)data0)[1] +
                                         ((npy_ulong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
ulong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data_out = (npy_ulong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ulong *)data_out + 2*6)[0] =
                                    ((npy_ulong *)data0 + 2*6)[0] +
                                    ((npy_ulong *)data_out + 2*6)[0];
            ((npy_ulong *)data_out + 2*6)[1] =
                                    ((npy_ulong *)data0 + 2*6)[1] +
                                    ((npy_ulong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ulong *)data_out + 2*5)[0] =
                                    ((npy_ulong *)data0 + 2*5)[0] +
                                    ((npy_ulong *)data_out + 2*5)[0];
            ((npy_ulong *)data_out + 2*5)[1] =
                                    ((npy_ulong *)data0 + 2*5)[1] +
                                    ((npy_ulong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ulong *)data_out + 2*4)[0] =
                                    ((npy_ulong *)data0 + 2*4)[0] +
                                    ((npy_ulong *)data_out + 2*4)[0];
            ((npy_ulong *)data_out + 2*4)[1] =
                                    ((npy_ulong *)data0 + 2*4)[1] +
                                    ((npy_ulong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ulong *)data_out + 2*3)[0] =
                                    ((npy_ulong *)data0 + 2*3)[0] +
                                    ((npy_ulong *)data_out + 2*3)[0];
            ((npy_ulong *)data_out + 2*3)[1] =
                                    ((npy_ulong *)data0 + 2*3)[1] +
                                    ((npy_ulong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ulong *)data_out + 2*2)[0] =
                                    ((npy_ulong *)data0 + 2*2)[0] +
                                    ((npy_ulong *)data_out + 2*2)[0];
            ((npy_ulong *)data_out + 2*2)[1] =
                                    ((npy_ulong *)data0 + 2*2)[1] +
                                    ((npy_ulong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ulong *)data_out + 2*1)[0] =
                                    ((npy_ulong *)data0 + 2*1)[0] +
                                    ((npy_ulong *)data_out + 2*1)[0];
            ((npy_ulong *)data_out + 2*1)[1] =
                                    ((npy_ulong *)data0 + 2*1)[1] +
                                    ((npy_ulong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ulong *)data_out + 2*0)[0] =
                                    ((npy_ulong *)data0 + 2*0)[0] +
                                    ((npy_ulong *)data_out + 2*0)[0];
            ((npy_ulong *)data_out + 2*0)[1] =
                                    ((npy_ulong *)data0 + 2*0)[1] +
                                    ((npy_ulong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ulong *)data_out + 2*0)[0] =
                                ((npy_ulong *)data0 + 2*0)[0] +
                                ((npy_ulong *)data_out + 2*0)[0];
        ((npy_ulong *)data_out + 2*0)[1] =
                                ((npy_ulong *)data0 + 2*0)[1] +
                                ((npy_ulong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ulong *)data_out + 2*1)[0] =
                                ((npy_ulong *)data0 + 2*1)[0] +
                                ((npy_ulong *)data_out + 2*1)[0];
        ((npy_ulong *)data_out + 2*1)[1] =
                                ((npy_ulong *)data0 + 2*1)[1] +
                                ((npy_ulong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ulong *)data_out + 2*2)[0] =
                                ((npy_ulong *)data0 + 2*2)[0] +
                                ((npy_ulong *)data_out + 2*2)[0];
        ((npy_ulong *)data_out + 2*2)[1] =
                                ((npy_ulong *)data0 + 2*2)[1] +
                                ((npy_ulong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ulong *)data_out + 2*3)[0] =
                                ((npy_ulong *)data0 + 2*3)[0] +
                                ((npy_ulong *)data_out + 2*3)[0];
        ((npy_ulong *)data_out + 2*3)[1] =
                                ((npy_ulong *)data0 + 2*3)[1] +
                                ((npy_ulong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ulong *)data_out + 2*4)[0] =
                                ((npy_ulong *)data0 + 2*4)[0] +
                                ((npy_ulong *)data_out + 2*4)[0];
        ((npy_ulong *)data_out + 2*4)[1] =
                                ((npy_ulong *)data0 + 2*4)[1] +
                                ((npy_ulong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ulong *)data_out + 2*5)[0] =
                                ((npy_ulong *)data0 + 2*5)[0] +
                                ((npy_ulong *)data_out + 2*5)[0];
        ((npy_ulong *)data_out + 2*5)[1] =
                                ((npy_ulong *)data0 + 2*5)[1] +
                                ((npy_ulong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ulong *)data_out + 2*6)[0] =
                                ((npy_ulong *)data0 + 2*6)[0] +
                                ((npy_ulong *)data_out + 2*6)[0];
        ((npy_ulong *)data_out + 2*6)[1] =
                                ((npy_ulong *)data0 + 2*6)[1] +
                                ((npy_ulong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ulong *)data_out + 2*7)[0] =
                                ((npy_ulong *)data0 + 2*7)[0] +
                                ((npy_ulong *)data_out + 2*7)[0];
        ((npy_ulong *)data_out + 2*7)[1] =
                                ((npy_ulong *)data0 + 2*7)[1] +
                                ((npy_ulong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
ulong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ulong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong value0 = (*(npy_ulong *)dataptr[0]);
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ulong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong value1 = (*(npy_ulong *)dataptr[1]);
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong value0 = (*(npy_ulong *)dataptr[0]);
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong value1 = (*(npy_ulong *)dataptr[1]);
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
ulong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data2 = (npy_ulong *)dataptr[2];
    npy_ulong *data_out = (npy_ulong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
ulong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        *(npy_ulong *)dataptr[nop] = (temp +
                                           (*(npy_ulong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ulong);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ulong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
ulong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulong accum_re = 0, accum_im = 0;
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
#else
    npy_ulong accum = 0;
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ulong *)dataptr[1])[0] += accum_re;
            ((npy_ulong *)dataptr[1])[1] += accum_im;
#else
            *((npy_ulong *)dataptr[1]) = (accum +
                                    (*((npy_ulong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
ulong_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulong accum_re = 0, accum_im = 0;
#else
    npy_ulong accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_ulong *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_ulong *)data0) *
                 (*(npy_ulong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_ulong *)data0) *
                 (*(npy_ulong *)data1) *
                 (*(npy_ulong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_ulong *)data0)[0];
        accum_im += ((npy_ulong *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_ulong *)dataptr[3])[0] += accum_re;
    ((npy_ulong *)dataptr[3])[1] += accum_im;
#  else
    ((npy_ulong *)dataptr[nop])[0] += accum_re;
    ((npy_ulong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_ulong *)dataptr[3]) = (accum +
                                    (*((npy_ulong *)dataptr[3])));
#  else
    *((npy_ulong *)dataptr[nop]) = (accum +
                                    (*((npy_ulong *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ulong_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) *
                                         (*(npy_ulong *)data1) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_ulong *)data_out = ((*(npy_ulong *)data0) *
                                         (*(npy_ulong *)data1) *
                                         (*(npy_ulong *)data2) +
                                         (*(npy_ulong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        *(npy_ulong *)dataptr[nop] = (temp +
                                           (*(npy_ulong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_ulong *)data_out)[0] = ((npy_ulong *)data0)[0] +
                                         ((npy_ulong *)data_out)[0];
        ((npy_ulong *)data_out)[1] = ((npy_ulong *)data0)[1] +
                                         ((npy_ulong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
ulong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data_out = (npy_ulong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ulong *)data_out + 2*6)[0] =
                                    ((npy_ulong *)data0 + 2*6)[0] +
                                    ((npy_ulong *)data_out + 2*6)[0];
            ((npy_ulong *)data_out + 2*6)[1] =
                                    ((npy_ulong *)data0 + 2*6)[1] +
                                    ((npy_ulong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ulong *)data_out + 2*5)[0] =
                                    ((npy_ulong *)data0 + 2*5)[0] +
                                    ((npy_ulong *)data_out + 2*5)[0];
            ((npy_ulong *)data_out + 2*5)[1] =
                                    ((npy_ulong *)data0 + 2*5)[1] +
                                    ((npy_ulong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ulong *)data_out + 2*4)[0] =
                                    ((npy_ulong *)data0 + 2*4)[0] +
                                    ((npy_ulong *)data_out + 2*4)[0];
            ((npy_ulong *)data_out + 2*4)[1] =
                                    ((npy_ulong *)data0 + 2*4)[1] +
                                    ((npy_ulong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ulong *)data_out + 2*3)[0] =
                                    ((npy_ulong *)data0 + 2*3)[0] +
                                    ((npy_ulong *)data_out + 2*3)[0];
            ((npy_ulong *)data_out + 2*3)[1] =
                                    ((npy_ulong *)data0 + 2*3)[1] +
                                    ((npy_ulong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ulong *)data_out + 2*2)[0] =
                                    ((npy_ulong *)data0 + 2*2)[0] +
                                    ((npy_ulong *)data_out + 2*2)[0];
            ((npy_ulong *)data_out + 2*2)[1] =
                                    ((npy_ulong *)data0 + 2*2)[1] +
                                    ((npy_ulong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ulong *)data_out + 2*1)[0] =
                                    ((npy_ulong *)data0 + 2*1)[0] +
                                    ((npy_ulong *)data_out + 2*1)[0];
            ((npy_ulong *)data_out + 2*1)[1] =
                                    ((npy_ulong *)data0 + 2*1)[1] +
                                    ((npy_ulong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ulong *)data_out + 2*0)[0] =
                                    ((npy_ulong *)data0 + 2*0)[0] +
                                    ((npy_ulong *)data_out + 2*0)[0];
            ((npy_ulong *)data_out + 2*0)[1] =
                                    ((npy_ulong *)data0 + 2*0)[1] +
                                    ((npy_ulong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ulong *)data_out + 2*0)[0] =
                                ((npy_ulong *)data0 + 2*0)[0] +
                                ((npy_ulong *)data_out + 2*0)[0];
        ((npy_ulong *)data_out + 2*0)[1] =
                                ((npy_ulong *)data0 + 2*0)[1] +
                                ((npy_ulong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ulong *)data_out + 2*1)[0] =
                                ((npy_ulong *)data0 + 2*1)[0] +
                                ((npy_ulong *)data_out + 2*1)[0];
        ((npy_ulong *)data_out + 2*1)[1] =
                                ((npy_ulong *)data0 + 2*1)[1] +
                                ((npy_ulong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ulong *)data_out + 2*2)[0] =
                                ((npy_ulong *)data0 + 2*2)[0] +
                                ((npy_ulong *)data_out + 2*2)[0];
        ((npy_ulong *)data_out + 2*2)[1] =
                                ((npy_ulong *)data0 + 2*2)[1] +
                                ((npy_ulong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ulong *)data_out + 2*3)[0] =
                                ((npy_ulong *)data0 + 2*3)[0] +
                                ((npy_ulong *)data_out + 2*3)[0];
        ((npy_ulong *)data_out + 2*3)[1] =
                                ((npy_ulong *)data0 + 2*3)[1] +
                                ((npy_ulong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ulong *)data_out + 2*4)[0] =
                                ((npy_ulong *)data0 + 2*4)[0] +
                                ((npy_ulong *)data_out + 2*4)[0];
        ((npy_ulong *)data_out + 2*4)[1] =
                                ((npy_ulong *)data0 + 2*4)[1] +
                                ((npy_ulong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ulong *)data_out + 2*5)[0] =
                                ((npy_ulong *)data0 + 2*5)[0] +
                                ((npy_ulong *)data_out + 2*5)[0];
        ((npy_ulong *)data_out + 2*5)[1] =
                                ((npy_ulong *)data0 + 2*5)[1] +
                                ((npy_ulong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ulong *)data_out + 2*6)[0] =
                                ((npy_ulong *)data0 + 2*6)[0] +
                                ((npy_ulong *)data_out + 2*6)[0];
        ((npy_ulong *)data_out + 2*6)[1] =
                                ((npy_ulong *)data0 + 2*6)[1] +
                                ((npy_ulong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ulong *)data_out + 2*7)[0] =
                                ((npy_ulong *)data0 + 2*7)[0] +
                                ((npy_ulong *)data_out + 2*7)[0];
        ((npy_ulong *)data_out + 2*7)[1] =
                                ((npy_ulong *)data0 + 2*7)[1] +
                                ((npy_ulong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
ulong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ulong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong value0 = (*(npy_ulong *)dataptr[0]);
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ulong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong value1 = (*(npy_ulong *)dataptr[1]);
    npy_ulong *data_out = (npy_ulong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong value0 = (*(npy_ulong *)dataptr[0]);
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong value1 = (*(npy_ulong *)dataptr[1]);
    npy_ulong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ulong *)dataptr[2] = ((*(npy_ulong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
ulong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
    npy_ulong *data1 = (npy_ulong *)dataptr[1];
    npy_ulong *data2 = (npy_ulong *)dataptr[2];
    npy_ulong *data_out = (npy_ulong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
ulong_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        *(npy_ulong *)dataptr[nop] = (temp +
                                           (*(npy_ulong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ulong);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ulong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
ulong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulong accum_re = 0, accum_im = 0;
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
#else
    npy_ulong accum = 0;
    npy_ulong *data0 = (npy_ulong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ulong *)dataptr[1])[0] += accum_re;
            ((npy_ulong *)dataptr[1])[1] += accum_im;
#else
            *((npy_ulong *)dataptr[1]) = (accum +
                                    (*((npy_ulong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
ulong_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulong accum_re = 0, accum_im = 0;
#else
    npy_ulong accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ulong_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_ulong *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_ulong *)data0) *
                 (*(npy_ulong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_ulong *)data0) *
                 (*(npy_ulong *)data1) *
                 (*(npy_ulong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ulong temp = (*(npy_ulong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_ulong *)data0)[0];
        accum_im += ((npy_ulong *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulong re, im, tmp;
        int i;
        re = ((npy_ulong *)dataptr[0])[0];
        im = ((npy_ulong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulong *)dataptr[i])[0] -
                  im * ((npy_ulong *)dataptr[i])[1];
            im = re * ((npy_ulong *)dataptr[i])[1] +
                 im * ((npy_ulong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_ulong *)dataptr[1000])[0] += accum_re;
    ((npy_ulong *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_ulong *)dataptr[nop])[0] += accum_re;
    ((npy_ulong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_ulong *)dataptr[1000]) = (accum +
                                    (*((npy_ulong *)dataptr[1000])));
#  else
    *((npy_ulong *)dataptr[nop]) = (accum +
                                    (*((npy_ulong *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
ulonglong_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) *
                                         (*(npy_ulonglong *)data1) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) *
                                         (*(npy_ulonglong *)data1) *
                                         (*(npy_ulonglong *)data2) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        *(npy_ulonglong *)dataptr[nop] = (temp +
                                           (*(npy_ulonglong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_ulonglong *)data_out)[0] = ((npy_ulonglong *)data0)[0] +
                                         ((npy_ulonglong *)data_out)[0];
        ((npy_ulonglong *)data_out)[1] = ((npy_ulonglong *)data0)[1] +
                                         ((npy_ulonglong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
ulonglong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ulonglong *)data_out + 2*6)[0] =
                                    ((npy_ulonglong *)data0 + 2*6)[0] +
                                    ((npy_ulonglong *)data_out + 2*6)[0];
            ((npy_ulonglong *)data_out + 2*6)[1] =
                                    ((npy_ulonglong *)data0 + 2*6)[1] +
                                    ((npy_ulonglong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ulonglong *)data_out + 2*5)[0] =
                                    ((npy_ulonglong *)data0 + 2*5)[0] +
                                    ((npy_ulonglong *)data_out + 2*5)[0];
            ((npy_ulonglong *)data_out + 2*5)[1] =
                                    ((npy_ulonglong *)data0 + 2*5)[1] +
                                    ((npy_ulonglong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ulonglong *)data_out + 2*4)[0] =
                                    ((npy_ulonglong *)data0 + 2*4)[0] +
                                    ((npy_ulonglong *)data_out + 2*4)[0];
            ((npy_ulonglong *)data_out + 2*4)[1] =
                                    ((npy_ulonglong *)data0 + 2*4)[1] +
                                    ((npy_ulonglong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ulonglong *)data_out + 2*3)[0] =
                                    ((npy_ulonglong *)data0 + 2*3)[0] +
                                    ((npy_ulonglong *)data_out + 2*3)[0];
            ((npy_ulonglong *)data_out + 2*3)[1] =
                                    ((npy_ulonglong *)data0 + 2*3)[1] +
                                    ((npy_ulonglong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ulonglong *)data_out + 2*2)[0] =
                                    ((npy_ulonglong *)data0 + 2*2)[0] +
                                    ((npy_ulonglong *)data_out + 2*2)[0];
            ((npy_ulonglong *)data_out + 2*2)[1] =
                                    ((npy_ulonglong *)data0 + 2*2)[1] +
                                    ((npy_ulonglong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ulonglong *)data_out + 2*1)[0] =
                                    ((npy_ulonglong *)data0 + 2*1)[0] +
                                    ((npy_ulonglong *)data_out + 2*1)[0];
            ((npy_ulonglong *)data_out + 2*1)[1] =
                                    ((npy_ulonglong *)data0 + 2*1)[1] +
                                    ((npy_ulonglong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ulonglong *)data_out + 2*0)[0] =
                                    ((npy_ulonglong *)data0 + 2*0)[0] +
                                    ((npy_ulonglong *)data_out + 2*0)[0];
            ((npy_ulonglong *)data_out + 2*0)[1] =
                                    ((npy_ulonglong *)data0 + 2*0)[1] +
                                    ((npy_ulonglong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*0)[0] =
                                ((npy_ulonglong *)data0 + 2*0)[0] +
                                ((npy_ulonglong *)data_out + 2*0)[0];
        ((npy_ulonglong *)data_out + 2*0)[1] =
                                ((npy_ulonglong *)data0 + 2*0)[1] +
                                ((npy_ulonglong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*1)[0] =
                                ((npy_ulonglong *)data0 + 2*1)[0] +
                                ((npy_ulonglong *)data_out + 2*1)[0];
        ((npy_ulonglong *)data_out + 2*1)[1] =
                                ((npy_ulonglong *)data0 + 2*1)[1] +
                                ((npy_ulonglong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*2)[0] =
                                ((npy_ulonglong *)data0 + 2*2)[0] +
                                ((npy_ulonglong *)data_out + 2*2)[0];
        ((npy_ulonglong *)data_out + 2*2)[1] =
                                ((npy_ulonglong *)data0 + 2*2)[1] +
                                ((npy_ulonglong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*3)[0] =
                                ((npy_ulonglong *)data0 + 2*3)[0] +
                                ((npy_ulonglong *)data_out + 2*3)[0];
        ((npy_ulonglong *)data_out + 2*3)[1] =
                                ((npy_ulonglong *)data0 + 2*3)[1] +
                                ((npy_ulonglong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*4)[0] =
                                ((npy_ulonglong *)data0 + 2*4)[0] +
                                ((npy_ulonglong *)data_out + 2*4)[0];
        ((npy_ulonglong *)data_out + 2*4)[1] =
                                ((npy_ulonglong *)data0 + 2*4)[1] +
                                ((npy_ulonglong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*5)[0] =
                                ((npy_ulonglong *)data0 + 2*5)[0] +
                                ((npy_ulonglong *)data_out + 2*5)[0];
        ((npy_ulonglong *)data_out + 2*5)[1] =
                                ((npy_ulonglong *)data0 + 2*5)[1] +
                                ((npy_ulonglong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*6)[0] =
                                ((npy_ulonglong *)data0 + 2*6)[0] +
                                ((npy_ulonglong *)data_out + 2*6)[0];
        ((npy_ulonglong *)data_out + 2*6)[1] =
                                ((npy_ulonglong *)data0 + 2*6)[1] +
                                ((npy_ulonglong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*7)[0] =
                                ((npy_ulonglong *)data0 + 2*7)[0] +
                                ((npy_ulonglong *)data_out + 2*7)[0];
        ((npy_ulonglong *)data_out + 2*7)[1] =
                                ((npy_ulonglong *)data0 + 2*7)[1] +
                                ((npy_ulonglong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
ulonglong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ulonglong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong value0 = (*(npy_ulonglong *)dataptr[0]);
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ulonglong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong value1 = (*(npy_ulonglong *)dataptr[1]);
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong value0 = (*(npy_ulonglong *)dataptr[0]);
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong value1 = (*(npy_ulonglong *)dataptr[1]);
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
ulonglong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data2 = (npy_ulonglong *)dataptr[2];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
ulonglong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        *(npy_ulonglong *)dataptr[nop] = (temp +
                                           (*(npy_ulonglong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ulonglong);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ulonglong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
ulonglong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulonglong accum_re = 0, accum_im = 0;
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
#else
    npy_ulonglong accum = 0;
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ulonglong *)dataptr[1])[0] += accum_re;
            ((npy_ulonglong *)dataptr[1])[1] += accum_im;
#else
            *((npy_ulonglong *)dataptr[1]) = (accum +
                                    (*((npy_ulonglong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
ulonglong_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulonglong accum_re = 0, accum_im = 0;
#else
    npy_ulonglong accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_ulonglong *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_ulonglong *)data0) *
                 (*(npy_ulonglong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_ulonglong *)data0) *
                 (*(npy_ulonglong *)data1) *
                 (*(npy_ulonglong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_ulonglong *)data0)[0];
        accum_im += ((npy_ulonglong *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_ulonglong *)dataptr[1])[0] += accum_re;
    ((npy_ulonglong *)dataptr[1])[1] += accum_im;
#  else
    ((npy_ulonglong *)dataptr[nop])[0] += accum_re;
    ((npy_ulonglong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_ulonglong *)dataptr[1]) = (accum +
                                    (*((npy_ulonglong *)dataptr[1])));
#  else
    *((npy_ulonglong *)dataptr[nop]) = (accum +
                                    (*((npy_ulonglong *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ulonglong_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) *
                                         (*(npy_ulonglong *)data1) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) *
                                         (*(npy_ulonglong *)data1) *
                                         (*(npy_ulonglong *)data2) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        *(npy_ulonglong *)dataptr[nop] = (temp +
                                           (*(npy_ulonglong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_ulonglong *)data_out)[0] = ((npy_ulonglong *)data0)[0] +
                                         ((npy_ulonglong *)data_out)[0];
        ((npy_ulonglong *)data_out)[1] = ((npy_ulonglong *)data0)[1] +
                                         ((npy_ulonglong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
ulonglong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ulonglong *)data_out + 2*6)[0] =
                                    ((npy_ulonglong *)data0 + 2*6)[0] +
                                    ((npy_ulonglong *)data_out + 2*6)[0];
            ((npy_ulonglong *)data_out + 2*6)[1] =
                                    ((npy_ulonglong *)data0 + 2*6)[1] +
                                    ((npy_ulonglong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ulonglong *)data_out + 2*5)[0] =
                                    ((npy_ulonglong *)data0 + 2*5)[0] +
                                    ((npy_ulonglong *)data_out + 2*5)[0];
            ((npy_ulonglong *)data_out + 2*5)[1] =
                                    ((npy_ulonglong *)data0 + 2*5)[1] +
                                    ((npy_ulonglong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ulonglong *)data_out + 2*4)[0] =
                                    ((npy_ulonglong *)data0 + 2*4)[0] +
                                    ((npy_ulonglong *)data_out + 2*4)[0];
            ((npy_ulonglong *)data_out + 2*4)[1] =
                                    ((npy_ulonglong *)data0 + 2*4)[1] +
                                    ((npy_ulonglong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ulonglong *)data_out + 2*3)[0] =
                                    ((npy_ulonglong *)data0 + 2*3)[0] +
                                    ((npy_ulonglong *)data_out + 2*3)[0];
            ((npy_ulonglong *)data_out + 2*3)[1] =
                                    ((npy_ulonglong *)data0 + 2*3)[1] +
                                    ((npy_ulonglong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ulonglong *)data_out + 2*2)[0] =
                                    ((npy_ulonglong *)data0 + 2*2)[0] +
                                    ((npy_ulonglong *)data_out + 2*2)[0];
            ((npy_ulonglong *)data_out + 2*2)[1] =
                                    ((npy_ulonglong *)data0 + 2*2)[1] +
                                    ((npy_ulonglong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ulonglong *)data_out + 2*1)[0] =
                                    ((npy_ulonglong *)data0 + 2*1)[0] +
                                    ((npy_ulonglong *)data_out + 2*1)[0];
            ((npy_ulonglong *)data_out + 2*1)[1] =
                                    ((npy_ulonglong *)data0 + 2*1)[1] +
                                    ((npy_ulonglong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ulonglong *)data_out + 2*0)[0] =
                                    ((npy_ulonglong *)data0 + 2*0)[0] +
                                    ((npy_ulonglong *)data_out + 2*0)[0];
            ((npy_ulonglong *)data_out + 2*0)[1] =
                                    ((npy_ulonglong *)data0 + 2*0)[1] +
                                    ((npy_ulonglong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*0)[0] =
                                ((npy_ulonglong *)data0 + 2*0)[0] +
                                ((npy_ulonglong *)data_out + 2*0)[0];
        ((npy_ulonglong *)data_out + 2*0)[1] =
                                ((npy_ulonglong *)data0 + 2*0)[1] +
                                ((npy_ulonglong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*1)[0] =
                                ((npy_ulonglong *)data0 + 2*1)[0] +
                                ((npy_ulonglong *)data_out + 2*1)[0];
        ((npy_ulonglong *)data_out + 2*1)[1] =
                                ((npy_ulonglong *)data0 + 2*1)[1] +
                                ((npy_ulonglong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*2)[0] =
                                ((npy_ulonglong *)data0 + 2*2)[0] +
                                ((npy_ulonglong *)data_out + 2*2)[0];
        ((npy_ulonglong *)data_out + 2*2)[1] =
                                ((npy_ulonglong *)data0 + 2*2)[1] +
                                ((npy_ulonglong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*3)[0] =
                                ((npy_ulonglong *)data0 + 2*3)[0] +
                                ((npy_ulonglong *)data_out + 2*3)[0];
        ((npy_ulonglong *)data_out + 2*3)[1] =
                                ((npy_ulonglong *)data0 + 2*3)[1] +
                                ((npy_ulonglong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*4)[0] =
                                ((npy_ulonglong *)data0 + 2*4)[0] +
                                ((npy_ulonglong *)data_out + 2*4)[0];
        ((npy_ulonglong *)data_out + 2*4)[1] =
                                ((npy_ulonglong *)data0 + 2*4)[1] +
                                ((npy_ulonglong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*5)[0] =
                                ((npy_ulonglong *)data0 + 2*5)[0] +
                                ((npy_ulonglong *)data_out + 2*5)[0];
        ((npy_ulonglong *)data_out + 2*5)[1] =
                                ((npy_ulonglong *)data0 + 2*5)[1] +
                                ((npy_ulonglong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*6)[0] =
                                ((npy_ulonglong *)data0 + 2*6)[0] +
                                ((npy_ulonglong *)data_out + 2*6)[0];
        ((npy_ulonglong *)data_out + 2*6)[1] =
                                ((npy_ulonglong *)data0 + 2*6)[1] +
                                ((npy_ulonglong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*7)[0] =
                                ((npy_ulonglong *)data0 + 2*7)[0] +
                                ((npy_ulonglong *)data_out + 2*7)[0];
        ((npy_ulonglong *)data_out + 2*7)[1] =
                                ((npy_ulonglong *)data0 + 2*7)[1] +
                                ((npy_ulonglong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
ulonglong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ulonglong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong value0 = (*(npy_ulonglong *)dataptr[0]);
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ulonglong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong value1 = (*(npy_ulonglong *)dataptr[1]);
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong value0 = (*(npy_ulonglong *)dataptr[0]);
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong value1 = (*(npy_ulonglong *)dataptr[1]);
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
ulonglong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data2 = (npy_ulonglong *)dataptr[2];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
ulonglong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        *(npy_ulonglong *)dataptr[nop] = (temp +
                                           (*(npy_ulonglong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ulonglong);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ulonglong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
ulonglong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulonglong accum_re = 0, accum_im = 0;
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
#else
    npy_ulonglong accum = 0;
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ulonglong *)dataptr[1])[0] += accum_re;
            ((npy_ulonglong *)dataptr[1])[1] += accum_im;
#else
            *((npy_ulonglong *)dataptr[1]) = (accum +
                                    (*((npy_ulonglong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
ulonglong_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulonglong accum_re = 0, accum_im = 0;
#else
    npy_ulonglong accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_ulonglong *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_ulonglong *)data0) *
                 (*(npy_ulonglong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_ulonglong *)data0) *
                 (*(npy_ulonglong *)data1) *
                 (*(npy_ulonglong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_ulonglong *)data0)[0];
        accum_im += ((npy_ulonglong *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_ulonglong *)dataptr[2])[0] += accum_re;
    ((npy_ulonglong *)dataptr[2])[1] += accum_im;
#  else
    ((npy_ulonglong *)dataptr[nop])[0] += accum_re;
    ((npy_ulonglong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_ulonglong *)dataptr[2]) = (accum +
                                    (*((npy_ulonglong *)dataptr[2])));
#  else
    *((npy_ulonglong *)dataptr[nop]) = (accum +
                                    (*((npy_ulonglong *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ulonglong_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) *
                                         (*(npy_ulonglong *)data1) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) *
                                         (*(npy_ulonglong *)data1) *
                                         (*(npy_ulonglong *)data2) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        *(npy_ulonglong *)dataptr[nop] = (temp +
                                           (*(npy_ulonglong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_ulonglong *)data_out)[0] = ((npy_ulonglong *)data0)[0] +
                                         ((npy_ulonglong *)data_out)[0];
        ((npy_ulonglong *)data_out)[1] = ((npy_ulonglong *)data0)[1] +
                                         ((npy_ulonglong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
ulonglong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ulonglong *)data_out + 2*6)[0] =
                                    ((npy_ulonglong *)data0 + 2*6)[0] +
                                    ((npy_ulonglong *)data_out + 2*6)[0];
            ((npy_ulonglong *)data_out + 2*6)[1] =
                                    ((npy_ulonglong *)data0 + 2*6)[1] +
                                    ((npy_ulonglong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ulonglong *)data_out + 2*5)[0] =
                                    ((npy_ulonglong *)data0 + 2*5)[0] +
                                    ((npy_ulonglong *)data_out + 2*5)[0];
            ((npy_ulonglong *)data_out + 2*5)[1] =
                                    ((npy_ulonglong *)data0 + 2*5)[1] +
                                    ((npy_ulonglong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ulonglong *)data_out + 2*4)[0] =
                                    ((npy_ulonglong *)data0 + 2*4)[0] +
                                    ((npy_ulonglong *)data_out + 2*4)[0];
            ((npy_ulonglong *)data_out + 2*4)[1] =
                                    ((npy_ulonglong *)data0 + 2*4)[1] +
                                    ((npy_ulonglong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ulonglong *)data_out + 2*3)[0] =
                                    ((npy_ulonglong *)data0 + 2*3)[0] +
                                    ((npy_ulonglong *)data_out + 2*3)[0];
            ((npy_ulonglong *)data_out + 2*3)[1] =
                                    ((npy_ulonglong *)data0 + 2*3)[1] +
                                    ((npy_ulonglong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ulonglong *)data_out + 2*2)[0] =
                                    ((npy_ulonglong *)data0 + 2*2)[0] +
                                    ((npy_ulonglong *)data_out + 2*2)[0];
            ((npy_ulonglong *)data_out + 2*2)[1] =
                                    ((npy_ulonglong *)data0 + 2*2)[1] +
                                    ((npy_ulonglong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ulonglong *)data_out + 2*1)[0] =
                                    ((npy_ulonglong *)data0 + 2*1)[0] +
                                    ((npy_ulonglong *)data_out + 2*1)[0];
            ((npy_ulonglong *)data_out + 2*1)[1] =
                                    ((npy_ulonglong *)data0 + 2*1)[1] +
                                    ((npy_ulonglong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ulonglong *)data_out + 2*0)[0] =
                                    ((npy_ulonglong *)data0 + 2*0)[0] +
                                    ((npy_ulonglong *)data_out + 2*0)[0];
            ((npy_ulonglong *)data_out + 2*0)[1] =
                                    ((npy_ulonglong *)data0 + 2*0)[1] +
                                    ((npy_ulonglong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*0)[0] =
                                ((npy_ulonglong *)data0 + 2*0)[0] +
                                ((npy_ulonglong *)data_out + 2*0)[0];
        ((npy_ulonglong *)data_out + 2*0)[1] =
                                ((npy_ulonglong *)data0 + 2*0)[1] +
                                ((npy_ulonglong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*1)[0] =
                                ((npy_ulonglong *)data0 + 2*1)[0] +
                                ((npy_ulonglong *)data_out + 2*1)[0];
        ((npy_ulonglong *)data_out + 2*1)[1] =
                                ((npy_ulonglong *)data0 + 2*1)[1] +
                                ((npy_ulonglong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*2)[0] =
                                ((npy_ulonglong *)data0 + 2*2)[0] +
                                ((npy_ulonglong *)data_out + 2*2)[0];
        ((npy_ulonglong *)data_out + 2*2)[1] =
                                ((npy_ulonglong *)data0 + 2*2)[1] +
                                ((npy_ulonglong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*3)[0] =
                                ((npy_ulonglong *)data0 + 2*3)[0] +
                                ((npy_ulonglong *)data_out + 2*3)[0];
        ((npy_ulonglong *)data_out + 2*3)[1] =
                                ((npy_ulonglong *)data0 + 2*3)[1] +
                                ((npy_ulonglong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*4)[0] =
                                ((npy_ulonglong *)data0 + 2*4)[0] +
                                ((npy_ulonglong *)data_out + 2*4)[0];
        ((npy_ulonglong *)data_out + 2*4)[1] =
                                ((npy_ulonglong *)data0 + 2*4)[1] +
                                ((npy_ulonglong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*5)[0] =
                                ((npy_ulonglong *)data0 + 2*5)[0] +
                                ((npy_ulonglong *)data_out + 2*5)[0];
        ((npy_ulonglong *)data_out + 2*5)[1] =
                                ((npy_ulonglong *)data0 + 2*5)[1] +
                                ((npy_ulonglong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*6)[0] =
                                ((npy_ulonglong *)data0 + 2*6)[0] +
                                ((npy_ulonglong *)data_out + 2*6)[0];
        ((npy_ulonglong *)data_out + 2*6)[1] =
                                ((npy_ulonglong *)data0 + 2*6)[1] +
                                ((npy_ulonglong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*7)[0] =
                                ((npy_ulonglong *)data0 + 2*7)[0] +
                                ((npy_ulonglong *)data_out + 2*7)[0];
        ((npy_ulonglong *)data_out + 2*7)[1] =
                                ((npy_ulonglong *)data0 + 2*7)[1] +
                                ((npy_ulonglong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
ulonglong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ulonglong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong value0 = (*(npy_ulonglong *)dataptr[0]);
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ulonglong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong value1 = (*(npy_ulonglong *)dataptr[1]);
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong value0 = (*(npy_ulonglong *)dataptr[0]);
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong value1 = (*(npy_ulonglong *)dataptr[1]);
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
ulonglong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data2 = (npy_ulonglong *)dataptr[2];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
ulonglong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        *(npy_ulonglong *)dataptr[nop] = (temp +
                                           (*(npy_ulonglong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ulonglong);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ulonglong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
ulonglong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulonglong accum_re = 0, accum_im = 0;
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
#else
    npy_ulonglong accum = 0;
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ulonglong *)dataptr[1])[0] += accum_re;
            ((npy_ulonglong *)dataptr[1])[1] += accum_im;
#else
            *((npy_ulonglong *)dataptr[1]) = (accum +
                                    (*((npy_ulonglong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
ulonglong_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulonglong accum_re = 0, accum_im = 0;
#else
    npy_ulonglong accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_ulonglong *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_ulonglong *)data0) *
                 (*(npy_ulonglong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_ulonglong *)data0) *
                 (*(npy_ulonglong *)data1) *
                 (*(npy_ulonglong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_ulonglong *)data0)[0];
        accum_im += ((npy_ulonglong *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_ulonglong *)dataptr[3])[0] += accum_re;
    ((npy_ulonglong *)dataptr[3])[1] += accum_im;
#  else
    ((npy_ulonglong *)dataptr[nop])[0] += accum_re;
    ((npy_ulonglong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_ulonglong *)dataptr[3]) = (accum +
                                    (*((npy_ulonglong *)dataptr[3])));
#  else
    *((npy_ulonglong *)dataptr[nop]) = (accum +
                                    (*((npy_ulonglong *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
ulonglong_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) *
                                         (*(npy_ulonglong *)data1) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_ulonglong *)data_out = ((*(npy_ulonglong *)data0) *
                                         (*(npy_ulonglong *)data1) *
                                         (*(npy_ulonglong *)data2) +
                                         (*(npy_ulonglong *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        *(npy_ulonglong *)dataptr[nop] = (temp +
                                           (*(npy_ulonglong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_ulonglong *)data_out)[0] = ((npy_ulonglong *)data0)[0] +
                                         ((npy_ulonglong *)data_out)[0];
        ((npy_ulonglong *)data_out)[1] = ((npy_ulonglong *)data0)[1] +
                                         ((npy_ulonglong *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
ulonglong_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_ulonglong *)data_out + 2*6)[0] =
                                    ((npy_ulonglong *)data0 + 2*6)[0] +
                                    ((npy_ulonglong *)data_out + 2*6)[0];
            ((npy_ulonglong *)data_out + 2*6)[1] =
                                    ((npy_ulonglong *)data0 + 2*6)[1] +
                                    ((npy_ulonglong *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_ulonglong *)data_out + 2*5)[0] =
                                    ((npy_ulonglong *)data0 + 2*5)[0] +
                                    ((npy_ulonglong *)data_out + 2*5)[0];
            ((npy_ulonglong *)data_out + 2*5)[1] =
                                    ((npy_ulonglong *)data0 + 2*5)[1] +
                                    ((npy_ulonglong *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_ulonglong *)data_out + 2*4)[0] =
                                    ((npy_ulonglong *)data0 + 2*4)[0] +
                                    ((npy_ulonglong *)data_out + 2*4)[0];
            ((npy_ulonglong *)data_out + 2*4)[1] =
                                    ((npy_ulonglong *)data0 + 2*4)[1] +
                                    ((npy_ulonglong *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_ulonglong *)data_out + 2*3)[0] =
                                    ((npy_ulonglong *)data0 + 2*3)[0] +
                                    ((npy_ulonglong *)data_out + 2*3)[0];
            ((npy_ulonglong *)data_out + 2*3)[1] =
                                    ((npy_ulonglong *)data0 + 2*3)[1] +
                                    ((npy_ulonglong *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_ulonglong *)data_out + 2*2)[0] =
                                    ((npy_ulonglong *)data0 + 2*2)[0] +
                                    ((npy_ulonglong *)data_out + 2*2)[0];
            ((npy_ulonglong *)data_out + 2*2)[1] =
                                    ((npy_ulonglong *)data0 + 2*2)[1] +
                                    ((npy_ulonglong *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_ulonglong *)data_out + 2*1)[0] =
                                    ((npy_ulonglong *)data0 + 2*1)[0] +
                                    ((npy_ulonglong *)data_out + 2*1)[0];
            ((npy_ulonglong *)data_out + 2*1)[1] =
                                    ((npy_ulonglong *)data0 + 2*1)[1] +
                                    ((npy_ulonglong *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_ulonglong *)data_out + 2*0)[0] =
                                    ((npy_ulonglong *)data0 + 2*0)[0] +
                                    ((npy_ulonglong *)data_out + 2*0)[0];
            ((npy_ulonglong *)data_out + 2*0)[1] =
                                    ((npy_ulonglong *)data0 + 2*0)[1] +
                                    ((npy_ulonglong *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*0)[0] =
                                ((npy_ulonglong *)data0 + 2*0)[0] +
                                ((npy_ulonglong *)data_out + 2*0)[0];
        ((npy_ulonglong *)data_out + 2*0)[1] =
                                ((npy_ulonglong *)data0 + 2*0)[1] +
                                ((npy_ulonglong *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*1)[0] =
                                ((npy_ulonglong *)data0 + 2*1)[0] +
                                ((npy_ulonglong *)data_out + 2*1)[0];
        ((npy_ulonglong *)data_out + 2*1)[1] =
                                ((npy_ulonglong *)data0 + 2*1)[1] +
                                ((npy_ulonglong *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*2)[0] =
                                ((npy_ulonglong *)data0 + 2*2)[0] +
                                ((npy_ulonglong *)data_out + 2*2)[0];
        ((npy_ulonglong *)data_out + 2*2)[1] =
                                ((npy_ulonglong *)data0 + 2*2)[1] +
                                ((npy_ulonglong *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*3)[0] =
                                ((npy_ulonglong *)data0 + 2*3)[0] +
                                ((npy_ulonglong *)data_out + 2*3)[0];
        ((npy_ulonglong *)data_out + 2*3)[1] =
                                ((npy_ulonglong *)data0 + 2*3)[1] +
                                ((npy_ulonglong *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*4)[0] =
                                ((npy_ulonglong *)data0 + 2*4)[0] +
                                ((npy_ulonglong *)data_out + 2*4)[0];
        ((npy_ulonglong *)data_out + 2*4)[1] =
                                ((npy_ulonglong *)data0 + 2*4)[1] +
                                ((npy_ulonglong *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*5)[0] =
                                ((npy_ulonglong *)data0 + 2*5)[0] +
                                ((npy_ulonglong *)data_out + 2*5)[0];
        ((npy_ulonglong *)data_out + 2*5)[1] =
                                ((npy_ulonglong *)data0 + 2*5)[1] +
                                ((npy_ulonglong *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*6)[0] =
                                ((npy_ulonglong *)data0 + 2*6)[0] +
                                ((npy_ulonglong *)data_out + 2*6)[0];
        ((npy_ulonglong *)data_out + 2*6)[1] =
                                ((npy_ulonglong *)data0 + 2*6)[1] +
                                ((npy_ulonglong *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_ulonglong *)data_out + 2*7)[0] =
                                ((npy_ulonglong *)data0 + 2*7)[0] +
                                ((npy_ulonglong *)data_out + 2*7)[0];
        ((npy_ulonglong *)data_out + 2*7)[1] =
                                ((npy_ulonglong *)data0 + 2*7)[1] +
                                ((npy_ulonglong *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
ulonglong_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
ulonglong_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong value0 = (*(npy_ulonglong *)dataptr[0]);
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
ulonglong_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong value1 = (*(npy_ulonglong *)dataptr[1]);
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong value0 = (*(npy_ulonglong *)dataptr[0]);
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
ulonglong_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong value1 = (*(npy_ulonglong *)dataptr[1]);
    npy_ulonglong accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_ulonglong *)dataptr[2] = ((*(npy_ulonglong *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
ulonglong_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
    npy_ulonglong *data1 = (npy_ulonglong *)dataptr[1];
    npy_ulonglong *data2 = (npy_ulonglong *)dataptr[2];
    npy_ulonglong *data_out = (npy_ulonglong *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
ulonglong_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        *(npy_ulonglong *)dataptr[nop] = (temp +
                                           (*(npy_ulonglong *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_ulonglong);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[0];
        ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_ulonglong *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_ulonglong);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
ulonglong_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulonglong accum_re = 0, accum_im = 0;
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
#else
    npy_ulonglong accum = 0;
    npy_ulonglong *data0 = (npy_ulonglong *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_ulonglong *)dataptr[1])[0] += accum_re;
            ((npy_ulonglong *)dataptr[1])[1] += accum_im;
#else
            *((npy_ulonglong *)dataptr[1]) = (accum +
                                    (*((npy_ulonglong *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
ulonglong_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_ulonglong accum_re = 0, accum_im = 0;
#else
    npy_ulonglong accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("ulonglong_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_ulonglong *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_ulonglong *)data0) *
                 (*(npy_ulonglong *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_ulonglong *)data0) *
                 (*(npy_ulonglong *)data1) *
                 (*(npy_ulonglong *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_ulonglong temp = (*(npy_ulonglong *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_ulonglong *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_ulonglong *)data0)[0];
        accum_im += ((npy_ulonglong *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_ulonglong re, im, tmp;
        int i;
        re = ((npy_ulonglong *)dataptr[0])[0];
        im = ((npy_ulonglong *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_ulonglong *)dataptr[i])[0] -
                  im * ((npy_ulonglong *)dataptr[i])[1];
            im = re * ((npy_ulonglong *)dataptr[i])[1] +
                 im * ((npy_ulonglong *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_ulonglong *)dataptr[1000])[0] += accum_re;
    ((npy_ulonglong *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_ulonglong *)dataptr[nop])[0] += accum_re;
    ((npy_ulonglong *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_ulonglong *)dataptr[1000]) = (accum +
                                    (*((npy_ulonglong *)dataptr[1000])));
#  else
    *((npy_ulonglong *)dataptr[nop]) = (accum +
                                    (*((npy_ulonglong *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
half_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) *
                                         npy_half_to_float(*(npy_half *)data1) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) *
                                         npy_half_to_float(*(npy_half *)data1) *
                                         npy_half_to_float(*(npy_half *)data2) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        *(npy_half *)dataptr[nop] = npy_float_to_half(temp +
                                           npy_half_to_float(*(npy_half *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
half_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data_out = (npy_half *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) +
                                 npy_half_to_float(data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) +
                                 npy_half_to_float(data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) +
                                 npy_half_to_float(data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) +
                                 npy_half_to_float(data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) +
                                 npy_half_to_float(data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) +
                                 npy_half_to_float(data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) +
                                 npy_half_to_float(data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) +
                             npy_half_to_float(data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) +
                             npy_half_to_float(data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) +
                             npy_half_to_float(data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) +
                             npy_half_to_float(data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) +
                             npy_half_to_float(data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) +
                             npy_half_to_float(data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) +
                             npy_half_to_float(data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) +
                             npy_half_to_float(data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
half_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                                 npy_half_to_float(data1[6]) +
                                 npy_half_to_float(data_out[6]));

#line 269
        case 5+1:
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                                 npy_half_to_float(data1[5]) +
                                 npy_half_to_float(data_out[5]));

#line 269
        case 4+1:
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                                 npy_half_to_float(data1[4]) +
                                 npy_half_to_float(data_out[4]));

#line 269
        case 3+1:
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                                 npy_half_to_float(data1[3]) +
                                 npy_half_to_float(data_out[3]));

#line 269
        case 2+1:
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                                 npy_half_to_float(data1[2]) +
                                 npy_half_to_float(data_out[2]));

#line 269
        case 1+1:
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                                 npy_half_to_float(data1[1]) +
                                 npy_half_to_float(data_out[1]));

#line 269
        case 0+1:
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                                 npy_half_to_float(data1[0]) +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                             npy_half_to_float(data1[0]) +
                             npy_half_to_float(data_out[0]));

#line 350
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                             npy_half_to_float(data1[1]) +
                             npy_half_to_float(data_out[1]));

#line 350
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                             npy_half_to_float(data1[2]) +
                             npy_half_to_float(data_out[2]));

#line 350
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                             npy_half_to_float(data1[3]) +
                             npy_half_to_float(data_out[3]));

#line 350
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                             npy_half_to_float(data1[4]) +
                             npy_half_to_float(data_out[4]));

#line 350
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                             npy_half_to_float(data1[5]) +
                             npy_half_to_float(data_out[5]));

#line 350
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                             npy_half_to_float(data1[6]) +
                             npy_half_to_float(data_out[6]));

#line 350
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                             npy_half_to_float(data1[7]) +
                             npy_half_to_float(data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
half_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = npy_half_to_float(*(npy_half *)dataptr[0]);
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[6]) +
                                 npy_half_to_float(data_out[6]));

#line 388
        case 5+1:
            data_out[5] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[5]) +
                                 npy_half_to_float(data_out[5]));

#line 388
        case 4+1:
            data_out[4] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[4]) +
                                 npy_half_to_float(data_out[4]));

#line 388
        case 3+1:
            data_out[3] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[3]) +
                                 npy_half_to_float(data_out[3]));

#line 388
        case 2+1:
            data_out[2] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[2]) +
                                 npy_half_to_float(data_out[2]));

#line 388
        case 1+1:
            data_out[1] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[1]) +
                                 npy_half_to_float(data_out[1]));

#line 388
        case 0+1:
            data_out[0] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[0]) +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[0]) +
                             npy_half_to_float(data_out[0]));

#line 479
        data_out[1] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[1]) +
                             npy_half_to_float(data_out[1]));

#line 479
        data_out[2] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[2]) +
                             npy_half_to_float(data_out[2]));

#line 479
        data_out[3] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[3]) +
                             npy_half_to_float(data_out[3]));

#line 479
        data_out[4] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[4]) +
                             npy_half_to_float(data_out[4]));

#line 479
        data_out[5] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[5]) +
                             npy_half_to_float(data_out[5]));

#line 479
        data_out[6] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[6]) +
                             npy_half_to_float(data_out[6]));

#line 479
        data_out[7] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[7]) +
                             npy_half_to_float(data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
half_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_float value1 = npy_half_to_float(*(npy_half *)dataptr[1]);
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6])*
                                 value1  +
                                 npy_half_to_float(data_out[6]));

#line 517
        case 5+1:
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5])*
                                 value1  +
                                 npy_half_to_float(data_out[5]));

#line 517
        case 4+1:
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4])*
                                 value1  +
                                 npy_half_to_float(data_out[4]));

#line 517
        case 3+1:
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3])*
                                 value1  +
                                 npy_half_to_float(data_out[3]));

#line 517
        case 2+1:
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2])*
                                 value1  +
                                 npy_half_to_float(data_out[2]));

#line 517
        case 1+1:
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1])*
                                 value1  +
                                 npy_half_to_float(data_out[1]));

#line 517
        case 0+1:
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0])*
                                 value1  +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0])*
                             value1  +
                             npy_half_to_float(data_out[0]));

#line 598
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1])*
                             value1  +
                             npy_half_to_float(data_out[1]));

#line 598
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2])*
                             value1  +
                             npy_half_to_float(data_out[2]));

#line 598
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3])*
                             value1  +
                             npy_half_to_float(data_out[3]));

#line 598
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4])*
                             value1  +
                             npy_half_to_float(data_out[4]));

#line 598
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5])*
                             value1  +
                             npy_half_to_float(data_out[5]));

#line 598
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6])*
                             value1  +
                             npy_half_to_float(data_out[6]));

#line 598
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7])*
                             value1  +
                             npy_half_to_float(data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += npy_half_to_float(data0[6]) * npy_half_to_float(data1[6]);

#line 634
        case 5+1:
            accum += npy_half_to_float(data0[5]) * npy_half_to_float(data1[5]);

#line 634
        case 4+1:
            accum += npy_half_to_float(data0[4]) * npy_half_to_float(data1[4]);

#line 634
        case 3+1:
            accum += npy_half_to_float(data0[3]) * npy_half_to_float(data1[3]);

#line 634
        case 2+1:
            accum += npy_half_to_float(data0[2]) * npy_half_to_float(data1[2]);

#line 634
        case 1+1:
            accum += npy_half_to_float(data0[1]) * npy_half_to_float(data1[1]);

#line 634
        case 0+1:
            accum += npy_half_to_float(data0[0]) * npy_half_to_float(data1[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += npy_half_to_float(data0[0]) * npy_half_to_float(data1[0]);

#line 746
        accum += npy_half_to_float(data0[1]) * npy_half_to_float(data1[1]);

#line 746
        accum += npy_half_to_float(data0[2]) * npy_half_to_float(data1[2]);

#line 746
        accum += npy_half_to_float(data0[3]) * npy_half_to_float(data1[3]);

#line 746
        accum += npy_half_to_float(data0[4]) * npy_half_to_float(data1[4]);

#line 746
        accum += npy_half_to_float(data0[5]) * npy_half_to_float(data1[5]);

#line 746
        accum += npy_half_to_float(data0[6]) * npy_half_to_float(data1[6]);

#line 746
        accum += npy_half_to_float(data0[7]) * npy_half_to_float(data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = npy_half_to_float(*(npy_half *)dataptr[0]);
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += npy_half_to_float(data1[6]);

#line 794
        case 5+1:
            accum += npy_half_to_float(data1[5]);

#line 794
        case 4+1:
            accum += npy_half_to_float(data1[4]);

#line 794
        case 3+1:
            accum += npy_half_to_float(data1[3]);

#line 794
        case 2+1:
            accum += npy_half_to_float(data1[2]);

#line 794
        case 1+1:
            accum += npy_half_to_float(data1[1]);

#line 794
        case 0+1:
            accum += npy_half_to_float(data1[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += npy_half_to_float(data1[0]);

#line 886
        accum += npy_half_to_float(data1[1]);

#line 886
        accum += npy_half_to_float(data1[2]);

#line 886
        accum += npy_half_to_float(data1[3]);

#line 886
        accum += npy_half_to_float(data1[4]);

#line 886
        accum += npy_half_to_float(data1[5]);

#line 886
        accum += npy_half_to_float(data1[6]);

#line 886
        accum += npy_half_to_float(data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_float value1 = npy_half_to_float(*(npy_half *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += npy_half_to_float(data0[6]);

#line 933
        case 5+1:
            accum += npy_half_to_float(data0[5]);

#line 933
        case 4+1:
            accum += npy_half_to_float(data0[4]);

#line 933
        case 3+1:
            accum += npy_half_to_float(data0[3]);

#line 933
        case 2+1:
            accum += npy_half_to_float(data0[2]);

#line 933
        case 1+1:
            accum += npy_half_to_float(data0[1]);

#line 933
        case 0+1:
            accum += npy_half_to_float(data0[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += npy_half_to_float(data0[0]);

#line 1023
        accum += npy_half_to_float(data0[1]);

#line 1023
        accum += npy_half_to_float(data0[2]);

#line 1023
        accum += npy_half_to_float(data0[3]);

#line 1023
        accum += npy_half_to_float(data0[4]);

#line 1023
        accum += npy_half_to_float(data0[5]);

#line 1023
        accum += npy_half_to_float(data0[6]);

#line 1023
        accum += npy_half_to_float(data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
half_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data2 = (npy_half *)dataptr[2];
    npy_half *data_out = (npy_half *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                             npy_half_to_float(data1[0]) *
                             npy_half_to_float(data2[0]) +
                             npy_half_to_float(data_out[0]));

#line 1065
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                             npy_half_to_float(data1[1]) *
                             npy_half_to_float(data2[1]) +
                             npy_half_to_float(data_out[1]));

#line 1065
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                             npy_half_to_float(data1[2]) *
                             npy_half_to_float(data2[2]) +
                             npy_half_to_float(data_out[2]));

#line 1065
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                             npy_half_to_float(data1[3]) *
                             npy_half_to_float(data2[3]) +
                             npy_half_to_float(data_out[3]));

#line 1065
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                             npy_half_to_float(data1[4]) *
                             npy_half_to_float(data2[4]) +
                             npy_half_to_float(data_out[4]));

#line 1065
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                             npy_half_to_float(data1[5]) *
                             npy_half_to_float(data2[5]) +
                             npy_half_to_float(data_out[5]));

#line 1065
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                             npy_half_to_float(data1[6]) *
                             npy_half_to_float(data2[6]) +
                             npy_half_to_float(data_out[6]));

#line 1065
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                             npy_half_to_float(data1[7]) *
                             npy_half_to_float(data2[7]) +
                             npy_half_to_float(data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                         npy_half_to_float(data1[0]) *
                         npy_half_to_float(data2[0]) +
                         npy_half_to_float(data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                         npy_half_to_float(data1[1]) *
                         npy_half_to_float(data2[1]) +
                         npy_half_to_float(data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                         npy_half_to_float(data1[2]) *
                         npy_half_to_float(data2[2]) +
                         npy_half_to_float(data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                         npy_half_to_float(data1[3]) *
                         npy_half_to_float(data2[3]) +
                         npy_half_to_float(data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                         npy_half_to_float(data1[4]) *
                         npy_half_to_float(data2[4]) +
                         npy_half_to_float(data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                         npy_half_to_float(data1[5]) *
                         npy_half_to_float(data2[5]) +
                         npy_half_to_float(data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                         npy_half_to_float(data1[6]) *
                         npy_half_to_float(data2[6]) +
                         npy_half_to_float(data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                         npy_half_to_float(data1[7]) *
                         npy_half_to_float(data2[7]) +
                         npy_half_to_float(data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
half_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        *(npy_half *)dataptr[nop] = npy_float_to_half(temp +
                                           npy_half_to_float(*(npy_half *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_half);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_half);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
half_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_half *data0 = (npy_half *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += npy_half_to_float(data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += npy_half_to_float(data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += npy_half_to_float(data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += npy_half_to_float(data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += npy_half_to_float(data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += npy_half_to_float(data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += npy_half_to_float(data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_half *)dataptr[1]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += npy_half_to_float(data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
half_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += npy_half_to_float(*(npy_half *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += npy_half_to_float(*(npy_half *)data0) *
                 npy_half_to_float(*(npy_half *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += npy_half_to_float(*(npy_half *)data0) *
                 npy_half_to_float(*(npy_half *)data1) *
                 npy_half_to_float(*(npy_half *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_float *)dataptr[1])[0] += accum_re;
    ((npy_float *)dataptr[1])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_half *)dataptr[1]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[1])));
#  else
    *((npy_half *)dataptr[nop]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
half_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) *
                                         npy_half_to_float(*(npy_half *)data1) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) *
                                         npy_half_to_float(*(npy_half *)data1) *
                                         npy_half_to_float(*(npy_half *)data2) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        *(npy_half *)dataptr[nop] = npy_float_to_half(temp +
                                           npy_half_to_float(*(npy_half *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
half_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data_out = (npy_half *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) +
                                 npy_half_to_float(data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) +
                                 npy_half_to_float(data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) +
                                 npy_half_to_float(data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) +
                                 npy_half_to_float(data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) +
                                 npy_half_to_float(data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) +
                                 npy_half_to_float(data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) +
                                 npy_half_to_float(data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) +
                             npy_half_to_float(data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) +
                             npy_half_to_float(data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) +
                             npy_half_to_float(data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) +
                             npy_half_to_float(data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) +
                             npy_half_to_float(data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) +
                             npy_half_to_float(data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) +
                             npy_half_to_float(data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) +
                             npy_half_to_float(data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
half_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                                 npy_half_to_float(data1[6]) +
                                 npy_half_to_float(data_out[6]));

#line 269
        case 5+1:
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                                 npy_half_to_float(data1[5]) +
                                 npy_half_to_float(data_out[5]));

#line 269
        case 4+1:
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                                 npy_half_to_float(data1[4]) +
                                 npy_half_to_float(data_out[4]));

#line 269
        case 3+1:
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                                 npy_half_to_float(data1[3]) +
                                 npy_half_to_float(data_out[3]));

#line 269
        case 2+1:
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                                 npy_half_to_float(data1[2]) +
                                 npy_half_to_float(data_out[2]));

#line 269
        case 1+1:
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                                 npy_half_to_float(data1[1]) +
                                 npy_half_to_float(data_out[1]));

#line 269
        case 0+1:
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                                 npy_half_to_float(data1[0]) +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                             npy_half_to_float(data1[0]) +
                             npy_half_to_float(data_out[0]));

#line 350
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                             npy_half_to_float(data1[1]) +
                             npy_half_to_float(data_out[1]));

#line 350
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                             npy_half_to_float(data1[2]) +
                             npy_half_to_float(data_out[2]));

#line 350
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                             npy_half_to_float(data1[3]) +
                             npy_half_to_float(data_out[3]));

#line 350
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                             npy_half_to_float(data1[4]) +
                             npy_half_to_float(data_out[4]));

#line 350
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                             npy_half_to_float(data1[5]) +
                             npy_half_to_float(data_out[5]));

#line 350
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                             npy_half_to_float(data1[6]) +
                             npy_half_to_float(data_out[6]));

#line 350
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                             npy_half_to_float(data1[7]) +
                             npy_half_to_float(data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
half_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = npy_half_to_float(*(npy_half *)dataptr[0]);
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[6]) +
                                 npy_half_to_float(data_out[6]));

#line 388
        case 5+1:
            data_out[5] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[5]) +
                                 npy_half_to_float(data_out[5]));

#line 388
        case 4+1:
            data_out[4] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[4]) +
                                 npy_half_to_float(data_out[4]));

#line 388
        case 3+1:
            data_out[3] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[3]) +
                                 npy_half_to_float(data_out[3]));

#line 388
        case 2+1:
            data_out[2] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[2]) +
                                 npy_half_to_float(data_out[2]));

#line 388
        case 1+1:
            data_out[1] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[1]) +
                                 npy_half_to_float(data_out[1]));

#line 388
        case 0+1:
            data_out[0] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[0]) +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[0]) +
                             npy_half_to_float(data_out[0]));

#line 479
        data_out[1] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[1]) +
                             npy_half_to_float(data_out[1]));

#line 479
        data_out[2] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[2]) +
                             npy_half_to_float(data_out[2]));

#line 479
        data_out[3] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[3]) +
                             npy_half_to_float(data_out[3]));

#line 479
        data_out[4] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[4]) +
                             npy_half_to_float(data_out[4]));

#line 479
        data_out[5] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[5]) +
                             npy_half_to_float(data_out[5]));

#line 479
        data_out[6] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[6]) +
                             npy_half_to_float(data_out[6]));

#line 479
        data_out[7] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[7]) +
                             npy_half_to_float(data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
half_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_float value1 = npy_half_to_float(*(npy_half *)dataptr[1]);
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6])*
                                 value1  +
                                 npy_half_to_float(data_out[6]));

#line 517
        case 5+1:
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5])*
                                 value1  +
                                 npy_half_to_float(data_out[5]));

#line 517
        case 4+1:
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4])*
                                 value1  +
                                 npy_half_to_float(data_out[4]));

#line 517
        case 3+1:
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3])*
                                 value1  +
                                 npy_half_to_float(data_out[3]));

#line 517
        case 2+1:
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2])*
                                 value1  +
                                 npy_half_to_float(data_out[2]));

#line 517
        case 1+1:
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1])*
                                 value1  +
                                 npy_half_to_float(data_out[1]));

#line 517
        case 0+1:
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0])*
                                 value1  +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0])*
                             value1  +
                             npy_half_to_float(data_out[0]));

#line 598
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1])*
                             value1  +
                             npy_half_to_float(data_out[1]));

#line 598
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2])*
                             value1  +
                             npy_half_to_float(data_out[2]));

#line 598
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3])*
                             value1  +
                             npy_half_to_float(data_out[3]));

#line 598
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4])*
                             value1  +
                             npy_half_to_float(data_out[4]));

#line 598
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5])*
                             value1  +
                             npy_half_to_float(data_out[5]));

#line 598
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6])*
                             value1  +
                             npy_half_to_float(data_out[6]));

#line 598
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7])*
                             value1  +
                             npy_half_to_float(data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += npy_half_to_float(data0[6]) * npy_half_to_float(data1[6]);

#line 634
        case 5+1:
            accum += npy_half_to_float(data0[5]) * npy_half_to_float(data1[5]);

#line 634
        case 4+1:
            accum += npy_half_to_float(data0[4]) * npy_half_to_float(data1[4]);

#line 634
        case 3+1:
            accum += npy_half_to_float(data0[3]) * npy_half_to_float(data1[3]);

#line 634
        case 2+1:
            accum += npy_half_to_float(data0[2]) * npy_half_to_float(data1[2]);

#line 634
        case 1+1:
            accum += npy_half_to_float(data0[1]) * npy_half_to_float(data1[1]);

#line 634
        case 0+1:
            accum += npy_half_to_float(data0[0]) * npy_half_to_float(data1[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += npy_half_to_float(data0[0]) * npy_half_to_float(data1[0]);

#line 746
        accum += npy_half_to_float(data0[1]) * npy_half_to_float(data1[1]);

#line 746
        accum += npy_half_to_float(data0[2]) * npy_half_to_float(data1[2]);

#line 746
        accum += npy_half_to_float(data0[3]) * npy_half_to_float(data1[3]);

#line 746
        accum += npy_half_to_float(data0[4]) * npy_half_to_float(data1[4]);

#line 746
        accum += npy_half_to_float(data0[5]) * npy_half_to_float(data1[5]);

#line 746
        accum += npy_half_to_float(data0[6]) * npy_half_to_float(data1[6]);

#line 746
        accum += npy_half_to_float(data0[7]) * npy_half_to_float(data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = npy_half_to_float(*(npy_half *)dataptr[0]);
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += npy_half_to_float(data1[6]);

#line 794
        case 5+1:
            accum += npy_half_to_float(data1[5]);

#line 794
        case 4+1:
            accum += npy_half_to_float(data1[4]);

#line 794
        case 3+1:
            accum += npy_half_to_float(data1[3]);

#line 794
        case 2+1:
            accum += npy_half_to_float(data1[2]);

#line 794
        case 1+1:
            accum += npy_half_to_float(data1[1]);

#line 794
        case 0+1:
            accum += npy_half_to_float(data1[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += npy_half_to_float(data1[0]);

#line 886
        accum += npy_half_to_float(data1[1]);

#line 886
        accum += npy_half_to_float(data1[2]);

#line 886
        accum += npy_half_to_float(data1[3]);

#line 886
        accum += npy_half_to_float(data1[4]);

#line 886
        accum += npy_half_to_float(data1[5]);

#line 886
        accum += npy_half_to_float(data1[6]);

#line 886
        accum += npy_half_to_float(data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_float value1 = npy_half_to_float(*(npy_half *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += npy_half_to_float(data0[6]);

#line 933
        case 5+1:
            accum += npy_half_to_float(data0[5]);

#line 933
        case 4+1:
            accum += npy_half_to_float(data0[4]);

#line 933
        case 3+1:
            accum += npy_half_to_float(data0[3]);

#line 933
        case 2+1:
            accum += npy_half_to_float(data0[2]);

#line 933
        case 1+1:
            accum += npy_half_to_float(data0[1]);

#line 933
        case 0+1:
            accum += npy_half_to_float(data0[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += npy_half_to_float(data0[0]);

#line 1023
        accum += npy_half_to_float(data0[1]);

#line 1023
        accum += npy_half_to_float(data0[2]);

#line 1023
        accum += npy_half_to_float(data0[3]);

#line 1023
        accum += npy_half_to_float(data0[4]);

#line 1023
        accum += npy_half_to_float(data0[5]);

#line 1023
        accum += npy_half_to_float(data0[6]);

#line 1023
        accum += npy_half_to_float(data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
half_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data2 = (npy_half *)dataptr[2];
    npy_half *data_out = (npy_half *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                             npy_half_to_float(data1[0]) *
                             npy_half_to_float(data2[0]) +
                             npy_half_to_float(data_out[0]));

#line 1065
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                             npy_half_to_float(data1[1]) *
                             npy_half_to_float(data2[1]) +
                             npy_half_to_float(data_out[1]));

#line 1065
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                             npy_half_to_float(data1[2]) *
                             npy_half_to_float(data2[2]) +
                             npy_half_to_float(data_out[2]));

#line 1065
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                             npy_half_to_float(data1[3]) *
                             npy_half_to_float(data2[3]) +
                             npy_half_to_float(data_out[3]));

#line 1065
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                             npy_half_to_float(data1[4]) *
                             npy_half_to_float(data2[4]) +
                             npy_half_to_float(data_out[4]));

#line 1065
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                             npy_half_to_float(data1[5]) *
                             npy_half_to_float(data2[5]) +
                             npy_half_to_float(data_out[5]));

#line 1065
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                             npy_half_to_float(data1[6]) *
                             npy_half_to_float(data2[6]) +
                             npy_half_to_float(data_out[6]));

#line 1065
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                             npy_half_to_float(data1[7]) *
                             npy_half_to_float(data2[7]) +
                             npy_half_to_float(data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                         npy_half_to_float(data1[0]) *
                         npy_half_to_float(data2[0]) +
                         npy_half_to_float(data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                         npy_half_to_float(data1[1]) *
                         npy_half_to_float(data2[1]) +
                         npy_half_to_float(data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                         npy_half_to_float(data1[2]) *
                         npy_half_to_float(data2[2]) +
                         npy_half_to_float(data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                         npy_half_to_float(data1[3]) *
                         npy_half_to_float(data2[3]) +
                         npy_half_to_float(data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                         npy_half_to_float(data1[4]) *
                         npy_half_to_float(data2[4]) +
                         npy_half_to_float(data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                         npy_half_to_float(data1[5]) *
                         npy_half_to_float(data2[5]) +
                         npy_half_to_float(data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                         npy_half_to_float(data1[6]) *
                         npy_half_to_float(data2[6]) +
                         npy_half_to_float(data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                         npy_half_to_float(data1[7]) *
                         npy_half_to_float(data2[7]) +
                         npy_half_to_float(data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
half_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        *(npy_half *)dataptr[nop] = npy_float_to_half(temp +
                                           npy_half_to_float(*(npy_half *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_half);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_half);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
half_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_half *data0 = (npy_half *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += npy_half_to_float(data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += npy_half_to_float(data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += npy_half_to_float(data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += npy_half_to_float(data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += npy_half_to_float(data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += npy_half_to_float(data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += npy_half_to_float(data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_half *)dataptr[1]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += npy_half_to_float(data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
half_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += npy_half_to_float(*(npy_half *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += npy_half_to_float(*(npy_half *)data0) *
                 npy_half_to_float(*(npy_half *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += npy_half_to_float(*(npy_half *)data0) *
                 npy_half_to_float(*(npy_half *)data1) *
                 npy_half_to_float(*(npy_half *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_float *)dataptr[2])[0] += accum_re;
    ((npy_float *)dataptr[2])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_half *)dataptr[2]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[2])));
#  else
    *((npy_half *)dataptr[nop]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
half_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) *
                                         npy_half_to_float(*(npy_half *)data1) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) *
                                         npy_half_to_float(*(npy_half *)data1) *
                                         npy_half_to_float(*(npy_half *)data2) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        *(npy_half *)dataptr[nop] = npy_float_to_half(temp +
                                           npy_half_to_float(*(npy_half *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
half_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data_out = (npy_half *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) +
                                 npy_half_to_float(data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) +
                                 npy_half_to_float(data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) +
                                 npy_half_to_float(data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) +
                                 npy_half_to_float(data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) +
                                 npy_half_to_float(data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) +
                                 npy_half_to_float(data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) +
                                 npy_half_to_float(data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) +
                             npy_half_to_float(data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) +
                             npy_half_to_float(data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) +
                             npy_half_to_float(data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) +
                             npy_half_to_float(data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) +
                             npy_half_to_float(data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) +
                             npy_half_to_float(data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) +
                             npy_half_to_float(data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) +
                             npy_half_to_float(data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
half_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                                 npy_half_to_float(data1[6]) +
                                 npy_half_to_float(data_out[6]));

#line 269
        case 5+1:
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                                 npy_half_to_float(data1[5]) +
                                 npy_half_to_float(data_out[5]));

#line 269
        case 4+1:
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                                 npy_half_to_float(data1[4]) +
                                 npy_half_to_float(data_out[4]));

#line 269
        case 3+1:
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                                 npy_half_to_float(data1[3]) +
                                 npy_half_to_float(data_out[3]));

#line 269
        case 2+1:
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                                 npy_half_to_float(data1[2]) +
                                 npy_half_to_float(data_out[2]));

#line 269
        case 1+1:
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                                 npy_half_to_float(data1[1]) +
                                 npy_half_to_float(data_out[1]));

#line 269
        case 0+1:
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                                 npy_half_to_float(data1[0]) +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                             npy_half_to_float(data1[0]) +
                             npy_half_to_float(data_out[0]));

#line 350
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                             npy_half_to_float(data1[1]) +
                             npy_half_to_float(data_out[1]));

#line 350
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                             npy_half_to_float(data1[2]) +
                             npy_half_to_float(data_out[2]));

#line 350
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                             npy_half_to_float(data1[3]) +
                             npy_half_to_float(data_out[3]));

#line 350
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                             npy_half_to_float(data1[4]) +
                             npy_half_to_float(data_out[4]));

#line 350
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                             npy_half_to_float(data1[5]) +
                             npy_half_to_float(data_out[5]));

#line 350
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                             npy_half_to_float(data1[6]) +
                             npy_half_to_float(data_out[6]));

#line 350
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                             npy_half_to_float(data1[7]) +
                             npy_half_to_float(data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
half_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = npy_half_to_float(*(npy_half *)dataptr[0]);
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[6]) +
                                 npy_half_to_float(data_out[6]));

#line 388
        case 5+1:
            data_out[5] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[5]) +
                                 npy_half_to_float(data_out[5]));

#line 388
        case 4+1:
            data_out[4] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[4]) +
                                 npy_half_to_float(data_out[4]));

#line 388
        case 3+1:
            data_out[3] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[3]) +
                                 npy_half_to_float(data_out[3]));

#line 388
        case 2+1:
            data_out[2] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[2]) +
                                 npy_half_to_float(data_out[2]));

#line 388
        case 1+1:
            data_out[1] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[1]) +
                                 npy_half_to_float(data_out[1]));

#line 388
        case 0+1:
            data_out[0] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[0]) +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[0]) +
                             npy_half_to_float(data_out[0]));

#line 479
        data_out[1] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[1]) +
                             npy_half_to_float(data_out[1]));

#line 479
        data_out[2] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[2]) +
                             npy_half_to_float(data_out[2]));

#line 479
        data_out[3] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[3]) +
                             npy_half_to_float(data_out[3]));

#line 479
        data_out[4] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[4]) +
                             npy_half_to_float(data_out[4]));

#line 479
        data_out[5] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[5]) +
                             npy_half_to_float(data_out[5]));

#line 479
        data_out[6] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[6]) +
                             npy_half_to_float(data_out[6]));

#line 479
        data_out[7] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[7]) +
                             npy_half_to_float(data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
half_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_float value1 = npy_half_to_float(*(npy_half *)dataptr[1]);
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6])*
                                 value1  +
                                 npy_half_to_float(data_out[6]));

#line 517
        case 5+1:
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5])*
                                 value1  +
                                 npy_half_to_float(data_out[5]));

#line 517
        case 4+1:
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4])*
                                 value1  +
                                 npy_half_to_float(data_out[4]));

#line 517
        case 3+1:
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3])*
                                 value1  +
                                 npy_half_to_float(data_out[3]));

#line 517
        case 2+1:
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2])*
                                 value1  +
                                 npy_half_to_float(data_out[2]));

#line 517
        case 1+1:
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1])*
                                 value1  +
                                 npy_half_to_float(data_out[1]));

#line 517
        case 0+1:
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0])*
                                 value1  +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0])*
                             value1  +
                             npy_half_to_float(data_out[0]));

#line 598
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1])*
                             value1  +
                             npy_half_to_float(data_out[1]));

#line 598
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2])*
                             value1  +
                             npy_half_to_float(data_out[2]));

#line 598
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3])*
                             value1  +
                             npy_half_to_float(data_out[3]));

#line 598
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4])*
                             value1  +
                             npy_half_to_float(data_out[4]));

#line 598
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5])*
                             value1  +
                             npy_half_to_float(data_out[5]));

#line 598
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6])*
                             value1  +
                             npy_half_to_float(data_out[6]));

#line 598
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7])*
                             value1  +
                             npy_half_to_float(data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += npy_half_to_float(data0[6]) * npy_half_to_float(data1[6]);

#line 634
        case 5+1:
            accum += npy_half_to_float(data0[5]) * npy_half_to_float(data1[5]);

#line 634
        case 4+1:
            accum += npy_half_to_float(data0[4]) * npy_half_to_float(data1[4]);

#line 634
        case 3+1:
            accum += npy_half_to_float(data0[3]) * npy_half_to_float(data1[3]);

#line 634
        case 2+1:
            accum += npy_half_to_float(data0[2]) * npy_half_to_float(data1[2]);

#line 634
        case 1+1:
            accum += npy_half_to_float(data0[1]) * npy_half_to_float(data1[1]);

#line 634
        case 0+1:
            accum += npy_half_to_float(data0[0]) * npy_half_to_float(data1[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += npy_half_to_float(data0[0]) * npy_half_to_float(data1[0]);

#line 746
        accum += npy_half_to_float(data0[1]) * npy_half_to_float(data1[1]);

#line 746
        accum += npy_half_to_float(data0[2]) * npy_half_to_float(data1[2]);

#line 746
        accum += npy_half_to_float(data0[3]) * npy_half_to_float(data1[3]);

#line 746
        accum += npy_half_to_float(data0[4]) * npy_half_to_float(data1[4]);

#line 746
        accum += npy_half_to_float(data0[5]) * npy_half_to_float(data1[5]);

#line 746
        accum += npy_half_to_float(data0[6]) * npy_half_to_float(data1[6]);

#line 746
        accum += npy_half_to_float(data0[7]) * npy_half_to_float(data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = npy_half_to_float(*(npy_half *)dataptr[0]);
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += npy_half_to_float(data1[6]);

#line 794
        case 5+1:
            accum += npy_half_to_float(data1[5]);

#line 794
        case 4+1:
            accum += npy_half_to_float(data1[4]);

#line 794
        case 3+1:
            accum += npy_half_to_float(data1[3]);

#line 794
        case 2+1:
            accum += npy_half_to_float(data1[2]);

#line 794
        case 1+1:
            accum += npy_half_to_float(data1[1]);

#line 794
        case 0+1:
            accum += npy_half_to_float(data1[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += npy_half_to_float(data1[0]);

#line 886
        accum += npy_half_to_float(data1[1]);

#line 886
        accum += npy_half_to_float(data1[2]);

#line 886
        accum += npy_half_to_float(data1[3]);

#line 886
        accum += npy_half_to_float(data1[4]);

#line 886
        accum += npy_half_to_float(data1[5]);

#line 886
        accum += npy_half_to_float(data1[6]);

#line 886
        accum += npy_half_to_float(data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_float value1 = npy_half_to_float(*(npy_half *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += npy_half_to_float(data0[6]);

#line 933
        case 5+1:
            accum += npy_half_to_float(data0[5]);

#line 933
        case 4+1:
            accum += npy_half_to_float(data0[4]);

#line 933
        case 3+1:
            accum += npy_half_to_float(data0[3]);

#line 933
        case 2+1:
            accum += npy_half_to_float(data0[2]);

#line 933
        case 1+1:
            accum += npy_half_to_float(data0[1]);

#line 933
        case 0+1:
            accum += npy_half_to_float(data0[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += npy_half_to_float(data0[0]);

#line 1023
        accum += npy_half_to_float(data0[1]);

#line 1023
        accum += npy_half_to_float(data0[2]);

#line 1023
        accum += npy_half_to_float(data0[3]);

#line 1023
        accum += npy_half_to_float(data0[4]);

#line 1023
        accum += npy_half_to_float(data0[5]);

#line 1023
        accum += npy_half_to_float(data0[6]);

#line 1023
        accum += npy_half_to_float(data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
half_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data2 = (npy_half *)dataptr[2];
    npy_half *data_out = (npy_half *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                             npy_half_to_float(data1[0]) *
                             npy_half_to_float(data2[0]) +
                             npy_half_to_float(data_out[0]));

#line 1065
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                             npy_half_to_float(data1[1]) *
                             npy_half_to_float(data2[1]) +
                             npy_half_to_float(data_out[1]));

#line 1065
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                             npy_half_to_float(data1[2]) *
                             npy_half_to_float(data2[2]) +
                             npy_half_to_float(data_out[2]));

#line 1065
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                             npy_half_to_float(data1[3]) *
                             npy_half_to_float(data2[3]) +
                             npy_half_to_float(data_out[3]));

#line 1065
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                             npy_half_to_float(data1[4]) *
                             npy_half_to_float(data2[4]) +
                             npy_half_to_float(data_out[4]));

#line 1065
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                             npy_half_to_float(data1[5]) *
                             npy_half_to_float(data2[5]) +
                             npy_half_to_float(data_out[5]));

#line 1065
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                             npy_half_to_float(data1[6]) *
                             npy_half_to_float(data2[6]) +
                             npy_half_to_float(data_out[6]));

#line 1065
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                             npy_half_to_float(data1[7]) *
                             npy_half_to_float(data2[7]) +
                             npy_half_to_float(data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                         npy_half_to_float(data1[0]) *
                         npy_half_to_float(data2[0]) +
                         npy_half_to_float(data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                         npy_half_to_float(data1[1]) *
                         npy_half_to_float(data2[1]) +
                         npy_half_to_float(data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                         npy_half_to_float(data1[2]) *
                         npy_half_to_float(data2[2]) +
                         npy_half_to_float(data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                         npy_half_to_float(data1[3]) *
                         npy_half_to_float(data2[3]) +
                         npy_half_to_float(data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                         npy_half_to_float(data1[4]) *
                         npy_half_to_float(data2[4]) +
                         npy_half_to_float(data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                         npy_half_to_float(data1[5]) *
                         npy_half_to_float(data2[5]) +
                         npy_half_to_float(data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                         npy_half_to_float(data1[6]) *
                         npy_half_to_float(data2[6]) +
                         npy_half_to_float(data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                         npy_half_to_float(data1[7]) *
                         npy_half_to_float(data2[7]) +
                         npy_half_to_float(data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
half_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        *(npy_half *)dataptr[nop] = npy_float_to_half(temp +
                                           npy_half_to_float(*(npy_half *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_half);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_half);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
half_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_half *data0 = (npy_half *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += npy_half_to_float(data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += npy_half_to_float(data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += npy_half_to_float(data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += npy_half_to_float(data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += npy_half_to_float(data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += npy_half_to_float(data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += npy_half_to_float(data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_half *)dataptr[1]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += npy_half_to_float(data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
half_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += npy_half_to_float(*(npy_half *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += npy_half_to_float(*(npy_half *)data0) *
                 npy_half_to_float(*(npy_half *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += npy_half_to_float(*(npy_half *)data0) *
                 npy_half_to_float(*(npy_half *)data1) *
                 npy_half_to_float(*(npy_half *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_float *)dataptr[3])[0] += accum_re;
    ((npy_float *)dataptr[3])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_half *)dataptr[3]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[3])));
#  else
    *((npy_half *)dataptr[nop]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
half_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) *
                                         npy_half_to_float(*(npy_half *)data1) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_half *)data_out = npy_float_to_half(npy_half_to_float(*(npy_half *)data0) *
                                         npy_half_to_float(*(npy_half *)data1) *
                                         npy_half_to_float(*(npy_half *)data2) +
                                         npy_half_to_float(*(npy_half *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        *(npy_half *)dataptr[nop] = npy_float_to_half(temp +
                                           npy_half_to_float(*(npy_half *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
half_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data_out = (npy_half *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) +
                                 npy_half_to_float(data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) +
                                 npy_half_to_float(data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) +
                                 npy_half_to_float(data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) +
                                 npy_half_to_float(data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) +
                                 npy_half_to_float(data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) +
                                 npy_half_to_float(data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) +
                                 npy_half_to_float(data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) +
                             npy_half_to_float(data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) +
                             npy_half_to_float(data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) +
                             npy_half_to_float(data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) +
                             npy_half_to_float(data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) +
                             npy_half_to_float(data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) +
                             npy_half_to_float(data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) +
                             npy_half_to_float(data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) +
                             npy_half_to_float(data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
half_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                                 npy_half_to_float(data1[6]) +
                                 npy_half_to_float(data_out[6]));

#line 269
        case 5+1:
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                                 npy_half_to_float(data1[5]) +
                                 npy_half_to_float(data_out[5]));

#line 269
        case 4+1:
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                                 npy_half_to_float(data1[4]) +
                                 npy_half_to_float(data_out[4]));

#line 269
        case 3+1:
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                                 npy_half_to_float(data1[3]) +
                                 npy_half_to_float(data_out[3]));

#line 269
        case 2+1:
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                                 npy_half_to_float(data1[2]) +
                                 npy_half_to_float(data_out[2]));

#line 269
        case 1+1:
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                                 npy_half_to_float(data1[1]) +
                                 npy_half_to_float(data_out[1]));

#line 269
        case 0+1:
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                                 npy_half_to_float(data1[0]) +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                             npy_half_to_float(data1[0]) +
                             npy_half_to_float(data_out[0]));

#line 350
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                             npy_half_to_float(data1[1]) +
                             npy_half_to_float(data_out[1]));

#line 350
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                             npy_half_to_float(data1[2]) +
                             npy_half_to_float(data_out[2]));

#line 350
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                             npy_half_to_float(data1[3]) +
                             npy_half_to_float(data_out[3]));

#line 350
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                             npy_half_to_float(data1[4]) +
                             npy_half_to_float(data_out[4]));

#line 350
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                             npy_half_to_float(data1[5]) +
                             npy_half_to_float(data_out[5]));

#line 350
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                             npy_half_to_float(data1[6]) +
                             npy_half_to_float(data_out[6]));

#line 350
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                             npy_half_to_float(data1[7]) +
                             npy_half_to_float(data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
half_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = npy_half_to_float(*(npy_half *)dataptr[0]);
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[6]) +
                                 npy_half_to_float(data_out[6]));

#line 388
        case 5+1:
            data_out[5] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[5]) +
                                 npy_half_to_float(data_out[5]));

#line 388
        case 4+1:
            data_out[4] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[4]) +
                                 npy_half_to_float(data_out[4]));

#line 388
        case 3+1:
            data_out[3] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[3]) +
                                 npy_half_to_float(data_out[3]));

#line 388
        case 2+1:
            data_out[2] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[2]) +
                                 npy_half_to_float(data_out[2]));

#line 388
        case 1+1:
            data_out[1] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[1]) +
                                 npy_half_to_float(data_out[1]));

#line 388
        case 0+1:
            data_out[0] = npy_float_to_half(value0 *
                                 npy_half_to_float(data1[0]) +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[0]) +
                             npy_half_to_float(data_out[0]));

#line 479
        data_out[1] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[1]) +
                             npy_half_to_float(data_out[1]));

#line 479
        data_out[2] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[2]) +
                             npy_half_to_float(data_out[2]));

#line 479
        data_out[3] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[3]) +
                             npy_half_to_float(data_out[3]));

#line 479
        data_out[4] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[4]) +
                             npy_half_to_float(data_out[4]));

#line 479
        data_out[5] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[5]) +
                             npy_half_to_float(data_out[5]));

#line 479
        data_out[6] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[6]) +
                             npy_half_to_float(data_out[6]));

#line 479
        data_out[7] = npy_float_to_half(value0 *
                             npy_half_to_float(data1[7]) +
                             npy_half_to_float(data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
half_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_float value1 = npy_half_to_float(*(npy_half *)dataptr[1]);
    npy_half *data_out = (npy_half *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = npy_float_to_half(npy_half_to_float(data0[6])*
                                 value1  +
                                 npy_half_to_float(data_out[6]));

#line 517
        case 5+1:
            data_out[5] = npy_float_to_half(npy_half_to_float(data0[5])*
                                 value1  +
                                 npy_half_to_float(data_out[5]));

#line 517
        case 4+1:
            data_out[4] = npy_float_to_half(npy_half_to_float(data0[4])*
                                 value1  +
                                 npy_half_to_float(data_out[4]));

#line 517
        case 3+1:
            data_out[3] = npy_float_to_half(npy_half_to_float(data0[3])*
                                 value1  +
                                 npy_half_to_float(data_out[3]));

#line 517
        case 2+1:
            data_out[2] = npy_float_to_half(npy_half_to_float(data0[2])*
                                 value1  +
                                 npy_half_to_float(data_out[2]));

#line 517
        case 1+1:
            data_out[1] = npy_float_to_half(npy_half_to_float(data0[1])*
                                 value1  +
                                 npy_half_to_float(data_out[1]));

#line 517
        case 0+1:
            data_out[0] = npy_float_to_half(npy_half_to_float(data0[0])*
                                 value1  +
                                 npy_half_to_float(data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0])*
                             value1  +
                             npy_half_to_float(data_out[0]));

#line 598
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1])*
                             value1  +
                             npy_half_to_float(data_out[1]));

#line 598
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2])*
                             value1  +
                             npy_half_to_float(data_out[2]));

#line 598
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3])*
                             value1  +
                             npy_half_to_float(data_out[3]));

#line 598
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4])*
                             value1  +
                             npy_half_to_float(data_out[4]));

#line 598
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5])*
                             value1  +
                             npy_half_to_float(data_out[5]));

#line 598
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6])*
                             value1  +
                             npy_half_to_float(data_out[6]));

#line 598
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7])*
                             value1  +
                             npy_half_to_float(data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += npy_half_to_float(data0[6]) * npy_half_to_float(data1[6]);

#line 634
        case 5+1:
            accum += npy_half_to_float(data0[5]) * npy_half_to_float(data1[5]);

#line 634
        case 4+1:
            accum += npy_half_to_float(data0[4]) * npy_half_to_float(data1[4]);

#line 634
        case 3+1:
            accum += npy_half_to_float(data0[3]) * npy_half_to_float(data1[3]);

#line 634
        case 2+1:
            accum += npy_half_to_float(data0[2]) * npy_half_to_float(data1[2]);

#line 634
        case 1+1:
            accum += npy_half_to_float(data0[1]) * npy_half_to_float(data1[1]);

#line 634
        case 0+1:
            accum += npy_half_to_float(data0[0]) * npy_half_to_float(data1[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += npy_half_to_float(data0[0]) * npy_half_to_float(data1[0]);

#line 746
        accum += npy_half_to_float(data0[1]) * npy_half_to_float(data1[1]);

#line 746
        accum += npy_half_to_float(data0[2]) * npy_half_to_float(data1[2]);

#line 746
        accum += npy_half_to_float(data0[3]) * npy_half_to_float(data1[3]);

#line 746
        accum += npy_half_to_float(data0[4]) * npy_half_to_float(data1[4]);

#line 746
        accum += npy_half_to_float(data0[5]) * npy_half_to_float(data1[5]);

#line 746
        accum += npy_half_to_float(data0[6]) * npy_half_to_float(data1[6]);

#line 746
        accum += npy_half_to_float(data0[7]) * npy_half_to_float(data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = npy_half_to_float(*(npy_half *)dataptr[0]);
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += npy_half_to_float(data1[6]);

#line 794
        case 5+1:
            accum += npy_half_to_float(data1[5]);

#line 794
        case 4+1:
            accum += npy_half_to_float(data1[4]);

#line 794
        case 3+1:
            accum += npy_half_to_float(data1[3]);

#line 794
        case 2+1:
            accum += npy_half_to_float(data1[2]);

#line 794
        case 1+1:
            accum += npy_half_to_float(data1[1]);

#line 794
        case 0+1:
            accum += npy_half_to_float(data1[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += npy_half_to_float(data1[0]);

#line 886
        accum += npy_half_to_float(data1[1]);

#line 886
        accum += npy_half_to_float(data1[2]);

#line 886
        accum += npy_half_to_float(data1[3]);

#line 886
        accum += npy_half_to_float(data1[4]);

#line 886
        accum += npy_half_to_float(data1[5]);

#line 886
        accum += npy_half_to_float(data1[6]);

#line 886
        accum += npy_half_to_float(data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
half_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_float value1 = npy_half_to_float(*(npy_half *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += npy_half_to_float(data0[6]);

#line 933
        case 5+1:
            accum += npy_half_to_float(data0[5]);

#line 933
        case 4+1:
            accum += npy_half_to_float(data0[4]);

#line 933
        case 3+1:
            accum += npy_half_to_float(data0[3]);

#line 933
        case 2+1:
            accum += npy_half_to_float(data0[2]);

#line 933
        case 1+1:
            accum += npy_half_to_float(data0[1]);

#line 933
        case 0+1:
            accum += npy_half_to_float(data0[0]);

        case 0:
            *(npy_half *)dataptr[2] = npy_float_to_half(npy_half_to_float(*(npy_half *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += npy_half_to_float(data0[0]);

#line 1023
        accum += npy_half_to_float(data0[1]);

#line 1023
        accum += npy_half_to_float(data0[2]);

#line 1023
        accum += npy_half_to_float(data0[3]);

#line 1023
        accum += npy_half_to_float(data0[4]);

#line 1023
        accum += npy_half_to_float(data0[5]);

#line 1023
        accum += npy_half_to_float(data0[6]);

#line 1023
        accum += npy_half_to_float(data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
half_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_half *data0 = (npy_half *)dataptr[0];
    npy_half *data1 = (npy_half *)dataptr[1];
    npy_half *data2 = (npy_half *)dataptr[2];
    npy_half *data_out = (npy_half *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                             npy_half_to_float(data1[0]) *
                             npy_half_to_float(data2[0]) +
                             npy_half_to_float(data_out[0]));

#line 1065
        data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                             npy_half_to_float(data1[1]) *
                             npy_half_to_float(data2[1]) +
                             npy_half_to_float(data_out[1]));

#line 1065
        data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                             npy_half_to_float(data1[2]) *
                             npy_half_to_float(data2[2]) +
                             npy_half_to_float(data_out[2]));

#line 1065
        data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                             npy_half_to_float(data1[3]) *
                             npy_half_to_float(data2[3]) +
                             npy_half_to_float(data_out[3]));

#line 1065
        data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                             npy_half_to_float(data1[4]) *
                             npy_half_to_float(data2[4]) +
                             npy_half_to_float(data_out[4]));

#line 1065
        data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                             npy_half_to_float(data1[5]) *
                             npy_half_to_float(data2[5]) +
                             npy_half_to_float(data_out[5]));

#line 1065
        data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                             npy_half_to_float(data1[6]) *
                             npy_half_to_float(data2[6]) +
                             npy_half_to_float(data_out[6]));

#line 1065
        data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                             npy_half_to_float(data1[7]) *
                             npy_half_to_float(data2[7]) +
                             npy_half_to_float(data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = npy_float_to_half(npy_half_to_float(data0[0]) *
                         npy_half_to_float(data1[0]) *
                         npy_half_to_float(data2[0]) +
                         npy_half_to_float(data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = npy_float_to_half(npy_half_to_float(data0[1]) *
                         npy_half_to_float(data1[1]) *
                         npy_half_to_float(data2[1]) +
                         npy_half_to_float(data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = npy_float_to_half(npy_half_to_float(data0[2]) *
                         npy_half_to_float(data1[2]) *
                         npy_half_to_float(data2[2]) +
                         npy_half_to_float(data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = npy_float_to_half(npy_half_to_float(data0[3]) *
                         npy_half_to_float(data1[3]) *
                         npy_half_to_float(data2[3]) +
                         npy_half_to_float(data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = npy_float_to_half(npy_half_to_float(data0[4]) *
                         npy_half_to_float(data1[4]) *
                         npy_half_to_float(data2[4]) +
                         npy_half_to_float(data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = npy_float_to_half(npy_half_to_float(data0[5]) *
                         npy_half_to_float(data1[5]) *
                         npy_half_to_float(data2[5]) +
                         npy_half_to_float(data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = npy_float_to_half(npy_half_to_float(data0[6]) *
                         npy_half_to_float(data1[6]) *
                         npy_half_to_float(data2[6]) +
                         npy_half_to_float(data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = npy_float_to_half(npy_half_to_float(data0[7]) *
                         npy_half_to_float(data1[7]) *
                         npy_half_to_float(data2[7]) +
                         npy_half_to_float(data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
half_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        *(npy_half *)dataptr[nop] = npy_float_to_half(temp +
                                           npy_half_to_float(*(npy_half *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_half);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_half);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
half_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_half *data0 = (npy_half *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += npy_half_to_float(data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += npy_half_to_float(data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += npy_half_to_float(data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += npy_half_to_float(data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += npy_half_to_float(data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += npy_half_to_float(data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += npy_half_to_float(data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_half *)dataptr[1]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += npy_half_to_float(data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += npy_half_to_float(data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
half_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("half_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += npy_half_to_float(*(npy_half *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += npy_half_to_float(*(npy_half *)data0) *
                 npy_half_to_float(*(npy_half *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += npy_half_to_float(*(npy_half *)data0) *
                 npy_half_to_float(*(npy_half *)data1) *
                 npy_half_to_float(*(npy_half *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = npy_half_to_float(*(npy_half *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= npy_half_to_float(*(npy_half *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_float *)dataptr[1000])[0] += accum_re;
    ((npy_float *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_half *)dataptr[1000]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[1000])));
#  else
    *((npy_half *)dataptr[nop]) = npy_float_to_half(accum +
                                    npy_half_to_float(*((npy_half *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
float_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_float *)data_out = ((*(npy_float *)data0) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_float *)data_out = ((*(npy_float *)data0) *
                                         (*(npy_float *)data1) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_float *)data_out = ((*(npy_float *)data0) *
                                         (*(npy_float *)data1) *
                                         (*(npy_float *)data2) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        *(npy_float *)dataptr[nop] = (temp +
                                           (*(npy_float *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
float_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data_out = (npy_float *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
float_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
float_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_float *)dataptr[0]);
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
float_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float value1 = (*(npy_float *)dataptr[1]);
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_float *)dataptr[0]);
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float value1 = (*(npy_float *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
float_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data2 = (npy_float *)dataptr[2];
    npy_float *data_out = (npy_float *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
float_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        *(npy_float *)dataptr[nop] = (temp +
                                           (*(npy_float *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_float);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_float);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
float_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_float *)dataptr[1]) = (accum +
                                    (*((npy_float *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
float_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_float *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_float *)data0) *
                 (*(npy_float *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_float *)data0) *
                 (*(npy_float *)data1) *
                 (*(npy_float *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_float *)dataptr[1])[0] += accum_re;
    ((npy_float *)dataptr[1])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_float *)dataptr[1]) = (accum +
                                    (*((npy_float *)dataptr[1])));
#  else
    *((npy_float *)dataptr[nop]) = (accum +
                                    (*((npy_float *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
float_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_float *)data_out = ((*(npy_float *)data0) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_float *)data_out = ((*(npy_float *)data0) *
                                         (*(npy_float *)data1) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_float *)data_out = ((*(npy_float *)data0) *
                                         (*(npy_float *)data1) *
                                         (*(npy_float *)data2) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        *(npy_float *)dataptr[nop] = (temp +
                                           (*(npy_float *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
float_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data_out = (npy_float *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
float_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
float_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_float *)dataptr[0]);
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
float_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float value1 = (*(npy_float *)dataptr[1]);
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_float *)dataptr[0]);
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float value1 = (*(npy_float *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
float_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data2 = (npy_float *)dataptr[2];
    npy_float *data_out = (npy_float *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
float_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        *(npy_float *)dataptr[nop] = (temp +
                                           (*(npy_float *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_float);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_float);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
float_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_float *)dataptr[1]) = (accum +
                                    (*((npy_float *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
float_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_float *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_float *)data0) *
                 (*(npy_float *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_float *)data0) *
                 (*(npy_float *)data1) *
                 (*(npy_float *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_float *)dataptr[2])[0] += accum_re;
    ((npy_float *)dataptr[2])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_float *)dataptr[2]) = (accum +
                                    (*((npy_float *)dataptr[2])));
#  else
    *((npy_float *)dataptr[nop]) = (accum +
                                    (*((npy_float *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
float_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_float *)data_out = ((*(npy_float *)data0) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_float *)data_out = ((*(npy_float *)data0) *
                                         (*(npy_float *)data1) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_float *)data_out = ((*(npy_float *)data0) *
                                         (*(npy_float *)data1) *
                                         (*(npy_float *)data2) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        *(npy_float *)dataptr[nop] = (temp +
                                           (*(npy_float *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
float_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data_out = (npy_float *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
float_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
float_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_float *)dataptr[0]);
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
float_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float value1 = (*(npy_float *)dataptr[1]);
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_float *)dataptr[0]);
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float value1 = (*(npy_float *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
float_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data2 = (npy_float *)dataptr[2];
    npy_float *data_out = (npy_float *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
float_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        *(npy_float *)dataptr[nop] = (temp +
                                           (*(npy_float *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_float);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_float);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
float_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_float *)dataptr[1]) = (accum +
                                    (*((npy_float *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
float_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_float *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_float *)data0) *
                 (*(npy_float *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_float *)data0) *
                 (*(npy_float *)data1) *
                 (*(npy_float *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_float *)dataptr[3])[0] += accum_re;
    ((npy_float *)dataptr[3])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_float *)dataptr[3]) = (accum +
                                    (*((npy_float *)dataptr[3])));
#  else
    *((npy_float *)dataptr[nop]) = (accum +
                                    (*((npy_float *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
float_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_float *)data_out = ((*(npy_float *)data0) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_float *)data_out = ((*(npy_float *)data0) *
                                         (*(npy_float *)data1) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_float *)data_out = ((*(npy_float *)data0) *
                                         (*(npy_float *)data1) *
                                         (*(npy_float *)data2) +
                                         (*(npy_float *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        *(npy_float *)dataptr[nop] = (temp +
                                           (*(npy_float *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
float_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data_out = (npy_float *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
float_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
float_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_float *)dataptr[0]);
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
float_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float value1 = (*(npy_float *)dataptr[1]);
    npy_float *data_out = (npy_float *)dataptr[2];

#if EINSUM_USE_SSE1 && 1
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 1
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_float *)dataptr[0]);
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
float_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float value1 = (*(npy_float *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_float *)dataptr[2] = ((*(npy_float *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
float_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float *data0 = (npy_float *)dataptr[0];
    npy_float *data1 = (npy_float *)dataptr[1];
    npy_float *data2 = (npy_float *)dataptr[2];
    npy_float *data_out = (npy_float *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
float_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        *(npy_float *)dataptr[nop] = (temp +
                                           (*(npy_float *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_float);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_float);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
float_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 1
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_float *)dataptr[1]) = (accum +
                                    (*((npy_float *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 1
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
float_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("float_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_float *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_float *)data0) *
                 (*(npy_float *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_float *)data0) *
                 (*(npy_float *)data1) *
                 (*(npy_float *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = (*(npy_float *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_float *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_float *)dataptr[1000])[0] += accum_re;
    ((npy_float *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_float *)dataptr[1000]) = (accum +
                                    (*((npy_float *)dataptr[1000])));
#  else
    *((npy_float *)dataptr[nop]) = (accum +
                                    (*((npy_float *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
double_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_double *)data_out = ((*(npy_double *)data0) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_double *)data_out = ((*(npy_double *)data0) *
                                         (*(npy_double *)data1) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_double *)data_out = ((*(npy_double *)data0) *
                                         (*(npy_double *)data1) *
                                         (*(npy_double *)data2) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        *(npy_double *)dataptr[nop] = (temp +
                                           (*(npy_double *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_double *)data_out)[0] = ((npy_double *)data0)[0] +
                                         ((npy_double *)data_out)[0];
        ((npy_double *)data_out)[1] = ((npy_double *)data0)[1] +
                                         ((npy_double *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
double_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data_out = (npy_double *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_double *)data_out + 2*6)[0] =
                                    ((npy_double *)data0 + 2*6)[0] +
                                    ((npy_double *)data_out + 2*6)[0];
            ((npy_double *)data_out + 2*6)[1] =
                                    ((npy_double *)data0 + 2*6)[1] +
                                    ((npy_double *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_double *)data_out + 2*5)[0] =
                                    ((npy_double *)data0 + 2*5)[0] +
                                    ((npy_double *)data_out + 2*5)[0];
            ((npy_double *)data_out + 2*5)[1] =
                                    ((npy_double *)data0 + 2*5)[1] +
                                    ((npy_double *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_double *)data_out + 2*4)[0] =
                                    ((npy_double *)data0 + 2*4)[0] +
                                    ((npy_double *)data_out + 2*4)[0];
            ((npy_double *)data_out + 2*4)[1] =
                                    ((npy_double *)data0 + 2*4)[1] +
                                    ((npy_double *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_double *)data_out + 2*3)[0] =
                                    ((npy_double *)data0 + 2*3)[0] +
                                    ((npy_double *)data_out + 2*3)[0];
            ((npy_double *)data_out + 2*3)[1] =
                                    ((npy_double *)data0 + 2*3)[1] +
                                    ((npy_double *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_double *)data_out + 2*2)[0] =
                                    ((npy_double *)data0 + 2*2)[0] +
                                    ((npy_double *)data_out + 2*2)[0];
            ((npy_double *)data_out + 2*2)[1] =
                                    ((npy_double *)data0 + 2*2)[1] +
                                    ((npy_double *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_double *)data_out + 2*1)[0] =
                                    ((npy_double *)data0 + 2*1)[0] +
                                    ((npy_double *)data_out + 2*1)[0];
            ((npy_double *)data_out + 2*1)[1] =
                                    ((npy_double *)data0 + 2*1)[1] +
                                    ((npy_double *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_double *)data_out + 2*0)[0] =
                                    ((npy_double *)data0 + 2*0)[0] +
                                    ((npy_double *)data_out + 2*0)[0];
            ((npy_double *)data_out + 2*0)[1] =
                                    ((npy_double *)data0 + 2*0)[1] +
                                    ((npy_double *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_double *)data_out + 2*0)[0] =
                                ((npy_double *)data0 + 2*0)[0] +
                                ((npy_double *)data_out + 2*0)[0];
        ((npy_double *)data_out + 2*0)[1] =
                                ((npy_double *)data0 + 2*0)[1] +
                                ((npy_double *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_double *)data_out + 2*1)[0] =
                                ((npy_double *)data0 + 2*1)[0] +
                                ((npy_double *)data_out + 2*1)[0];
        ((npy_double *)data_out + 2*1)[1] =
                                ((npy_double *)data0 + 2*1)[1] +
                                ((npy_double *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_double *)data_out + 2*2)[0] =
                                ((npy_double *)data0 + 2*2)[0] +
                                ((npy_double *)data_out + 2*2)[0];
        ((npy_double *)data_out + 2*2)[1] =
                                ((npy_double *)data0 + 2*2)[1] +
                                ((npy_double *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_double *)data_out + 2*3)[0] =
                                ((npy_double *)data0 + 2*3)[0] +
                                ((npy_double *)data_out + 2*3)[0];
        ((npy_double *)data_out + 2*3)[1] =
                                ((npy_double *)data0 + 2*3)[1] +
                                ((npy_double *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_double *)data_out + 2*4)[0] =
                                ((npy_double *)data0 + 2*4)[0] +
                                ((npy_double *)data_out + 2*4)[0];
        ((npy_double *)data_out + 2*4)[1] =
                                ((npy_double *)data0 + 2*4)[1] +
                                ((npy_double *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_double *)data_out + 2*5)[0] =
                                ((npy_double *)data0 + 2*5)[0] +
                                ((npy_double *)data_out + 2*5)[0];
        ((npy_double *)data_out + 2*5)[1] =
                                ((npy_double *)data0 + 2*5)[1] +
                                ((npy_double *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_double *)data_out + 2*6)[0] =
                                ((npy_double *)data0 + 2*6)[0] +
                                ((npy_double *)data_out + 2*6)[0];
        ((npy_double *)data_out + 2*6)[1] =
                                ((npy_double *)data0 + 2*6)[1] +
                                ((npy_double *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_double *)data_out + 2*7)[0] =
                                ((npy_double *)data0 + 2*7)[0] +
                                ((npy_double *)data_out + 2*7)[0];
        ((npy_double *)data_out + 2*7)[1] =
                                ((npy_double *)data0 + 2*7)[1] +
                                ((npy_double *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
double_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
double_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_double *)dataptr[0]);
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 1
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
double_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double value1 = (*(npy_double *)dataptr[1]);
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_double *)dataptr[0]);
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 1
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double value1 = (*(npy_double *)dataptr[1]);
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 1
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
double_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data2 = (npy_double *)dataptr[2];
    npy_double *data_out = (npy_double *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
double_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        *(npy_double *)dataptr[nop] = (temp +
                                           (*(npy_double *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_double);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_double);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
double_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_double accum_re = 0, accum_im = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#else
    npy_double accum = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_double *)dataptr[1])[0] += accum_re;
            ((npy_double *)dataptr[1])[1] += accum_im;
#else
            *((npy_double *)dataptr[1]) = (accum +
                                    (*((npy_double *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
double_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_double accum_re = 0, accum_im = 0;
#else
    npy_double accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_double *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_double *)data0) *
                 (*(npy_double *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_double *)data0) *
                 (*(npy_double *)data1) *
                 (*(npy_double *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_double *)data0)[0];
        accum_im += ((npy_double *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_double *)dataptr[1])[0] += accum_re;
    ((npy_double *)dataptr[1])[1] += accum_im;
#  else
    ((npy_double *)dataptr[nop])[0] += accum_re;
    ((npy_double *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_double *)dataptr[1]) = (accum +
                                    (*((npy_double *)dataptr[1])));
#  else
    *((npy_double *)dataptr[nop]) = (accum +
                                    (*((npy_double *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
double_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_double *)data_out = ((*(npy_double *)data0) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_double *)data_out = ((*(npy_double *)data0) *
                                         (*(npy_double *)data1) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_double *)data_out = ((*(npy_double *)data0) *
                                         (*(npy_double *)data1) *
                                         (*(npy_double *)data2) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        *(npy_double *)dataptr[nop] = (temp +
                                           (*(npy_double *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_double *)data_out)[0] = ((npy_double *)data0)[0] +
                                         ((npy_double *)data_out)[0];
        ((npy_double *)data_out)[1] = ((npy_double *)data0)[1] +
                                         ((npy_double *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
double_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data_out = (npy_double *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_double *)data_out + 2*6)[0] =
                                    ((npy_double *)data0 + 2*6)[0] +
                                    ((npy_double *)data_out + 2*6)[0];
            ((npy_double *)data_out + 2*6)[1] =
                                    ((npy_double *)data0 + 2*6)[1] +
                                    ((npy_double *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_double *)data_out + 2*5)[0] =
                                    ((npy_double *)data0 + 2*5)[0] +
                                    ((npy_double *)data_out + 2*5)[0];
            ((npy_double *)data_out + 2*5)[1] =
                                    ((npy_double *)data0 + 2*5)[1] +
                                    ((npy_double *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_double *)data_out + 2*4)[0] =
                                    ((npy_double *)data0 + 2*4)[0] +
                                    ((npy_double *)data_out + 2*4)[0];
            ((npy_double *)data_out + 2*4)[1] =
                                    ((npy_double *)data0 + 2*4)[1] +
                                    ((npy_double *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_double *)data_out + 2*3)[0] =
                                    ((npy_double *)data0 + 2*3)[0] +
                                    ((npy_double *)data_out + 2*3)[0];
            ((npy_double *)data_out + 2*3)[1] =
                                    ((npy_double *)data0 + 2*3)[1] +
                                    ((npy_double *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_double *)data_out + 2*2)[0] =
                                    ((npy_double *)data0 + 2*2)[0] +
                                    ((npy_double *)data_out + 2*2)[0];
            ((npy_double *)data_out + 2*2)[1] =
                                    ((npy_double *)data0 + 2*2)[1] +
                                    ((npy_double *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_double *)data_out + 2*1)[0] =
                                    ((npy_double *)data0 + 2*1)[0] +
                                    ((npy_double *)data_out + 2*1)[0];
            ((npy_double *)data_out + 2*1)[1] =
                                    ((npy_double *)data0 + 2*1)[1] +
                                    ((npy_double *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_double *)data_out + 2*0)[0] =
                                    ((npy_double *)data0 + 2*0)[0] +
                                    ((npy_double *)data_out + 2*0)[0];
            ((npy_double *)data_out + 2*0)[1] =
                                    ((npy_double *)data0 + 2*0)[1] +
                                    ((npy_double *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_double *)data_out + 2*0)[0] =
                                ((npy_double *)data0 + 2*0)[0] +
                                ((npy_double *)data_out + 2*0)[0];
        ((npy_double *)data_out + 2*0)[1] =
                                ((npy_double *)data0 + 2*0)[1] +
                                ((npy_double *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_double *)data_out + 2*1)[0] =
                                ((npy_double *)data0 + 2*1)[0] +
                                ((npy_double *)data_out + 2*1)[0];
        ((npy_double *)data_out + 2*1)[1] =
                                ((npy_double *)data0 + 2*1)[1] +
                                ((npy_double *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_double *)data_out + 2*2)[0] =
                                ((npy_double *)data0 + 2*2)[0] +
                                ((npy_double *)data_out + 2*2)[0];
        ((npy_double *)data_out + 2*2)[1] =
                                ((npy_double *)data0 + 2*2)[1] +
                                ((npy_double *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_double *)data_out + 2*3)[0] =
                                ((npy_double *)data0 + 2*3)[0] +
                                ((npy_double *)data_out + 2*3)[0];
        ((npy_double *)data_out + 2*3)[1] =
                                ((npy_double *)data0 + 2*3)[1] +
                                ((npy_double *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_double *)data_out + 2*4)[0] =
                                ((npy_double *)data0 + 2*4)[0] +
                                ((npy_double *)data_out + 2*4)[0];
        ((npy_double *)data_out + 2*4)[1] =
                                ((npy_double *)data0 + 2*4)[1] +
                                ((npy_double *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_double *)data_out + 2*5)[0] =
                                ((npy_double *)data0 + 2*5)[0] +
                                ((npy_double *)data_out + 2*5)[0];
        ((npy_double *)data_out + 2*5)[1] =
                                ((npy_double *)data0 + 2*5)[1] +
                                ((npy_double *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_double *)data_out + 2*6)[0] =
                                ((npy_double *)data0 + 2*6)[0] +
                                ((npy_double *)data_out + 2*6)[0];
        ((npy_double *)data_out + 2*6)[1] =
                                ((npy_double *)data0 + 2*6)[1] +
                                ((npy_double *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_double *)data_out + 2*7)[0] =
                                ((npy_double *)data0 + 2*7)[0] +
                                ((npy_double *)data_out + 2*7)[0];
        ((npy_double *)data_out + 2*7)[1] =
                                ((npy_double *)data0 + 2*7)[1] +
                                ((npy_double *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
double_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
double_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_double *)dataptr[0]);
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 1
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
double_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double value1 = (*(npy_double *)dataptr[1]);
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_double *)dataptr[0]);
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 1
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double value1 = (*(npy_double *)dataptr[1]);
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 1
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
double_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data2 = (npy_double *)dataptr[2];
    npy_double *data_out = (npy_double *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
double_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        *(npy_double *)dataptr[nop] = (temp +
                                           (*(npy_double *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_double);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_double);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
double_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_double accum_re = 0, accum_im = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#else
    npy_double accum = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_double *)dataptr[1])[0] += accum_re;
            ((npy_double *)dataptr[1])[1] += accum_im;
#else
            *((npy_double *)dataptr[1]) = (accum +
                                    (*((npy_double *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
double_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_double accum_re = 0, accum_im = 0;
#else
    npy_double accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_double *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_double *)data0) *
                 (*(npy_double *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_double *)data0) *
                 (*(npy_double *)data1) *
                 (*(npy_double *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_double *)data0)[0];
        accum_im += ((npy_double *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_double *)dataptr[2])[0] += accum_re;
    ((npy_double *)dataptr[2])[1] += accum_im;
#  else
    ((npy_double *)dataptr[nop])[0] += accum_re;
    ((npy_double *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_double *)dataptr[2]) = (accum +
                                    (*((npy_double *)dataptr[2])));
#  else
    *((npy_double *)dataptr[nop]) = (accum +
                                    (*((npy_double *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
double_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_double *)data_out = ((*(npy_double *)data0) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_double *)data_out = ((*(npy_double *)data0) *
                                         (*(npy_double *)data1) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_double *)data_out = ((*(npy_double *)data0) *
                                         (*(npy_double *)data1) *
                                         (*(npy_double *)data2) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        *(npy_double *)dataptr[nop] = (temp +
                                           (*(npy_double *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_double *)data_out)[0] = ((npy_double *)data0)[0] +
                                         ((npy_double *)data_out)[0];
        ((npy_double *)data_out)[1] = ((npy_double *)data0)[1] +
                                         ((npy_double *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
double_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data_out = (npy_double *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_double *)data_out + 2*6)[0] =
                                    ((npy_double *)data0 + 2*6)[0] +
                                    ((npy_double *)data_out + 2*6)[0];
            ((npy_double *)data_out + 2*6)[1] =
                                    ((npy_double *)data0 + 2*6)[1] +
                                    ((npy_double *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_double *)data_out + 2*5)[0] =
                                    ((npy_double *)data0 + 2*5)[0] +
                                    ((npy_double *)data_out + 2*5)[0];
            ((npy_double *)data_out + 2*5)[1] =
                                    ((npy_double *)data0 + 2*5)[1] +
                                    ((npy_double *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_double *)data_out + 2*4)[0] =
                                    ((npy_double *)data0 + 2*4)[0] +
                                    ((npy_double *)data_out + 2*4)[0];
            ((npy_double *)data_out + 2*4)[1] =
                                    ((npy_double *)data0 + 2*4)[1] +
                                    ((npy_double *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_double *)data_out + 2*3)[0] =
                                    ((npy_double *)data0 + 2*3)[0] +
                                    ((npy_double *)data_out + 2*3)[0];
            ((npy_double *)data_out + 2*3)[1] =
                                    ((npy_double *)data0 + 2*3)[1] +
                                    ((npy_double *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_double *)data_out + 2*2)[0] =
                                    ((npy_double *)data0 + 2*2)[0] +
                                    ((npy_double *)data_out + 2*2)[0];
            ((npy_double *)data_out + 2*2)[1] =
                                    ((npy_double *)data0 + 2*2)[1] +
                                    ((npy_double *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_double *)data_out + 2*1)[0] =
                                    ((npy_double *)data0 + 2*1)[0] +
                                    ((npy_double *)data_out + 2*1)[0];
            ((npy_double *)data_out + 2*1)[1] =
                                    ((npy_double *)data0 + 2*1)[1] +
                                    ((npy_double *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_double *)data_out + 2*0)[0] =
                                    ((npy_double *)data0 + 2*0)[0] +
                                    ((npy_double *)data_out + 2*0)[0];
            ((npy_double *)data_out + 2*0)[1] =
                                    ((npy_double *)data0 + 2*0)[1] +
                                    ((npy_double *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_double *)data_out + 2*0)[0] =
                                ((npy_double *)data0 + 2*0)[0] +
                                ((npy_double *)data_out + 2*0)[0];
        ((npy_double *)data_out + 2*0)[1] =
                                ((npy_double *)data0 + 2*0)[1] +
                                ((npy_double *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_double *)data_out + 2*1)[0] =
                                ((npy_double *)data0 + 2*1)[0] +
                                ((npy_double *)data_out + 2*1)[0];
        ((npy_double *)data_out + 2*1)[1] =
                                ((npy_double *)data0 + 2*1)[1] +
                                ((npy_double *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_double *)data_out + 2*2)[0] =
                                ((npy_double *)data0 + 2*2)[0] +
                                ((npy_double *)data_out + 2*2)[0];
        ((npy_double *)data_out + 2*2)[1] =
                                ((npy_double *)data0 + 2*2)[1] +
                                ((npy_double *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_double *)data_out + 2*3)[0] =
                                ((npy_double *)data0 + 2*3)[0] +
                                ((npy_double *)data_out + 2*3)[0];
        ((npy_double *)data_out + 2*3)[1] =
                                ((npy_double *)data0 + 2*3)[1] +
                                ((npy_double *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_double *)data_out + 2*4)[0] =
                                ((npy_double *)data0 + 2*4)[0] +
                                ((npy_double *)data_out + 2*4)[0];
        ((npy_double *)data_out + 2*4)[1] =
                                ((npy_double *)data0 + 2*4)[1] +
                                ((npy_double *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_double *)data_out + 2*5)[0] =
                                ((npy_double *)data0 + 2*5)[0] +
                                ((npy_double *)data_out + 2*5)[0];
        ((npy_double *)data_out + 2*5)[1] =
                                ((npy_double *)data0 + 2*5)[1] +
                                ((npy_double *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_double *)data_out + 2*6)[0] =
                                ((npy_double *)data0 + 2*6)[0] +
                                ((npy_double *)data_out + 2*6)[0];
        ((npy_double *)data_out + 2*6)[1] =
                                ((npy_double *)data0 + 2*6)[1] +
                                ((npy_double *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_double *)data_out + 2*7)[0] =
                                ((npy_double *)data0 + 2*7)[0] +
                                ((npy_double *)data_out + 2*7)[0];
        ((npy_double *)data_out + 2*7)[1] =
                                ((npy_double *)data0 + 2*7)[1] +
                                ((npy_double *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
double_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
double_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_double *)dataptr[0]);
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 1
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
double_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double value1 = (*(npy_double *)dataptr[1]);
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_double *)dataptr[0]);
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 1
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double value1 = (*(npy_double *)dataptr[1]);
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 1
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
double_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data2 = (npy_double *)dataptr[2];
    npy_double *data_out = (npy_double *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
double_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        *(npy_double *)dataptr[nop] = (temp +
                                           (*(npy_double *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_double);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_double);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
double_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_double accum_re = 0, accum_im = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#else
    npy_double accum = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_double *)dataptr[1])[0] += accum_re;
            ((npy_double *)dataptr[1])[1] += accum_im;
#else
            *((npy_double *)dataptr[1]) = (accum +
                                    (*((npy_double *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
double_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_double accum_re = 0, accum_im = 0;
#else
    npy_double accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_double *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_double *)data0) *
                 (*(npy_double *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_double *)data0) *
                 (*(npy_double *)data1) *
                 (*(npy_double *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_double *)data0)[0];
        accum_im += ((npy_double *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_double *)dataptr[3])[0] += accum_re;
    ((npy_double *)dataptr[3])[1] += accum_im;
#  else
    ((npy_double *)dataptr[nop])[0] += accum_re;
    ((npy_double *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_double *)dataptr[3]) = (accum +
                                    (*((npy_double *)dataptr[3])));
#  else
    *((npy_double *)dataptr[nop]) = (accum +
                                    (*((npy_double *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
double_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_double *)data_out = ((*(npy_double *)data0) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_double *)data_out = ((*(npy_double *)data0) *
                                         (*(npy_double *)data1) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_double *)data_out = ((*(npy_double *)data0) *
                                         (*(npy_double *)data1) *
                                         (*(npy_double *)data2) +
                                         (*(npy_double *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        *(npy_double *)dataptr[nop] = (temp +
                                           (*(npy_double *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_double *)data_out)[0] = ((npy_double *)data0)[0] +
                                         ((npy_double *)data_out)[0];
        ((npy_double *)data_out)[1] = ((npy_double *)data0)[1] +
                                         ((npy_double *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
double_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data_out = (npy_double *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_double *)data_out + 2*6)[0] =
                                    ((npy_double *)data0 + 2*6)[0] +
                                    ((npy_double *)data_out + 2*6)[0];
            ((npy_double *)data_out + 2*6)[1] =
                                    ((npy_double *)data0 + 2*6)[1] +
                                    ((npy_double *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_double *)data_out + 2*5)[0] =
                                    ((npy_double *)data0 + 2*5)[0] +
                                    ((npy_double *)data_out + 2*5)[0];
            ((npy_double *)data_out + 2*5)[1] =
                                    ((npy_double *)data0 + 2*5)[1] +
                                    ((npy_double *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_double *)data_out + 2*4)[0] =
                                    ((npy_double *)data0 + 2*4)[0] +
                                    ((npy_double *)data_out + 2*4)[0];
            ((npy_double *)data_out + 2*4)[1] =
                                    ((npy_double *)data0 + 2*4)[1] +
                                    ((npy_double *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_double *)data_out + 2*3)[0] =
                                    ((npy_double *)data0 + 2*3)[0] +
                                    ((npy_double *)data_out + 2*3)[0];
            ((npy_double *)data_out + 2*3)[1] =
                                    ((npy_double *)data0 + 2*3)[1] +
                                    ((npy_double *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_double *)data_out + 2*2)[0] =
                                    ((npy_double *)data0 + 2*2)[0] +
                                    ((npy_double *)data_out + 2*2)[0];
            ((npy_double *)data_out + 2*2)[1] =
                                    ((npy_double *)data0 + 2*2)[1] +
                                    ((npy_double *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_double *)data_out + 2*1)[0] =
                                    ((npy_double *)data0 + 2*1)[0] +
                                    ((npy_double *)data_out + 2*1)[0];
            ((npy_double *)data_out + 2*1)[1] =
                                    ((npy_double *)data0 + 2*1)[1] +
                                    ((npy_double *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_double *)data_out + 2*0)[0] =
                                    ((npy_double *)data0 + 2*0)[0] +
                                    ((npy_double *)data_out + 2*0)[0];
            ((npy_double *)data_out + 2*0)[1] =
                                    ((npy_double *)data0 + 2*0)[1] +
                                    ((npy_double *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_double *)data_out + 2*0)[0] =
                                ((npy_double *)data0 + 2*0)[0] +
                                ((npy_double *)data_out + 2*0)[0];
        ((npy_double *)data_out + 2*0)[1] =
                                ((npy_double *)data0 + 2*0)[1] +
                                ((npy_double *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_double *)data_out + 2*1)[0] =
                                ((npy_double *)data0 + 2*1)[0] +
                                ((npy_double *)data_out + 2*1)[0];
        ((npy_double *)data_out + 2*1)[1] =
                                ((npy_double *)data0 + 2*1)[1] +
                                ((npy_double *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_double *)data_out + 2*2)[0] =
                                ((npy_double *)data0 + 2*2)[0] +
                                ((npy_double *)data_out + 2*2)[0];
        ((npy_double *)data_out + 2*2)[1] =
                                ((npy_double *)data0 + 2*2)[1] +
                                ((npy_double *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_double *)data_out + 2*3)[0] =
                                ((npy_double *)data0 + 2*3)[0] +
                                ((npy_double *)data_out + 2*3)[0];
        ((npy_double *)data_out + 2*3)[1] =
                                ((npy_double *)data0 + 2*3)[1] +
                                ((npy_double *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_double *)data_out + 2*4)[0] =
                                ((npy_double *)data0 + 2*4)[0] +
                                ((npy_double *)data_out + 2*4)[0];
        ((npy_double *)data_out + 2*4)[1] =
                                ((npy_double *)data0 + 2*4)[1] +
                                ((npy_double *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_double *)data_out + 2*5)[0] =
                                ((npy_double *)data0 + 2*5)[0] +
                                ((npy_double *)data_out + 2*5)[0];
        ((npy_double *)data_out + 2*5)[1] =
                                ((npy_double *)data0 + 2*5)[1] +
                                ((npy_double *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_double *)data_out + 2*6)[0] =
                                ((npy_double *)data0 + 2*6)[0] +
                                ((npy_double *)data_out + 2*6)[0];
        ((npy_double *)data_out + 2*6)[1] =
                                ((npy_double *)data0 + 2*6)[1] +
                                ((npy_double *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_double *)data_out + 2*7)[0] =
                                ((npy_double *)data0 + 2*7)[0] +
                                ((npy_double *)data_out + 2*7)[0];
        ((npy_double *)data_out + 2*7)[1] =
                                ((npy_double *)data0 + 2*7)[1] +
                                ((npy_double *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
double_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
double_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_double *)dataptr[0]);
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 1
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
double_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double value1 = (*(npy_double *)dataptr[1]);
    npy_double *data_out = (npy_double *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 1
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 1
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_double *)dataptr[0]);
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 1
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
double_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double value1 = (*(npy_double *)dataptr[1]);
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_double *)dataptr[2] = ((*(npy_double *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 1
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
double_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double *data0 = (npy_double *)dataptr[0];
    npy_double *data1 = (npy_double *)dataptr[1];
    npy_double *data2 = (npy_double *)dataptr[2];
    npy_double *data_out = (npy_double *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
double_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        *(npy_double *)dataptr[nop] = (temp +
                                           (*(npy_double *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_double);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_double);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
double_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_double accum_re = 0, accum_im = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#else
    npy_double accum = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 1
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_double *)dataptr[1])[0] += accum_re;
            ((npy_double *)dataptr[1])[1] += accum_im;
#else
            *((npy_double *)dataptr[1]) = (accum +
                                    (*((npy_double *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 1
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 1
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 1
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
double_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_double accum_re = 0, accum_im = 0;
#else
    npy_double accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("double_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_double *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_double *)data0) *
                 (*(npy_double *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_double *)data0) *
                 (*(npy_double *)data1) *
                 (*(npy_double *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_double temp = (*(npy_double *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_double *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_double *)data0)[0];
        accum_im += ((npy_double *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_double *)dataptr[1000])[0] += accum_re;
    ((npy_double *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_double *)dataptr[nop])[0] += accum_re;
    ((npy_double *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_double *)dataptr[1000]) = (accum +
                                    (*((npy_double *)dataptr[1000])));
#  else
    *((npy_double *)dataptr[nop]) = (accum +
                                    (*((npy_double *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
longdouble_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !0)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) *
                                         (*(npy_longdouble *)data1) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) *
                                         (*(npy_longdouble *)data1) *
                                         (*(npy_longdouble *)data2) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        *(npy_longdouble *)dataptr[nop] = (temp +
                                           (*(npy_longdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_longdouble *)data_out)[0] = ((npy_longdouble *)data0)[0] +
                                         ((npy_longdouble *)data_out)[0];
        ((npy_longdouble *)data_out)[1] = ((npy_longdouble *)data0)[1] +
                                         ((npy_longdouble *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
longdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longdouble *)data_out + 2*6)[0] =
                                    ((npy_longdouble *)data0 + 2*6)[0] +
                                    ((npy_longdouble *)data_out + 2*6)[0];
            ((npy_longdouble *)data_out + 2*6)[1] =
                                    ((npy_longdouble *)data0 + 2*6)[1] +
                                    ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longdouble *)data_out + 2*5)[0] =
                                    ((npy_longdouble *)data0 + 2*5)[0] +
                                    ((npy_longdouble *)data_out + 2*5)[0];
            ((npy_longdouble *)data_out + 2*5)[1] =
                                    ((npy_longdouble *)data0 + 2*5)[1] +
                                    ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longdouble *)data_out + 2*4)[0] =
                                    ((npy_longdouble *)data0 + 2*4)[0] +
                                    ((npy_longdouble *)data_out + 2*4)[0];
            ((npy_longdouble *)data_out + 2*4)[1] =
                                    ((npy_longdouble *)data0 + 2*4)[1] +
                                    ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longdouble *)data_out + 2*3)[0] =
                                    ((npy_longdouble *)data0 + 2*3)[0] +
                                    ((npy_longdouble *)data_out + 2*3)[0];
            ((npy_longdouble *)data_out + 2*3)[1] =
                                    ((npy_longdouble *)data0 + 2*3)[1] +
                                    ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longdouble *)data_out + 2*2)[0] =
                                    ((npy_longdouble *)data0 + 2*2)[0] +
                                    ((npy_longdouble *)data_out + 2*2)[0];
            ((npy_longdouble *)data_out + 2*2)[1] =
                                    ((npy_longdouble *)data0 + 2*2)[1] +
                                    ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longdouble *)data_out + 2*1)[0] =
                                    ((npy_longdouble *)data0 + 2*1)[0] +
                                    ((npy_longdouble *)data_out + 2*1)[0];
            ((npy_longdouble *)data_out + 2*1)[1] =
                                    ((npy_longdouble *)data0 + 2*1)[1] +
                                    ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longdouble *)data_out + 2*0)[0] =
                                    ((npy_longdouble *)data0 + 2*0)[0] +
                                    ((npy_longdouble *)data_out + 2*0)[0];
            ((npy_longdouble *)data_out + 2*0)[1] =
                                    ((npy_longdouble *)data0 + 2*0)[1] +
                                    ((npy_longdouble *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*0)[0] =
                                ((npy_longdouble *)data0 + 2*0)[0] +
                                ((npy_longdouble *)data_out + 2*0)[0];
        ((npy_longdouble *)data_out + 2*0)[1] =
                                ((npy_longdouble *)data0 + 2*0)[1] +
                                ((npy_longdouble *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*1)[0] =
                                ((npy_longdouble *)data0 + 2*1)[0] +
                                ((npy_longdouble *)data_out + 2*1)[0];
        ((npy_longdouble *)data_out + 2*1)[1] =
                                ((npy_longdouble *)data0 + 2*1)[1] +
                                ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*2)[0] =
                                ((npy_longdouble *)data0 + 2*2)[0] +
                                ((npy_longdouble *)data_out + 2*2)[0];
        ((npy_longdouble *)data_out + 2*2)[1] =
                                ((npy_longdouble *)data0 + 2*2)[1] +
                                ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*3)[0] =
                                ((npy_longdouble *)data0 + 2*3)[0] +
                                ((npy_longdouble *)data_out + 2*3)[0];
        ((npy_longdouble *)data_out + 2*3)[1] =
                                ((npy_longdouble *)data0 + 2*3)[1] +
                                ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*4)[0] =
                                ((npy_longdouble *)data0 + 2*4)[0] +
                                ((npy_longdouble *)data_out + 2*4)[0];
        ((npy_longdouble *)data_out + 2*4)[1] =
                                ((npy_longdouble *)data0 + 2*4)[1] +
                                ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*5)[0] =
                                ((npy_longdouble *)data0 + 2*5)[0] +
                                ((npy_longdouble *)data_out + 2*5)[0];
        ((npy_longdouble *)data_out + 2*5)[1] =
                                ((npy_longdouble *)data0 + 2*5)[1] +
                                ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*6)[0] =
                                ((npy_longdouble *)data0 + 2*6)[0] +
                                ((npy_longdouble *)data_out + 2*6)[0];
        ((npy_longdouble *)data_out + 2*6)[1] =
                                ((npy_longdouble *)data0 + 2*6)[1] +
                                ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*7)[0] =
                                ((npy_longdouble *)data0 + 2*7)[0] +
                                ((npy_longdouble *)data_out + 2*7)[0];
        ((npy_longdouble *)data_out + 2*7)[1] =
                                ((npy_longdouble *)data0 + 2*7)[1] +
                                ((npy_longdouble *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !0

static void
longdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
longdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_longdouble *)dataptr[0]);
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
longdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_longdouble *)dataptr[1]);
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_longdouble *)dataptr[0]);
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_longdouble *)dataptr[1]);
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !0

static void
longdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data2 = (npy_longdouble *)dataptr[2];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
longdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        *(npy_longdouble *)dataptr[nop] = (temp +
                                           (*(npy_longdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_longdouble);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_longdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
longdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longdouble accum_re = 0, accum_im = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#else
    npy_longdouble accum = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_longdouble *)dataptr[1])[0] += accum_re;
            ((npy_longdouble *)dataptr[1])[1] += accum_im;
#else
            *((npy_longdouble *)dataptr[1]) = (accum +
                                    (*((npy_longdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
longdouble_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longdouble accum_re = 0, accum_im = 0;
#else
    npy_longdouble accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1 == 1
        accum += (*(npy_longdouble *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_longdouble *)data0) *
                 (*(npy_longdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_longdouble *)data0) *
                 (*(npy_longdouble *)data1) *
                 (*(npy_longdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_longdouble *)data0)[0];
        accum_im += ((npy_longdouble *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1 <= 3
    ((npy_longdouble *)dataptr[1])[0] += accum_re;
    ((npy_longdouble *)dataptr[1])[1] += accum_im;
#  else
    ((npy_longdouble *)dataptr[nop])[0] += accum_re;
    ((npy_longdouble *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_longdouble *)dataptr[1]) = (accum +
                                    (*((npy_longdouble *)dataptr[1])));
#  else
    *((npy_longdouble *)dataptr[nop]) = (accum +
                                    (*((npy_longdouble *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
longdouble_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !0)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) *
                                         (*(npy_longdouble *)data1) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) *
                                         (*(npy_longdouble *)data1) *
                                         (*(npy_longdouble *)data2) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        *(npy_longdouble *)dataptr[nop] = (temp +
                                           (*(npy_longdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_longdouble *)data_out)[0] = ((npy_longdouble *)data0)[0] +
                                         ((npy_longdouble *)data_out)[0];
        ((npy_longdouble *)data_out)[1] = ((npy_longdouble *)data0)[1] +
                                         ((npy_longdouble *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
longdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longdouble *)data_out + 2*6)[0] =
                                    ((npy_longdouble *)data0 + 2*6)[0] +
                                    ((npy_longdouble *)data_out + 2*6)[0];
            ((npy_longdouble *)data_out + 2*6)[1] =
                                    ((npy_longdouble *)data0 + 2*6)[1] +
                                    ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longdouble *)data_out + 2*5)[0] =
                                    ((npy_longdouble *)data0 + 2*5)[0] +
                                    ((npy_longdouble *)data_out + 2*5)[0];
            ((npy_longdouble *)data_out + 2*5)[1] =
                                    ((npy_longdouble *)data0 + 2*5)[1] +
                                    ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longdouble *)data_out + 2*4)[0] =
                                    ((npy_longdouble *)data0 + 2*4)[0] +
                                    ((npy_longdouble *)data_out + 2*4)[0];
            ((npy_longdouble *)data_out + 2*4)[1] =
                                    ((npy_longdouble *)data0 + 2*4)[1] +
                                    ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longdouble *)data_out + 2*3)[0] =
                                    ((npy_longdouble *)data0 + 2*3)[0] +
                                    ((npy_longdouble *)data_out + 2*3)[0];
            ((npy_longdouble *)data_out + 2*3)[1] =
                                    ((npy_longdouble *)data0 + 2*3)[1] +
                                    ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longdouble *)data_out + 2*2)[0] =
                                    ((npy_longdouble *)data0 + 2*2)[0] +
                                    ((npy_longdouble *)data_out + 2*2)[0];
            ((npy_longdouble *)data_out + 2*2)[1] =
                                    ((npy_longdouble *)data0 + 2*2)[1] +
                                    ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longdouble *)data_out + 2*1)[0] =
                                    ((npy_longdouble *)data0 + 2*1)[0] +
                                    ((npy_longdouble *)data_out + 2*1)[0];
            ((npy_longdouble *)data_out + 2*1)[1] =
                                    ((npy_longdouble *)data0 + 2*1)[1] +
                                    ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longdouble *)data_out + 2*0)[0] =
                                    ((npy_longdouble *)data0 + 2*0)[0] +
                                    ((npy_longdouble *)data_out + 2*0)[0];
            ((npy_longdouble *)data_out + 2*0)[1] =
                                    ((npy_longdouble *)data0 + 2*0)[1] +
                                    ((npy_longdouble *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*0)[0] =
                                ((npy_longdouble *)data0 + 2*0)[0] +
                                ((npy_longdouble *)data_out + 2*0)[0];
        ((npy_longdouble *)data_out + 2*0)[1] =
                                ((npy_longdouble *)data0 + 2*0)[1] +
                                ((npy_longdouble *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*1)[0] =
                                ((npy_longdouble *)data0 + 2*1)[0] +
                                ((npy_longdouble *)data_out + 2*1)[0];
        ((npy_longdouble *)data_out + 2*1)[1] =
                                ((npy_longdouble *)data0 + 2*1)[1] +
                                ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*2)[0] =
                                ((npy_longdouble *)data0 + 2*2)[0] +
                                ((npy_longdouble *)data_out + 2*2)[0];
        ((npy_longdouble *)data_out + 2*2)[1] =
                                ((npy_longdouble *)data0 + 2*2)[1] +
                                ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*3)[0] =
                                ((npy_longdouble *)data0 + 2*3)[0] +
                                ((npy_longdouble *)data_out + 2*3)[0];
        ((npy_longdouble *)data_out + 2*3)[1] =
                                ((npy_longdouble *)data0 + 2*3)[1] +
                                ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*4)[0] =
                                ((npy_longdouble *)data0 + 2*4)[0] +
                                ((npy_longdouble *)data_out + 2*4)[0];
        ((npy_longdouble *)data_out + 2*4)[1] =
                                ((npy_longdouble *)data0 + 2*4)[1] +
                                ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*5)[0] =
                                ((npy_longdouble *)data0 + 2*5)[0] +
                                ((npy_longdouble *)data_out + 2*5)[0];
        ((npy_longdouble *)data_out + 2*5)[1] =
                                ((npy_longdouble *)data0 + 2*5)[1] +
                                ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*6)[0] =
                                ((npy_longdouble *)data0 + 2*6)[0] +
                                ((npy_longdouble *)data_out + 2*6)[0];
        ((npy_longdouble *)data_out + 2*6)[1] =
                                ((npy_longdouble *)data0 + 2*6)[1] +
                                ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*7)[0] =
                                ((npy_longdouble *)data0 + 2*7)[0] +
                                ((npy_longdouble *)data_out + 2*7)[0];
        ((npy_longdouble *)data_out + 2*7)[1] =
                                ((npy_longdouble *)data0 + 2*7)[1] +
                                ((npy_longdouble *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !0

static void
longdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
longdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_longdouble *)dataptr[0]);
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
longdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_longdouble *)dataptr[1]);
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_longdouble *)dataptr[0]);
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_longdouble *)dataptr[1]);
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !0

static void
longdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data2 = (npy_longdouble *)dataptr[2];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
longdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        *(npy_longdouble *)dataptr[nop] = (temp +
                                           (*(npy_longdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_longdouble);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_longdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
longdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longdouble accum_re = 0, accum_im = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#else
    npy_longdouble accum = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_longdouble *)dataptr[1])[0] += accum_re;
            ((npy_longdouble *)dataptr[1])[1] += accum_im;
#else
            *((npy_longdouble *)dataptr[1]) = (accum +
                                    (*((npy_longdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
longdouble_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longdouble accum_re = 0, accum_im = 0;
#else
    npy_longdouble accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 2 == 1
        accum += (*(npy_longdouble *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_longdouble *)data0) *
                 (*(npy_longdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_longdouble *)data0) *
                 (*(npy_longdouble *)data1) *
                 (*(npy_longdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_longdouble *)data0)[0];
        accum_im += ((npy_longdouble *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 2 <= 3
    ((npy_longdouble *)dataptr[2])[0] += accum_re;
    ((npy_longdouble *)dataptr[2])[1] += accum_im;
#  else
    ((npy_longdouble *)dataptr[nop])[0] += accum_re;
    ((npy_longdouble *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_longdouble *)dataptr[2]) = (accum +
                                    (*((npy_longdouble *)dataptr[2])));
#  else
    *((npy_longdouble *)dataptr[nop]) = (accum +
                                    (*((npy_longdouble *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
longdouble_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !0)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) *
                                         (*(npy_longdouble *)data1) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) *
                                         (*(npy_longdouble *)data1) *
                                         (*(npy_longdouble *)data2) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        *(npy_longdouble *)dataptr[nop] = (temp +
                                           (*(npy_longdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_longdouble *)data_out)[0] = ((npy_longdouble *)data0)[0] +
                                         ((npy_longdouble *)data_out)[0];
        ((npy_longdouble *)data_out)[1] = ((npy_longdouble *)data0)[1] +
                                         ((npy_longdouble *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
longdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longdouble *)data_out + 2*6)[0] =
                                    ((npy_longdouble *)data0 + 2*6)[0] +
                                    ((npy_longdouble *)data_out + 2*6)[0];
            ((npy_longdouble *)data_out + 2*6)[1] =
                                    ((npy_longdouble *)data0 + 2*6)[1] +
                                    ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longdouble *)data_out + 2*5)[0] =
                                    ((npy_longdouble *)data0 + 2*5)[0] +
                                    ((npy_longdouble *)data_out + 2*5)[0];
            ((npy_longdouble *)data_out + 2*5)[1] =
                                    ((npy_longdouble *)data0 + 2*5)[1] +
                                    ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longdouble *)data_out + 2*4)[0] =
                                    ((npy_longdouble *)data0 + 2*4)[0] +
                                    ((npy_longdouble *)data_out + 2*4)[0];
            ((npy_longdouble *)data_out + 2*4)[1] =
                                    ((npy_longdouble *)data0 + 2*4)[1] +
                                    ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longdouble *)data_out + 2*3)[0] =
                                    ((npy_longdouble *)data0 + 2*3)[0] +
                                    ((npy_longdouble *)data_out + 2*3)[0];
            ((npy_longdouble *)data_out + 2*3)[1] =
                                    ((npy_longdouble *)data0 + 2*3)[1] +
                                    ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longdouble *)data_out + 2*2)[0] =
                                    ((npy_longdouble *)data0 + 2*2)[0] +
                                    ((npy_longdouble *)data_out + 2*2)[0];
            ((npy_longdouble *)data_out + 2*2)[1] =
                                    ((npy_longdouble *)data0 + 2*2)[1] +
                                    ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longdouble *)data_out + 2*1)[0] =
                                    ((npy_longdouble *)data0 + 2*1)[0] +
                                    ((npy_longdouble *)data_out + 2*1)[0];
            ((npy_longdouble *)data_out + 2*1)[1] =
                                    ((npy_longdouble *)data0 + 2*1)[1] +
                                    ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longdouble *)data_out + 2*0)[0] =
                                    ((npy_longdouble *)data0 + 2*0)[0] +
                                    ((npy_longdouble *)data_out + 2*0)[0];
            ((npy_longdouble *)data_out + 2*0)[1] =
                                    ((npy_longdouble *)data0 + 2*0)[1] +
                                    ((npy_longdouble *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*0)[0] =
                                ((npy_longdouble *)data0 + 2*0)[0] +
                                ((npy_longdouble *)data_out + 2*0)[0];
        ((npy_longdouble *)data_out + 2*0)[1] =
                                ((npy_longdouble *)data0 + 2*0)[1] +
                                ((npy_longdouble *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*1)[0] =
                                ((npy_longdouble *)data0 + 2*1)[0] +
                                ((npy_longdouble *)data_out + 2*1)[0];
        ((npy_longdouble *)data_out + 2*1)[1] =
                                ((npy_longdouble *)data0 + 2*1)[1] +
                                ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*2)[0] =
                                ((npy_longdouble *)data0 + 2*2)[0] +
                                ((npy_longdouble *)data_out + 2*2)[0];
        ((npy_longdouble *)data_out + 2*2)[1] =
                                ((npy_longdouble *)data0 + 2*2)[1] +
                                ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*3)[0] =
                                ((npy_longdouble *)data0 + 2*3)[0] +
                                ((npy_longdouble *)data_out + 2*3)[0];
        ((npy_longdouble *)data_out + 2*3)[1] =
                                ((npy_longdouble *)data0 + 2*3)[1] +
                                ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*4)[0] =
                                ((npy_longdouble *)data0 + 2*4)[0] +
                                ((npy_longdouble *)data_out + 2*4)[0];
        ((npy_longdouble *)data_out + 2*4)[1] =
                                ((npy_longdouble *)data0 + 2*4)[1] +
                                ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*5)[0] =
                                ((npy_longdouble *)data0 + 2*5)[0] +
                                ((npy_longdouble *)data_out + 2*5)[0];
        ((npy_longdouble *)data_out + 2*5)[1] =
                                ((npy_longdouble *)data0 + 2*5)[1] +
                                ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*6)[0] =
                                ((npy_longdouble *)data0 + 2*6)[0] +
                                ((npy_longdouble *)data_out + 2*6)[0];
        ((npy_longdouble *)data_out + 2*6)[1] =
                                ((npy_longdouble *)data0 + 2*6)[1] +
                                ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*7)[0] =
                                ((npy_longdouble *)data0 + 2*7)[0] +
                                ((npy_longdouble *)data_out + 2*7)[0];
        ((npy_longdouble *)data_out + 2*7)[1] =
                                ((npy_longdouble *)data0 + 2*7)[1] +
                                ((npy_longdouble *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !0

static void
longdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
longdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_longdouble *)dataptr[0]);
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
longdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_longdouble *)dataptr[1]);
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_longdouble *)dataptr[0]);
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_longdouble *)dataptr[1]);
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !0

static void
longdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data2 = (npy_longdouble *)dataptr[2];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
longdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        *(npy_longdouble *)dataptr[nop] = (temp +
                                           (*(npy_longdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_longdouble);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_longdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
longdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longdouble accum_re = 0, accum_im = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#else
    npy_longdouble accum = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_longdouble *)dataptr[1])[0] += accum_re;
            ((npy_longdouble *)dataptr[1])[1] += accum_im;
#else
            *((npy_longdouble *)dataptr[1]) = (accum +
                                    (*((npy_longdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
longdouble_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longdouble accum_re = 0, accum_im = 0;
#else
    npy_longdouble accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 3 == 1
        accum += (*(npy_longdouble *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_longdouble *)data0) *
                 (*(npy_longdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_longdouble *)data0) *
                 (*(npy_longdouble *)data1) *
                 (*(npy_longdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_longdouble *)data0)[0];
        accum_im += ((npy_longdouble *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 3 <= 3
    ((npy_longdouble *)dataptr[3])[0] += accum_re;
    ((npy_longdouble *)dataptr[3])[1] += accum_im;
#  else
    ((npy_longdouble *)dataptr[nop])[0] += accum_re;
    ((npy_longdouble *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_longdouble *)dataptr[3]) = (accum +
                                    (*((npy_longdouble *)dataptr[3])));
#  else
    *((npy_longdouble *)dataptr[nop]) = (accum +
                                    (*((npy_longdouble *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
longdouble_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !0)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) *
                                         (*(npy_longdouble *)data1) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_longdouble *)data_out = ((*(npy_longdouble *)data0) *
                                         (*(npy_longdouble *)data1) *
                                         (*(npy_longdouble *)data2) +
                                         (*(npy_longdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        *(npy_longdouble *)dataptr[nop] = (temp +
                                           (*(npy_longdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_longdouble *)data_out)[0] = ((npy_longdouble *)data0)[0] +
                                         ((npy_longdouble *)data_out)[0];
        ((npy_longdouble *)data_out)[1] = ((npy_longdouble *)data0)[1] +
                                         ((npy_longdouble *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
longdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !0
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longdouble *)data_out + 2*6)[0] =
                                    ((npy_longdouble *)data0 + 2*6)[0] +
                                    ((npy_longdouble *)data_out + 2*6)[0];
            ((npy_longdouble *)data_out + 2*6)[1] =
                                    ((npy_longdouble *)data0 + 2*6)[1] +
                                    ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !0
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longdouble *)data_out + 2*5)[0] =
                                    ((npy_longdouble *)data0 + 2*5)[0] +
                                    ((npy_longdouble *)data_out + 2*5)[0];
            ((npy_longdouble *)data_out + 2*5)[1] =
                                    ((npy_longdouble *)data0 + 2*5)[1] +
                                    ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !0
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longdouble *)data_out + 2*4)[0] =
                                    ((npy_longdouble *)data0 + 2*4)[0] +
                                    ((npy_longdouble *)data_out + 2*4)[0];
            ((npy_longdouble *)data_out + 2*4)[1] =
                                    ((npy_longdouble *)data0 + 2*4)[1] +
                                    ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !0
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longdouble *)data_out + 2*3)[0] =
                                    ((npy_longdouble *)data0 + 2*3)[0] +
                                    ((npy_longdouble *)data_out + 2*3)[0];
            ((npy_longdouble *)data_out + 2*3)[1] =
                                    ((npy_longdouble *)data0 + 2*3)[1] +
                                    ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !0
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longdouble *)data_out + 2*2)[0] =
                                    ((npy_longdouble *)data0 + 2*2)[0] +
                                    ((npy_longdouble *)data_out + 2*2)[0];
            ((npy_longdouble *)data_out + 2*2)[1] =
                                    ((npy_longdouble *)data0 + 2*2)[1] +
                                    ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !0
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longdouble *)data_out + 2*1)[0] =
                                    ((npy_longdouble *)data0 + 2*1)[0] +
                                    ((npy_longdouble *)data_out + 2*1)[0];
            ((npy_longdouble *)data_out + 2*1)[1] =
                                    ((npy_longdouble *)data0 + 2*1)[1] +
                                    ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !0
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longdouble *)data_out + 2*0)[0] =
                                    ((npy_longdouble *)data0 + 2*0)[0] +
                                    ((npy_longdouble *)data_out + 2*0)[0];
            ((npy_longdouble *)data_out + 2*0)[1] =
                                    ((npy_longdouble *)data0 + 2*0)[1] +
                                    ((npy_longdouble *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !0
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*0)[0] =
                                ((npy_longdouble *)data0 + 2*0)[0] +
                                ((npy_longdouble *)data_out + 2*0)[0];
        ((npy_longdouble *)data_out + 2*0)[1] =
                                ((npy_longdouble *)data0 + 2*0)[1] +
                                ((npy_longdouble *)data_out + 2*0)[1];
#endif

#line 224
#if !0
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*1)[0] =
                                ((npy_longdouble *)data0 + 2*1)[0] +
                                ((npy_longdouble *)data_out + 2*1)[0];
        ((npy_longdouble *)data_out + 2*1)[1] =
                                ((npy_longdouble *)data0 + 2*1)[1] +
                                ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 224
#if !0
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*2)[0] =
                                ((npy_longdouble *)data0 + 2*2)[0] +
                                ((npy_longdouble *)data_out + 2*2)[0];
        ((npy_longdouble *)data_out + 2*2)[1] =
                                ((npy_longdouble *)data0 + 2*2)[1] +
                                ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 224
#if !0
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*3)[0] =
                                ((npy_longdouble *)data0 + 2*3)[0] +
                                ((npy_longdouble *)data_out + 2*3)[0];
        ((npy_longdouble *)data_out + 2*3)[1] =
                                ((npy_longdouble *)data0 + 2*3)[1] +
                                ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 224
#if !0
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*4)[0] =
                                ((npy_longdouble *)data0 + 2*4)[0] +
                                ((npy_longdouble *)data_out + 2*4)[0];
        ((npy_longdouble *)data_out + 2*4)[1] =
                                ((npy_longdouble *)data0 + 2*4)[1] +
                                ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 224
#if !0
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*5)[0] =
                                ((npy_longdouble *)data0 + 2*5)[0] +
                                ((npy_longdouble *)data_out + 2*5)[0];
        ((npy_longdouble *)data_out + 2*5)[1] =
                                ((npy_longdouble *)data0 + 2*5)[1] +
                                ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 224
#if !0
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*6)[0] =
                                ((npy_longdouble *)data0 + 2*6)[0] +
                                ((npy_longdouble *)data_out + 2*6)[0];
        ((npy_longdouble *)data_out + 2*6)[1] =
                                ((npy_longdouble *)data0 + 2*6)[1] +
                                ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 224
#if !0
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*7)[0] =
                                ((npy_longdouble *)data0 + 2*7)[0] +
                                ((npy_longdouble *)data_out + 2*7)[0];
        ((npy_longdouble *)data_out + 2*7)[1] =
                                ((npy_longdouble *)data0 + 2*7)[1] +
                                ((npy_longdouble *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !0

static void
longdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
longdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_longdouble *)dataptr[0]);
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
longdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_longdouble *)dataptr[1]);
    npy_longdouble *data_out = (npy_longdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_longdouble *)dataptr[0]);
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
longdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_longdouble *)dataptr[1]);
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_longdouble *)dataptr[2] = ((*(npy_longdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !0

static void
longdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
    npy_longdouble *data1 = (npy_longdouble *)dataptr[1];
    npy_longdouble *data2 = (npy_longdouble *)dataptr[2];
    npy_longdouble *data_out = (npy_longdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
longdouble_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        *(npy_longdouble *)dataptr[nop] = (temp +
                                           (*(npy_longdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_longdouble);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_longdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
longdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longdouble accum_re = 0, accum_im = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#else
    npy_longdouble accum = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !0
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !0
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !0
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !0
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !0
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !0
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !0
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 0
            ((npy_longdouble *)dataptr[1])[0] += accum_re;
            ((npy_longdouble *)dataptr[1])[1] += accum_im;
#else
            *((npy_longdouble *)dataptr[1]) = (accum +
                                    (*((npy_longdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !0
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !0
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !0
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !0
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !0
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !0
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !0
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !0
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !0
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
longdouble_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 0
    npy_longdouble accum_re = 0, accum_im = 0;
#else
    npy_longdouble accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !0)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !0
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !0
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("longdouble_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !0
#  if 1000 == 1
        accum += (*(npy_longdouble *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_longdouble *)data0) *
                 (*(npy_longdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_longdouble *)data0) *
                 (*(npy_longdouble *)data1) *
                 (*(npy_longdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longdouble temp = (*(npy_longdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_longdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_longdouble *)data0)[0];
        accum_im += ((npy_longdouble *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 0
#  if 1000 <= 3
    ((npy_longdouble *)dataptr[1000])[0] += accum_re;
    ((npy_longdouble *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_longdouble *)dataptr[nop])[0] += accum_re;
    ((npy_longdouble *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_longdouble *)dataptr[1000]) = (accum +
                                    (*((npy_longdouble *)dataptr[1000])));
#  else
    *((npy_longdouble *)dataptr[nop]) = (accum +
                                    (*((npy_longdouble *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
cfloat_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !1)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 1 == 1
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) *
                                         (*(npy_cfloat *)data1) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) *
                                         (*(npy_cfloat *)data1) *
                                         (*(npy_cfloat *)data2) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        *(npy_cfloat *)dataptr[nop] = (temp +
                                           (*(npy_cfloat *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
cfloat_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !1

static void
cfloat_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
cfloat_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_cfloat *)dataptr[0]);
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
cfloat_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_float value1 = (*(npy_cfloat *)dataptr[1]);
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_cfloat *)dataptr[0]);
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_float value1 = (*(npy_cfloat *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !1

static void
cfloat_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data2 = (npy_cfloat *)dataptr[2];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
cfloat_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        *(npy_cfloat *)dataptr[nop] = (temp +
                                           (*(npy_cfloat *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_cfloat);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_cfloat);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
cfloat_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_cfloat *)dataptr[1]) = (accum +
                                    (*((npy_cfloat *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
cfloat_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 1 == 1
        accum += (*(npy_cfloat *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_cfloat *)data0) *
                 (*(npy_cfloat *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_cfloat *)data0) *
                 (*(npy_cfloat *)data1) *
                 (*(npy_cfloat *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 1 <= 3
    ((npy_float *)dataptr[1])[0] += accum_re;
    ((npy_float *)dataptr[1])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_cfloat *)dataptr[1]) = (accum +
                                    (*((npy_cfloat *)dataptr[1])));
#  else
    *((npy_cfloat *)dataptr[nop]) = (accum +
                                    (*((npy_cfloat *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
cfloat_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !1)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 2 == 1
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) *
                                         (*(npy_cfloat *)data1) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) *
                                         (*(npy_cfloat *)data1) *
                                         (*(npy_cfloat *)data2) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        *(npy_cfloat *)dataptr[nop] = (temp +
                                           (*(npy_cfloat *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
cfloat_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !1

static void
cfloat_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
cfloat_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_cfloat *)dataptr[0]);
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
cfloat_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_float value1 = (*(npy_cfloat *)dataptr[1]);
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_cfloat *)dataptr[0]);
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_float value1 = (*(npy_cfloat *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !1

static void
cfloat_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data2 = (npy_cfloat *)dataptr[2];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
cfloat_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        *(npy_cfloat *)dataptr[nop] = (temp +
                                           (*(npy_cfloat *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_cfloat);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_cfloat);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
cfloat_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_cfloat *)dataptr[1]) = (accum +
                                    (*((npy_cfloat *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
cfloat_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 2 == 1
        accum += (*(npy_cfloat *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_cfloat *)data0) *
                 (*(npy_cfloat *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_cfloat *)data0) *
                 (*(npy_cfloat *)data1) *
                 (*(npy_cfloat *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 2 <= 3
    ((npy_float *)dataptr[2])[0] += accum_re;
    ((npy_float *)dataptr[2])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_cfloat *)dataptr[2]) = (accum +
                                    (*((npy_cfloat *)dataptr[2])));
#  else
    *((npy_cfloat *)dataptr[nop]) = (accum +
                                    (*((npy_cfloat *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
cfloat_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !1)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 3 == 1
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) *
                                         (*(npy_cfloat *)data1) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) *
                                         (*(npy_cfloat *)data1) *
                                         (*(npy_cfloat *)data2) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        *(npy_cfloat *)dataptr[nop] = (temp +
                                           (*(npy_cfloat *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
cfloat_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !1

static void
cfloat_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
cfloat_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_cfloat *)dataptr[0]);
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
cfloat_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_float value1 = (*(npy_cfloat *)dataptr[1]);
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_cfloat *)dataptr[0]);
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_float value1 = (*(npy_cfloat *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !1

static void
cfloat_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data2 = (npy_cfloat *)dataptr[2];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
cfloat_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        *(npy_cfloat *)dataptr[nop] = (temp +
                                           (*(npy_cfloat *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_cfloat);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_cfloat);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
cfloat_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_cfloat *)dataptr[1]) = (accum +
                                    (*((npy_cfloat *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
cfloat_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 3 == 1
        accum += (*(npy_cfloat *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_cfloat *)data0) *
                 (*(npy_cfloat *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_cfloat *)data0) *
                 (*(npy_cfloat *)data1) *
                 (*(npy_cfloat *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 3 <= 3
    ((npy_float *)dataptr[3])[0] += accum_re;
    ((npy_float *)dataptr[3])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_cfloat *)dataptr[3]) = (accum +
                                    (*((npy_cfloat *)dataptr[3])));
#  else
    *((npy_cfloat *)dataptr[nop]) = (accum +
                                    (*((npy_cfloat *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
cfloat_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !1)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 1000 == 1
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) *
                                         (*(npy_cfloat *)data1) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_cfloat *)data_out = ((*(npy_cfloat *)data0) *
                                         (*(npy_cfloat *)data1) *
                                         (*(npy_cfloat *)data2) +
                                         (*(npy_cfloat *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        *(npy_cfloat *)dataptr[nop] = (temp +
                                           (*(npy_cfloat *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_float *)data_out)[0] = ((npy_float *)data0)[0] +
                                         ((npy_float *)data_out)[0];
        ((npy_float *)data_out)[1] = ((npy_float *)data0)[1] +
                                         ((npy_float *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
cfloat_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_float *)data_out + 2*6)[0] =
                                    ((npy_float *)data0 + 2*6)[0] +
                                    ((npy_float *)data_out + 2*6)[0];
            ((npy_float *)data_out + 2*6)[1] =
                                    ((npy_float *)data0 + 2*6)[1] +
                                    ((npy_float *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_float *)data_out + 2*5)[0] =
                                    ((npy_float *)data0 + 2*5)[0] +
                                    ((npy_float *)data_out + 2*5)[0];
            ((npy_float *)data_out + 2*5)[1] =
                                    ((npy_float *)data0 + 2*5)[1] +
                                    ((npy_float *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_float *)data_out + 2*4)[0] =
                                    ((npy_float *)data0 + 2*4)[0] +
                                    ((npy_float *)data_out + 2*4)[0];
            ((npy_float *)data_out + 2*4)[1] =
                                    ((npy_float *)data0 + 2*4)[1] +
                                    ((npy_float *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_float *)data_out + 2*3)[0] =
                                    ((npy_float *)data0 + 2*3)[0] +
                                    ((npy_float *)data_out + 2*3)[0];
            ((npy_float *)data_out + 2*3)[1] =
                                    ((npy_float *)data0 + 2*3)[1] +
                                    ((npy_float *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_float *)data_out + 2*2)[0] =
                                    ((npy_float *)data0 + 2*2)[0] +
                                    ((npy_float *)data_out + 2*2)[0];
            ((npy_float *)data_out + 2*2)[1] =
                                    ((npy_float *)data0 + 2*2)[1] +
                                    ((npy_float *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_float *)data_out + 2*1)[0] =
                                    ((npy_float *)data0 + 2*1)[0] +
                                    ((npy_float *)data_out + 2*1)[0];
            ((npy_float *)data_out + 2*1)[1] =
                                    ((npy_float *)data0 + 2*1)[1] +
                                    ((npy_float *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_float *)data_out + 2*0)[0] =
                                    ((npy_float *)data0 + 2*0)[0] +
                                    ((npy_float *)data_out + 2*0)[0];
            ((npy_float *)data_out + 2*0)[1] =
                                    ((npy_float *)data0 + 2*0)[1] +
                                    ((npy_float *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_float *)data_out + 2*0)[0] =
                                ((npy_float *)data0 + 2*0)[0] +
                                ((npy_float *)data_out + 2*0)[0];
        ((npy_float *)data_out + 2*0)[1] =
                                ((npy_float *)data0 + 2*0)[1] +
                                ((npy_float *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_float *)data_out + 2*1)[0] =
                                ((npy_float *)data0 + 2*1)[0] +
                                ((npy_float *)data_out + 2*1)[0];
        ((npy_float *)data_out + 2*1)[1] =
                                ((npy_float *)data0 + 2*1)[1] +
                                ((npy_float *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_float *)data_out + 2*2)[0] =
                                ((npy_float *)data0 + 2*2)[0] +
                                ((npy_float *)data_out + 2*2)[0];
        ((npy_float *)data_out + 2*2)[1] =
                                ((npy_float *)data0 + 2*2)[1] +
                                ((npy_float *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_float *)data_out + 2*3)[0] =
                                ((npy_float *)data0 + 2*3)[0] +
                                ((npy_float *)data_out + 2*3)[0];
        ((npy_float *)data_out + 2*3)[1] =
                                ((npy_float *)data0 + 2*3)[1] +
                                ((npy_float *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_float *)data_out + 2*4)[0] =
                                ((npy_float *)data0 + 2*4)[0] +
                                ((npy_float *)data_out + 2*4)[0];
        ((npy_float *)data_out + 2*4)[1] =
                                ((npy_float *)data0 + 2*4)[1] +
                                ((npy_float *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_float *)data_out + 2*5)[0] =
                                ((npy_float *)data0 + 2*5)[0] +
                                ((npy_float *)data_out + 2*5)[0];
        ((npy_float *)data_out + 2*5)[1] =
                                ((npy_float *)data0 + 2*5)[1] +
                                ((npy_float *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_float *)data_out + 2*6)[0] =
                                ((npy_float *)data0 + 2*6)[0] +
                                ((npy_float *)data_out + 2*6)[0];
        ((npy_float *)data_out + 2*6)[1] =
                                ((npy_float *)data0 + 2*6)[1] +
                                ((npy_float *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_float *)data_out + 2*7)[0] =
                                ((npy_float *)data0 + 2*7)[0] +
                                ((npy_float *)data_out + 2*7)[0];
        ((npy_float *)data_out + 2*7)[1] =
                                ((npy_float *)data0 + 2*7)[1] +
                                ((npy_float *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !1

static void
cfloat_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
cfloat_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_cfloat *)dataptr[0]);
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
cfloat_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_float value1 = (*(npy_cfloat *)dataptr[1]);
    npy_cfloat *data_out = (npy_cfloat *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_float value0 = (*(npy_cfloat *)dataptr[0]);
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cfloat_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_float value1 = (*(npy_cfloat *)dataptr[1]);
    npy_float accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_cfloat *)dataptr[2] = ((*(npy_cfloat *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !1

static void
cfloat_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
    npy_cfloat *data1 = (npy_cfloat *)dataptr[1];
    npy_cfloat *data2 = (npy_cfloat *)dataptr[2];
    npy_cfloat *data_out = (npy_cfloat *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
cfloat_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        *(npy_cfloat *)dataptr[nop] = (temp +
                                           (*(npy_cfloat *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_cfloat);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_float *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[0];
        ((npy_float *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_float *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_cfloat);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
cfloat_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_float accum_re = 0, accum_im = 0;
    npy_float *data0 = (npy_float *)dataptr[0];
#else
    npy_float accum = 0;
    npy_cfloat *data0 = (npy_cfloat *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_float *)dataptr[1])[0] += accum_re;
            ((npy_float *)dataptr[1])[1] += accum_im;
#else
            *((npy_cfloat *)dataptr[1]) = (accum +
                                    (*((npy_cfloat *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
cfloat_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_float accum_re = 0, accum_im = 0;
#else
    npy_float accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("cfloat_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 1000 == 1
        accum += (*(npy_cfloat *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_cfloat *)data0) *
                 (*(npy_cfloat *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_cfloat *)data0) *
                 (*(npy_cfloat *)data1) *
                 (*(npy_cfloat *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_float temp = (*(npy_cfloat *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cfloat *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_float *)data0)[0];
        accum_im += ((npy_float *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_float re, im, tmp;
        int i;
        re = ((npy_float *)dataptr[0])[0];
        im = ((npy_float *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_float *)dataptr[i])[0] -
                  im * ((npy_float *)dataptr[i])[1];
            im = re * ((npy_float *)dataptr[i])[1] +
                 im * ((npy_float *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 1000 <= 3
    ((npy_float *)dataptr[1000])[0] += accum_re;
    ((npy_float *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_float *)dataptr[nop])[0] += accum_re;
    ((npy_float *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_cfloat *)dataptr[1000]) = (accum +
                                    (*((npy_cfloat *)dataptr[1000])));
#  else
    *((npy_cfloat *)dataptr[nop]) = (accum +
                                    (*((npy_cfloat *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
cdouble_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !1)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 1 == 1
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) *
                                         (*(npy_cdouble *)data1) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) *
                                         (*(npy_cdouble *)data1) *
                                         (*(npy_cdouble *)data2) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        *(npy_cdouble *)dataptr[nop] = (temp +
                                           (*(npy_cdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_double *)data_out)[0] = ((npy_double *)data0)[0] +
                                         ((npy_double *)data_out)[0];
        ((npy_double *)data_out)[1] = ((npy_double *)data0)[1] +
                                         ((npy_double *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
cdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_double *)data_out + 2*6)[0] =
                                    ((npy_double *)data0 + 2*6)[0] +
                                    ((npy_double *)data_out + 2*6)[0];
            ((npy_double *)data_out + 2*6)[1] =
                                    ((npy_double *)data0 + 2*6)[1] +
                                    ((npy_double *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_double *)data_out + 2*5)[0] =
                                    ((npy_double *)data0 + 2*5)[0] +
                                    ((npy_double *)data_out + 2*5)[0];
            ((npy_double *)data_out + 2*5)[1] =
                                    ((npy_double *)data0 + 2*5)[1] +
                                    ((npy_double *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_double *)data_out + 2*4)[0] =
                                    ((npy_double *)data0 + 2*4)[0] +
                                    ((npy_double *)data_out + 2*4)[0];
            ((npy_double *)data_out + 2*4)[1] =
                                    ((npy_double *)data0 + 2*4)[1] +
                                    ((npy_double *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_double *)data_out + 2*3)[0] =
                                    ((npy_double *)data0 + 2*3)[0] +
                                    ((npy_double *)data_out + 2*3)[0];
            ((npy_double *)data_out + 2*3)[1] =
                                    ((npy_double *)data0 + 2*3)[1] +
                                    ((npy_double *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_double *)data_out + 2*2)[0] =
                                    ((npy_double *)data0 + 2*2)[0] +
                                    ((npy_double *)data_out + 2*2)[0];
            ((npy_double *)data_out + 2*2)[1] =
                                    ((npy_double *)data0 + 2*2)[1] +
                                    ((npy_double *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_double *)data_out + 2*1)[0] =
                                    ((npy_double *)data0 + 2*1)[0] +
                                    ((npy_double *)data_out + 2*1)[0];
            ((npy_double *)data_out + 2*1)[1] =
                                    ((npy_double *)data0 + 2*1)[1] +
                                    ((npy_double *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_double *)data_out + 2*0)[0] =
                                    ((npy_double *)data0 + 2*0)[0] +
                                    ((npy_double *)data_out + 2*0)[0];
            ((npy_double *)data_out + 2*0)[1] =
                                    ((npy_double *)data0 + 2*0)[1] +
                                    ((npy_double *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_double *)data_out + 2*0)[0] =
                                ((npy_double *)data0 + 2*0)[0] +
                                ((npy_double *)data_out + 2*0)[0];
        ((npy_double *)data_out + 2*0)[1] =
                                ((npy_double *)data0 + 2*0)[1] +
                                ((npy_double *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_double *)data_out + 2*1)[0] =
                                ((npy_double *)data0 + 2*1)[0] +
                                ((npy_double *)data_out + 2*1)[0];
        ((npy_double *)data_out + 2*1)[1] =
                                ((npy_double *)data0 + 2*1)[1] +
                                ((npy_double *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_double *)data_out + 2*2)[0] =
                                ((npy_double *)data0 + 2*2)[0] +
                                ((npy_double *)data_out + 2*2)[0];
        ((npy_double *)data_out + 2*2)[1] =
                                ((npy_double *)data0 + 2*2)[1] +
                                ((npy_double *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_double *)data_out + 2*3)[0] =
                                ((npy_double *)data0 + 2*3)[0] +
                                ((npy_double *)data_out + 2*3)[0];
        ((npy_double *)data_out + 2*3)[1] =
                                ((npy_double *)data0 + 2*3)[1] +
                                ((npy_double *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_double *)data_out + 2*4)[0] =
                                ((npy_double *)data0 + 2*4)[0] +
                                ((npy_double *)data_out + 2*4)[0];
        ((npy_double *)data_out + 2*4)[1] =
                                ((npy_double *)data0 + 2*4)[1] +
                                ((npy_double *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_double *)data_out + 2*5)[0] =
                                ((npy_double *)data0 + 2*5)[0] +
                                ((npy_double *)data_out + 2*5)[0];
        ((npy_double *)data_out + 2*5)[1] =
                                ((npy_double *)data0 + 2*5)[1] +
                                ((npy_double *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_double *)data_out + 2*6)[0] =
                                ((npy_double *)data0 + 2*6)[0] +
                                ((npy_double *)data_out + 2*6)[0];
        ((npy_double *)data_out + 2*6)[1] =
                                ((npy_double *)data0 + 2*6)[1] +
                                ((npy_double *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_double *)data_out + 2*7)[0] =
                                ((npy_double *)data0 + 2*7)[0] +
                                ((npy_double *)data_out + 2*7)[0];
        ((npy_double *)data_out + 2*7)[1] =
                                ((npy_double *)data0 + 2*7)[1] +
                                ((npy_double *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !1

static void
cdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
cdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_cdouble *)dataptr[0]);
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
cdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_double value1 = (*(npy_cdouble *)dataptr[1]);
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_cdouble *)dataptr[0]);
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_double value1 = (*(npy_cdouble *)dataptr[1]);
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !1

static void
cdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data2 = (npy_cdouble *)dataptr[2];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
cdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        *(npy_cdouble *)dataptr[nop] = (temp +
                                           (*(npy_cdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_cdouble);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_cdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
cdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_double accum_re = 0, accum_im = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#else
    npy_double accum = 0;
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_double *)dataptr[1])[0] += accum_re;
            ((npy_double *)dataptr[1])[1] += accum_im;
#else
            *((npy_cdouble *)dataptr[1]) = (accum +
                                    (*((npy_cdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
cdouble_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_double accum_re = 0, accum_im = 0;
#else
    npy_double accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 1 == 1
        accum += (*(npy_cdouble *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_cdouble *)data0) *
                 (*(npy_cdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_cdouble *)data0) *
                 (*(npy_cdouble *)data1) *
                 (*(npy_cdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_double *)data0)[0];
        accum_im += ((npy_double *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 1 <= 3
    ((npy_double *)dataptr[1])[0] += accum_re;
    ((npy_double *)dataptr[1])[1] += accum_im;
#  else
    ((npy_double *)dataptr[nop])[0] += accum_re;
    ((npy_double *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_cdouble *)dataptr[1]) = (accum +
                                    (*((npy_cdouble *)dataptr[1])));
#  else
    *((npy_cdouble *)dataptr[nop]) = (accum +
                                    (*((npy_cdouble *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
cdouble_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !1)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 2 == 1
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) *
                                         (*(npy_cdouble *)data1) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) *
                                         (*(npy_cdouble *)data1) *
                                         (*(npy_cdouble *)data2) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        *(npy_cdouble *)dataptr[nop] = (temp +
                                           (*(npy_cdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_double *)data_out)[0] = ((npy_double *)data0)[0] +
                                         ((npy_double *)data_out)[0];
        ((npy_double *)data_out)[1] = ((npy_double *)data0)[1] +
                                         ((npy_double *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
cdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_double *)data_out + 2*6)[0] =
                                    ((npy_double *)data0 + 2*6)[0] +
                                    ((npy_double *)data_out + 2*6)[0];
            ((npy_double *)data_out + 2*6)[1] =
                                    ((npy_double *)data0 + 2*6)[1] +
                                    ((npy_double *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_double *)data_out + 2*5)[0] =
                                    ((npy_double *)data0 + 2*5)[0] +
                                    ((npy_double *)data_out + 2*5)[0];
            ((npy_double *)data_out + 2*5)[1] =
                                    ((npy_double *)data0 + 2*5)[1] +
                                    ((npy_double *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_double *)data_out + 2*4)[0] =
                                    ((npy_double *)data0 + 2*4)[0] +
                                    ((npy_double *)data_out + 2*4)[0];
            ((npy_double *)data_out + 2*4)[1] =
                                    ((npy_double *)data0 + 2*4)[1] +
                                    ((npy_double *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_double *)data_out + 2*3)[0] =
                                    ((npy_double *)data0 + 2*3)[0] +
                                    ((npy_double *)data_out + 2*3)[0];
            ((npy_double *)data_out + 2*3)[1] =
                                    ((npy_double *)data0 + 2*3)[1] +
                                    ((npy_double *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_double *)data_out + 2*2)[0] =
                                    ((npy_double *)data0 + 2*2)[0] +
                                    ((npy_double *)data_out + 2*2)[0];
            ((npy_double *)data_out + 2*2)[1] =
                                    ((npy_double *)data0 + 2*2)[1] +
                                    ((npy_double *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_double *)data_out + 2*1)[0] =
                                    ((npy_double *)data0 + 2*1)[0] +
                                    ((npy_double *)data_out + 2*1)[0];
            ((npy_double *)data_out + 2*1)[1] =
                                    ((npy_double *)data0 + 2*1)[1] +
                                    ((npy_double *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_double *)data_out + 2*0)[0] =
                                    ((npy_double *)data0 + 2*0)[0] +
                                    ((npy_double *)data_out + 2*0)[0];
            ((npy_double *)data_out + 2*0)[1] =
                                    ((npy_double *)data0 + 2*0)[1] +
                                    ((npy_double *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_double *)data_out + 2*0)[0] =
                                ((npy_double *)data0 + 2*0)[0] +
                                ((npy_double *)data_out + 2*0)[0];
        ((npy_double *)data_out + 2*0)[1] =
                                ((npy_double *)data0 + 2*0)[1] +
                                ((npy_double *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_double *)data_out + 2*1)[0] =
                                ((npy_double *)data0 + 2*1)[0] +
                                ((npy_double *)data_out + 2*1)[0];
        ((npy_double *)data_out + 2*1)[1] =
                                ((npy_double *)data0 + 2*1)[1] +
                                ((npy_double *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_double *)data_out + 2*2)[0] =
                                ((npy_double *)data0 + 2*2)[0] +
                                ((npy_double *)data_out + 2*2)[0];
        ((npy_double *)data_out + 2*2)[1] =
                                ((npy_double *)data0 + 2*2)[1] +
                                ((npy_double *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_double *)data_out + 2*3)[0] =
                                ((npy_double *)data0 + 2*3)[0] +
                                ((npy_double *)data_out + 2*3)[0];
        ((npy_double *)data_out + 2*3)[1] =
                                ((npy_double *)data0 + 2*3)[1] +
                                ((npy_double *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_double *)data_out + 2*4)[0] =
                                ((npy_double *)data0 + 2*4)[0] +
                                ((npy_double *)data_out + 2*4)[0];
        ((npy_double *)data_out + 2*4)[1] =
                                ((npy_double *)data0 + 2*4)[1] +
                                ((npy_double *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_double *)data_out + 2*5)[0] =
                                ((npy_double *)data0 + 2*5)[0] +
                                ((npy_double *)data_out + 2*5)[0];
        ((npy_double *)data_out + 2*5)[1] =
                                ((npy_double *)data0 + 2*5)[1] +
                                ((npy_double *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_double *)data_out + 2*6)[0] =
                                ((npy_double *)data0 + 2*6)[0] +
                                ((npy_double *)data_out + 2*6)[0];
        ((npy_double *)data_out + 2*6)[1] =
                                ((npy_double *)data0 + 2*6)[1] +
                                ((npy_double *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_double *)data_out + 2*7)[0] =
                                ((npy_double *)data0 + 2*7)[0] +
                                ((npy_double *)data_out + 2*7)[0];
        ((npy_double *)data_out + 2*7)[1] =
                                ((npy_double *)data0 + 2*7)[1] +
                                ((npy_double *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !1

static void
cdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
cdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_cdouble *)dataptr[0]);
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
cdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_double value1 = (*(npy_cdouble *)dataptr[1]);
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_cdouble *)dataptr[0]);
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_double value1 = (*(npy_cdouble *)dataptr[1]);
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !1

static void
cdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data2 = (npy_cdouble *)dataptr[2];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
cdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        *(npy_cdouble *)dataptr[nop] = (temp +
                                           (*(npy_cdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_cdouble);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_cdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
cdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_double accum_re = 0, accum_im = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#else
    npy_double accum = 0;
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_double *)dataptr[1])[0] += accum_re;
            ((npy_double *)dataptr[1])[1] += accum_im;
#else
            *((npy_cdouble *)dataptr[1]) = (accum +
                                    (*((npy_cdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
cdouble_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_double accum_re = 0, accum_im = 0;
#else
    npy_double accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 2 == 1
        accum += (*(npy_cdouble *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_cdouble *)data0) *
                 (*(npy_cdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_cdouble *)data0) *
                 (*(npy_cdouble *)data1) *
                 (*(npy_cdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_double *)data0)[0];
        accum_im += ((npy_double *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 2 <= 3
    ((npy_double *)dataptr[2])[0] += accum_re;
    ((npy_double *)dataptr[2])[1] += accum_im;
#  else
    ((npy_double *)dataptr[nop])[0] += accum_re;
    ((npy_double *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_cdouble *)dataptr[2]) = (accum +
                                    (*((npy_cdouble *)dataptr[2])));
#  else
    *((npy_cdouble *)dataptr[nop]) = (accum +
                                    (*((npy_cdouble *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
cdouble_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !1)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 3 == 1
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) *
                                         (*(npy_cdouble *)data1) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) *
                                         (*(npy_cdouble *)data1) *
                                         (*(npy_cdouble *)data2) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        *(npy_cdouble *)dataptr[nop] = (temp +
                                           (*(npy_cdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_double *)data_out)[0] = ((npy_double *)data0)[0] +
                                         ((npy_double *)data_out)[0];
        ((npy_double *)data_out)[1] = ((npy_double *)data0)[1] +
                                         ((npy_double *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
cdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_double *)data_out + 2*6)[0] =
                                    ((npy_double *)data0 + 2*6)[0] +
                                    ((npy_double *)data_out + 2*6)[0];
            ((npy_double *)data_out + 2*6)[1] =
                                    ((npy_double *)data0 + 2*6)[1] +
                                    ((npy_double *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_double *)data_out + 2*5)[0] =
                                    ((npy_double *)data0 + 2*5)[0] +
                                    ((npy_double *)data_out + 2*5)[0];
            ((npy_double *)data_out + 2*5)[1] =
                                    ((npy_double *)data0 + 2*5)[1] +
                                    ((npy_double *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_double *)data_out + 2*4)[0] =
                                    ((npy_double *)data0 + 2*4)[0] +
                                    ((npy_double *)data_out + 2*4)[0];
            ((npy_double *)data_out + 2*4)[1] =
                                    ((npy_double *)data0 + 2*4)[1] +
                                    ((npy_double *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_double *)data_out + 2*3)[0] =
                                    ((npy_double *)data0 + 2*3)[0] +
                                    ((npy_double *)data_out + 2*3)[0];
            ((npy_double *)data_out + 2*3)[1] =
                                    ((npy_double *)data0 + 2*3)[1] +
                                    ((npy_double *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_double *)data_out + 2*2)[0] =
                                    ((npy_double *)data0 + 2*2)[0] +
                                    ((npy_double *)data_out + 2*2)[0];
            ((npy_double *)data_out + 2*2)[1] =
                                    ((npy_double *)data0 + 2*2)[1] +
                                    ((npy_double *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_double *)data_out + 2*1)[0] =
                                    ((npy_double *)data0 + 2*1)[0] +
                                    ((npy_double *)data_out + 2*1)[0];
            ((npy_double *)data_out + 2*1)[1] =
                                    ((npy_double *)data0 + 2*1)[1] +
                                    ((npy_double *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_double *)data_out + 2*0)[0] =
                                    ((npy_double *)data0 + 2*0)[0] +
                                    ((npy_double *)data_out + 2*0)[0];
            ((npy_double *)data_out + 2*0)[1] =
                                    ((npy_double *)data0 + 2*0)[1] +
                                    ((npy_double *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_double *)data_out + 2*0)[0] =
                                ((npy_double *)data0 + 2*0)[0] +
                                ((npy_double *)data_out + 2*0)[0];
        ((npy_double *)data_out + 2*0)[1] =
                                ((npy_double *)data0 + 2*0)[1] +
                                ((npy_double *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_double *)data_out + 2*1)[0] =
                                ((npy_double *)data0 + 2*1)[0] +
                                ((npy_double *)data_out + 2*1)[0];
        ((npy_double *)data_out + 2*1)[1] =
                                ((npy_double *)data0 + 2*1)[1] +
                                ((npy_double *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_double *)data_out + 2*2)[0] =
                                ((npy_double *)data0 + 2*2)[0] +
                                ((npy_double *)data_out + 2*2)[0];
        ((npy_double *)data_out + 2*2)[1] =
                                ((npy_double *)data0 + 2*2)[1] +
                                ((npy_double *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_double *)data_out + 2*3)[0] =
                                ((npy_double *)data0 + 2*3)[0] +
                                ((npy_double *)data_out + 2*3)[0];
        ((npy_double *)data_out + 2*3)[1] =
                                ((npy_double *)data0 + 2*3)[1] +
                                ((npy_double *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_double *)data_out + 2*4)[0] =
                                ((npy_double *)data0 + 2*4)[0] +
                                ((npy_double *)data_out + 2*4)[0];
        ((npy_double *)data_out + 2*4)[1] =
                                ((npy_double *)data0 + 2*4)[1] +
                                ((npy_double *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_double *)data_out + 2*5)[0] =
                                ((npy_double *)data0 + 2*5)[0] +
                                ((npy_double *)data_out + 2*5)[0];
        ((npy_double *)data_out + 2*5)[1] =
                                ((npy_double *)data0 + 2*5)[1] +
                                ((npy_double *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_double *)data_out + 2*6)[0] =
                                ((npy_double *)data0 + 2*6)[0] +
                                ((npy_double *)data_out + 2*6)[0];
        ((npy_double *)data_out + 2*6)[1] =
                                ((npy_double *)data0 + 2*6)[1] +
                                ((npy_double *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_double *)data_out + 2*7)[0] =
                                ((npy_double *)data0 + 2*7)[0] +
                                ((npy_double *)data_out + 2*7)[0];
        ((npy_double *)data_out + 2*7)[1] =
                                ((npy_double *)data0 + 2*7)[1] +
                                ((npy_double *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !1

static void
cdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
cdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_cdouble *)dataptr[0]);
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
cdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_double value1 = (*(npy_cdouble *)dataptr[1]);
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_cdouble *)dataptr[0]);
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_double value1 = (*(npy_cdouble *)dataptr[1]);
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !1

static void
cdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data2 = (npy_cdouble *)dataptr[2];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
cdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        *(npy_cdouble *)dataptr[nop] = (temp +
                                           (*(npy_cdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_cdouble);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_cdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
cdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_double accum_re = 0, accum_im = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#else
    npy_double accum = 0;
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_double *)dataptr[1])[0] += accum_re;
            ((npy_double *)dataptr[1])[1] += accum_im;
#else
            *((npy_cdouble *)dataptr[1]) = (accum +
                                    (*((npy_cdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
cdouble_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_double accum_re = 0, accum_im = 0;
#else
    npy_double accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 3 == 1
        accum += (*(npy_cdouble *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_cdouble *)data0) *
                 (*(npy_cdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_cdouble *)data0) *
                 (*(npy_cdouble *)data1) *
                 (*(npy_cdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_double *)data0)[0];
        accum_im += ((npy_double *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 3 <= 3
    ((npy_double *)dataptr[3])[0] += accum_re;
    ((npy_double *)dataptr[3])[1] += accum_im;
#  else
    ((npy_double *)dataptr[nop])[0] += accum_re;
    ((npy_double *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_cdouble *)dataptr[3]) = (accum +
                                    (*((npy_cdouble *)dataptr[3])));
#  else
    *((npy_cdouble *)dataptr[nop]) = (accum +
                                    (*((npy_cdouble *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
cdouble_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !1)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 1000 == 1
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) *
                                         (*(npy_cdouble *)data1) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_cdouble *)data_out = ((*(npy_cdouble *)data0) *
                                         (*(npy_cdouble *)data1) *
                                         (*(npy_cdouble *)data2) +
                                         (*(npy_cdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        *(npy_cdouble *)dataptr[nop] = (temp +
                                           (*(npy_cdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_double *)data_out)[0] = ((npy_double *)data0)[0] +
                                         ((npy_double *)data_out)[0];
        ((npy_double *)data_out)[1] = ((npy_double *)data0)[1] +
                                         ((npy_double *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
cdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_double *)data_out + 2*6)[0] =
                                    ((npy_double *)data0 + 2*6)[0] +
                                    ((npy_double *)data_out + 2*6)[0];
            ((npy_double *)data_out + 2*6)[1] =
                                    ((npy_double *)data0 + 2*6)[1] +
                                    ((npy_double *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_double *)data_out + 2*5)[0] =
                                    ((npy_double *)data0 + 2*5)[0] +
                                    ((npy_double *)data_out + 2*5)[0];
            ((npy_double *)data_out + 2*5)[1] =
                                    ((npy_double *)data0 + 2*5)[1] +
                                    ((npy_double *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_double *)data_out + 2*4)[0] =
                                    ((npy_double *)data0 + 2*4)[0] +
                                    ((npy_double *)data_out + 2*4)[0];
            ((npy_double *)data_out + 2*4)[1] =
                                    ((npy_double *)data0 + 2*4)[1] +
                                    ((npy_double *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_double *)data_out + 2*3)[0] =
                                    ((npy_double *)data0 + 2*3)[0] +
                                    ((npy_double *)data_out + 2*3)[0];
            ((npy_double *)data_out + 2*3)[1] =
                                    ((npy_double *)data0 + 2*3)[1] +
                                    ((npy_double *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_double *)data_out + 2*2)[0] =
                                    ((npy_double *)data0 + 2*2)[0] +
                                    ((npy_double *)data_out + 2*2)[0];
            ((npy_double *)data_out + 2*2)[1] =
                                    ((npy_double *)data0 + 2*2)[1] +
                                    ((npy_double *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_double *)data_out + 2*1)[0] =
                                    ((npy_double *)data0 + 2*1)[0] +
                                    ((npy_double *)data_out + 2*1)[0];
            ((npy_double *)data_out + 2*1)[1] =
                                    ((npy_double *)data0 + 2*1)[1] +
                                    ((npy_double *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_double *)data_out + 2*0)[0] =
                                    ((npy_double *)data0 + 2*0)[0] +
                                    ((npy_double *)data_out + 2*0)[0];
            ((npy_double *)data_out + 2*0)[1] =
                                    ((npy_double *)data0 + 2*0)[1] +
                                    ((npy_double *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_double *)data_out + 2*0)[0] =
                                ((npy_double *)data0 + 2*0)[0] +
                                ((npy_double *)data_out + 2*0)[0];
        ((npy_double *)data_out + 2*0)[1] =
                                ((npy_double *)data0 + 2*0)[1] +
                                ((npy_double *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_double *)data_out + 2*1)[0] =
                                ((npy_double *)data0 + 2*1)[0] +
                                ((npy_double *)data_out + 2*1)[0];
        ((npy_double *)data_out + 2*1)[1] =
                                ((npy_double *)data0 + 2*1)[1] +
                                ((npy_double *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_double *)data_out + 2*2)[0] =
                                ((npy_double *)data0 + 2*2)[0] +
                                ((npy_double *)data_out + 2*2)[0];
        ((npy_double *)data_out + 2*2)[1] =
                                ((npy_double *)data0 + 2*2)[1] +
                                ((npy_double *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_double *)data_out + 2*3)[0] =
                                ((npy_double *)data0 + 2*3)[0] +
                                ((npy_double *)data_out + 2*3)[0];
        ((npy_double *)data_out + 2*3)[1] =
                                ((npy_double *)data0 + 2*3)[1] +
                                ((npy_double *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_double *)data_out + 2*4)[0] =
                                ((npy_double *)data0 + 2*4)[0] +
                                ((npy_double *)data_out + 2*4)[0];
        ((npy_double *)data_out + 2*4)[1] =
                                ((npy_double *)data0 + 2*4)[1] +
                                ((npy_double *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_double *)data_out + 2*5)[0] =
                                ((npy_double *)data0 + 2*5)[0] +
                                ((npy_double *)data_out + 2*5)[0];
        ((npy_double *)data_out + 2*5)[1] =
                                ((npy_double *)data0 + 2*5)[1] +
                                ((npy_double *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_double *)data_out + 2*6)[0] =
                                ((npy_double *)data0 + 2*6)[0] +
                                ((npy_double *)data_out + 2*6)[0];
        ((npy_double *)data_out + 2*6)[1] =
                                ((npy_double *)data0 + 2*6)[1] +
                                ((npy_double *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_double *)data_out + 2*7)[0] =
                                ((npy_double *)data0 + 2*7)[0] +
                                ((npy_double *)data_out + 2*7)[0];
        ((npy_double *)data_out + 2*7)[1] =
                                ((npy_double *)data0 + 2*7)[1] +
                                ((npy_double *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !1

static void
cdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
cdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_cdouble *)dataptr[0]);
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
cdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_double value1 = (*(npy_cdouble *)dataptr[1]);
    npy_cdouble *data_out = (npy_cdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_double value0 = (*(npy_cdouble *)dataptr[0]);
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
cdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_double value1 = (*(npy_cdouble *)dataptr[1]);
    npy_double accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_cdouble *)dataptr[2] = ((*(npy_cdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !1

static void
cdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
    npy_cdouble *data1 = (npy_cdouble *)dataptr[1];
    npy_cdouble *data2 = (npy_cdouble *)dataptr[2];
    npy_cdouble *data_out = (npy_cdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
cdouble_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        *(npy_cdouble *)dataptr[nop] = (temp +
                                           (*(npy_cdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_cdouble);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_double *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[0];
        ((npy_double *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_double *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_cdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
cdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_double accum_re = 0, accum_im = 0;
    npy_double *data0 = (npy_double *)dataptr[0];
#else
    npy_double accum = 0;
    npy_cdouble *data0 = (npy_cdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_double *)dataptr[1])[0] += accum_re;
            ((npy_double *)dataptr[1])[1] += accum_im;
#else
            *((npy_cdouble *)dataptr[1]) = (accum +
                                    (*((npy_cdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
cdouble_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_double accum_re = 0, accum_im = 0;
#else
    npy_double accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("cdouble_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 1000 == 1
        accum += (*(npy_cdouble *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_cdouble *)data0) *
                 (*(npy_cdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_cdouble *)data0) *
                 (*(npy_cdouble *)data1) *
                 (*(npy_cdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_double temp = (*(npy_cdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_cdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_double *)data0)[0];
        accum_im += ((npy_double *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_double re, im, tmp;
        int i;
        re = ((npy_double *)dataptr[0])[0];
        im = ((npy_double *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_double *)dataptr[i])[0] -
                  im * ((npy_double *)dataptr[i])[1];
            im = re * ((npy_double *)dataptr[i])[1] +
                 im * ((npy_double *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 1000 <= 3
    ((npy_double *)dataptr[1000])[0] += accum_re;
    ((npy_double *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_double *)dataptr[nop])[0] += accum_re;
    ((npy_double *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_cdouble *)dataptr[1000]) = (accum +
                                    (*((npy_cdouble *)dataptr[1000])));
#  else
    *((npy_cdouble *)dataptr[nop]) = (accum +
                                    (*((npy_cdouble *)dataptr[nop])));
#  endif
#endif

}




#line 80

#line 85
static void
clongdouble_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 == 1) || (1 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 == 1) || (1 <= 3 && !1)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_one (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 1 == 1
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1 == 2
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) *
                                         (*(npy_clongdouble *)data1) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1 == 3
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) *
                                         (*(npy_clongdouble *)data1) *
                                         (*(npy_clongdouble *)data2) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        *(npy_clongdouble *)dataptr[nop] = (temp +
                                           (*(npy_clongdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        ((npy_longdouble *)data_out)[0] = ((npy_longdouble *)data0)[0] +
                                         ((npy_longdouble *)data_out)[0];
        ((npy_longdouble *)data_out)[1] = ((npy_longdouble *)data0)[1] +
                                         ((npy_longdouble *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1 == 1

static void
clongdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longdouble *)data_out + 2*6)[0] =
                                    ((npy_longdouble *)data0 + 2*6)[0] +
                                    ((npy_longdouble *)data_out + 2*6)[0];
            ((npy_longdouble *)data_out + 2*6)[1] =
                                    ((npy_longdouble *)data0 + 2*6)[1] +
                                    ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longdouble *)data_out + 2*5)[0] =
                                    ((npy_longdouble *)data0 + 2*5)[0] +
                                    ((npy_longdouble *)data_out + 2*5)[0];
            ((npy_longdouble *)data_out + 2*5)[1] =
                                    ((npy_longdouble *)data0 + 2*5)[1] +
                                    ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longdouble *)data_out + 2*4)[0] =
                                    ((npy_longdouble *)data0 + 2*4)[0] +
                                    ((npy_longdouble *)data_out + 2*4)[0];
            ((npy_longdouble *)data_out + 2*4)[1] =
                                    ((npy_longdouble *)data0 + 2*4)[1] +
                                    ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longdouble *)data_out + 2*3)[0] =
                                    ((npy_longdouble *)data0 + 2*3)[0] +
                                    ((npy_longdouble *)data_out + 2*3)[0];
            ((npy_longdouble *)data_out + 2*3)[1] =
                                    ((npy_longdouble *)data0 + 2*3)[1] +
                                    ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longdouble *)data_out + 2*2)[0] =
                                    ((npy_longdouble *)data0 + 2*2)[0] +
                                    ((npy_longdouble *)data_out + 2*2)[0];
            ((npy_longdouble *)data_out + 2*2)[1] =
                                    ((npy_longdouble *)data0 + 2*2)[1] +
                                    ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longdouble *)data_out + 2*1)[0] =
                                    ((npy_longdouble *)data0 + 2*1)[0] +
                                    ((npy_longdouble *)data_out + 2*1)[0];
            ((npy_longdouble *)data_out + 2*1)[1] =
                                    ((npy_longdouble *)data0 + 2*1)[1] +
                                    ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longdouble *)data_out + 2*0)[0] =
                                    ((npy_longdouble *)data0 + 2*0)[0] +
                                    ((npy_longdouble *)data_out + 2*0)[0];
            ((npy_longdouble *)data_out + 2*0)[1] =
                                    ((npy_longdouble *)data0 + 2*0)[1] +
                                    ((npy_longdouble *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*0)[0] =
                                ((npy_longdouble *)data0 + 2*0)[0] +
                                ((npy_longdouble *)data_out + 2*0)[0];
        ((npy_longdouble *)data_out + 2*0)[1] =
                                ((npy_longdouble *)data0 + 2*0)[1] +
                                ((npy_longdouble *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*1)[0] =
                                ((npy_longdouble *)data0 + 2*1)[0] +
                                ((npy_longdouble *)data_out + 2*1)[0];
        ((npy_longdouble *)data_out + 2*1)[1] =
                                ((npy_longdouble *)data0 + 2*1)[1] +
                                ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*2)[0] =
                                ((npy_longdouble *)data0 + 2*2)[0] +
                                ((npy_longdouble *)data_out + 2*2)[0];
        ((npy_longdouble *)data_out + 2*2)[1] =
                                ((npy_longdouble *)data0 + 2*2)[1] +
                                ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*3)[0] =
                                ((npy_longdouble *)data0 + 2*3)[0] +
                                ((npy_longdouble *)data_out + 2*3)[0];
        ((npy_longdouble *)data_out + 2*3)[1] =
                                ((npy_longdouble *)data0 + 2*3)[1] +
                                ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*4)[0] =
                                ((npy_longdouble *)data0 + 2*4)[0] +
                                ((npy_longdouble *)data_out + 2*4)[0];
        ((npy_longdouble *)data_out + 2*4)[1] =
                                ((npy_longdouble *)data0 + 2*4)[1] +
                                ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*5)[0] =
                                ((npy_longdouble *)data0 + 2*5)[0] +
                                ((npy_longdouble *)data_out + 2*5)[0];
        ((npy_longdouble *)data_out + 2*5)[1] =
                                ((npy_longdouble *)data0 + 2*5)[1] +
                                ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*6)[0] =
                                ((npy_longdouble *)data0 + 2*6)[0] +
                                ((npy_longdouble *)data_out + 2*6)[0];
        ((npy_longdouble *)data_out + 2*6)[1] =
                                ((npy_longdouble *)data0 + 2*6)[1] +
                                ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*7)[0] =
                                ((npy_longdouble *)data0 + 2*7)[0] +
                                ((npy_longdouble *)data_out + 2*7)[0];
        ((npy_longdouble *)data_out + 2*7)[1] =
                                ((npy_longdouble *)data0 + 2*7)[1] +
                                ((npy_longdouble *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 2 && !1

static void
clongdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
clongdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_clongdouble *)dataptr[0]);
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
clongdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_clongdouble *)dataptr[1]);
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_clongdouble *)dataptr[0]);
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_clongdouble *)dataptr[1]);
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1 == 3 && !1

static void
clongdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data2 = (npy_clongdouble *)dataptr[2];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1 > 3 || @complex */

static void
clongdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        *(npy_clongdouble *)dataptr[nop] = (temp +
                                           (*(npy_clongdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_clongdouble);
        }
#else /* complex */
#  if 1 <= 3
#    define _SUMPROD_NOP 1
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_clongdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1 */

#if 1 == 1

static void
clongdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_longdouble accum_re = 0, accum_im = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#else
    npy_longdouble accum = 0;
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_longdouble *)dataptr[1])[0] += accum_re;
            ((npy_longdouble *)dataptr[1])[1] += accum_im;
#else
            *((npy_clongdouble *)dataptr[1]) = (accum +
                                    (*((npy_clongdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1 == 1 */

static void
clongdouble_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_longdouble accum_re = 0, accum_im = 0;
#else
    npy_longdouble accum = 0;
#endif

#if (1 == 1) || (1 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_outstride0_one (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 1 == 1
        accum += (*(npy_clongdouble *)data0);
        data0 += stride0;
#  elif 1 == 2
        accum += (*(npy_clongdouble *)data0) *
                 (*(npy_clongdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1 == 3
        accum += (*(npy_clongdouble *)data0) *
                 (*(npy_clongdouble *)data1) *
                 (*(npy_clongdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1 == 1
        accum_re += ((npy_longdouble *)data0)[0];
        accum_im += ((npy_longdouble *)data0)[1];
        data0 += stride0;
#  else
#    if 1 <= 3
#define _SUMPROD_NOP 1
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 1 <= 3
    ((npy_longdouble *)dataptr[1])[0] += accum_re;
    ((npy_longdouble *)dataptr[1])[1] += accum_im;
#  else
    ((npy_longdouble *)dataptr[nop])[0] += accum_re;
    ((npy_longdouble *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1 <= 3
    *((npy_clongdouble *)dataptr[1]) = (accum +
                                    (*((npy_clongdouble *)dataptr[1])));
#  else
    *((npy_clongdouble *)dataptr[nop]) = (accum +
                                    (*((npy_clongdouble *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
clongdouble_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 == 1) || (2 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 == 1) || (2 <= 3 && !1)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_two (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 2 == 1
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 2 == 2
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) *
                                         (*(npy_clongdouble *)data1) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 2 == 3
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) *
                                         (*(npy_clongdouble *)data1) *
                                         (*(npy_clongdouble *)data2) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        *(npy_clongdouble *)dataptr[nop] = (temp +
                                           (*(npy_clongdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        ((npy_longdouble *)data_out)[0] = ((npy_longdouble *)data0)[0] +
                                         ((npy_longdouble *)data_out)[0];
        ((npy_longdouble *)data_out)[1] = ((npy_longdouble *)data0)[1] +
                                         ((npy_longdouble *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 2 == 1

static void
clongdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longdouble *)data_out + 2*6)[0] =
                                    ((npy_longdouble *)data0 + 2*6)[0] +
                                    ((npy_longdouble *)data_out + 2*6)[0];
            ((npy_longdouble *)data_out + 2*6)[1] =
                                    ((npy_longdouble *)data0 + 2*6)[1] +
                                    ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longdouble *)data_out + 2*5)[0] =
                                    ((npy_longdouble *)data0 + 2*5)[0] +
                                    ((npy_longdouble *)data_out + 2*5)[0];
            ((npy_longdouble *)data_out + 2*5)[1] =
                                    ((npy_longdouble *)data0 + 2*5)[1] +
                                    ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longdouble *)data_out + 2*4)[0] =
                                    ((npy_longdouble *)data0 + 2*4)[0] +
                                    ((npy_longdouble *)data_out + 2*4)[0];
            ((npy_longdouble *)data_out + 2*4)[1] =
                                    ((npy_longdouble *)data0 + 2*4)[1] +
                                    ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longdouble *)data_out + 2*3)[0] =
                                    ((npy_longdouble *)data0 + 2*3)[0] +
                                    ((npy_longdouble *)data_out + 2*3)[0];
            ((npy_longdouble *)data_out + 2*3)[1] =
                                    ((npy_longdouble *)data0 + 2*3)[1] +
                                    ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longdouble *)data_out + 2*2)[0] =
                                    ((npy_longdouble *)data0 + 2*2)[0] +
                                    ((npy_longdouble *)data_out + 2*2)[0];
            ((npy_longdouble *)data_out + 2*2)[1] =
                                    ((npy_longdouble *)data0 + 2*2)[1] +
                                    ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longdouble *)data_out + 2*1)[0] =
                                    ((npy_longdouble *)data0 + 2*1)[0] +
                                    ((npy_longdouble *)data_out + 2*1)[0];
            ((npy_longdouble *)data_out + 2*1)[1] =
                                    ((npy_longdouble *)data0 + 2*1)[1] +
                                    ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longdouble *)data_out + 2*0)[0] =
                                    ((npy_longdouble *)data0 + 2*0)[0] +
                                    ((npy_longdouble *)data_out + 2*0)[0];
            ((npy_longdouble *)data_out + 2*0)[1] =
                                    ((npy_longdouble *)data0 + 2*0)[1] +
                                    ((npy_longdouble *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*0)[0] =
                                ((npy_longdouble *)data0 + 2*0)[0] +
                                ((npy_longdouble *)data_out + 2*0)[0];
        ((npy_longdouble *)data_out + 2*0)[1] =
                                ((npy_longdouble *)data0 + 2*0)[1] +
                                ((npy_longdouble *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*1)[0] =
                                ((npy_longdouble *)data0 + 2*1)[0] +
                                ((npy_longdouble *)data_out + 2*1)[0];
        ((npy_longdouble *)data_out + 2*1)[1] =
                                ((npy_longdouble *)data0 + 2*1)[1] +
                                ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*2)[0] =
                                ((npy_longdouble *)data0 + 2*2)[0] +
                                ((npy_longdouble *)data_out + 2*2)[0];
        ((npy_longdouble *)data_out + 2*2)[1] =
                                ((npy_longdouble *)data0 + 2*2)[1] +
                                ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*3)[0] =
                                ((npy_longdouble *)data0 + 2*3)[0] +
                                ((npy_longdouble *)data_out + 2*3)[0];
        ((npy_longdouble *)data_out + 2*3)[1] =
                                ((npy_longdouble *)data0 + 2*3)[1] +
                                ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*4)[0] =
                                ((npy_longdouble *)data0 + 2*4)[0] +
                                ((npy_longdouble *)data_out + 2*4)[0];
        ((npy_longdouble *)data_out + 2*4)[1] =
                                ((npy_longdouble *)data0 + 2*4)[1] +
                                ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*5)[0] =
                                ((npy_longdouble *)data0 + 2*5)[0] +
                                ((npy_longdouble *)data_out + 2*5)[0];
        ((npy_longdouble *)data_out + 2*5)[1] =
                                ((npy_longdouble *)data0 + 2*5)[1] +
                                ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*6)[0] =
                                ((npy_longdouble *)data0 + 2*6)[0] +
                                ((npy_longdouble *)data_out + 2*6)[0];
        ((npy_longdouble *)data_out + 2*6)[1] =
                                ((npy_longdouble *)data0 + 2*6)[1] +
                                ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*7)[0] =
                                ((npy_longdouble *)data0 + 2*7)[0] +
                                ((npy_longdouble *)data_out + 2*7)[0];
        ((npy_longdouble *)data_out + 2*7)[1] =
                                ((npy_longdouble *)data0 + 2*7)[1] +
                                ((npy_longdouble *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 2 && !1

static void
clongdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
clongdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_clongdouble *)dataptr[0]);
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
clongdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_clongdouble *)dataptr[1]);
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_clongdouble *)dataptr[0]);
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_clongdouble *)dataptr[1]);
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 2 == 3 && !1

static void
clongdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data2 = (npy_clongdouble *)dataptr[2];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 2 > 3 || @complex */

static void
clongdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        *(npy_clongdouble *)dataptr[nop] = (temp +
                                           (*(npy_clongdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_clongdouble);
        }
#else /* complex */
#  if 2 <= 3
#    define _SUMPROD_NOP 2
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_clongdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 2 */

#if 2 == 1

static void
clongdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_longdouble accum_re = 0, accum_im = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#else
    npy_longdouble accum = 0;
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_longdouble *)dataptr[1])[0] += accum_re;
            ((npy_longdouble *)dataptr[1])[1] += accum_im;
#else
            *((npy_clongdouble *)dataptr[1]) = (accum +
                                    (*((npy_clongdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 2 == 1 */

static void
clongdouble_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_longdouble accum_re = 0, accum_im = 0;
#else
    npy_longdouble accum = 0;
#endif

#if (2 == 1) || (2 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_outstride0_two (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 2 == 1
        accum += (*(npy_clongdouble *)data0);
        data0 += stride0;
#  elif 2 == 2
        accum += (*(npy_clongdouble *)data0) *
                 (*(npy_clongdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 2 == 3
        accum += (*(npy_clongdouble *)data0) *
                 (*(npy_clongdouble *)data1) *
                 (*(npy_clongdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 2 == 1
        accum_re += ((npy_longdouble *)data0)[0];
        accum_im += ((npy_longdouble *)data0)[1];
        data0 += stride0;
#  else
#    if 2 <= 3
#define _SUMPROD_NOP 2
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 2 <= 3
    ((npy_longdouble *)dataptr[2])[0] += accum_re;
    ((npy_longdouble *)dataptr[2])[1] += accum_im;
#  else
    ((npy_longdouble *)dataptr[nop])[0] += accum_re;
    ((npy_longdouble *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 2 <= 3
    *((npy_clongdouble *)dataptr[2]) = (accum +
                                    (*((npy_clongdouble *)dataptr[2])));
#  else
    *((npy_clongdouble *)dataptr[nop]) = (accum +
                                    (*((npy_clongdouble *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
clongdouble_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 == 1) || (3 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 == 1) || (3 <= 3 && !1)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_three (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 3 == 1
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 3 == 2
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) *
                                         (*(npy_clongdouble *)data1) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 3 == 3
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) *
                                         (*(npy_clongdouble *)data1) *
                                         (*(npy_clongdouble *)data2) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        *(npy_clongdouble *)dataptr[nop] = (temp +
                                           (*(npy_clongdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        ((npy_longdouble *)data_out)[0] = ((npy_longdouble *)data0)[0] +
                                         ((npy_longdouble *)data_out)[0];
        ((npy_longdouble *)data_out)[1] = ((npy_longdouble *)data0)[1] +
                                         ((npy_longdouble *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 3 == 1

static void
clongdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longdouble *)data_out + 2*6)[0] =
                                    ((npy_longdouble *)data0 + 2*6)[0] +
                                    ((npy_longdouble *)data_out + 2*6)[0];
            ((npy_longdouble *)data_out + 2*6)[1] =
                                    ((npy_longdouble *)data0 + 2*6)[1] +
                                    ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longdouble *)data_out + 2*5)[0] =
                                    ((npy_longdouble *)data0 + 2*5)[0] +
                                    ((npy_longdouble *)data_out + 2*5)[0];
            ((npy_longdouble *)data_out + 2*5)[1] =
                                    ((npy_longdouble *)data0 + 2*5)[1] +
                                    ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longdouble *)data_out + 2*4)[0] =
                                    ((npy_longdouble *)data0 + 2*4)[0] +
                                    ((npy_longdouble *)data_out + 2*4)[0];
            ((npy_longdouble *)data_out + 2*4)[1] =
                                    ((npy_longdouble *)data0 + 2*4)[1] +
                                    ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longdouble *)data_out + 2*3)[0] =
                                    ((npy_longdouble *)data0 + 2*3)[0] +
                                    ((npy_longdouble *)data_out + 2*3)[0];
            ((npy_longdouble *)data_out + 2*3)[1] =
                                    ((npy_longdouble *)data0 + 2*3)[1] +
                                    ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longdouble *)data_out + 2*2)[0] =
                                    ((npy_longdouble *)data0 + 2*2)[0] +
                                    ((npy_longdouble *)data_out + 2*2)[0];
            ((npy_longdouble *)data_out + 2*2)[1] =
                                    ((npy_longdouble *)data0 + 2*2)[1] +
                                    ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longdouble *)data_out + 2*1)[0] =
                                    ((npy_longdouble *)data0 + 2*1)[0] +
                                    ((npy_longdouble *)data_out + 2*1)[0];
            ((npy_longdouble *)data_out + 2*1)[1] =
                                    ((npy_longdouble *)data0 + 2*1)[1] +
                                    ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longdouble *)data_out + 2*0)[0] =
                                    ((npy_longdouble *)data0 + 2*0)[0] +
                                    ((npy_longdouble *)data_out + 2*0)[0];
            ((npy_longdouble *)data_out + 2*0)[1] =
                                    ((npy_longdouble *)data0 + 2*0)[1] +
                                    ((npy_longdouble *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*0)[0] =
                                ((npy_longdouble *)data0 + 2*0)[0] +
                                ((npy_longdouble *)data_out + 2*0)[0];
        ((npy_longdouble *)data_out + 2*0)[1] =
                                ((npy_longdouble *)data0 + 2*0)[1] +
                                ((npy_longdouble *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*1)[0] =
                                ((npy_longdouble *)data0 + 2*1)[0] +
                                ((npy_longdouble *)data_out + 2*1)[0];
        ((npy_longdouble *)data_out + 2*1)[1] =
                                ((npy_longdouble *)data0 + 2*1)[1] +
                                ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*2)[0] =
                                ((npy_longdouble *)data0 + 2*2)[0] +
                                ((npy_longdouble *)data_out + 2*2)[0];
        ((npy_longdouble *)data_out + 2*2)[1] =
                                ((npy_longdouble *)data0 + 2*2)[1] +
                                ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*3)[0] =
                                ((npy_longdouble *)data0 + 2*3)[0] +
                                ((npy_longdouble *)data_out + 2*3)[0];
        ((npy_longdouble *)data_out + 2*3)[1] =
                                ((npy_longdouble *)data0 + 2*3)[1] +
                                ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*4)[0] =
                                ((npy_longdouble *)data0 + 2*4)[0] +
                                ((npy_longdouble *)data_out + 2*4)[0];
        ((npy_longdouble *)data_out + 2*4)[1] =
                                ((npy_longdouble *)data0 + 2*4)[1] +
                                ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*5)[0] =
                                ((npy_longdouble *)data0 + 2*5)[0] +
                                ((npy_longdouble *)data_out + 2*5)[0];
        ((npy_longdouble *)data_out + 2*5)[1] =
                                ((npy_longdouble *)data0 + 2*5)[1] +
                                ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*6)[0] =
                                ((npy_longdouble *)data0 + 2*6)[0] +
                                ((npy_longdouble *)data_out + 2*6)[0];
        ((npy_longdouble *)data_out + 2*6)[1] =
                                ((npy_longdouble *)data0 + 2*6)[1] +
                                ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*7)[0] =
                                ((npy_longdouble *)data0 + 2*7)[0] +
                                ((npy_longdouble *)data_out + 2*7)[0];
        ((npy_longdouble *)data_out + 2*7)[1] =
                                ((npy_longdouble *)data0 + 2*7)[1] +
                                ((npy_longdouble *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 2 && !1

static void
clongdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
clongdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_clongdouble *)dataptr[0]);
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
clongdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_clongdouble *)dataptr[1]);
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_clongdouble *)dataptr[0]);
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_clongdouble *)dataptr[1]);
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 3 == 3 && !1

static void
clongdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data2 = (npy_clongdouble *)dataptr[2];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 3 > 3 || @complex */

static void
clongdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        *(npy_clongdouble *)dataptr[nop] = (temp +
                                           (*(npy_clongdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_clongdouble);
        }
#else /* complex */
#  if 3 <= 3
#    define _SUMPROD_NOP 3
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_clongdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 3 */

#if 3 == 1

static void
clongdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_longdouble accum_re = 0, accum_im = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#else
    npy_longdouble accum = 0;
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_longdouble *)dataptr[1])[0] += accum_re;
            ((npy_longdouble *)dataptr[1])[1] += accum_im;
#else
            *((npy_clongdouble *)dataptr[1]) = (accum +
                                    (*((npy_clongdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 3 == 1 */

static void
clongdouble_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_longdouble accum_re = 0, accum_im = 0;
#else
    npy_longdouble accum = 0;
#endif

#if (3 == 1) || (3 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_outstride0_three (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 3 == 1
        accum += (*(npy_clongdouble *)data0);
        data0 += stride0;
#  elif 3 == 2
        accum += (*(npy_clongdouble *)data0) *
                 (*(npy_clongdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 3 == 3
        accum += (*(npy_clongdouble *)data0) *
                 (*(npy_clongdouble *)data1) *
                 (*(npy_clongdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 3 == 1
        accum_re += ((npy_longdouble *)data0)[0];
        accum_im += ((npy_longdouble *)data0)[1];
        data0 += stride0;
#  else
#    if 3 <= 3
#define _SUMPROD_NOP 3
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 3 <= 3
    ((npy_longdouble *)dataptr[3])[0] += accum_re;
    ((npy_longdouble *)dataptr[3])[1] += accum_im;
#  else
    ((npy_longdouble *)dataptr[nop])[0] += accum_re;
    ((npy_longdouble *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 3 <= 3
    *((npy_clongdouble *)dataptr[3]) = (accum +
                                    (*((npy_clongdouble *)dataptr[3])));
#  else
    *((npy_clongdouble *)dataptr[nop]) = (accum +
                                    (*((npy_clongdouble *)dataptr[nop])));
#  endif
#endif

}


#line 85
static void
clongdouble_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 == 1) || (1000 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 == 1) || (1000 <= 3 && !1)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_any (%d)\n", (int)count);

    while (count--) {
#if !1
#  if 1000 == 1
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data_out += stride_out;
#  elif 1000 == 2
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) *
                                         (*(npy_clongdouble *)data1) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#  elif 1000 == 3
        *(npy_clongdouble *)data_out = ((*(npy_clongdouble *)data0) *
                                         (*(npy_clongdouble *)data1) *
                                         (*(npy_clongdouble *)data2) +
                                         (*(npy_clongdouble *)data_out));
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#  else
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        *(npy_clongdouble *)dataptr[nop] = (temp +
                                           (*(npy_clongdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        ((npy_longdouble *)data_out)[0] = ((npy_longdouble *)data0)[0] +
                                         ((npy_longdouble *)data_out)[0];
        ((npy_longdouble *)data_out)[1] = ((npy_longdouble *)data0)[1] +
                                         ((npy_longdouble *)data_out)[1];
        data0 += stride0;
        data_out += stride_out;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }
}

#if 1000 == 1

static void
clongdouble_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[1];

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_one (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 200
        case 6+1:
#if !1
            data_out[6] = ((data0[6]) +
                                 (data_out[6]));
#else
            ((npy_longdouble *)data_out + 2*6)[0] =
                                    ((npy_longdouble *)data0 + 2*6)[0] +
                                    ((npy_longdouble *)data_out + 2*6)[0];
            ((npy_longdouble *)data_out + 2*6)[1] =
                                    ((npy_longdouble *)data0 + 2*6)[1] +
                                    ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 200
        case 5+1:
#if !1
            data_out[5] = ((data0[5]) +
                                 (data_out[5]));
#else
            ((npy_longdouble *)data_out + 2*5)[0] =
                                    ((npy_longdouble *)data0 + 2*5)[0] +
                                    ((npy_longdouble *)data_out + 2*5)[0];
            ((npy_longdouble *)data_out + 2*5)[1] =
                                    ((npy_longdouble *)data0 + 2*5)[1] +
                                    ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 200
        case 4+1:
#if !1
            data_out[4] = ((data0[4]) +
                                 (data_out[4]));
#else
            ((npy_longdouble *)data_out + 2*4)[0] =
                                    ((npy_longdouble *)data0 + 2*4)[0] +
                                    ((npy_longdouble *)data_out + 2*4)[0];
            ((npy_longdouble *)data_out + 2*4)[1] =
                                    ((npy_longdouble *)data0 + 2*4)[1] +
                                    ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 200
        case 3+1:
#if !1
            data_out[3] = ((data0[3]) +
                                 (data_out[3]));
#else
            ((npy_longdouble *)data_out + 2*3)[0] =
                                    ((npy_longdouble *)data0 + 2*3)[0] +
                                    ((npy_longdouble *)data_out + 2*3)[0];
            ((npy_longdouble *)data_out + 2*3)[1] =
                                    ((npy_longdouble *)data0 + 2*3)[1] +
                                    ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 200
        case 2+1:
#if !1
            data_out[2] = ((data0[2]) +
                                 (data_out[2]));
#else
            ((npy_longdouble *)data_out + 2*2)[0] =
                                    ((npy_longdouble *)data0 + 2*2)[0] +
                                    ((npy_longdouble *)data_out + 2*2)[0];
            ((npy_longdouble *)data_out + 2*2)[1] =
                                    ((npy_longdouble *)data0 + 2*2)[1] +
                                    ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 200
        case 1+1:
#if !1
            data_out[1] = ((data0[1]) +
                                 (data_out[1]));
#else
            ((npy_longdouble *)data_out + 2*1)[0] =
                                    ((npy_longdouble *)data0 + 2*1)[0] +
                                    ((npy_longdouble *)data_out + 2*1)[0];
            ((npy_longdouble *)data_out + 2*1)[1] =
                                    ((npy_longdouble *)data0 + 2*1)[1] +
                                    ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 200
        case 0+1:
#if !1
            data_out[0] = ((data0[0]) +
                                 (data_out[0]));
#else
            ((npy_longdouble *)data_out + 2*0)[0] =
                                    ((npy_longdouble *)data0 + 2*0)[0] +
                                    ((npy_longdouble *)data_out + 2*0)[0];
            ((npy_longdouble *)data_out + 2*0)[1] =
                                    ((npy_longdouble *)data0 + 2*0)[1] +
                                    ((npy_longdouble *)data_out + 2*0)[1];
#endif

        case 0:
            return;
    }

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 224
#if !1
        data_out[0] = ((data0[0]) +
                             (data_out[0]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*0)[0] =
                                ((npy_longdouble *)data0 + 2*0)[0] +
                                ((npy_longdouble *)data_out + 2*0)[0];
        ((npy_longdouble *)data_out + 2*0)[1] =
                                ((npy_longdouble *)data0 + 2*0)[1] +
                                ((npy_longdouble *)data_out + 2*0)[1];
#endif

#line 224
#if !1
        data_out[1] = ((data0[1]) +
                             (data_out[1]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*1)[0] =
                                ((npy_longdouble *)data0 + 2*1)[0] +
                                ((npy_longdouble *)data_out + 2*1)[0];
        ((npy_longdouble *)data_out + 2*1)[1] =
                                ((npy_longdouble *)data0 + 2*1)[1] +
                                ((npy_longdouble *)data_out + 2*1)[1];
#endif

#line 224
#if !1
        data_out[2] = ((data0[2]) +
                             (data_out[2]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*2)[0] =
                                ((npy_longdouble *)data0 + 2*2)[0] +
                                ((npy_longdouble *)data_out + 2*2)[0];
        ((npy_longdouble *)data_out + 2*2)[1] =
                                ((npy_longdouble *)data0 + 2*2)[1] +
                                ((npy_longdouble *)data_out + 2*2)[1];
#endif

#line 224
#if !1
        data_out[3] = ((data0[3]) +
                             (data_out[3]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*3)[0] =
                                ((npy_longdouble *)data0 + 2*3)[0] +
                                ((npy_longdouble *)data_out + 2*3)[0];
        ((npy_longdouble *)data_out + 2*3)[1] =
                                ((npy_longdouble *)data0 + 2*3)[1] +
                                ((npy_longdouble *)data_out + 2*3)[1];
#endif

#line 224
#if !1
        data_out[4] = ((data0[4]) +
                             (data_out[4]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*4)[0] =
                                ((npy_longdouble *)data0 + 2*4)[0] +
                                ((npy_longdouble *)data_out + 2*4)[0];
        ((npy_longdouble *)data_out + 2*4)[1] =
                                ((npy_longdouble *)data0 + 2*4)[1] +
                                ((npy_longdouble *)data_out + 2*4)[1];
#endif

#line 224
#if !1
        data_out[5] = ((data0[5]) +
                             (data_out[5]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*5)[0] =
                                ((npy_longdouble *)data0 + 2*5)[0] +
                                ((npy_longdouble *)data_out + 2*5)[0];
        ((npy_longdouble *)data_out + 2*5)[1] =
                                ((npy_longdouble *)data0 + 2*5)[1] +
                                ((npy_longdouble *)data_out + 2*5)[1];
#endif

#line 224
#if !1
        data_out[6] = ((data0[6]) +
                             (data_out[6]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*6)[0] =
                                ((npy_longdouble *)data0 + 2*6)[0] +
                                ((npy_longdouble *)data_out + 2*6)[0];
        ((npy_longdouble *)data_out + 2*6)[1] =
                                ((npy_longdouble *)data0 + 2*6)[1] +
                                ((npy_longdouble *)data_out + 2*6)[1];
#endif

#line 224
#if !1
        data_out[7] = ((data0[7]) +
                             (data_out[7]));
#else /* complex */
        ((npy_longdouble *)data_out + 2*7)[0] =
                                ((npy_longdouble *)data0 + 2*7)[0] +
                                ((npy_longdouble *)data_out + 2*7)[0];
        ((npy_longdouble *)data_out + 2*7)[1] =
                                ((npy_longdouble *)data0 + 2*7)[1] +
                                ((npy_longdouble *)data_out + 2*7)[1];
#endif

        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 2 && !1

static void
clongdouble_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_two (%d)\n",
                                                            (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 269
        case 6+1:
            data_out[6] = ((data0[6]) *
                                 (data1[6]) +
                                 (data_out[6]));

#line 269
        case 5+1:
            data_out[5] = ((data0[5]) *
                                 (data1[5]) +
                                 (data_out[5]));

#line 269
        case 4+1:
            data_out[4] = ((data0[4]) *
                                 (data1[4]) +
                                 (data_out[4]));

#line 269
        case 3+1:
            data_out[3] = ((data0[3]) *
                                 (data1[3]) +
                                 (data_out[3]));

#line 269
        case 2+1:
            data_out[2] = ((data0[2]) *
                                 (data1[2]) +
                                 (data_out[2]));

#line 269
        case 1+1:
            data_out[1] = ((data0[1]) *
                                 (data1[1]) +
                                 (data_out[1]));

#line 269
        case 0+1:
            data_out[0] = ((data0[0]) *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 289
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1) &&
        EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 312
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 334
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 342
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 350
        data_out[0] = ((data0[0]) *
                             (data1[0]) +
                             (data_out[0]));

#line 350
        data_out[1] = ((data0[1]) *
                             (data1[1]) +
                             (data_out[1]));

#line 350
        data_out[2] = ((data0[2]) *
                             (data1[2]) +
                             (data_out[2]));

#line 350
        data_out[3] = ((data0[3]) *
                             (data1[3]) +
                             (data_out[3]));

#line 350
        data_out[4] = ((data0[4]) *
                             (data1[4]) +
                             (data_out[4]));

#line 350
        data_out[5] = ((data0[5]) *
                             (data1[5]) +
                             (data_out[5]));

#line 350
        data_out[6] = ((data0[6]) *
                             (data1[6]) +
                             (data_out[6]));

#line 350
        data_out[7] = ((data0[7]) *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data0 += 8;
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

/* Some extra specializations for the two operand case */
static void
clongdouble_sum_of_products_stride0_contig_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_clongdouble *)dataptr[0]);
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value0_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value0_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_stride0_contig_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 388
        case 6+1:
            data_out[6] = (value0 *
                                 (data1[6]) +
                                 (data_out[6]));

#line 388
        case 5+1:
            data_out[5] = (value0 *
                                 (data1[5]) +
                                 (data_out[5]));

#line 388
        case 4+1:
            data_out[4] = (value0 *
                                 (data1[4]) +
                                 (data_out[4]));

#line 388
        case 3+1:
            data_out[3] = (value0 *
                                 (data1[3]) +
                                 (data_out[3]));

#line 388
        case 2+1:
            data_out[2] = (value0 *
                                 (data1[2]) +
                                 (data_out[2]));

#line 388
        case 1+1:
            data_out[1] = (value0 *
                                 (data1[1]) +
                                 (data_out[1]));

#line 388
        case 0+1:
            data_out[0] = (value0 *
                                 (data1[0]) +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value0_sse = _mm_set_ps1(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+0));
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 409
            a = _mm_mul_ps(value0_sse, _mm_load_ps(data1+4));
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#elif EINSUM_USE_SSE2 && 0
    value0_sse = _mm_set1_pd(value0);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+0));
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+2));
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+4));
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 437
            a = _mm_mul_pd(value0_sse, _mm_load_pd(data1+6));
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data1 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        if (count > 0) {
            goto finish_after_unrolled_loop;
        }
        else {
            return;
        }
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+0));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 463
        a = _mm_mul_ps(value0_sse, _mm_loadu_ps(data1+4));
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+0));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+2));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+4));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 471
        a = _mm_mul_pd(value0_sse, _mm_loadu_pd(data1+6));
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 479
        data_out[0] = (value0 *
                             (data1[0]) +
                             (data_out[0]));

#line 479
        data_out[1] = (value0 *
                             (data1[1]) +
                             (data_out[1]));

#line 479
        data_out[2] = (value0 *
                             (data1[2]) +
                             (data_out[2]));

#line 479
        data_out[3] = (value0 *
                             (data1[3]) +
                             (data_out[3]));

#line 479
        data_out[4] = (value0 *
                             (data1[4]) +
                             (data_out[4]));

#line 479
        data_out[5] = (value0 *
                             (data1[5]) +
                             (data_out[5]));

#line 479
        data_out[6] = (value0 *
                             (data1[6]) +
                             (data_out[6]));

#line 479
        data_out[7] = (value0 *
                             (data1[7]) +
                             (data_out[7]));

#endif
        data1 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    if (count > 0) {
        goto finish_after_unrolled_loop;
    }
}

static void
clongdouble_sum_of_products_contig_stride0_outcontig_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_clongdouble *)dataptr[1]);
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[2];

#if EINSUM_USE_SSE1 && 0
    __m128 a, b, value1_sse;
#elif EINSUM_USE_SSE2 && 0
    __m128d a, b, value1_sse;
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_stride0_outcontig_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 517
        case 6+1:
            data_out[6] = ((data0[6])*
                                 value1  +
                                 (data_out[6]));

#line 517
        case 5+1:
            data_out[5] = ((data0[5])*
                                 value1  +
                                 (data_out[5]));

#line 517
        case 4+1:
            data_out[4] = ((data0[4])*
                                 value1  +
                                 (data_out[4]));

#line 517
        case 3+1:
            data_out[3] = ((data0[3])*
                                 value1  +
                                 (data_out[3]));

#line 517
        case 2+1:
            data_out[2] = ((data0[2])*
                                 value1  +
                                 (data_out[2]));

#line 517
        case 1+1:
            data_out[1] = ((data0[1])*
                                 value1  +
                                 (data_out[1]));

#line 517
        case 0+1:
            data_out[0] = ((data0[0])*
                                 value1  +
                                 (data_out[0]));

        case 0:
            return;
    }

#if EINSUM_USE_SSE1 && 0
    value1_sse = _mm_set_ps1(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+0), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+0));
            _mm_store_ps(data_out+0, b);

#line 538
            a = _mm_mul_ps(_mm_load_ps(data0+4), value1_sse);
            b = _mm_add_ps(a, _mm_load_ps(data_out+4));
            _mm_store_ps(data_out+4, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    value1_sse = _mm_set1_pd(value1);

    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data_out)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+0), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+0));
            _mm_store_pd(data_out+0, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+2), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+2));
            _mm_store_pd(data_out+2, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+4), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+4));
            _mm_store_pd(data_out+4, b);

#line 561
            a = _mm_mul_pd(_mm_load_pd(data0+6), value1_sse);
            b = _mm_add_pd(a, _mm_load_pd(data_out+6));
            _mm_store_pd(data_out+6, b);

            data0 += 8;
            data_out += 8;
        }

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+0));
        _mm_storeu_ps(data_out+0, b);

#line 582
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), value1_sse);
        b = _mm_add_ps(a, _mm_loadu_ps(data_out+4));
        _mm_storeu_ps(data_out+4, b);

#elif EINSUM_USE_SSE2 && 0
#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+0));
        _mm_storeu_pd(data_out+0, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+2));
        _mm_storeu_pd(data_out+2, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+4));
        _mm_storeu_pd(data_out+4, b);

#line 590
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), value1_sse);
        b = _mm_add_pd(a, _mm_loadu_pd(data_out+6));
        _mm_storeu_pd(data_out+6, b);

#else
#line 598
        data_out[0] = ((data0[0])*
                             value1  +
                             (data_out[0]));

#line 598
        data_out[1] = ((data0[1])*
                             value1  +
                             (data_out[1]));

#line 598
        data_out[2] = ((data0[2])*
                             value1  +
                             (data_out[2]));

#line 598
        data_out[3] = ((data0[3])*
                             value1  +
                             (data_out[3]));

#line 598
        data_out[4] = ((data0[4])*
                             value1  +
                             (data_out[4]));

#line 598
        data_out[5] = ((data0[5])*
                             value1  +
                             (data_out[5]));

#line 598
        data_out[6] = ((data0[6])*
                             value1  +
                             (data_out[6]));

#line 598
        data_out[7] = ((data0[7])*
                             value1  +
                             (data_out[7]));

#endif
        data0 += 8;
        data_out += 8;
    }

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_contig_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 634
        case 6+1:
            accum += (data0[6]) * (data1[6]);

#line 634
        case 5+1:
            accum += (data0[5]) * (data1[5]);

#line 634
        case 4+1:
            accum += (data0[4]) * (data1[4]);

#line 634
        case 3+1:
            accum += (data0[3]) * (data1[3]);

#line 634
        case 2+1:
            accum += (data0[2]) * (data1[2]);

#line 634
        case 1+1:
            accum += (data0[1]) * (data1[1]);

#line 634
        case 0+1:
            accum += (data0[0]) * (data1[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+0), _mm_load_ps(data1+0));
            accum_sse = _mm_add_ps(accum_sse, a);

#line 655
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_ps(_mm_load_ps(data0+4), _mm_load_ps(data1+4));
            accum_sse = _mm_add_ps(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0) && EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);
            _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+0), _mm_load_pd(data1+0));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+2), _mm_load_pd(data1+2));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+4), _mm_load_pd(data1+4));
            accum_sse = _mm_add_pd(accum_sse, a);

#line 689
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            a = _mm_mul_pd(_mm_load_pd(data0+6), _mm_load_pd(data1+6));
            accum_sse = _mm_add_pd(accum_sse, a);

            data0 += 8;
            data1 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+0), _mm_loadu_ps(data1+0));
        accum_sse = _mm_add_ps(accum_sse, a);

#line 721
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_ps(_mm_loadu_ps(data0+4), _mm_loadu_ps(data1+4));
        accum_sse = _mm_add_ps(accum_sse, a);

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);
        _mm_prefetch(data1 + 512, _MM_HINT_T0);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+0), _mm_loadu_pd(data1+0));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+2), _mm_loadu_pd(data1+2));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+4), _mm_loadu_pd(data1+4));
        accum_sse = _mm_add_pd(accum_sse, a);

#line 735
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        a = _mm_mul_pd(_mm_loadu_pd(data0+6), _mm_loadu_pd(data1+6));
        accum_sse = _mm_add_pd(accum_sse, a);

#else
#line 746
        accum += (data0[0]) * (data1[0]);

#line 746
        accum += (data0[1]) * (data1[1]);

#line 746
        accum += (data0[2]) * (data1[2]);

#line 746
        accum += (data0[3]) * (data1[3]);

#line 746
        accum += (data0[4]) * (data1[4]);

#line 746
        accum += (data0[5]) * (data1[5]);

#line 746
        accum += (data0[6]) * (data1[6]);

#line 746
        accum += (data0[7]) * (data1[7]);

#endif
        data0 += 8;
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_stride0_contig_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_longdouble value0 = (*(npy_clongdouble *)dataptr[0]);
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_stride0_contig_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 794
        case 6+1:
            accum += (data1[6]);

#line 794
        case 5+1:
            accum += (data1[5]);

#line 794
        case 4+1:
            accum += (data1[4]);

#line 794
        case 3+1:
            accum += (data1[3]);

#line 794
        case 2+1:
            accum += (data1[2]);

#line 794
        case 1+1:
            accum += (data1[1]);

#line 794
        case 0+1:
            accum += (data1[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + value0 * accum);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+0));

#line 812
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data1+4));

            data1 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data1)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+0));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+2));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+4));

#line 840
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data1+6));

            data1 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+0));

#line 866
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data1+4));

#elif EINSUM_USE_SSE2 && 0
#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+0));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+2));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+4));

#line 876
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data1+6));

#else
#line 886
        accum += (data1[0]);

#line 886
        accum += (data1[1]);

#line 886
        accum += (data1[2]);

#line 886
        accum += (data1[3]);

#line 886
        accum += (data1[4]);

#line 886
        accum += (data1[5]);

#line 886
        accum += (data1[6]);

#line 886
        accum += (data1[7]);

#endif
        data1 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

static void
clongdouble_sum_of_products_contig_stride0_outstride0_two(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_longdouble value1 = (*(npy_clongdouble *)dataptr[1]);
    npy_longdouble accum = 0;

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_stride0_outstride0_two (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 933
        case 6+1:
            accum += (data0[6]);

#line 933
        case 5+1:
            accum += (data0[5]);

#line 933
        case 4+1:
            accum += (data0[4]);

#line 933
        case 3+1:
            accum += (data0[3]);

#line 933
        case 2+1:
            accum += (data0[2]);

#line 933
        case 1+1:
            accum += (data0[1]);

#line 933
        case 0+1:
            accum += (data0[0]);

        case 0:
            *(npy_clongdouble *)dataptr[2] = ((*(npy_clongdouble *)dataptr[2]) + accum * value1);
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 951
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }
        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 978
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }
        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);
        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1003
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1013
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1023
        accum += (data0[0]);

#line 1023
        accum += (data0[1]);

#line 1023
        accum += (data0[2]);

#line 1023
        accum += (data0[3]);

#line 1023
        accum += (data0[4]);

#line 1023
        accum += (data0[5]);

#line 1023
        accum += (data0[6]);

#line 1023
        accum += (data0[7]);

#endif
        data0 += 8;
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#elif 1000 == 3 && !1

static void
clongdouble_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
    npy_clongdouble *data1 = (npy_clongdouble *)dataptr[1];
    npy_clongdouble *data2 = (npy_clongdouble *)dataptr[2];
    npy_clongdouble *data_out = (npy_clongdouble *)dataptr[3];

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#line 1065
        data_out[0] = ((data0[0]) *
                             (data1[0]) *
                             (data2[0]) +
                             (data_out[0]));

#line 1065
        data_out[1] = ((data0[1]) *
                             (data1[1]) *
                             (data2[1]) +
                             (data_out[1]));

#line 1065
        data_out[2] = ((data0[2]) *
                             (data1[2]) *
                             (data2[2]) +
                             (data_out[2]));

#line 1065
        data_out[3] = ((data0[3]) *
                             (data1[3]) *
                             (data2[3]) +
                             (data_out[3]));

#line 1065
        data_out[4] = ((data0[4]) *
                             (data1[4]) *
                             (data2[4]) +
                             (data_out[4]));

#line 1065
        data_out[5] = ((data0[5]) *
                             (data1[5]) *
                             (data2[5]) +
                             (data_out[5]));

#line 1065
        data_out[6] = ((data0[6]) *
                             (data1[6]) *
                             (data2[6]) +
                             (data_out[6]));

#line 1065
        data_out[7] = ((data0[7]) *
                             (data1[7]) *
                             (data2[7]) +
                             (data_out[7]));

        data0 += 8;
        data1 += 8;
        data2 += 8;
        data_out += 8;
    }

    /* Finish off the loop */

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[0] = ((data0[0]) *
                         (data1[0]) *
                         (data2[0]) +
                         (data_out[0]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[1] = ((data0[1]) *
                         (data1[1]) *
                         (data2[1]) +
                         (data_out[1]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[2] = ((data0[2]) *
                         (data1[2]) *
                         (data2[2]) +
                         (data_out[2]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[3] = ((data0[3]) *
                         (data1[3]) *
                         (data2[3]) +
                         (data_out[3]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[4] = ((data0[4]) *
                         (data1[4]) *
                         (data2[4]) +
                         (data_out[4]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[5] = ((data0[5]) *
                         (data1[5]) *
                         (data2[5]) +
                         (data_out[5]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[6] = ((data0[6]) *
                         (data1[6]) *
                         (data2[6]) +
                         (data_out[6]));

#line 1081
    if (count-- == 0) {
        return;
    }
    data_out[7] = ((data0[7]) *
                         (data1[7]) *
                         (data2[7]) +
                         (data_out[7]));

}

#else /* 1000 > 3 || @complex */

static void
clongdouble_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *NPY_UNUSED(strides), npy_intp count)
{
    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        *(npy_clongdouble *)dataptr[nop] = (temp +
                                           (*(npy_clongdouble *)dataptr[i]));
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_clongdouble);
        }
#else /* complex */
#  if 1000 <= 3
#    define _SUMPROD_NOP 1000
#  else
#    define _SUMPROD_NOP nop
#  endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0] = re +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[0];
        ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1] = im +
                                     ((npy_longdouble *)dataptr[_SUMPROD_NOP])[1];

        for (i = 0; i <= _SUMPROD_NOP; ++i) {
            dataptr[i] += sizeof(npy_clongdouble);
        }
#  undef _SUMPROD_NOP
#endif
    }
}

#endif /* functions for various 1000 */

#if 1000 == 1

static void
clongdouble_sum_of_products_contig_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_longdouble accum_re = 0, accum_im = 0;
    npy_longdouble *data0 = (npy_longdouble *)dataptr[0];
#else
    npy_longdouble accum = 0;
    npy_clongdouble *data0 = (npy_clongdouble *)dataptr[0];
#endif

#if EINSUM_USE_SSE1 && 0
    __m128 a, accum_sse = _mm_setzero_ps();
#elif EINSUM_USE_SSE2 && 0
    __m128d a, accum_sse = _mm_setzero_pd();
#endif


    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_contig_outstride0_one (%d)\n",
                                                    (int)count);

/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1174
        case 6+1:
#if !1
            accum += (data0[6]);
#else /* complex */
            accum_re += data0[2*6+0];
            accum_im += data0[2*6+1];
#endif

#line 1174
        case 5+1:
#if !1
            accum += (data0[5]);
#else /* complex */
            accum_re += data0[2*5+0];
            accum_im += data0[2*5+1];
#endif

#line 1174
        case 4+1:
#if !1
            accum += (data0[4]);
#else /* complex */
            accum_re += data0[2*4+0];
            accum_im += data0[2*4+1];
#endif

#line 1174
        case 3+1:
#if !1
            accum += (data0[3]);
#else /* complex */
            accum_re += data0[2*3+0];
            accum_im += data0[2*3+1];
#endif

#line 1174
        case 2+1:
#if !1
            accum += (data0[2]);
#else /* complex */
            accum_re += data0[2*2+0];
            accum_im += data0[2*2+1];
#endif

#line 1174
        case 1+1:
#if !1
            accum += (data0[1]);
#else /* complex */
            accum_re += data0[2*1+0];
            accum_im += data0[2*1+1];
#endif

#line 1174
        case 0+1:
#if !1
            accum += (data0[0]);
#else /* complex */
            accum_re += data0[2*0+0];
            accum_im += data0[2*0+1];
#endif

        case 0:
#if 1
            ((npy_longdouble *)dataptr[1])[0] += accum_re;
            ((npy_longdouble *)dataptr[1])[1] += accum_im;
#else
            *((npy_clongdouble *)dataptr[1]) = (accum +
                                    (*((npy_clongdouble *)dataptr[1])));
#endif
            return;
    }

#if EINSUM_USE_SSE1 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+0));

#line 1205
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_ps(accum_sse, _mm_load_ps(data0+4));

            data0 += 8;
        }

        /* Add the four SSE values and put in accum */
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
        accum_sse = _mm_add_ps(a, accum_sse);
        a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
        accum_sse = _mm_add_ps(a, accum_sse);
        _mm_store_ss(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#elif EINSUM_USE_SSE2 && 0
    /* Use aligned instructions if possible */
    if (EINSUM_IS_SSE_ALIGNED(data0)) {
        /* Unroll the loop by 8 */
        while (count >= 8) {
            count -= 8;

            _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+0));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+2));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+4));

#line 1236
            /*
             * NOTE: This accumulation changes the order, so will likely
             *       produce slightly different results.
             */
            accum_sse = _mm_add_pd(accum_sse, _mm_load_pd(data0+6));

            data0 += 8;
        }

        /* Add the two SSE2 values and put in accum */
        a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
        accum_sse = _mm_add_pd(a, accum_sse);
        _mm_store_sd(&accum, accum_sse);

        /* Finish off the loop */
        goto finish_after_unrolled_loop;
    }
#endif

    /* Unroll the loop by 8 */
    while (count >= 8) {
        count -= 8;

#if EINSUM_USE_SSE1 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+0));

#line 1265
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_ps(accum_sse, _mm_loadu_ps(data0+4));

#elif EINSUM_USE_SSE2 && 0
        _mm_prefetch(data0 + 512, _MM_HINT_T0);

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+0));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+2));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+4));

#line 1277
        /*
         * NOTE: This accumulation changes the order, so will likely
         *       produce slightly different results.
         */
        accum_sse = _mm_add_pd(accum_sse, _mm_loadu_pd(data0+6));

#else
#line 1287
#  if !1
        accum += (data0[0]);
#  else /* complex */
        accum_re += data0[2*0+0];
        accum_im += data0[2*0+1];
#  endif

#line 1287
#  if !1
        accum += (data0[1]);
#  else /* complex */
        accum_re += data0[2*1+0];
        accum_im += data0[2*1+1];
#  endif

#line 1287
#  if !1
        accum += (data0[2]);
#  else /* complex */
        accum_re += data0[2*2+0];
        accum_im += data0[2*2+1];
#  endif

#line 1287
#  if !1
        accum += (data0[3]);
#  else /* complex */
        accum_re += data0[2*3+0];
        accum_im += data0[2*3+1];
#  endif

#line 1287
#  if !1
        accum += (data0[4]);
#  else /* complex */
        accum_re += data0[2*4+0];
        accum_im += data0[2*4+1];
#  endif

#line 1287
#  if !1
        accum += (data0[5]);
#  else /* complex */
        accum_re += data0[2*5+0];
        accum_im += data0[2*5+1];
#  endif

#line 1287
#  if !1
        accum += (data0[6]);
#  else /* complex */
        accum_re += data0[2*6+0];
        accum_im += data0[2*6+1];
#  endif

#line 1287
#  if !1
        accum += (data0[7]);
#  else /* complex */
        accum_re += data0[2*7+0];
        accum_im += data0[2*7+1];
#  endif

#endif

#if !1
        data0 += 8;
#else
        data0 += 8*2;
#endif
    }

#if EINSUM_USE_SSE1 && 0
    /* Add the four SSE values and put in accum */
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(2,3,0,1));
    accum_sse = _mm_add_ps(a, accum_sse);
    a = _mm_shuffle_ps(accum_sse, accum_sse, _MM_SHUFFLE(1,0,3,2));
    accum_sse = _mm_add_ps(a, accum_sse);
    _mm_store_ss(&accum, accum_sse);
#elif EINSUM_USE_SSE2 && 0
    /* Add the two SSE2 values and put in accum */
    a = _mm_shuffle_pd(accum_sse, accum_sse, _MM_SHUFFLE2(0,1));
    accum_sse = _mm_add_pd(a, accum_sse);
    _mm_store_sd(&accum, accum_sse);
#endif

    /* Finish off the loop */
    goto finish_after_unrolled_loop;
}

#endif /* 1000 == 1 */

static void
clongdouble_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if 1
    npy_longdouble accum_re = 0, accum_im = 0;
#else
    npy_longdouble accum = 0;
#endif

#if (1000 == 1) || (1000 <= 3 && !1)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3) && !1
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3) && !1
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    NPY_EINSUM_DBG_PRINT1("clongdouble_sum_of_products_outstride0_any (%d)\n",
                                                    (int)count);

    while (count--) {
#if !1
#  if 1000 == 1
        accum += (*(npy_clongdouble *)data0);
        data0 += stride0;
#  elif 1000 == 2
        accum += (*(npy_clongdouble *)data0) *
                 (*(npy_clongdouble *)data1);
        data0 += stride0;
        data1 += stride1;
#  elif 1000 == 3
        accum += (*(npy_clongdouble *)data0) *
                 (*(npy_clongdouble *)data1) *
                 (*(npy_clongdouble *)data2);
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#  else
        npy_longdouble temp = (*(npy_clongdouble *)dataptr[0]);
        int i;
        for (i = 1; i < nop; ++i) {
            temp *= (*(npy_clongdouble *)dataptr[i]);
        }
        accum += temp;
        for (i = 0; i < nop; ++i) {
            dataptr[i] += strides[i];
        }
#  endif
#else /* complex */
#  if 1000 == 1
        accum_re += ((npy_longdouble *)data0)[0];
        accum_im += ((npy_longdouble *)data0)[1];
        data0 += stride0;
#  else
#    if 1000 <= 3
#define _SUMPROD_NOP 1000
#    else
#define _SUMPROD_NOP nop
#    endif
        npy_longdouble re, im, tmp;
        int i;
        re = ((npy_longdouble *)dataptr[0])[0];
        im = ((npy_longdouble *)dataptr[0])[1];
        for (i = 1; i < _SUMPROD_NOP; ++i) {
            tmp = re * ((npy_longdouble *)dataptr[i])[0] -
                  im * ((npy_longdouble *)dataptr[i])[1];
            im = re * ((npy_longdouble *)dataptr[i])[1] +
                 im * ((npy_longdouble *)dataptr[i])[0];
            re = tmp;
        }
        accum_re += re;
        accum_im += im;
        for (i = 0; i < _SUMPROD_NOP; ++i) {
            dataptr[i] += strides[i];
        }
#undef _SUMPROD_NOP
#  endif
#endif
    }

#if 1
#  if 1000 <= 3
    ((npy_longdouble *)dataptr[1000])[0] += accum_re;
    ((npy_longdouble *)dataptr[1000])[1] += accum_im;
#  else
    ((npy_longdouble *)dataptr[nop])[0] += accum_re;
    ((npy_longdouble *)dataptr[nop])[1] += accum_im;
#  endif
#else
#  if 1000 <= 3
    *((npy_clongdouble *)dataptr[1000]) = (accum +
                                    (*((npy_clongdouble *)dataptr[1000])));
#  else
    *((npy_clongdouble *)dataptr[nop]) = (accum +
                                    (*((npy_clongdouble *)dataptr[nop])));
#  endif
#endif

}






/* Do OR of ANDs for the boolean type */

#line 1440

static void
bool_sum_of_products_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 <= 3)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3)
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3)
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1 <= 3)
    char *data_out = dataptr[1];
    npy_intp stride_out = strides[1];
#endif

    while (count--) {
#if 1 == 1
        *(npy_bool *)data_out = *(npy_bool *)data0 ||
                                  *(npy_bool *)data_out;
        data0 += stride0;
        data_out += stride_out;
#elif 1 == 2
        *(npy_bool *)data_out = (*(npy_bool *)data0 &&
                                   *(npy_bool *)data1) ||
                                   *(npy_bool *)data_out;
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#elif 1 == 3
        *(npy_bool *)data_out = (*(npy_bool *)data0 &&
                                   *(npy_bool *)data1 &&
                                   *(npy_bool *)data2) ||
                                   *(npy_bool *)data_out;
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        *(npy_bool *)dataptr[nop] = temp || *(npy_bool *)dataptr[i];
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#endif
    }
}

static void
bool_sum_of_products_contig_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1 <= 3)
    char *data0 = dataptr[0];
#endif
#if (1 == 2 || 1 == 3)
    char *data1 = dataptr[1];
#endif
#if (1 == 3)
    char *data2 = dataptr[2];
#endif
#if (1 <= 3)
    char *data_out = dataptr[1];
#endif

#if (1 <= 3)
/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1522
        case 6+1:
#  if 1 == 1
            ((npy_bool *)data_out)[6] = ((npy_bool *)data0)[6] ||
                                            ((npy_bool *)data_out)[6];
#  elif 1 == 2
            ((npy_bool *)data_out)[6] =
                            (((npy_bool *)data0)[6] &&
                             ((npy_bool *)data1)[6]) ||
                                ((npy_bool *)data_out)[6];
#  elif 1 == 3
            ((npy_bool *)data_out)[6] =
                           (((npy_bool *)data0)[6] &&
                            ((npy_bool *)data1)[6] &&
                            ((npy_bool *)data2)[6]) ||
                                ((npy_bool *)data_out)[6];
#  endif

#line 1522
        case 5+1:
#  if 1 == 1
            ((npy_bool *)data_out)[5] = ((npy_bool *)data0)[5] ||
                                            ((npy_bool *)data_out)[5];
#  elif 1 == 2
            ((npy_bool *)data_out)[5] =
                            (((npy_bool *)data0)[5] &&
                             ((npy_bool *)data1)[5]) ||
                                ((npy_bool *)data_out)[5];
#  elif 1 == 3
            ((npy_bool *)data_out)[5] =
                           (((npy_bool *)data0)[5] &&
                            ((npy_bool *)data1)[5] &&
                            ((npy_bool *)data2)[5]) ||
                                ((npy_bool *)data_out)[5];
#  endif

#line 1522
        case 4+1:
#  if 1 == 1
            ((npy_bool *)data_out)[4] = ((npy_bool *)data0)[4] ||
                                            ((npy_bool *)data_out)[4];
#  elif 1 == 2
            ((npy_bool *)data_out)[4] =
                            (((npy_bool *)data0)[4] &&
                             ((npy_bool *)data1)[4]) ||
                                ((npy_bool *)data_out)[4];
#  elif 1 == 3
            ((npy_bool *)data_out)[4] =
                           (((npy_bool *)data0)[4] &&
                            ((npy_bool *)data1)[4] &&
                            ((npy_bool *)data2)[4]) ||
                                ((npy_bool *)data_out)[4];
#  endif

#line 1522
        case 3+1:
#  if 1 == 1
            ((npy_bool *)data_out)[3] = ((npy_bool *)data0)[3] ||
                                            ((npy_bool *)data_out)[3];
#  elif 1 == 2
            ((npy_bool *)data_out)[3] =
                            (((npy_bool *)data0)[3] &&
                             ((npy_bool *)data1)[3]) ||
                                ((npy_bool *)data_out)[3];
#  elif 1 == 3
            ((npy_bool *)data_out)[3] =
                           (((npy_bool *)data0)[3] &&
                            ((npy_bool *)data1)[3] &&
                            ((npy_bool *)data2)[3]) ||
                                ((npy_bool *)data_out)[3];
#  endif

#line 1522
        case 2+1:
#  if 1 == 1
            ((npy_bool *)data_out)[2] = ((npy_bool *)data0)[2] ||
                                            ((npy_bool *)data_out)[2];
#  elif 1 == 2
            ((npy_bool *)data_out)[2] =
                            (((npy_bool *)data0)[2] &&
                             ((npy_bool *)data1)[2]) ||
                                ((npy_bool *)data_out)[2];
#  elif 1 == 3
            ((npy_bool *)data_out)[2] =
                           (((npy_bool *)data0)[2] &&
                            ((npy_bool *)data1)[2] &&
                            ((npy_bool *)data2)[2]) ||
                                ((npy_bool *)data_out)[2];
#  endif

#line 1522
        case 1+1:
#  if 1 == 1
            ((npy_bool *)data_out)[1] = ((npy_bool *)data0)[1] ||
                                            ((npy_bool *)data_out)[1];
#  elif 1 == 2
            ((npy_bool *)data_out)[1] =
                            (((npy_bool *)data0)[1] &&
                             ((npy_bool *)data1)[1]) ||
                                ((npy_bool *)data_out)[1];
#  elif 1 == 3
            ((npy_bool *)data_out)[1] =
                           (((npy_bool *)data0)[1] &&
                            ((npy_bool *)data1)[1] &&
                            ((npy_bool *)data2)[1]) ||
                                ((npy_bool *)data_out)[1];
#  endif

#line 1522
        case 0+1:
#  if 1 == 1
            ((npy_bool *)data_out)[0] = ((npy_bool *)data0)[0] ||
                                            ((npy_bool *)data_out)[0];
#  elif 1 == 2
            ((npy_bool *)data_out)[0] =
                            (((npy_bool *)data0)[0] &&
                             ((npy_bool *)data1)[0]) ||
                                ((npy_bool *)data_out)[0];
#  elif 1 == 3
            ((npy_bool *)data_out)[0] =
                           (((npy_bool *)data0)[0] &&
                            ((npy_bool *)data1)[0] &&
                            ((npy_bool *)data2)[0]) ||
                                ((npy_bool *)data_out)[0];
#  endif

        case 0:
            return;
    }
#endif

/* Unroll the loop by 8 for fixed-size nop */
#if (1 <= 3)
    while (count >= 8) {
        count -= 8;
#else
    while (count--) {
#endif

#  if 1 == 1
#line 1556
        *((npy_bool *)data_out + 0) = (*((npy_bool *)data0 + 0)) ||
                                        (*((npy_bool *)data_out + 0));

#line 1556
        *((npy_bool *)data_out + 1) = (*((npy_bool *)data0 + 1)) ||
                                        (*((npy_bool *)data_out + 1));

#line 1556
        *((npy_bool *)data_out + 2) = (*((npy_bool *)data0 + 2)) ||
                                        (*((npy_bool *)data_out + 2));

#line 1556
        *((npy_bool *)data_out + 3) = (*((npy_bool *)data0 + 3)) ||
                                        (*((npy_bool *)data_out + 3));

#line 1556
        *((npy_bool *)data_out + 4) = (*((npy_bool *)data0 + 4)) ||
                                        (*((npy_bool *)data_out + 4));

#line 1556
        *((npy_bool *)data_out + 5) = (*((npy_bool *)data0 + 5)) ||
                                        (*((npy_bool *)data_out + 5));

#line 1556
        *((npy_bool *)data_out + 6) = (*((npy_bool *)data0 + 6)) ||
                                        (*((npy_bool *)data_out + 6));

#line 1556
        *((npy_bool *)data_out + 7) = (*((npy_bool *)data0 + 7)) ||
                                        (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  elif 1 == 2
#line 1565
        *((npy_bool *)data_out + 0) =
                        ((*((npy_bool *)data0 + 0)) &&
                         (*((npy_bool *)data1 + 0))) ||
                            (*((npy_bool *)data_out + 0));

#line 1565
        *((npy_bool *)data_out + 1) =
                        ((*((npy_bool *)data0 + 1)) &&
                         (*((npy_bool *)data1 + 1))) ||
                            (*((npy_bool *)data_out + 1));

#line 1565
        *((npy_bool *)data_out + 2) =
                        ((*((npy_bool *)data0 + 2)) &&
                         (*((npy_bool *)data1 + 2))) ||
                            (*((npy_bool *)data_out + 2));

#line 1565
        *((npy_bool *)data_out + 3) =
                        ((*((npy_bool *)data0 + 3)) &&
                         (*((npy_bool *)data1 + 3))) ||
                            (*((npy_bool *)data_out + 3));

#line 1565
        *((npy_bool *)data_out + 4) =
                        ((*((npy_bool *)data0 + 4)) &&
                         (*((npy_bool *)data1 + 4))) ||
                            (*((npy_bool *)data_out + 4));

#line 1565
        *((npy_bool *)data_out + 5) =
                        ((*((npy_bool *)data0 + 5)) &&
                         (*((npy_bool *)data1 + 5))) ||
                            (*((npy_bool *)data_out + 5));

#line 1565
        *((npy_bool *)data_out + 6) =
                        ((*((npy_bool *)data0 + 6)) &&
                         (*((npy_bool *)data1 + 6))) ||
                            (*((npy_bool *)data_out + 6));

#line 1565
        *((npy_bool *)data_out + 7) =
                        ((*((npy_bool *)data0 + 7)) &&
                         (*((npy_bool *)data1 + 7))) ||
                            (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data1 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  elif 1 == 3
#line 1577
        *((npy_bool *)data_out + 0) =
                       ((*((npy_bool *)data0 + 0)) &&
                        (*((npy_bool *)data1 + 0)) &&
                        (*((npy_bool *)data2 + 0))) ||
                            (*((npy_bool *)data_out + 0));

#line 1577
        *((npy_bool *)data_out + 1) =
                       ((*((npy_bool *)data0 + 1)) &&
                        (*((npy_bool *)data1 + 1)) &&
                        (*((npy_bool *)data2 + 1))) ||
                            (*((npy_bool *)data_out + 1));

#line 1577
        *((npy_bool *)data_out + 2) =
                       ((*((npy_bool *)data0 + 2)) &&
                        (*((npy_bool *)data1 + 2)) &&
                        (*((npy_bool *)data2 + 2))) ||
                            (*((npy_bool *)data_out + 2));

#line 1577
        *((npy_bool *)data_out + 3) =
                       ((*((npy_bool *)data0 + 3)) &&
                        (*((npy_bool *)data1 + 3)) &&
                        (*((npy_bool *)data2 + 3))) ||
                            (*((npy_bool *)data_out + 3));

#line 1577
        *((npy_bool *)data_out + 4) =
                       ((*((npy_bool *)data0 + 4)) &&
                        (*((npy_bool *)data1 + 4)) &&
                        (*((npy_bool *)data2 + 4))) ||
                            (*((npy_bool *)data_out + 4));

#line 1577
        *((npy_bool *)data_out + 5) =
                       ((*((npy_bool *)data0 + 5)) &&
                        (*((npy_bool *)data1 + 5)) &&
                        (*((npy_bool *)data2 + 5))) ||
                            (*((npy_bool *)data_out + 5));

#line 1577
        *((npy_bool *)data_out + 6) =
                       ((*((npy_bool *)data0 + 6)) &&
                        (*((npy_bool *)data1 + 6)) &&
                        (*((npy_bool *)data2 + 6))) ||
                            (*((npy_bool *)data_out + 6));

#line 1577
        *((npy_bool *)data_out + 7) =
                       ((*((npy_bool *)data0 + 7)) &&
                        (*((npy_bool *)data1 + 7)) &&
                        (*((npy_bool *)data2 + 7))) ||
                            (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data1 += 8*sizeof(npy_bool);
        data2 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        *(npy_bool *)dataptr[nop] = temp || *(npy_bool *)dataptr[i];
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_bool);
        }
#  endif
    }

    /* If the loop was unrolled, we need to finish it off */
#if (1 <= 3)
    goto finish_after_unrolled_loop;
#endif
}

static void
bool_sum_of_products_outstride0_one(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
    npy_bool accum = 0;

#if (1 <= 3)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1 == 2 || 1 == 3)
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1 == 3)
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    while (count--) {
#if 1 == 1
        accum = *(npy_bool *)data0 || accum;
        data0 += stride0;
#elif 1 == 2
        accum = (*(npy_bool *)data0 && *(npy_bool *)data1) || accum;
        data0 += stride0;
        data1 += stride1;
#elif 1 == 3
        accum = (*(npy_bool *)data0 &&
                 *(npy_bool *)data1 &&
                 *(npy_bool *)data2) || accum;
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        accum = temp || accum;
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#endif
    }

#  if 1 <= 3
    *((npy_bool *)dataptr[1]) = accum || *((npy_bool *)dataptr[1]);
#  else
    *((npy_bool *)dataptr[nop]) = accum || *((npy_bool *)dataptr[nop]);
#  endif
}


#line 1440

static void
bool_sum_of_products_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 <= 3)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3)
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3)
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (2 <= 3)
    char *data_out = dataptr[2];
    npy_intp stride_out = strides[2];
#endif

    while (count--) {
#if 2 == 1
        *(npy_bool *)data_out = *(npy_bool *)data0 ||
                                  *(npy_bool *)data_out;
        data0 += stride0;
        data_out += stride_out;
#elif 2 == 2
        *(npy_bool *)data_out = (*(npy_bool *)data0 &&
                                   *(npy_bool *)data1) ||
                                   *(npy_bool *)data_out;
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#elif 2 == 3
        *(npy_bool *)data_out = (*(npy_bool *)data0 &&
                                   *(npy_bool *)data1 &&
                                   *(npy_bool *)data2) ||
                                   *(npy_bool *)data_out;
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        *(npy_bool *)dataptr[nop] = temp || *(npy_bool *)dataptr[i];
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#endif
    }
}

static void
bool_sum_of_products_contig_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (2 <= 3)
    char *data0 = dataptr[0];
#endif
#if (2 == 2 || 2 == 3)
    char *data1 = dataptr[1];
#endif
#if (2 == 3)
    char *data2 = dataptr[2];
#endif
#if (2 <= 3)
    char *data_out = dataptr[2];
#endif

#if (2 <= 3)
/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1522
        case 6+1:
#  if 2 == 1
            ((npy_bool *)data_out)[6] = ((npy_bool *)data0)[6] ||
                                            ((npy_bool *)data_out)[6];
#  elif 2 == 2
            ((npy_bool *)data_out)[6] =
                            (((npy_bool *)data0)[6] &&
                             ((npy_bool *)data1)[6]) ||
                                ((npy_bool *)data_out)[6];
#  elif 2 == 3
            ((npy_bool *)data_out)[6] =
                           (((npy_bool *)data0)[6] &&
                            ((npy_bool *)data1)[6] &&
                            ((npy_bool *)data2)[6]) ||
                                ((npy_bool *)data_out)[6];
#  endif

#line 1522
        case 5+1:
#  if 2 == 1
            ((npy_bool *)data_out)[5] = ((npy_bool *)data0)[5] ||
                                            ((npy_bool *)data_out)[5];
#  elif 2 == 2
            ((npy_bool *)data_out)[5] =
                            (((npy_bool *)data0)[5] &&
                             ((npy_bool *)data1)[5]) ||
                                ((npy_bool *)data_out)[5];
#  elif 2 == 3
            ((npy_bool *)data_out)[5] =
                           (((npy_bool *)data0)[5] &&
                            ((npy_bool *)data1)[5] &&
                            ((npy_bool *)data2)[5]) ||
                                ((npy_bool *)data_out)[5];
#  endif

#line 1522
        case 4+1:
#  if 2 == 1
            ((npy_bool *)data_out)[4] = ((npy_bool *)data0)[4] ||
                                            ((npy_bool *)data_out)[4];
#  elif 2 == 2
            ((npy_bool *)data_out)[4] =
                            (((npy_bool *)data0)[4] &&
                             ((npy_bool *)data1)[4]) ||
                                ((npy_bool *)data_out)[4];
#  elif 2 == 3
            ((npy_bool *)data_out)[4] =
                           (((npy_bool *)data0)[4] &&
                            ((npy_bool *)data1)[4] &&
                            ((npy_bool *)data2)[4]) ||
                                ((npy_bool *)data_out)[4];
#  endif

#line 1522
        case 3+1:
#  if 2 == 1
            ((npy_bool *)data_out)[3] = ((npy_bool *)data0)[3] ||
                                            ((npy_bool *)data_out)[3];
#  elif 2 == 2
            ((npy_bool *)data_out)[3] =
                            (((npy_bool *)data0)[3] &&
                             ((npy_bool *)data1)[3]) ||
                                ((npy_bool *)data_out)[3];
#  elif 2 == 3
            ((npy_bool *)data_out)[3] =
                           (((npy_bool *)data0)[3] &&
                            ((npy_bool *)data1)[3] &&
                            ((npy_bool *)data2)[3]) ||
                                ((npy_bool *)data_out)[3];
#  endif

#line 1522
        case 2+1:
#  if 2 == 1
            ((npy_bool *)data_out)[2] = ((npy_bool *)data0)[2] ||
                                            ((npy_bool *)data_out)[2];
#  elif 2 == 2
            ((npy_bool *)data_out)[2] =
                            (((npy_bool *)data0)[2] &&
                             ((npy_bool *)data1)[2]) ||
                                ((npy_bool *)data_out)[2];
#  elif 2 == 3
            ((npy_bool *)data_out)[2] =
                           (((npy_bool *)data0)[2] &&
                            ((npy_bool *)data1)[2] &&
                            ((npy_bool *)data2)[2]) ||
                                ((npy_bool *)data_out)[2];
#  endif

#line 1522
        case 1+1:
#  if 2 == 1
            ((npy_bool *)data_out)[1] = ((npy_bool *)data0)[1] ||
                                            ((npy_bool *)data_out)[1];
#  elif 2 == 2
            ((npy_bool *)data_out)[1] =
                            (((npy_bool *)data0)[1] &&
                             ((npy_bool *)data1)[1]) ||
                                ((npy_bool *)data_out)[1];
#  elif 2 == 3
            ((npy_bool *)data_out)[1] =
                           (((npy_bool *)data0)[1] &&
                            ((npy_bool *)data1)[1] &&
                            ((npy_bool *)data2)[1]) ||
                                ((npy_bool *)data_out)[1];
#  endif

#line 1522
        case 0+1:
#  if 2 == 1
            ((npy_bool *)data_out)[0] = ((npy_bool *)data0)[0] ||
                                            ((npy_bool *)data_out)[0];
#  elif 2 == 2
            ((npy_bool *)data_out)[0] =
                            (((npy_bool *)data0)[0] &&
                             ((npy_bool *)data1)[0]) ||
                                ((npy_bool *)data_out)[0];
#  elif 2 == 3
            ((npy_bool *)data_out)[0] =
                           (((npy_bool *)data0)[0] &&
                            ((npy_bool *)data1)[0] &&
                            ((npy_bool *)data2)[0]) ||
                                ((npy_bool *)data_out)[0];
#  endif

        case 0:
            return;
    }
#endif

/* Unroll the loop by 8 for fixed-size nop */
#if (2 <= 3)
    while (count >= 8) {
        count -= 8;
#else
    while (count--) {
#endif

#  if 2 == 1
#line 1556
        *((npy_bool *)data_out + 0) = (*((npy_bool *)data0 + 0)) ||
                                        (*((npy_bool *)data_out + 0));

#line 1556
        *((npy_bool *)data_out + 1) = (*((npy_bool *)data0 + 1)) ||
                                        (*((npy_bool *)data_out + 1));

#line 1556
        *((npy_bool *)data_out + 2) = (*((npy_bool *)data0 + 2)) ||
                                        (*((npy_bool *)data_out + 2));

#line 1556
        *((npy_bool *)data_out + 3) = (*((npy_bool *)data0 + 3)) ||
                                        (*((npy_bool *)data_out + 3));

#line 1556
        *((npy_bool *)data_out + 4) = (*((npy_bool *)data0 + 4)) ||
                                        (*((npy_bool *)data_out + 4));

#line 1556
        *((npy_bool *)data_out + 5) = (*((npy_bool *)data0 + 5)) ||
                                        (*((npy_bool *)data_out + 5));

#line 1556
        *((npy_bool *)data_out + 6) = (*((npy_bool *)data0 + 6)) ||
                                        (*((npy_bool *)data_out + 6));

#line 1556
        *((npy_bool *)data_out + 7) = (*((npy_bool *)data0 + 7)) ||
                                        (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  elif 2 == 2
#line 1565
        *((npy_bool *)data_out + 0) =
                        ((*((npy_bool *)data0 + 0)) &&
                         (*((npy_bool *)data1 + 0))) ||
                            (*((npy_bool *)data_out + 0));

#line 1565
        *((npy_bool *)data_out + 1) =
                        ((*((npy_bool *)data0 + 1)) &&
                         (*((npy_bool *)data1 + 1))) ||
                            (*((npy_bool *)data_out + 1));

#line 1565
        *((npy_bool *)data_out + 2) =
                        ((*((npy_bool *)data0 + 2)) &&
                         (*((npy_bool *)data1 + 2))) ||
                            (*((npy_bool *)data_out + 2));

#line 1565
        *((npy_bool *)data_out + 3) =
                        ((*((npy_bool *)data0 + 3)) &&
                         (*((npy_bool *)data1 + 3))) ||
                            (*((npy_bool *)data_out + 3));

#line 1565
        *((npy_bool *)data_out + 4) =
                        ((*((npy_bool *)data0 + 4)) &&
                         (*((npy_bool *)data1 + 4))) ||
                            (*((npy_bool *)data_out + 4));

#line 1565
        *((npy_bool *)data_out + 5) =
                        ((*((npy_bool *)data0 + 5)) &&
                         (*((npy_bool *)data1 + 5))) ||
                            (*((npy_bool *)data_out + 5));

#line 1565
        *((npy_bool *)data_out + 6) =
                        ((*((npy_bool *)data0 + 6)) &&
                         (*((npy_bool *)data1 + 6))) ||
                            (*((npy_bool *)data_out + 6));

#line 1565
        *((npy_bool *)data_out + 7) =
                        ((*((npy_bool *)data0 + 7)) &&
                         (*((npy_bool *)data1 + 7))) ||
                            (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data1 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  elif 2 == 3
#line 1577
        *((npy_bool *)data_out + 0) =
                       ((*((npy_bool *)data0 + 0)) &&
                        (*((npy_bool *)data1 + 0)) &&
                        (*((npy_bool *)data2 + 0))) ||
                            (*((npy_bool *)data_out + 0));

#line 1577
        *((npy_bool *)data_out + 1) =
                       ((*((npy_bool *)data0 + 1)) &&
                        (*((npy_bool *)data1 + 1)) &&
                        (*((npy_bool *)data2 + 1))) ||
                            (*((npy_bool *)data_out + 1));

#line 1577
        *((npy_bool *)data_out + 2) =
                       ((*((npy_bool *)data0 + 2)) &&
                        (*((npy_bool *)data1 + 2)) &&
                        (*((npy_bool *)data2 + 2))) ||
                            (*((npy_bool *)data_out + 2));

#line 1577
        *((npy_bool *)data_out + 3) =
                       ((*((npy_bool *)data0 + 3)) &&
                        (*((npy_bool *)data1 + 3)) &&
                        (*((npy_bool *)data2 + 3))) ||
                            (*((npy_bool *)data_out + 3));

#line 1577
        *((npy_bool *)data_out + 4) =
                       ((*((npy_bool *)data0 + 4)) &&
                        (*((npy_bool *)data1 + 4)) &&
                        (*((npy_bool *)data2 + 4))) ||
                            (*((npy_bool *)data_out + 4));

#line 1577
        *((npy_bool *)data_out + 5) =
                       ((*((npy_bool *)data0 + 5)) &&
                        (*((npy_bool *)data1 + 5)) &&
                        (*((npy_bool *)data2 + 5))) ||
                            (*((npy_bool *)data_out + 5));

#line 1577
        *((npy_bool *)data_out + 6) =
                       ((*((npy_bool *)data0 + 6)) &&
                        (*((npy_bool *)data1 + 6)) &&
                        (*((npy_bool *)data2 + 6))) ||
                            (*((npy_bool *)data_out + 6));

#line 1577
        *((npy_bool *)data_out + 7) =
                       ((*((npy_bool *)data0 + 7)) &&
                        (*((npy_bool *)data1 + 7)) &&
                        (*((npy_bool *)data2 + 7))) ||
                            (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data1 += 8*sizeof(npy_bool);
        data2 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        *(npy_bool *)dataptr[nop] = temp || *(npy_bool *)dataptr[i];
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_bool);
        }
#  endif
    }

    /* If the loop was unrolled, we need to finish it off */
#if (2 <= 3)
    goto finish_after_unrolled_loop;
#endif
}

static void
bool_sum_of_products_outstride0_two(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
    npy_bool accum = 0;

#if (2 <= 3)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (2 == 2 || 2 == 3)
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (2 == 3)
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    while (count--) {
#if 2 == 1
        accum = *(npy_bool *)data0 || accum;
        data0 += stride0;
#elif 2 == 2
        accum = (*(npy_bool *)data0 && *(npy_bool *)data1) || accum;
        data0 += stride0;
        data1 += stride1;
#elif 2 == 3
        accum = (*(npy_bool *)data0 &&
                 *(npy_bool *)data1 &&
                 *(npy_bool *)data2) || accum;
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        accum = temp || accum;
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#endif
    }

#  if 2 <= 3
    *((npy_bool *)dataptr[2]) = accum || *((npy_bool *)dataptr[2]);
#  else
    *((npy_bool *)dataptr[nop]) = accum || *((npy_bool *)dataptr[nop]);
#  endif
}


#line 1440

static void
bool_sum_of_products_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 <= 3)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3)
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3)
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (3 <= 3)
    char *data_out = dataptr[3];
    npy_intp stride_out = strides[3];
#endif

    while (count--) {
#if 3 == 1
        *(npy_bool *)data_out = *(npy_bool *)data0 ||
                                  *(npy_bool *)data_out;
        data0 += stride0;
        data_out += stride_out;
#elif 3 == 2
        *(npy_bool *)data_out = (*(npy_bool *)data0 &&
                                   *(npy_bool *)data1) ||
                                   *(npy_bool *)data_out;
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#elif 3 == 3
        *(npy_bool *)data_out = (*(npy_bool *)data0 &&
                                   *(npy_bool *)data1 &&
                                   *(npy_bool *)data2) ||
                                   *(npy_bool *)data_out;
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        *(npy_bool *)dataptr[nop] = temp || *(npy_bool *)dataptr[i];
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#endif
    }
}

static void
bool_sum_of_products_contig_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (3 <= 3)
    char *data0 = dataptr[0];
#endif
#if (3 == 2 || 3 == 3)
    char *data1 = dataptr[1];
#endif
#if (3 == 3)
    char *data2 = dataptr[2];
#endif
#if (3 <= 3)
    char *data_out = dataptr[3];
#endif

#if (3 <= 3)
/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1522
        case 6+1:
#  if 3 == 1
            ((npy_bool *)data_out)[6] = ((npy_bool *)data0)[6] ||
                                            ((npy_bool *)data_out)[6];
#  elif 3 == 2
            ((npy_bool *)data_out)[6] =
                            (((npy_bool *)data0)[6] &&
                             ((npy_bool *)data1)[6]) ||
                                ((npy_bool *)data_out)[6];
#  elif 3 == 3
            ((npy_bool *)data_out)[6] =
                           (((npy_bool *)data0)[6] &&
                            ((npy_bool *)data1)[6] &&
                            ((npy_bool *)data2)[6]) ||
                                ((npy_bool *)data_out)[6];
#  endif

#line 1522
        case 5+1:
#  if 3 == 1
            ((npy_bool *)data_out)[5] = ((npy_bool *)data0)[5] ||
                                            ((npy_bool *)data_out)[5];
#  elif 3 == 2
            ((npy_bool *)data_out)[5] =
                            (((npy_bool *)data0)[5] &&
                             ((npy_bool *)data1)[5]) ||
                                ((npy_bool *)data_out)[5];
#  elif 3 == 3
            ((npy_bool *)data_out)[5] =
                           (((npy_bool *)data0)[5] &&
                            ((npy_bool *)data1)[5] &&
                            ((npy_bool *)data2)[5]) ||
                                ((npy_bool *)data_out)[5];
#  endif

#line 1522
        case 4+1:
#  if 3 == 1
            ((npy_bool *)data_out)[4] = ((npy_bool *)data0)[4] ||
                                            ((npy_bool *)data_out)[4];
#  elif 3 == 2
            ((npy_bool *)data_out)[4] =
                            (((npy_bool *)data0)[4] &&
                             ((npy_bool *)data1)[4]) ||
                                ((npy_bool *)data_out)[4];
#  elif 3 == 3
            ((npy_bool *)data_out)[4] =
                           (((npy_bool *)data0)[4] &&
                            ((npy_bool *)data1)[4] &&
                            ((npy_bool *)data2)[4]) ||
                                ((npy_bool *)data_out)[4];
#  endif

#line 1522
        case 3+1:
#  if 3 == 1
            ((npy_bool *)data_out)[3] = ((npy_bool *)data0)[3] ||
                                            ((npy_bool *)data_out)[3];
#  elif 3 == 2
            ((npy_bool *)data_out)[3] =
                            (((npy_bool *)data0)[3] &&
                             ((npy_bool *)data1)[3]) ||
                                ((npy_bool *)data_out)[3];
#  elif 3 == 3
            ((npy_bool *)data_out)[3] =
                           (((npy_bool *)data0)[3] &&
                            ((npy_bool *)data1)[3] &&
                            ((npy_bool *)data2)[3]) ||
                                ((npy_bool *)data_out)[3];
#  endif

#line 1522
        case 2+1:
#  if 3 == 1
            ((npy_bool *)data_out)[2] = ((npy_bool *)data0)[2] ||
                                            ((npy_bool *)data_out)[2];
#  elif 3 == 2
            ((npy_bool *)data_out)[2] =
                            (((npy_bool *)data0)[2] &&
                             ((npy_bool *)data1)[2]) ||
                                ((npy_bool *)data_out)[2];
#  elif 3 == 3
            ((npy_bool *)data_out)[2] =
                           (((npy_bool *)data0)[2] &&
                            ((npy_bool *)data1)[2] &&
                            ((npy_bool *)data2)[2]) ||
                                ((npy_bool *)data_out)[2];
#  endif

#line 1522
        case 1+1:
#  if 3 == 1
            ((npy_bool *)data_out)[1] = ((npy_bool *)data0)[1] ||
                                            ((npy_bool *)data_out)[1];
#  elif 3 == 2
            ((npy_bool *)data_out)[1] =
                            (((npy_bool *)data0)[1] &&
                             ((npy_bool *)data1)[1]) ||
                                ((npy_bool *)data_out)[1];
#  elif 3 == 3
            ((npy_bool *)data_out)[1] =
                           (((npy_bool *)data0)[1] &&
                            ((npy_bool *)data1)[1] &&
                            ((npy_bool *)data2)[1]) ||
                                ((npy_bool *)data_out)[1];
#  endif

#line 1522
        case 0+1:
#  if 3 == 1
            ((npy_bool *)data_out)[0] = ((npy_bool *)data0)[0] ||
                                            ((npy_bool *)data_out)[0];
#  elif 3 == 2
            ((npy_bool *)data_out)[0] =
                            (((npy_bool *)data0)[0] &&
                             ((npy_bool *)data1)[0]) ||
                                ((npy_bool *)data_out)[0];
#  elif 3 == 3
            ((npy_bool *)data_out)[0] =
                           (((npy_bool *)data0)[0] &&
                            ((npy_bool *)data1)[0] &&
                            ((npy_bool *)data2)[0]) ||
                                ((npy_bool *)data_out)[0];
#  endif

        case 0:
            return;
    }
#endif

/* Unroll the loop by 8 for fixed-size nop */
#if (3 <= 3)
    while (count >= 8) {
        count -= 8;
#else
    while (count--) {
#endif

#  if 3 == 1
#line 1556
        *((npy_bool *)data_out + 0) = (*((npy_bool *)data0 + 0)) ||
                                        (*((npy_bool *)data_out + 0));

#line 1556
        *((npy_bool *)data_out + 1) = (*((npy_bool *)data0 + 1)) ||
                                        (*((npy_bool *)data_out + 1));

#line 1556
        *((npy_bool *)data_out + 2) = (*((npy_bool *)data0 + 2)) ||
                                        (*((npy_bool *)data_out + 2));

#line 1556
        *((npy_bool *)data_out + 3) = (*((npy_bool *)data0 + 3)) ||
                                        (*((npy_bool *)data_out + 3));

#line 1556
        *((npy_bool *)data_out + 4) = (*((npy_bool *)data0 + 4)) ||
                                        (*((npy_bool *)data_out + 4));

#line 1556
        *((npy_bool *)data_out + 5) = (*((npy_bool *)data0 + 5)) ||
                                        (*((npy_bool *)data_out + 5));

#line 1556
        *((npy_bool *)data_out + 6) = (*((npy_bool *)data0 + 6)) ||
                                        (*((npy_bool *)data_out + 6));

#line 1556
        *((npy_bool *)data_out + 7) = (*((npy_bool *)data0 + 7)) ||
                                        (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  elif 3 == 2
#line 1565
        *((npy_bool *)data_out + 0) =
                        ((*((npy_bool *)data0 + 0)) &&
                         (*((npy_bool *)data1 + 0))) ||
                            (*((npy_bool *)data_out + 0));

#line 1565
        *((npy_bool *)data_out + 1) =
                        ((*((npy_bool *)data0 + 1)) &&
                         (*((npy_bool *)data1 + 1))) ||
                            (*((npy_bool *)data_out + 1));

#line 1565
        *((npy_bool *)data_out + 2) =
                        ((*((npy_bool *)data0 + 2)) &&
                         (*((npy_bool *)data1 + 2))) ||
                            (*((npy_bool *)data_out + 2));

#line 1565
        *((npy_bool *)data_out + 3) =
                        ((*((npy_bool *)data0 + 3)) &&
                         (*((npy_bool *)data1 + 3))) ||
                            (*((npy_bool *)data_out + 3));

#line 1565
        *((npy_bool *)data_out + 4) =
                        ((*((npy_bool *)data0 + 4)) &&
                         (*((npy_bool *)data1 + 4))) ||
                            (*((npy_bool *)data_out + 4));

#line 1565
        *((npy_bool *)data_out + 5) =
                        ((*((npy_bool *)data0 + 5)) &&
                         (*((npy_bool *)data1 + 5))) ||
                            (*((npy_bool *)data_out + 5));

#line 1565
        *((npy_bool *)data_out + 6) =
                        ((*((npy_bool *)data0 + 6)) &&
                         (*((npy_bool *)data1 + 6))) ||
                            (*((npy_bool *)data_out + 6));

#line 1565
        *((npy_bool *)data_out + 7) =
                        ((*((npy_bool *)data0 + 7)) &&
                         (*((npy_bool *)data1 + 7))) ||
                            (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data1 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  elif 3 == 3
#line 1577
        *((npy_bool *)data_out + 0) =
                       ((*((npy_bool *)data0 + 0)) &&
                        (*((npy_bool *)data1 + 0)) &&
                        (*((npy_bool *)data2 + 0))) ||
                            (*((npy_bool *)data_out + 0));

#line 1577
        *((npy_bool *)data_out + 1) =
                       ((*((npy_bool *)data0 + 1)) &&
                        (*((npy_bool *)data1 + 1)) &&
                        (*((npy_bool *)data2 + 1))) ||
                            (*((npy_bool *)data_out + 1));

#line 1577
        *((npy_bool *)data_out + 2) =
                       ((*((npy_bool *)data0 + 2)) &&
                        (*((npy_bool *)data1 + 2)) &&
                        (*((npy_bool *)data2 + 2))) ||
                            (*((npy_bool *)data_out + 2));

#line 1577
        *((npy_bool *)data_out + 3) =
                       ((*((npy_bool *)data0 + 3)) &&
                        (*((npy_bool *)data1 + 3)) &&
                        (*((npy_bool *)data2 + 3))) ||
                            (*((npy_bool *)data_out + 3));

#line 1577
        *((npy_bool *)data_out + 4) =
                       ((*((npy_bool *)data0 + 4)) &&
                        (*((npy_bool *)data1 + 4)) &&
                        (*((npy_bool *)data2 + 4))) ||
                            (*((npy_bool *)data_out + 4));

#line 1577
        *((npy_bool *)data_out + 5) =
                       ((*((npy_bool *)data0 + 5)) &&
                        (*((npy_bool *)data1 + 5)) &&
                        (*((npy_bool *)data2 + 5))) ||
                            (*((npy_bool *)data_out + 5));

#line 1577
        *((npy_bool *)data_out + 6) =
                       ((*((npy_bool *)data0 + 6)) &&
                        (*((npy_bool *)data1 + 6)) &&
                        (*((npy_bool *)data2 + 6))) ||
                            (*((npy_bool *)data_out + 6));

#line 1577
        *((npy_bool *)data_out + 7) =
                       ((*((npy_bool *)data0 + 7)) &&
                        (*((npy_bool *)data1 + 7)) &&
                        (*((npy_bool *)data2 + 7))) ||
                            (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data1 += 8*sizeof(npy_bool);
        data2 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        *(npy_bool *)dataptr[nop] = temp || *(npy_bool *)dataptr[i];
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_bool);
        }
#  endif
    }

    /* If the loop was unrolled, we need to finish it off */
#if (3 <= 3)
    goto finish_after_unrolled_loop;
#endif
}

static void
bool_sum_of_products_outstride0_three(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
    npy_bool accum = 0;

#if (3 <= 3)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (3 == 2 || 3 == 3)
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (3 == 3)
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    while (count--) {
#if 3 == 1
        accum = *(npy_bool *)data0 || accum;
        data0 += stride0;
#elif 3 == 2
        accum = (*(npy_bool *)data0 && *(npy_bool *)data1) || accum;
        data0 += stride0;
        data1 += stride1;
#elif 3 == 3
        accum = (*(npy_bool *)data0 &&
                 *(npy_bool *)data1 &&
                 *(npy_bool *)data2) || accum;
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        accum = temp || accum;
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#endif
    }

#  if 3 <= 3
    *((npy_bool *)dataptr[3]) = accum || *((npy_bool *)dataptr[3]);
#  else
    *((npy_bool *)dataptr[nop]) = accum || *((npy_bool *)dataptr[nop]);
#  endif
}


#line 1440

static void
bool_sum_of_products_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 <= 3)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3)
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3)
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif
#if (1000 <= 3)
    char *data_out = dataptr[1000];
    npy_intp stride_out = strides[1000];
#endif

    while (count--) {
#if 1000 == 1
        *(npy_bool *)data_out = *(npy_bool *)data0 ||
                                  *(npy_bool *)data_out;
        data0 += stride0;
        data_out += stride_out;
#elif 1000 == 2
        *(npy_bool *)data_out = (*(npy_bool *)data0 &&
                                   *(npy_bool *)data1) ||
                                   *(npy_bool *)data_out;
        data0 += stride0;
        data1 += stride1;
        data_out += stride_out;
#elif 1000 == 3
        *(npy_bool *)data_out = (*(npy_bool *)data0 &&
                                   *(npy_bool *)data1 &&
                                   *(npy_bool *)data2) ||
                                   *(npy_bool *)data_out;
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
        data_out += stride_out;
#else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        *(npy_bool *)dataptr[nop] = temp || *(npy_bool *)dataptr[i];
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#endif
    }
}

static void
bool_sum_of_products_contig_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
#if (1000 <= 3)
    char *data0 = dataptr[0];
#endif
#if (1000 == 2 || 1000 == 3)
    char *data1 = dataptr[1];
#endif
#if (1000 == 3)
    char *data2 = dataptr[2];
#endif
#if (1000 <= 3)
    char *data_out = dataptr[1000];
#endif

#if (1000 <= 3)
/* This is placed before the main loop to make small counts faster */
finish_after_unrolled_loop:
    switch (count) {
#line 1522
        case 6+1:
#  if 1000 == 1
            ((npy_bool *)data_out)[6] = ((npy_bool *)data0)[6] ||
                                            ((npy_bool *)data_out)[6];
#  elif 1000 == 2
            ((npy_bool *)data_out)[6] =
                            (((npy_bool *)data0)[6] &&
                             ((npy_bool *)data1)[6]) ||
                                ((npy_bool *)data_out)[6];
#  elif 1000 == 3
            ((npy_bool *)data_out)[6] =
                           (((npy_bool *)data0)[6] &&
                            ((npy_bool *)data1)[6] &&
                            ((npy_bool *)data2)[6]) ||
                                ((npy_bool *)data_out)[6];
#  endif

#line 1522
        case 5+1:
#  if 1000 == 1
            ((npy_bool *)data_out)[5] = ((npy_bool *)data0)[5] ||
                                            ((npy_bool *)data_out)[5];
#  elif 1000 == 2
            ((npy_bool *)data_out)[5] =
                            (((npy_bool *)data0)[5] &&
                             ((npy_bool *)data1)[5]) ||
                                ((npy_bool *)data_out)[5];
#  elif 1000 == 3
            ((npy_bool *)data_out)[5] =
                           (((npy_bool *)data0)[5] &&
                            ((npy_bool *)data1)[5] &&
                            ((npy_bool *)data2)[5]) ||
                                ((npy_bool *)data_out)[5];
#  endif

#line 1522
        case 4+1:
#  if 1000 == 1
            ((npy_bool *)data_out)[4] = ((npy_bool *)data0)[4] ||
                                            ((npy_bool *)data_out)[4];
#  elif 1000 == 2
            ((npy_bool *)data_out)[4] =
                            (((npy_bool *)data0)[4] &&
                             ((npy_bool *)data1)[4]) ||
                                ((npy_bool *)data_out)[4];
#  elif 1000 == 3
            ((npy_bool *)data_out)[4] =
                           (((npy_bool *)data0)[4] &&
                            ((npy_bool *)data1)[4] &&
                            ((npy_bool *)data2)[4]) ||
                                ((npy_bool *)data_out)[4];
#  endif

#line 1522
        case 3+1:
#  if 1000 == 1
            ((npy_bool *)data_out)[3] = ((npy_bool *)data0)[3] ||
                                            ((npy_bool *)data_out)[3];
#  elif 1000 == 2
            ((npy_bool *)data_out)[3] =
                            (((npy_bool *)data0)[3] &&
                             ((npy_bool *)data1)[3]) ||
                                ((npy_bool *)data_out)[3];
#  elif 1000 == 3
            ((npy_bool *)data_out)[3] =
                           (((npy_bool *)data0)[3] &&
                            ((npy_bool *)data1)[3] &&
                            ((npy_bool *)data2)[3]) ||
                                ((npy_bool *)data_out)[3];
#  endif

#line 1522
        case 2+1:
#  if 1000 == 1
            ((npy_bool *)data_out)[2] = ((npy_bool *)data0)[2] ||
                                            ((npy_bool *)data_out)[2];
#  elif 1000 == 2
            ((npy_bool *)data_out)[2] =
                            (((npy_bool *)data0)[2] &&
                             ((npy_bool *)data1)[2]) ||
                                ((npy_bool *)data_out)[2];
#  elif 1000 == 3
            ((npy_bool *)data_out)[2] =
                           (((npy_bool *)data0)[2] &&
                            ((npy_bool *)data1)[2] &&
                            ((npy_bool *)data2)[2]) ||
                                ((npy_bool *)data_out)[2];
#  endif

#line 1522
        case 1+1:
#  if 1000 == 1
            ((npy_bool *)data_out)[1] = ((npy_bool *)data0)[1] ||
                                            ((npy_bool *)data_out)[1];
#  elif 1000 == 2
            ((npy_bool *)data_out)[1] =
                            (((npy_bool *)data0)[1] &&
                             ((npy_bool *)data1)[1]) ||
                                ((npy_bool *)data_out)[1];
#  elif 1000 == 3
            ((npy_bool *)data_out)[1] =
                           (((npy_bool *)data0)[1] &&
                            ((npy_bool *)data1)[1] &&
                            ((npy_bool *)data2)[1]) ||
                                ((npy_bool *)data_out)[1];
#  endif

#line 1522
        case 0+1:
#  if 1000 == 1
            ((npy_bool *)data_out)[0] = ((npy_bool *)data0)[0] ||
                                            ((npy_bool *)data_out)[0];
#  elif 1000 == 2
            ((npy_bool *)data_out)[0] =
                            (((npy_bool *)data0)[0] &&
                             ((npy_bool *)data1)[0]) ||
                                ((npy_bool *)data_out)[0];
#  elif 1000 == 3
            ((npy_bool *)data_out)[0] =
                           (((npy_bool *)data0)[0] &&
                            ((npy_bool *)data1)[0] &&
                            ((npy_bool *)data2)[0]) ||
                                ((npy_bool *)data_out)[0];
#  endif

        case 0:
            return;
    }
#endif

/* Unroll the loop by 8 for fixed-size nop */
#if (1000 <= 3)
    while (count >= 8) {
        count -= 8;
#else
    while (count--) {
#endif

#  if 1000 == 1
#line 1556
        *((npy_bool *)data_out + 0) = (*((npy_bool *)data0 + 0)) ||
                                        (*((npy_bool *)data_out + 0));

#line 1556
        *((npy_bool *)data_out + 1) = (*((npy_bool *)data0 + 1)) ||
                                        (*((npy_bool *)data_out + 1));

#line 1556
        *((npy_bool *)data_out + 2) = (*((npy_bool *)data0 + 2)) ||
                                        (*((npy_bool *)data_out + 2));

#line 1556
        *((npy_bool *)data_out + 3) = (*((npy_bool *)data0 + 3)) ||
                                        (*((npy_bool *)data_out + 3));

#line 1556
        *((npy_bool *)data_out + 4) = (*((npy_bool *)data0 + 4)) ||
                                        (*((npy_bool *)data_out + 4));

#line 1556
        *((npy_bool *)data_out + 5) = (*((npy_bool *)data0 + 5)) ||
                                        (*((npy_bool *)data_out + 5));

#line 1556
        *((npy_bool *)data_out + 6) = (*((npy_bool *)data0 + 6)) ||
                                        (*((npy_bool *)data_out + 6));

#line 1556
        *((npy_bool *)data_out + 7) = (*((npy_bool *)data0 + 7)) ||
                                        (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  elif 1000 == 2
#line 1565
        *((npy_bool *)data_out + 0) =
                        ((*((npy_bool *)data0 + 0)) &&
                         (*((npy_bool *)data1 + 0))) ||
                            (*((npy_bool *)data_out + 0));

#line 1565
        *((npy_bool *)data_out + 1) =
                        ((*((npy_bool *)data0 + 1)) &&
                         (*((npy_bool *)data1 + 1))) ||
                            (*((npy_bool *)data_out + 1));

#line 1565
        *((npy_bool *)data_out + 2) =
                        ((*((npy_bool *)data0 + 2)) &&
                         (*((npy_bool *)data1 + 2))) ||
                            (*((npy_bool *)data_out + 2));

#line 1565
        *((npy_bool *)data_out + 3) =
                        ((*((npy_bool *)data0 + 3)) &&
                         (*((npy_bool *)data1 + 3))) ||
                            (*((npy_bool *)data_out + 3));

#line 1565
        *((npy_bool *)data_out + 4) =
                        ((*((npy_bool *)data0 + 4)) &&
                         (*((npy_bool *)data1 + 4))) ||
                            (*((npy_bool *)data_out + 4));

#line 1565
        *((npy_bool *)data_out + 5) =
                        ((*((npy_bool *)data0 + 5)) &&
                         (*((npy_bool *)data1 + 5))) ||
                            (*((npy_bool *)data_out + 5));

#line 1565
        *((npy_bool *)data_out + 6) =
                        ((*((npy_bool *)data0 + 6)) &&
                         (*((npy_bool *)data1 + 6))) ||
                            (*((npy_bool *)data_out + 6));

#line 1565
        *((npy_bool *)data_out + 7) =
                        ((*((npy_bool *)data0 + 7)) &&
                         (*((npy_bool *)data1 + 7))) ||
                            (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data1 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  elif 1000 == 3
#line 1577
        *((npy_bool *)data_out + 0) =
                       ((*((npy_bool *)data0 + 0)) &&
                        (*((npy_bool *)data1 + 0)) &&
                        (*((npy_bool *)data2 + 0))) ||
                            (*((npy_bool *)data_out + 0));

#line 1577
        *((npy_bool *)data_out + 1) =
                       ((*((npy_bool *)data0 + 1)) &&
                        (*((npy_bool *)data1 + 1)) &&
                        (*((npy_bool *)data2 + 1))) ||
                            (*((npy_bool *)data_out + 1));

#line 1577
        *((npy_bool *)data_out + 2) =
                       ((*((npy_bool *)data0 + 2)) &&
                        (*((npy_bool *)data1 + 2)) &&
                        (*((npy_bool *)data2 + 2))) ||
                            (*((npy_bool *)data_out + 2));

#line 1577
        *((npy_bool *)data_out + 3) =
                       ((*((npy_bool *)data0 + 3)) &&
                        (*((npy_bool *)data1 + 3)) &&
                        (*((npy_bool *)data2 + 3))) ||
                            (*((npy_bool *)data_out + 3));

#line 1577
        *((npy_bool *)data_out + 4) =
                       ((*((npy_bool *)data0 + 4)) &&
                        (*((npy_bool *)data1 + 4)) &&
                        (*((npy_bool *)data2 + 4))) ||
                            (*((npy_bool *)data_out + 4));

#line 1577
        *((npy_bool *)data_out + 5) =
                       ((*((npy_bool *)data0 + 5)) &&
                        (*((npy_bool *)data1 + 5)) &&
                        (*((npy_bool *)data2 + 5))) ||
                            (*((npy_bool *)data_out + 5));

#line 1577
        *((npy_bool *)data_out + 6) =
                       ((*((npy_bool *)data0 + 6)) &&
                        (*((npy_bool *)data1 + 6)) &&
                        (*((npy_bool *)data2 + 6))) ||
                            (*((npy_bool *)data_out + 6));

#line 1577
        *((npy_bool *)data_out + 7) =
                       ((*((npy_bool *)data0 + 7)) &&
                        (*((npy_bool *)data1 + 7)) &&
                        (*((npy_bool *)data2 + 7))) ||
                            (*((npy_bool *)data_out + 7));

        data0 += 8*sizeof(npy_bool);
        data1 += 8*sizeof(npy_bool);
        data2 += 8*sizeof(npy_bool);
        data_out += 8*sizeof(npy_bool);
#  else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        *(npy_bool *)dataptr[nop] = temp || *(npy_bool *)dataptr[i];
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += sizeof(npy_bool);
        }
#  endif
    }

    /* If the loop was unrolled, we need to finish it off */
#if (1000 <= 3)
    goto finish_after_unrolled_loop;
#endif
}

static void
bool_sum_of_products_outstride0_any(int nop, char **dataptr,
                                npy_intp const *strides, npy_intp count)
{
    npy_bool accum = 0;

#if (1000 <= 3)
    char *data0 = dataptr[0];
    npy_intp stride0 = strides[0];
#endif
#if (1000 == 2 || 1000 == 3)
    char *data1 = dataptr[1];
    npy_intp stride1 = strides[1];
#endif
#if (1000 == 3)
    char *data2 = dataptr[2];
    npy_intp stride2 = strides[2];
#endif

    while (count--) {
#if 1000 == 1
        accum = *(npy_bool *)data0 || accum;
        data0 += stride0;
#elif 1000 == 2
        accum = (*(npy_bool *)data0 && *(npy_bool *)data1) || accum;
        data0 += stride0;
        data1 += stride1;
#elif 1000 == 3
        accum = (*(npy_bool *)data0 &&
                 *(npy_bool *)data1 &&
                 *(npy_bool *)data2) || accum;
        data0 += stride0;
        data1 += stride1;
        data2 += stride2;
#else
        npy_bool temp = *(npy_bool *)dataptr[0];
        int i;
        for (i = 1; i < nop; ++i) {
            temp = temp && *(npy_bool *)dataptr[i];
        }
        accum = temp || accum;
        for (i = 0; i <= nop; ++i) {
            dataptr[i] += strides[i];
        }
#endif
    }

#  if 1000 <= 3
    *((npy_bool *)dataptr[1000]) = accum || *((npy_bool *)dataptr[1000]);
#  else
    *((npy_bool *)dataptr[nop]) = accum || *((npy_bool *)dataptr[nop]);
#  endif
}



/* These tables need to match up with the type enum */
static sum_of_products_fn
_contig_outstride0_unary_specialization_table[NPY_NTYPES] = {
#line 1687
#if 0
    &bool_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &byte_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &ubyte_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &short_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &ushort_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &int_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &uint_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &long_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &ulong_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &longlong_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &ulonglong_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &float_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &double_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &longdouble_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &cfloat_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &cdouble_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &clongdouble_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 0
    &object_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 0
    &string_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 0
    &unicode_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 0
    &void_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 0
    &datetime_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 0
    &timedelta_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

#line 1687
#if 1
    &half_sum_of_products_contig_outstride0_one,
#else
    NULL,
#endif

}; /* End of _contig_outstride0_unary_specialization_table */

static sum_of_products_fn _binary_specialization_table[NPY_NTYPES][5] = {
#line 1718
#if 0
{
    &bool_sum_of_products_stride0_contig_outstride0_two,
    &bool_sum_of_products_stride0_contig_outcontig_two,
    &bool_sum_of_products_contig_stride0_outstride0_two,
    &bool_sum_of_products_contig_stride0_outcontig_two,
    &bool_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &byte_sum_of_products_stride0_contig_outstride0_two,
    &byte_sum_of_products_stride0_contig_outcontig_two,
    &byte_sum_of_products_contig_stride0_outstride0_two,
    &byte_sum_of_products_contig_stride0_outcontig_two,
    &byte_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &ubyte_sum_of_products_stride0_contig_outstride0_two,
    &ubyte_sum_of_products_stride0_contig_outcontig_two,
    &ubyte_sum_of_products_contig_stride0_outstride0_two,
    &ubyte_sum_of_products_contig_stride0_outcontig_two,
    &ubyte_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &short_sum_of_products_stride0_contig_outstride0_two,
    &short_sum_of_products_stride0_contig_outcontig_two,
    &short_sum_of_products_contig_stride0_outstride0_two,
    &short_sum_of_products_contig_stride0_outcontig_two,
    &short_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &ushort_sum_of_products_stride0_contig_outstride0_two,
    &ushort_sum_of_products_stride0_contig_outcontig_two,
    &ushort_sum_of_products_contig_stride0_outstride0_two,
    &ushort_sum_of_products_contig_stride0_outcontig_two,
    &ushort_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &int_sum_of_products_stride0_contig_outstride0_two,
    &int_sum_of_products_stride0_contig_outcontig_two,
    &int_sum_of_products_contig_stride0_outstride0_two,
    &int_sum_of_products_contig_stride0_outcontig_two,
    &int_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &uint_sum_of_products_stride0_contig_outstride0_two,
    &uint_sum_of_products_stride0_contig_outcontig_two,
    &uint_sum_of_products_contig_stride0_outstride0_two,
    &uint_sum_of_products_contig_stride0_outcontig_two,
    &uint_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &long_sum_of_products_stride0_contig_outstride0_two,
    &long_sum_of_products_stride0_contig_outcontig_two,
    &long_sum_of_products_contig_stride0_outstride0_two,
    &long_sum_of_products_contig_stride0_outcontig_two,
    &long_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &ulong_sum_of_products_stride0_contig_outstride0_two,
    &ulong_sum_of_products_stride0_contig_outcontig_two,
    &ulong_sum_of_products_contig_stride0_outstride0_two,
    &ulong_sum_of_products_contig_stride0_outcontig_two,
    &ulong_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &longlong_sum_of_products_stride0_contig_outstride0_two,
    &longlong_sum_of_products_stride0_contig_outcontig_two,
    &longlong_sum_of_products_contig_stride0_outstride0_two,
    &longlong_sum_of_products_contig_stride0_outcontig_two,
    &longlong_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &ulonglong_sum_of_products_stride0_contig_outstride0_two,
    &ulonglong_sum_of_products_stride0_contig_outcontig_two,
    &ulonglong_sum_of_products_contig_stride0_outstride0_two,
    &ulonglong_sum_of_products_contig_stride0_outcontig_two,
    &ulonglong_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &float_sum_of_products_stride0_contig_outstride0_two,
    &float_sum_of_products_stride0_contig_outcontig_two,
    &float_sum_of_products_contig_stride0_outstride0_two,
    &float_sum_of_products_contig_stride0_outcontig_two,
    &float_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &double_sum_of_products_stride0_contig_outstride0_two,
    &double_sum_of_products_stride0_contig_outcontig_two,
    &double_sum_of_products_contig_stride0_outstride0_two,
    &double_sum_of_products_contig_stride0_outcontig_two,
    &double_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &longdouble_sum_of_products_stride0_contig_outstride0_two,
    &longdouble_sum_of_products_stride0_contig_outcontig_two,
    &longdouble_sum_of_products_contig_stride0_outstride0_two,
    &longdouble_sum_of_products_contig_stride0_outcontig_two,
    &longdouble_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 0
{
    &cfloat_sum_of_products_stride0_contig_outstride0_two,
    &cfloat_sum_of_products_stride0_contig_outcontig_two,
    &cfloat_sum_of_products_contig_stride0_outstride0_two,
    &cfloat_sum_of_products_contig_stride0_outcontig_two,
    &cfloat_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 0
{
    &cdouble_sum_of_products_stride0_contig_outstride0_two,
    &cdouble_sum_of_products_stride0_contig_outcontig_two,
    &cdouble_sum_of_products_contig_stride0_outstride0_two,
    &cdouble_sum_of_products_contig_stride0_outcontig_two,
    &cdouble_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 0
{
    &clongdouble_sum_of_products_stride0_contig_outstride0_two,
    &clongdouble_sum_of_products_stride0_contig_outcontig_two,
    &clongdouble_sum_of_products_contig_stride0_outstride0_two,
    &clongdouble_sum_of_products_contig_stride0_outcontig_two,
    &clongdouble_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 0
{
    &object_sum_of_products_stride0_contig_outstride0_two,
    &object_sum_of_products_stride0_contig_outcontig_two,
    &object_sum_of_products_contig_stride0_outstride0_two,
    &object_sum_of_products_contig_stride0_outcontig_two,
    &object_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 0
{
    &string_sum_of_products_stride0_contig_outstride0_two,
    &string_sum_of_products_stride0_contig_outcontig_two,
    &string_sum_of_products_contig_stride0_outstride0_two,
    &string_sum_of_products_contig_stride0_outcontig_two,
    &string_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 0
{
    &unicode_sum_of_products_stride0_contig_outstride0_two,
    &unicode_sum_of_products_stride0_contig_outcontig_two,
    &unicode_sum_of_products_contig_stride0_outstride0_two,
    &unicode_sum_of_products_contig_stride0_outcontig_two,
    &unicode_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 0
{
    &void_sum_of_products_stride0_contig_outstride0_two,
    &void_sum_of_products_stride0_contig_outcontig_two,
    &void_sum_of_products_contig_stride0_outstride0_two,
    &void_sum_of_products_contig_stride0_outcontig_two,
    &void_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 0
{
    &datetime_sum_of_products_stride0_contig_outstride0_two,
    &datetime_sum_of_products_stride0_contig_outcontig_two,
    &datetime_sum_of_products_contig_stride0_outstride0_two,
    &datetime_sum_of_products_contig_stride0_outcontig_two,
    &datetime_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 0
{
    &timedelta_sum_of_products_stride0_contig_outstride0_two,
    &timedelta_sum_of_products_stride0_contig_outcontig_two,
    &timedelta_sum_of_products_contig_stride0_outstride0_two,
    &timedelta_sum_of_products_contig_stride0_outcontig_two,
    &timedelta_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

#line 1718
#if 1
{
    &half_sum_of_products_stride0_contig_outstride0_two,
    &half_sum_of_products_stride0_contig_outcontig_two,
    &half_sum_of_products_contig_stride0_outstride0_two,
    &half_sum_of_products_contig_stride0_outcontig_two,
    &half_sum_of_products_contig_contig_outstride0_two,
},
#else
    {NULL, NULL, NULL, NULL, NULL},
#endif

}; /* End of _binary_specialization_table */

static sum_of_products_fn _outstride0_specialized_table[NPY_NTYPES][4] = {
#line 1755
#if 1
{
    &bool_sum_of_products_outstride0_any,
    &bool_sum_of_products_outstride0_one,
    &bool_sum_of_products_outstride0_two,
    &bool_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &byte_sum_of_products_outstride0_any,
    &byte_sum_of_products_outstride0_one,
    &byte_sum_of_products_outstride0_two,
    &byte_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &ubyte_sum_of_products_outstride0_any,
    &ubyte_sum_of_products_outstride0_one,
    &ubyte_sum_of_products_outstride0_two,
    &ubyte_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &short_sum_of_products_outstride0_any,
    &short_sum_of_products_outstride0_one,
    &short_sum_of_products_outstride0_two,
    &short_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &ushort_sum_of_products_outstride0_any,
    &ushort_sum_of_products_outstride0_one,
    &ushort_sum_of_products_outstride0_two,
    &ushort_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &int_sum_of_products_outstride0_any,
    &int_sum_of_products_outstride0_one,
    &int_sum_of_products_outstride0_two,
    &int_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &uint_sum_of_products_outstride0_any,
    &uint_sum_of_products_outstride0_one,
    &uint_sum_of_products_outstride0_two,
    &uint_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &long_sum_of_products_outstride0_any,
    &long_sum_of_products_outstride0_one,
    &long_sum_of_products_outstride0_two,
    &long_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &ulong_sum_of_products_outstride0_any,
    &ulong_sum_of_products_outstride0_one,
    &ulong_sum_of_products_outstride0_two,
    &ulong_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &longlong_sum_of_products_outstride0_any,
    &longlong_sum_of_products_outstride0_one,
    &longlong_sum_of_products_outstride0_two,
    &longlong_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &ulonglong_sum_of_products_outstride0_any,
    &ulonglong_sum_of_products_outstride0_one,
    &ulonglong_sum_of_products_outstride0_two,
    &ulonglong_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &float_sum_of_products_outstride0_any,
    &float_sum_of_products_outstride0_one,
    &float_sum_of_products_outstride0_two,
    &float_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &double_sum_of_products_outstride0_any,
    &double_sum_of_products_outstride0_one,
    &double_sum_of_products_outstride0_two,
    &double_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &longdouble_sum_of_products_outstride0_any,
    &longdouble_sum_of_products_outstride0_one,
    &longdouble_sum_of_products_outstride0_two,
    &longdouble_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &cfloat_sum_of_products_outstride0_any,
    &cfloat_sum_of_products_outstride0_one,
    &cfloat_sum_of_products_outstride0_two,
    &cfloat_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &cdouble_sum_of_products_outstride0_any,
    &cdouble_sum_of_products_outstride0_one,
    &cdouble_sum_of_products_outstride0_two,
    &cdouble_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &clongdouble_sum_of_products_outstride0_any,
    &clongdouble_sum_of_products_outstride0_one,
    &clongdouble_sum_of_products_outstride0_two,
    &clongdouble_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 0
{
    &object_sum_of_products_outstride0_any,
    &object_sum_of_products_outstride0_one,
    &object_sum_of_products_outstride0_two,
    &object_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 0
{
    &string_sum_of_products_outstride0_any,
    &string_sum_of_products_outstride0_one,
    &string_sum_of_products_outstride0_two,
    &string_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 0
{
    &unicode_sum_of_products_outstride0_any,
    &unicode_sum_of_products_outstride0_one,
    &unicode_sum_of_products_outstride0_two,
    &unicode_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 0
{
    &void_sum_of_products_outstride0_any,
    &void_sum_of_products_outstride0_one,
    &void_sum_of_products_outstride0_two,
    &void_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 0
{
    &datetime_sum_of_products_outstride0_any,
    &datetime_sum_of_products_outstride0_one,
    &datetime_sum_of_products_outstride0_two,
    &datetime_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 0
{
    &timedelta_sum_of_products_outstride0_any,
    &timedelta_sum_of_products_outstride0_one,
    &timedelta_sum_of_products_outstride0_two,
    &timedelta_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1755
#if 1
{
    &half_sum_of_products_outstride0_any,
    &half_sum_of_products_outstride0_one,
    &half_sum_of_products_outstride0_two,
    &half_sum_of_products_outstride0_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

}; /* End of _outstride0_specialized_table */

static sum_of_products_fn _allcontig_specialized_table[NPY_NTYPES][4] = {
#line 1791
#if 1
{
    &bool_sum_of_products_contig_any,
    &bool_sum_of_products_contig_one,
    &bool_sum_of_products_contig_two,
    &bool_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &byte_sum_of_products_contig_any,
    &byte_sum_of_products_contig_one,
    &byte_sum_of_products_contig_two,
    &byte_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &ubyte_sum_of_products_contig_any,
    &ubyte_sum_of_products_contig_one,
    &ubyte_sum_of_products_contig_two,
    &ubyte_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &short_sum_of_products_contig_any,
    &short_sum_of_products_contig_one,
    &short_sum_of_products_contig_two,
    &short_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &ushort_sum_of_products_contig_any,
    &ushort_sum_of_products_contig_one,
    &ushort_sum_of_products_contig_two,
    &ushort_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &int_sum_of_products_contig_any,
    &int_sum_of_products_contig_one,
    &int_sum_of_products_contig_two,
    &int_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &uint_sum_of_products_contig_any,
    &uint_sum_of_products_contig_one,
    &uint_sum_of_products_contig_two,
    &uint_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &long_sum_of_products_contig_any,
    &long_sum_of_products_contig_one,
    &long_sum_of_products_contig_two,
    &long_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &ulong_sum_of_products_contig_any,
    &ulong_sum_of_products_contig_one,
    &ulong_sum_of_products_contig_two,
    &ulong_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &longlong_sum_of_products_contig_any,
    &longlong_sum_of_products_contig_one,
    &longlong_sum_of_products_contig_two,
    &longlong_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &ulonglong_sum_of_products_contig_any,
    &ulonglong_sum_of_products_contig_one,
    &ulonglong_sum_of_products_contig_two,
    &ulonglong_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &float_sum_of_products_contig_any,
    &float_sum_of_products_contig_one,
    &float_sum_of_products_contig_two,
    &float_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &double_sum_of_products_contig_any,
    &double_sum_of_products_contig_one,
    &double_sum_of_products_contig_two,
    &double_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &longdouble_sum_of_products_contig_any,
    &longdouble_sum_of_products_contig_one,
    &longdouble_sum_of_products_contig_two,
    &longdouble_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &cfloat_sum_of_products_contig_any,
    &cfloat_sum_of_products_contig_one,
    &cfloat_sum_of_products_contig_two,
    &cfloat_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &cdouble_sum_of_products_contig_any,
    &cdouble_sum_of_products_contig_one,
    &cdouble_sum_of_products_contig_two,
    &cdouble_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &clongdouble_sum_of_products_contig_any,
    &clongdouble_sum_of_products_contig_one,
    &clongdouble_sum_of_products_contig_two,
    &clongdouble_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 0
{
    &object_sum_of_products_contig_any,
    &object_sum_of_products_contig_one,
    &object_sum_of_products_contig_two,
    &object_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 0
{
    &string_sum_of_products_contig_any,
    &string_sum_of_products_contig_one,
    &string_sum_of_products_contig_two,
    &string_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 0
{
    &unicode_sum_of_products_contig_any,
    &unicode_sum_of_products_contig_one,
    &unicode_sum_of_products_contig_two,
    &unicode_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 0
{
    &void_sum_of_products_contig_any,
    &void_sum_of_products_contig_one,
    &void_sum_of_products_contig_two,
    &void_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 0
{
    &datetime_sum_of_products_contig_any,
    &datetime_sum_of_products_contig_one,
    &datetime_sum_of_products_contig_two,
    &datetime_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 0
{
    &timedelta_sum_of_products_contig_any,
    &timedelta_sum_of_products_contig_one,
    &timedelta_sum_of_products_contig_two,
    &timedelta_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1791
#if 1
{
    &half_sum_of_products_contig_any,
    &half_sum_of_products_contig_one,
    &half_sum_of_products_contig_two,
    &half_sum_of_products_contig_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

}; /* End of _allcontig_specialized_table */

static sum_of_products_fn _unspecialized_table[NPY_NTYPES][4] = {
#line 1827
#if 1
{
    &bool_sum_of_products_any,
    &bool_sum_of_products_one,
    &bool_sum_of_products_two,
    &bool_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &byte_sum_of_products_any,
    &byte_sum_of_products_one,
    &byte_sum_of_products_two,
    &byte_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &ubyte_sum_of_products_any,
    &ubyte_sum_of_products_one,
    &ubyte_sum_of_products_two,
    &ubyte_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &short_sum_of_products_any,
    &short_sum_of_products_one,
    &short_sum_of_products_two,
    &short_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &ushort_sum_of_products_any,
    &ushort_sum_of_products_one,
    &ushort_sum_of_products_two,
    &ushort_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &int_sum_of_products_any,
    &int_sum_of_products_one,
    &int_sum_of_products_two,
    &int_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &uint_sum_of_products_any,
    &uint_sum_of_products_one,
    &uint_sum_of_products_two,
    &uint_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &long_sum_of_products_any,
    &long_sum_of_products_one,
    &long_sum_of_products_two,
    &long_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &ulong_sum_of_products_any,
    &ulong_sum_of_products_one,
    &ulong_sum_of_products_two,
    &ulong_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &longlong_sum_of_products_any,
    &longlong_sum_of_products_one,
    &longlong_sum_of_products_two,
    &longlong_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &ulonglong_sum_of_products_any,
    &ulonglong_sum_of_products_one,
    &ulonglong_sum_of_products_two,
    &ulonglong_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &float_sum_of_products_any,
    &float_sum_of_products_one,
    &float_sum_of_products_two,
    &float_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &double_sum_of_products_any,
    &double_sum_of_products_one,
    &double_sum_of_products_two,
    &double_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &longdouble_sum_of_products_any,
    &longdouble_sum_of_products_one,
    &longdouble_sum_of_products_two,
    &longdouble_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &cfloat_sum_of_products_any,
    &cfloat_sum_of_products_one,
    &cfloat_sum_of_products_two,
    &cfloat_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &cdouble_sum_of_products_any,
    &cdouble_sum_of_products_one,
    &cdouble_sum_of_products_two,
    &cdouble_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &clongdouble_sum_of_products_any,
    &clongdouble_sum_of_products_one,
    &clongdouble_sum_of_products_two,
    &clongdouble_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 0
{
    &object_sum_of_products_any,
    &object_sum_of_products_one,
    &object_sum_of_products_two,
    &object_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 0
{
    &string_sum_of_products_any,
    &string_sum_of_products_one,
    &string_sum_of_products_two,
    &string_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 0
{
    &unicode_sum_of_products_any,
    &unicode_sum_of_products_one,
    &unicode_sum_of_products_two,
    &unicode_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 0
{
    &void_sum_of_products_any,
    &void_sum_of_products_one,
    &void_sum_of_products_two,
    &void_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 0
{
    &datetime_sum_of_products_any,
    &datetime_sum_of_products_one,
    &datetime_sum_of_products_two,
    &datetime_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 0
{
    &timedelta_sum_of_products_any,
    &timedelta_sum_of_products_one,
    &timedelta_sum_of_products_two,
    &timedelta_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

#line 1827
#if 1
{
    &half_sum_of_products_any,
    &half_sum_of_products_one,
    &half_sum_of_products_two,
    &half_sum_of_products_three
},
#else
    {NULL, NULL, NULL, NULL},
#endif

}; /* End of _unnspecialized_table */

NPY_VISIBILITY_HIDDEN sum_of_products_fn
get_sum_of_products_function(int nop, int type_num,
                             npy_intp itemsize, npy_intp const *fixed_strides)
{
    int iop;

    if (type_num >= NPY_NTYPES) {
        return NULL;
    }

    /* contiguous reduction */
    if (nop == 1 && fixed_strides[0] == itemsize && fixed_strides[1] == 0) {
        sum_of_products_fn ret =
            _contig_outstride0_unary_specialization_table[type_num];
        if (ret != NULL) {
            return ret;
        }
    }

    /* nop of 2 has more specializations */
    if (nop == 2) {
        /* Encode the zero/contiguous strides */
        int code;
        code = (fixed_strides[0] == 0) ? 0 :
                    (fixed_strides[0] == itemsize) ? 2*2*1 : 8;
        code += (fixed_strides[1] == 0) ? 0 :
                    (fixed_strides[1] == itemsize) ? 2*1 : 8;
        code += (fixed_strides[2] == 0) ? 0 :
                    (fixed_strides[2] == itemsize) ? 1 : 8;
        if (code >= 2 && code < 7) {
            sum_of_products_fn ret =
                        _binary_specialization_table[type_num][code-2];
            if (ret != NULL) {
                return ret;
            }
        }
    }

    /* Inner loop with an output stride of 0 */
    if (fixed_strides[nop] == 0) {
        return _outstride0_specialized_table[type_num][nop <= 3 ? nop : 0];
    }

    /* Check for all contiguous */
    for (iop = 0; iop < nop + 1; ++iop) {
        if (fixed_strides[iop] != itemsize) {
            break;
        }
    }

    /* Contiguous loop */
    if (iop == nop + 1) {
        return _allcontig_specialized_table[type_num][nop <= 3 ? nop : 0];
    }

    /* None of the above specializations caught it, general loops */
    return _unspecialized_table[type_num][nop <= 3 ? nop : 0];
}

